/* 
// patch3new.sql
//
// Services triggers in the post MetTrack Version 7.0 Era
// The patchfile content significantly revised in April 2002.
//
// delete the triggers which were incorporated 
// to support MET/REMOTE
// 
*/
/*
// ================================================
// drop met remote publish triggers
*/
call mtxdroptrigger('rep_publish_trig', 'repair');;
call mtxdroptrigger('loc_publish_trig', 'location');;
call mtxdroptrigger('cal_publish_trig', 'calibration');;
call mtxdroptrigger('inv_publish_trig', 'inventory');;
call mtxdroptrigger('cust_publish_trig', 'customers');;
/* *
// these ten triggers do not get recreated.
*/
call mtxdroptrigger('cal_i_2310', 'calibration');; 
call mtxdroptrigger('cal_u_2310', 'calibration');; 
call mtxdroptrigger('cal_u_usr', 'calibration');; 
call mtxdroptrigger('rep_i_3239', 'repair');; 
call mtxdroptrigger('rep_u_3239', 'repair');; 
call mtxdroptrigger('cal_u_whomod', 'calibration');; 
call mtxdroptrigger('loc_u_whomod', 'location');; 
call mtxdroptrigger('rep_u_whomod', 'repair');; 
call mtxdroptrigger('inv_u_whomod', 'inventory');; 
call mtxdroptrigger('cust_u_whomod', 'customers');; 
/*
//
// ================================================================
//
// CAL_ARCHIVE_DELETE on calibration
//
*/
call mtxdroptrigger('cal_archive_delete', 'calibration');;
//
CREATE trigger mt.cal_archive_delete after delete on mt.calibration
referencing old as olddata
for each row when(olddata.C2339 = 1)
begin
  declare err_notfound exception for sqlstate value '02000';
  declare curcal dynamic scroll cursor for select ctag from
      calibration where calibration.mtag = olddata.mtag order by
      C2301 desc,C2333 desc;
  declare cur_ctag char(128);
  declare cur_flag integer;
  set cur_flag=1;
  open curcal;
  update mt.calibration set C2339 = 0 where mtag = olddata.mtag;
  fetch next curcal into cur_ctag;
  if sqlstate = err_notfound then return 
  end if;
  update mt.calibration set C2339 = 1 where ctag = cur_ctag;
  close curcal 
end;;
//
comment on trigger calibration.cal_archive_delete is 'April 2002: Fluke';;
/*
// ================================================================
//
// CAL_ARCHIVE_INSERT on calibration
//
*/
call mtxdroptrigger('cal_archive_insert', 'calibration');;
//
CREATE trigger mt.cal_archive_insert after insert order 100 on mt.calibration
referencing new as newdata
for each row
// ---------------------------------------------------------
// --
// -- This one is the problem
// -- The loop for d-copy generates an error 
// -- MAX-CURSOR_COUNT is exceeded
// -- MAX-STATEMENT_COUNT is exceeded
// -- Rewritten by SEG to properly set C2339
// --
// -- Loop for dCopy commented out
// --
// ---------------------------------------------------------

begin
  declare b4225 char(1);
  declare b4224 char(1);
  declare bpass char(1);
  declare cmd char(256);
  declare tmp integer;
  declare mydcopy char(20);
  declare mydatacol char(20);
   // --

  declare cur dynamic scroll cursor for select dcopy,datacol from
      mt.customiz where
      fform = 4 and dcopy <> 'OFF' and dcopy is not NULL and length(dcopy) > 0;
  // --

  declare curconfig dynamic scroll cursor for select b_cal_4225,b_cal_4224,b_cal_p from
      mt.dbconfig;
  // --

  declare err_notfound exception for sqlstate value '02000';
  // --

  declare curcal dynamic scroll cursor for select ctag from
      mt.calibration where
      mt.calibration.mtag = newdata.mtag order by
      C2301 desc,C2333 desc;
  // --

  declare cur_ctag char(128);
  declare cur_flag integer;
 
  // --  
  // --
  // --  
  // --
  // --  message 'cal_archive_insert ',newdata.C2301;
  // --
  // -------------------------------------------------------
  // --  Reset C2339 on all records for this assets
  // -- pkershaw made a change here from "update mt.calibration set C2339 = 0 where mtag = newdata.mtag;" 
  // -- to the code below:
  // -------------------------------------------------------

  update mt.calibration set C2339 = 0 where mtag = newdata.mtag;
  // -------------------------------------------------------
  // --  Set C2339 = 1 on the cal event returned by the cursor
  // -------------------------------------------------------

  open curcal;
  fetch next curcal into cur_ctag;
  update mt.calibration set C2339 = 1 where ctag = cur_ctag;
  close curcal;
  // -- ----------------------------------------------------
  // -- pkershaw added following to handle dcopy Steve needs to test. 

  open cur;
  dcopyloop: loop
    fetch next cur into mydcopy,mydatacol;
    if sqlstate = err_notfound then
      leave dcopyloop
    end if;
    set cmd='update mt.inventory set I'+mydcopy+' = (select '+mydatacol+' from mt.calibration where ctag = '''+cur_ctag+''') where mtag = '''+newdata.mtag+'''';
    execute immediate cmd
  end loop dcopyloop;
  close cur;
  // ------------------------------------------------
  // -- Reset status flag 4225
  // ------------------------------------------------

  open curconfig;
  fetch next curconfig into b4225,b4224,bpass;
  close curconfig;
  set cmd='update mt.inventory set I4225 = NULL where mtag = '''+newdata.mtag+'''';
  // --

  if(b4225 = 'Y') then if(bpass = '1') then if(newdata.C2323 = 'Y') then execute immediate cmd
      end if
    else execute immediate cmd
    end if
  end if;
  // --
  // --
  // --
  set cmd='update mt.inventory set I4224 = NULL where mtag = '''+newdata.mtag+'''';
  if(b4224 = 'Y') then if(bpass = '1') then if(newdata.C2323 = 'Y') then execute immediate cmd
      end if
    else execute immediate cmd
    end if
  end if;

end;;
//
comment on trigger calibration.cal_archive_insert is 'April 2002: Fluke';;
/*
// ================================================================
//
// cal_archive_update on calibration
//
//      need to keep this update on cal_archive_update in 
//      synch with pathch1.sql
*/
call mtxdroptrigger('cal_archive_update', 'calibration');;
CREATE trigger mt.cal_archive_update after update of "C2301", "C2333"
    order 10 on mt.calibration
    referencing new as newdata
    old as olddata
    for each row
    when (isnull(olddata.C2339,'0') = isnull(newdata.C2339,'0'))
begin
    declare err_notfound exception for sqlstate value '02000';
    declare curcal dynamic scroll cursor for select ctag from
    mt.calibration where
    mt.calibration.mtag = newdata.mtag order by
    C2301 desc,C2333 desc;
    declare cur_ctag char(128);
    open curcal;
    fetch next curcal into cur_ctag;
    if sqlstate = err_notfound then
        return
    end if;
    close curcal;
    update mt.calibration set C2339 = 0 where mtag = newdata.mtag and C2339 <> '0';
    update mt.calibration set C2339 = 1 where ctag = cur_ctag;
end;;
comment on trigger cal_archive_update is 'This trigger sets the archive bit whenever changes are made to the calibration history record.  April 2004: Fluke: Made changes to prevent recursion.';;
/*
// ================================================================
//
// cal_update_logtime on calibration
//
//      need to keep this update on cal_archive_update in 
//      synch with pathch1.sql
*/
call mtxdroptrigger('cal_update_logtime', 'calibration');;
CREATE TRIGGER cal_update_logtime BEFORE UPDATE OF "C2301", "C2302", "C2303", "C2304", "C2306", "C2307", "C2309", 
    "C2310", "C2311", "C2312", "C2313", "C2314", "C2316", "C2320", "C2321", "C2322", "C2323", "C2324", "C2326", 
    "C2327", "C2328", "C2329", "C2330", "C2331", "C2332", "C2333", "C2334", "C2341", "C2362", "C2308", "C2315", 
    "C2342", "C2343", "C2317", "C2318", "C2319", "C2325", "C2350", "C2351", "C2352", "C2353", "C2354", "C2355", 
    "C2356", "C2357", "C2358", "C2359", "C2360", "C2361", "C2363", "cdsrc", "CPUBLISH", "C2381", "C2382", "C2364", 
    "C2365", "C2366", "C2367", "C2368", "C2369", "C2370", "C2371", "C2372", "C2373", "C2374", "C2375", "C2376", 
    "C2377", "C2378", "C2379", "C2380", "C2383", "C2384", "C2385", "C2344", "C2345", "C2346", "C2347", "C2386", 
    "C2387", "C2388", "C2389", "C2390", "C2391", "C2392", "C2393", "C2394", "C2395", "C2396"
	ORDER 10 ON "mt"."Calibration"
	REFERENCING NEW AS newdata
    OLD AS olddata
	FOR EACH ROW
    WHEN ((isnull(olddata.C2337,'1970-01-01') = isnull(newdata.C2337,'1970-01-01')) AND (isnull(olddata.C2338,' ') = isnull(newdata.C2338,' ')))
BEGIN
	set newdata.C2337=(select now(*));
	set newdata.C2338=(current user);
END;;
comment on trigger cal_archive_update is 'April 2004: Fluke: Moving the changes to "modified by" and "modified times" to occur in the data prior to the UPDATE statement firing.  Removing same functionality from the cal_archive_update trigger.';;
/*
// =================================================================
//
// cal_i_2309 on calibration
//
*/
call mtxdroptrigger('cal_i_2309', 'calibration');;
CREATE trigger mt.cal_i_2309 before insert order 120 on mt.calibration
referencing new as newdata
for each row
begin declare rate1 decimal(12,2);
  declare rate2 decimal(12,2);
  declare rate3 decimal(12,2);
  declare total decimal(12,2);
  declare time1 decimal(12,2);
  declare time2 decimal(12,2);
  set rate1=(select rate from mt.userlist where mtuser = newdata.C2307);
  if(rate1 is null) then
    set rate1=0.0
  end if;
  set rate2=(select rate from mt.userlist where mtuser = newdata.C2327);
  if(rate2 is null) then
    set rate2=0.0
  end if;
  set rate3=(select rate from mt.userlist where mtuser = newdata.C2313);
  if(rate3 is null) then
    set rate3=0.0
  end if;
  set time1 = newdata.C2324;
  if(time1 is null) then
    set time1 = 0.0;
  end if;
  set time2 = newdata.C2328;
  if(time2 is null) then
    set time2 = 0.0;
  end if;
  set total = (time1+time2);
  set newdata.C2310=(total);
  set newdata.C2309=((time1*rate1)+(time2*rate2)+(total*rate3));
end;;
comment on trigger cal_i_2309 is 'April 2003: Fluke ';;
/*
//
// ================================================================
// CAL_TAG_TRIG on calibration
//
*/
call mtxdroptrigger('cal_tag_trig', 'calibration');;
//
CREATE trigger mt.cal_tag_trig before insert order 2 on mt.calibration
referencing new as indata
for each row
begin
  declare inasset char(80);
  declare xmtag char(80);
  declare xasset char(80);
  declare xtime char(30);
  declare xx integer;
  declare yy integer;
  set xasset=indata.mtag;
  if(indata.C2333 is null) then
    set indata.C2333=current time
  end if;
  if(indata.C2303 is not null) then
    if(indata.C2334 is null) then
      set indata.C2334=indata.C2333
    end if
  end if;
  set xtime=seconds('1970-01-01',indata.C2301)+seconds(current date,indata.C2333);
  if(byte_length(ltrim(indata.ctag)) > 0) then
    return
  end if;
  set xx=locate(xasset,':');
  set yy=1;
  set xmtag=null;
  if(xx > 0) then
    set xmtag=substr(xasset,yy,xx-1)
  else
    set xmtag=xasset
  end if;
  set xmtag=string(xmtag,':');
  set xmtag=string(xmtag,xtime);
  set indata.ctag=xmtag;
end;;
//
comment on trigger calibration.cal_tag_trig is 'April 2002: Fluke';;
/*
// =================================================================
//
// cal_u_2309 on calibration
//
*/
call mtxdroptrigger('cal_u_2309', 'calibration');;
CREATE trigger mt.cal_u_2309 before update of C2307,C2327,C2313,C2324,C2328 order 120 on mt.calibration
referencing new as newdata
for each row
begin
  declare rate1 decimal(12,2);
  declare rate2 decimal(12,2);
  declare rate3 decimal(12,2);
  declare total decimal(12,2);
  declare time1 decimal(12,2);
  declare time2 decimal(12,2);
  set rate1=(select rate from mt.userlist where mtuser = newdata.C2307);
  if(rate1 is null) then
    set rate1=0.0
  end if;
  set rate2=(select rate from mt.userlist where mtuser = newdata.C2327);
  if(rate2 is null) then
    set rate2=0.0
  end if;
  set rate3=(select rate from mt.userlist where mtuser = newdata.C2313);
  if(rate3 is null) then
    set rate3=0.0
  end if;
  set time1 = newdata.C2324;
  if(time1 is null) then
    set time1 = 0.0;
  end if;
  set time2 = newdata.C2328;
  if(time2 is null) then
    set time2 = 0.0;
  end if;
  set total = (time1+time2);
  set newdata.C2310=(total);
  set newdata.C2309=((time1*rate1)+(time2*rate2)+(total*rate3));
end;;
comment on trigger calibration.cal_u_2309 is 'April 2003: Fluke ';;
/*
// =================================================================
//
// remove cal_update_editlog on calibration
//
*/
call mtxdroptrigger('cal_update_editlog', 'calibration');;
/*
// ================================================================
//
// REL_FIELD_TRIG on calibration
//
*/
call mtxdroptrigger('rel_field_trig', 'calibration');;
//
CREATE trigger mt.rel_field_trig before insert on mt.calibration
referencing new as indata
for each row
when (indata.combine <>'CMB')
begin
    declare nLastRel int;
    set nLastRel= (select C2362 from calibration where C2339=1 and mtag=indata.mtag);
    if (nLastRel is null) then
	    set nLastRel = 0;
    end if;
    if (indata.c2308 = 'AS-FOUND' or indata.c2308 = 'FOUND-LEFT') then
        if(indata.c2323 = 'Y') then
            if(nLastRel < 1) then
                set indata.C2362=1
            else
                set indata.C2362=nLastRel+1
            end if
        else
            if (nLastRel > -1) then
                set indata.C2362=-1
            else
                set indata.C2362=nLastRel-1
            end if
        end if
    else
        set indata.C2362 = nLastRel;
    end if; 
end;;
//
comment on trigger calibration.rel_field_trig is 'April 2002: Fluke Adjusts C2362 based on C2308, C2323';;
/*
// ================================================================
//
// REL_FIELD_TRIG on calibration
//
*/
call mtxdroptrigger('cal_rel_upd_trig', 'calibration');;
//
CREATE TRIGGER cal_rel_upd_trig BEFORE UPDATE OF "C2323", "C2308"
	ORDER 25 ON "mt"."Calibration"
	REFERENCING OLD AS old_data NEW AS indata 
	FOR EACH ROW
	WHEN (old_data.C2339 = 1 and (old_data.C2323 <> indata.C2323 or old_data.C2308 <> indata.C2308))
BEGIN
	declare nLastRel int;
	declare cur_ctag char(128);
	declare curcal dynamic scroll cursor for select ctag,c2362 from
		mt.calibration where
		mt.calibration.mtag = indata.mtag  and
		mt.calibration.combine <> 'CMB' and
		mt.calibration.c2339 <> 1 order by
		C2301 desc,C2333 desc;
	open curcal;
	fetch next curcal into cur_ctag, nLastRel;
	close curcal;
	if (nLastRel is null) then
		set nLastRel = 0;
	end if;
	if (indata.c2308 = 'AS-FOUND' or indata.c2308 = 'FOUND-LEFT') then
		if(indata.c2323 = 'Y') then
			if(nLastRel < 1) then
				set indata.C2362=1
			else
				set indata.C2362=nLastRel+1
			end if
		else
			if (nLastRel > -1) then
				set indata.C2362=-1
			else
				set indata.C2362=nLastRel-1
			end if
		end if
	else
		set indata.C2362 = nLastRel;
	end if; 
END;;
comment on trigger calibration.cal_rel_upd_trig is 'April 2004: Fluke Adjusts C2362 based on C2308, C2323. Maintains reliability field (C2362) integrity when combining calibrations.';;
/*
//
// =============================================================================
//
// calres_update_calibr_mod on calresults
//
*/
call mtxdroptrigger('calres_update_calibr_mod', 'calresults');;
CREATE TRIGGER calres_update_calibr_mod AFTER UPDATE OF "C2501", "C2502"
	ORDER 1 ON "mt"."CalResults"
	REFERENCING  NEW AS newdata
	FOR EACH ROW
	
BEGIN
	update mt.calibration set C2337=now(*), C2338=(current user) where ctag=newdata.ctag;
END;;
comment on trigger calresults.calres_update_calibr_mod is 'April 2002: Fluke Changes the modified logtime and name in the corresponding calibration table';;
/*
//
// =============================================================================
//
// CUST_KTAG_TRIG on customers
//
*/
call mtxdroptrigger('cust_ktag_trig', 'customers');;
//
begin
    CREATE trigger mt.cust_ktag_trig before insert on mt.customers
    referencing new as indata
    for each row
    begin
      declare inasset char(80);
      declare xmtag char(80);
      declare xasset char(80);
      declare xtime char(30);
      declare xx integer;
      declare yy integer;
      set xasset=indata.K4601;
      set xtime=seconds('1970-01-01',current time);
      if(byte_length(ltrim(indata.ktag)) > 0) then
        return
      end if;
      set xx=locate(xasset,':');
      set yy=1;
      set xmtag=null;
      while(xx <> 0) loop
        if(yy < xx) then
          set xmtag=string(xmtag,substr(xasset,yy,xx-1));
          set xmtag=string(xmtag,'y')
        else
          set xmtag=string(xmtag,'y')
        end if;
        set yy=xx+1;
        set xx=locate(xasset,':',yy)
      end loop;
      set xmtag=string(xmtag,substr(xasset,yy));
      set xasset=xmtag;
      set xx=locate(xasset,' ');
      set yy=1;
      set xmtag=null;
      while(xx <> 0) loop
        if(yy < xx) then
          set xmtag=string(xmtag,substr(xasset,yy,xx-1));
          set xmtag=string(xmtag,'z')
        else
          set xmtag=string(xmtag,'z')
        end if;
        set yy=xx+1;
        set xx=locate(xasset,' ',yy)
      end loop;
      set xmtag=string(xmtag,substr(xasset,yy));
      set xasset=xmtag;
      set xx=locate(xasset,'''');
      set yy=1;
      set xmtag=null;
      while(xx <> 0) loop
        if(yy < xx) then
          set xmtag=string(xmtag,substr(xasset,yy,xx-1));
          set xmtag=string(xmtag,'x')
        else
          set xmtag=string(xmtag,'x')
        end if;
        set yy=xx+1;
        set xx=locate(xasset,'''',yy)
      end loop;
      set xmtag=string(xmtag,substr(xasset,yy));
      set xmtag=string(xmtag,':');
      set xmtag=string(xmtag,xtime);
      set indata.ktag=xmtag
    end
end;;
//
comment on trigger customers.cust_ktag_trig is 'April 2002: Fluke';;
/*
// =================================================================
//
// customer_update_mod on customers
//
*/
call mtxdroptrigger('customer_update_mod','customers');;
CREATE TRIGGER customer_update_mod BEFORE UPDATE OF "KTAG", "K4601", "K4602", "K4603", "K4604", "K4605", "K4606", "K4607", 
    "K4608", "K4609", "K4610", "K4611", "K4612", "K4613", "K4614", "K4615", "K4616", "K4617", "K4618", "K4619", "K4620", 
    "K4621", "K4622", "K4623", "K4624", "K4625", "K4626", "K4627", "K4628", "K4640", "KDSRC", "K4633", "K4634", "K4635", 
    "K4636", "K4637"
	ORDER 10 ON "mt"."customers"
	REFERENCING NEW AS newdata
    OLD AS olddata
	FOR EACH ROW
    WHEN ((isnull(olddata.K4631,'1970-01-01') = isnull(newdata.K4631,'1970-01-01')) AND (isnull(olddata.K4632,' ') = isnull(newdata.K4632,' ')))
BEGIN
	set newdata.K4631=(select now(*));
	set newdata.K4632=(current user);
END;;
comment on trigger customers.customer_update_mod is 'April 2002: Fluke Updates the modified logtime and user';;
/*
// =================================================================
//
// inv_d_replic on inventory
//
*/
call mtxdroptrigger('inv_d_replic', 'inventory');;
CREATE trigger mt.inv_d_replic after delete order 800 on mt.Inventory
referencing old as olddata
for each row
when(olddata.replic = 'C')
begin
  declare tmp integer;
  set tmp=(select count(I4201) from mt.inventory where I4201 = olddata.I4201);
  if(tmp = 1) then
    update mt.inventory set replic = null where I4201 = olddata.I4201
  end if
end;;
comment on trigger Inventory.inv_d_replic is 'April 2002: Fluke ';;
/*
//
//
//
// ================================================================
// INV_MTAG_TRIG on inventory
//
*/
call mtxdroptrigger('inv_mtag_trig', 'inventory');;
//
CREATE trigger mt.inv_mtag_trig before insert on mt.inventory
referencing new as indata
for each row
begin
  declare inasset char(80);
  declare xmtag char(80);
  declare xasset char(80);
  declare xtime char(30);
  declare xx integer;
  declare yy integer;
  set xasset=indata.I4201;
  set xtime=seconds('1970-01-01',current time);
  begin
    if(byte_length(ltrim(indata.mtag)) > 0) then
      return
    end if;
    set xx=locate(xasset,':');
    set yy=1;
    set xmtag=null;
    while(xx <> 0) loop
      if(yy < xx) then
        set xmtag=string(xmtag,substr(xasset,yy,xx-1));
        set xmtag=string(xmtag,'y')
      else
        set xmtag=string(xmtag,'y')
      end if;
      set yy=xx+1;
      set xx=locate(xasset,':',yy)
    end loop;
    set xmtag=string(xmtag,substr(xasset,yy));
    set xasset=xmtag;
    set xx=locate(xasset,' ');
    set yy=1;
    set xmtag=null;
    while(xx <> 0) loop
      if(yy < xx) then
        set xmtag=string(xmtag,substr(xasset,yy,xx-1));
        set xmtag=string(xmtag,'z')
      else
        set xmtag=string(xmtag,'z')
      end if;
      set yy=xx+1;
      set xx=locate(xasset,' ',yy)
    end loop;
    set xmtag=string(xmtag,substr(xasset,yy));
    set xasset=xmtag;
    set xx=locate(xasset,'''');
    set yy=1;
    set xmtag=null;
    while(xx <> 0) loop
      if(yy < xx) then
        set xmtag=string(xmtag,substr(xasset,yy,xx-1));
        set xmtag=string(xmtag,'x')
      else
        set xmtag=string(xmtag,'x')
      end if;
      set yy=xx+1;
      set xx=locate(xasset,'''',yy)
    end loop;
    set xmtag=string(xmtag,substr(xasset,yy));
    set xmtag=string(xmtag,':');
    set xmtag=string(xmtag,xtime);
    set indata.mtag=xmtag
  end
end;;
//
comment on trigger inventory.inv_mtag_trig is 'April 2002: Fluke';;
/*
// =================================================================
//
// inv_replic on inventory
//
*/
call mtxdroptrigger('inv_replic', 'inventory');;
CREATE trigger mt.inv_replic before insert order 800 on mt.inventory
referencing new as indata
for each row
begin
  declare inasset char(80);
  declare xmtag char(80);
  declare xasset char(80);
  set xasset=indata.I4201;
  if(exists(select I4201 from mt.inventory where I4201 = xasset)) then
    update mt.inventory set replic = 'C' where I4201 = xasset;
    set indata.replic='C'
  end if
end;;
comment on trigger inventory.inv_replic is 'April 2002: Fluke: 
This trigger is used for replication, and may be a candidate for removal.';;
/*
// =================================================================
//
// inv_u_4201 on inventory
//
*/
call mtxdroptrigger('inv_u_4201', 'inventory');;
CREATE trigger mt.inv_u_4201 after update of I4201 order 700 on mt.inventory
referencing old as olddata new as newdata
for each row
begin
  if(newdata.I4201 <> olddata.I4201) then
    insert into mt.assethistory(I4201,cdate,mtuser,mtag) values(olddata.I4201,current date,current user,olddata.mtag)
  end if
end;;
comment on trigger inventory.inv_u_4201 is 'April 2002: Fluke ';;
/*
// =================================================================
//
// inv_u_abeyance on inventory
//
*/
call mtxdroptrigger('inv_u_abeyance', 'inventory');;
CREATE trigger mt.inv_u_abeyance before update of I4258 on mt.inventory
referencing old as olddata new as newdata
for each row when(olddata.I4258 = 'Y')
begin
  declare abey_date char(20);
  declare cal_date char(10);
  declare cal_time char(8);
  declare cal_int integer;
  declare cal_unit char(1);
  declare cal_pass char(1);
  declare due_date char(10);
  declare due_time char(8);
  declare rtn integer;
  declare err_notfound exception for sqlstate value '02000';
  declare curs dynamic scroll cursor for select C2323,C2302,C2331 from
      calibration where mtag = newdata.mtag and C2339 = 1;
  if(olddata.I4258 <> 'Y') then
    return
  end if;
  if(newdata.I4258 <> 'N') then
    return
  end if;
  if(not exists(select C2380 from calibration where mtag = newdata.mtag)) then
    message('no cal record');
    return
  end if;
  set abey_date=(select C2380 from calibration where mtag = newdata.mtag and C2339 = 1);
  if(abey_date is not null) then
    message('abeyance already set');
    return
  end if;
  set cal_date=current date;
  set cal_time=current time;
  open curs;
  CursLoop: loop fetch next curs into cal_pass,cal_int,cal_unit;
    if sqlstate = err_notfound then
      leave CursLoop
    end if
  end loop CursLoop;
  close curs;
  call mt.mt_calc_due_date(cal_date,cal_time,cal_pass,cal_unit,cal_int,due_date,due_time,rtn);
  if(rtn < 0) then
    message 'Integernal error in computing abeyance';
    return
  end if;
  update calibration set C2380 = cal_date,C2381 = cal_time,C2303 = due_date,C2334 = due_time,
    C2382 = 'N'  where  mtag = newdata.mtag and C2339 = 1
end;;
comment on trigger inventory.inv_u_abeyance is 'April 2002: Fluke ';;
/*
// =================================================================
//
// inv_u_replic on inventory
//
*/
call mtxdroptrigger('inv_u_replic', 'inventory');;
CREATE trigger mt.inv_u_replic before update of I4201 order 800 on mt.Inventory
referencing old as olddata new as indata
for each row when(olddata.replic = 'C')
begin
  declare inasset char(80);
  declare xmtag char(80);
  declare xasset char(80);
  declare xreplic char(2);
  declare tmp integer;
  set xasset=olddata.I4201;
  set xreplic=olddata.replic;
  set indata.replic=null;
  set tmp=(select count(I4201) from mt.inventory where I4201 = xasset);
  if(tmp = 2) then
    update mt.inventory set replic = null where I4201 = xasset
  end if
end;;
comment on trigger inventory.inv_u_replic is 'April 2002: Fluke ';;
/*
//
// ========================================================================================
// MT_UPDATE_DUE_DATE on inventory
//
*/
call mtxdroptrigger('mt_update_due_date', 'inventory');;
Create trigger mt.mt_update_due_date after update of "I4229", "I4230" on mt.inventory
referencing new as indata
for each row
when (indata.I4228 = 'U')
begin
	declare xmtag char(80);
	declare xtime char(20);
	declare xdate char(20);
	declare due_date char(20);
	declare uses integer;
	declare maxuse integer;
	declare cmd char(128);
	set xmtag=indata.mtag;
	set uses=indata.I4230;
	set maxuse=indata.I4229;
	set xtime=substr(current time,1,8);
	set xdate=current date;
	if(uses >= maxuse) then
		if(exists(select C2303 from calibration where C2339 = 1 and mtag = xmtag)) then
			set due_date=(select C2303 from calibration where C2339 = 1 and mtag = xmtag);
			if(due_date is null) then
				set due_date='NULL';
				set cmd='update calibration set C2303 = '''+xdate+''', C2334 = '''+xtime+''' where C2339 =1 and mtag = '''+xmtag+'''';
				execute immediate(cmd)
			end if
		else
			set due_date='NOT THERE'
		end if
	end if;
end;;
//
comment on trigger inventory.mt_update_due_date is 'February 1998: Fluke';;
/*
//
// ================================================================
//
// inv_row_update on location
//
// since the inventory update trigger has reverted back, we need to create a new one to handle row updates (the previous one would only update the modified fields when the asset was use-based...
*/
call mtxdroptrigger('inv_row_update', 'inventory');;

CREATE trigger mt.inv_row_update BEFORE UPDATE OF "I4201", "I4202", "I4203", "I4204", "I4205", "I4206", 
    "I4207", "I4208", "I4209", "I4210", "I4211", "I4212", "I4213", "I4214", "I4215", "I4216", "I4217", 
    "I4218", "I4219", "I4220", "I4221", "I4222", "I4223", "I4224", "I4225", "I4226", "I4228", "I4229", 
    "I4230", "I4231", "I4232", "I4233", "I4234", "I4235", "I4240", "I4299", "I4241", "I4242", "I4243", 
    "idsrc", "ktag", "I4258", "I4244", "I4245", "I4246", "I4247", "I4248", "I4249", "I4250", "I4251", 
    "I4252", "I4253", "I4254", "I4255", "I4256", "I4257", "I4259", "I4260", "I4261", "I4262"
    ORDER 5 ON mt.inventory
    referencing new as newdata
    old AS olddata
    FOR each row
    WHEN ((isnull(olddata.I4238,'1970-01-01') = isnull(newdata.I4238,'1970-01-01')) AND (isnull(olddata.I4239,' ') = isnull(newdata.I4239,' ')))
begin
    SET newdata.I4238=(select now(*));
    SET newdata.I4239=(current user);
end;;
/*
//
// ================================================================
//
// LOC_ARCHIVE_DELETE on location
//
*/
call mtxdroptrigger('loc_archive_delete', 'location');;
//
CREATE trigger mt.loc_archive_delete after delete on mt.location
referencing old as olddata
for each row when(olddata.L2815 = 1)
// -----------------------------------------------------
// -- Resets L2815 if the most recent loc record deleted
// -----------------------------------------------------
begin
  declare err_notfound exception for sqlstate value '02000';
  declare curloc dynamic scroll cursor for select ltag from
      mt.location where
      mt.location.mtag = olddata.mtag order by L2809 desc,L2810 desc;
  declare cur_ltag char(128);
  declare cur_flag integer;
  set cur_flag=1;
  open curloc;
  fetch next curloc into cur_ltag;
  if sqlstate = err_notfound then 
    return
  end if;
  update mt.location set L2815 = 0 where ltag = olddata.mtag;
  update mt.location set L2815 = 1 where ltag = cur_ltag;
  close curloc 
end;;
//
comment on trigger location.loc_archive_delete is 'April 2002: Fluke';;
/*
//
// ================================================================
//
// LOC_ARCHIVE_INSERT on location
//
*/
call mtxdroptrigger('loc_archive_insert', 'location');;
//
CREATE trigger mt.loc_archive_insert after insert on mt.location
referencing new as newdata
for each row
/*
------------------------------------------------
Fires after inserting a new location record

Updates L2815 - Most recent flag
------------------------------------------------

*/
begin
  declare err_notfound exception for sqlstate value '02000';
  // --
  declare cur dynamic scroll cursor for select ltag from
      mt.location where
      mt.location.mtag = newdata.mtag order by
      L2809 desc,L2810 desc;
  // --	  
  declare mytable char(40);
  declare mydcopy char(20);
  declare mydatacol char(20);
  declare cur_ltag char(128);
  declare cur_flag integer;
  declare cmd char(256);
  // --
  declare dCopyCursor dynamic scroll cursor for select dcopy,datacol from
      mt.customiz where
      fform = 8 and dcopy <> 'OFF';
  // -- 
  // --
  // -- reset all l2815's for this asset to 0
  update mt.location set L2815 = 0 where mtag = newdata.mtag;
  // --
  // --
  open cur;
  fetch next cur into cur_ltag; 
  // -- First fetch should produce the most recent record
  if sqlstate = err_notfound then return
  end if;
  update mt.location set L2815 = 1 where mt.location.ltag = cur_ltag; 
  // -- Set it's L2815 to 1
  close cur;
  open dCopyCursor;
  dcopyloop: loop
    fetch next dCopyCursor into mydcopy,mydatacol;
    if sqlstate = err_notfound then
      leave dcopyloop
    end if;
    set cmd='update inventory set I'+mydcopy+' = (select '+mydatacol+' from mt.location where ltag = '''+cur_ltag+''') where mtag = '''+newdata.mtag+'''';
    execute immediate cmd
  end loop dcopyloop; 	
  close dCopyCursor;
// --
end;;
//
comment on trigger location.loc_archive_insert is 'April 2002: Fluke';;
/*
// =================================================================
//
// loc_archive_update on location
//
//      need to keep this update on loc_archive_update in 
//      synch with pathch1.sql
*/
call mtxdroptrigger('loc_archive_update', 'location');;
CREATE trigger mt.loc_archive_update after update of "L2809", "L2810"
    order 10 on mt.location
    referencing new as newdata
    old as olddata
    for each row
    when ((isnull(olddata.L2815,'0') = isnull(newdata.L2815,'0')) AND (isnull(olddata.L2814,' ') = isnull(newdata.L2814,' ')) AND (isnull(olddata.L2813,'1970-01-01') = isnull(newdata.L2813,'1970-01-01')))
begin
    declare err_notfound exception for sqlstate value '02000';
    declare curloc2 dynamic scroll cursor for select ltag from
    mt.location where
    mt.location.mtag = newdata.mtag order by
    L2809 desc,L2810 desc;
    declare cur_ltag char(128);
    open curloc2;
    fetch next curloc2 into cur_ltag;
    if sqlstate = err_notfound then
        return
    end if;
    close curloc2;
    update mt.location set L2815 = 0 where mtag = newdata.mtag and L2815 <> '0';
    update mt.location set L2815 = 1 where ltag = cur_ltag and L2815 = '0';
end;;
comment on trigger location.loc_archive_update is 'April 2004: Fluke: Made changes to prevent recursion within this trigger.';;


/*
// =================================================================
//
// loc_update_logtime on location
//
//      need to keep this update on loc_update_logtime in 
//      synch with pathch1.sql
*/
call mtxdroptrigger('loc_update_logtime', 'location');;
CREATE TRIGGER loc_update_logtime BEFORE UPDATE OF "L2801", "L2802", "L2803", "L2804", "L2805", "L2806", 
    "L2807", "L2808", "L2809", "L2810", "MTAG", "ltag", "ldsrc", "L2816", "L2817", "LPUBLISH", "L2818", 
    "L2819", "L2820", "L2821", "L2822", "L2823", "L2824", "L2825", "L2826", "L2827", "L2828", "L2829", 
    "L2830", "L2831", "L2832", "L2833", "L2834", "L2835", "L2836", "L2837"
	ORDER 10 ON "mt"."Location"
	REFERENCING NEW AS newdata
    OLD AS olddata
	FOR EACH ROW
    WHEN ((isnull(olddata.L2813,'1970-01-01') = isnull(newdata.L2813,'1970-01-01')) AND (isnull(olddata.L2814,' ') = isnull(newdata.L2814,' ')))
BEGIN
	set newdata.L2813=(select now(*));
	set newdata.L2814=(current user);
END;;
comment on trigger location.loc_update_logtime is 'April 2004: Fluke: Moving the changes to "modified by" and "modified times" to occur in the data prior to the UPDATE statement firing.  Removing same functionality from the loc_archive_update trigger. ';;


/*
//
// ================================================================
// LOC_TAG_TRIG on location
//
*/
call mtxdroptrigger('loc_tag_trig', 'location');;
//
CREATE trigger mt.loc_tag_trig before insert on mt.location
referencing new as indata
for each row
begin
  declare inasset char(80);
  declare xmtag char(80);
  declare xasset char(80);
  declare xtime char(30);
  declare xx integer;
  declare yy integer;
  set xasset=indata.mtag;
  set xtime=seconds('1970-01-01',indata.L2809)+seconds(current date,indata.L2810);
  if(byte_length(ltrim(indata.ltag)) > 0) then
    return
  end if;
  set xx=locate(xasset,':');
  set yy=1;
  set xmtag=null;
  if(xx > 0) then
    set xmtag=substr(xasset,yy,xx-1)
  else
    set xmtag=xasset
  end if;
  set xmtag=string(xmtag,':');
  set xmtag=string(xmtag,xtime);
  set indata.ltag=xmtag
end;;
//
comment on trigger location.loc_tag_trig is 'April 2002: Fluke';;
/*
// =================================================================
//
// mt_update_loc_uses on location
//
*/
call mtxdroptrigger('mt_update_loc_uses', 'location');;
/*
// =================================================================
//
// loc_insert_2808 on location
//
*/
call mtxdroptrigger('loc_insert_2808', 'location');;
CREATE TRIGGER loc_insert_2808 AFTER INSERT
	ORDER 52 ON "mt"."Location"
	REFERENCING NEW AS newdata_li2808
	FOR EACH ROW
	WHEN ((select I4228 from inventory where mtag = newdata_li2808.mtag) = 'U')
BEGIN
	declare mtagout char(80);
	set mtagout = newdata_li2808.mtag;
	call total_L2808_to_I4230(mtagout);
END;;
comment on trigger location.loc_insert_2808 is 'September 2002: Fluke: After of insert of location record, calls stored procedure which, for inteval type U UUTs, sums the uses in L2808 since the last calibration and updates I4230.';;
/*
// =================================================================
//
// loc_update_2808 on location
//
*/
call mtxdroptrigger('loc_update_2808', 'location');;
CREATE TRIGGER loc_update_2808 AFTER UPDATE OF "L2808"
	ORDER 51 ON "mt"."Location"
	REFERENCING NEW AS newdata_lu2808
	FOR EACH ROW
	WHEN ((select I4228 from inventory where mtag = newdata_lu2808.mtag) = 'U' )
BEGIN
	declare mtagout char(80);
	set mtagout = newdata_lu2808.mtag;
	call total_L2808_to_I4230(mtagout);
END;;
comment on trigger location.loc_update_2808 is 'September 2002: Fluke: After update of L2808, calls stored procedure which, for inteval type U UUTs, sums the uses in L2808 since the last calibration and updates I4230.';;
/*
// =================================================================
//
// rep_archive_delete on repair
//
*/
call mtxdroptrigger('rep_archive_delete', 'repair');;
CREATE trigger mt.rep_archive_delete after delete on mt.repair
referencing old as olddata
for each row when(olddata.R3246 = 1)
begin
  /*
  -----------------------------
  Updates the most recent flag
  -----------------------------
  */
  declare err_notfound exception for sqlstate value '02000';
  declare currep dynamic scroll cursor for select rtag,R3251 from
      mt.repair where
      mt.repair.R3251 = olddata.R3251 and
      mt.repair.mtag = olddata.mtag order by R3230 desc,R3241 desc;
  // --	
  declare cur_rtag char(128);
  declare cur_flag integer;
  declare last3251 char(48);
  declare cur3251 char(48);
  set cur_flag=1;
  set last3251='';
  open currep;
  fetch next currep into cur_rtag,cur3251;
  if sqlstate = err_notfound then 
    return
  end if;
  update mt.repair set R3246 = 0 where rtag = olddata.mtag;
  update mt.repair set R3246 = 1 where rtag = cur_rtag;
  close currep
end;;
comment on trigger repair.rep_archive_delete is 'April 2002: Fluke ';;
/*
// =================================================================
//
// rep_archive_insert on repair
//
*/
call mtxdroptrigger('rep_archive_insert', 'repair');;
CREATE trigger mt.rep_archive_insert after insert on mt.repair
referencing new as newdata
for each row
begin
  // -------------------------------------------------------------------------
  // --
  // -- Updates most recent flag
  // -- Handles with dCopy
  // -------------------------------------------------------------------------
	declare b4225 char(1);
	declare cmd char(256);
	declare err_notfound exception for sqlstate value '02000';
	declare currep dynamic scroll cursor for select rtag,R3251 from
		mt.repair where
		mt.repair.R3251=newdata.R3251 and
		mt.repair.mtag = newdata.mtag order by
		R3230 desc,R3241 desc;
	declare cur_rtag char(128);
	declare last3251 char(48);
	declare cur3251 char(48);
	declare mytable char(40);
	declare mydcopy char(20);
	declare mydatacol char(20);
	declare myfform integer;
	declare mostrecent integer;
	declare Cur_Rep_Ins dynamic scroll cursor for select dcopy,datacol from
		mt.customiz where
		fform = 16 and dcopy <> 'OFF';
	set last3251='';
	set myfform=16;
	set mytable='repair';
	open currep;
	fetch next currep into cur_rtag,cur3251;
	close currep;
	update mt.repair set R3246 = 0 where mtag = newdata.mtag and R3251 = newdata.R3251 and R3246 <> 0 and rtag <> cur_rtag;
	update mt.repair set R3246 = 1 where rtag = cur_rtag and R3246 <> 1;
	open Cur_Rep_Ins;
	dcopyloop: loop
		fetch next Cur_Rep_Ins into mydcopy,mydatacol;
		if sqlstate = err_notfound then 
			leave dcopyloop
		end if;
		set cmd='update inventory set I'+mydcopy+' = (select '+mydatacol+' from MT.Repair where rtag = '''+cur_rtag+''') where mtag = '''+newdata.mtag+'''';
		execute immediate cmd
	end loop dcopyloop;
	close Cur_Rep_Ins;
	set b4225 = (select b_rep_4225 from mt.dbconfig); 
	if (b4225 = 'Y') then
		update inventory set I4225 = '' where mtag=newdata.mtag;
	end if;
end;;
comment on trigger repair.rep_archive_insert is 'April 2002: Fluke ';;
/*
// =================================================================
//
// rep_archive_update on repair
//
//      need to keep this update on rep_archive_update in 
//      synch with pathch1.sql
//
*/
call mtxdroptrigger('rep_archive_update', 'repair');;
CREATE trigger mt.rep_archive_update after update of "R3230", "R3241", "R3251" on mt.repair
referencing new as newdata
for each row
begin
    declare err_notfound exception for sqlstate value '02000';
    declare currep dynamic scroll cursor for select rtag,R3251 from repair where repair.mtag=newdata.mtag and repair.R3251 = newdata.R3251 order by R3230 desc,R3241 desc;
    declare cur_rtag char(128);
    declare cur_flag integer;
    declare last3251 char(48);
    declare cur3251 char(48);
    set cur_flag=1;
    set last3251='';
    open currep;
    fetch next currep into cur_rtag,cur3251;
    close currep;
    update mt.repair set R3246 = 0 where mtag = newdata.mtag and R3251 = newdata.R3251 and R3246 <> 0 and rtag <> cur_rtag;
	update mt.repair set R3246 = 1 where rtag = cur_rtag and R3246 <> 1;
end;;
comment on trigger repair.rep_archive_update is 'April 2002: Fluke ';;
/*
// =================================================================
//
// rep_i_3232 on repair
//
*/
call mtxdroptrigger('rep_i_3232', 'repair');;
CREATE trigger mt.rep_i_3232 before insert order 130 on mt.repair
referencing new as newdata
for each row
begin
  declare cost1 decimal(12,2);
  declare cost2 decimal(12,2);
  declare cost3 decimal(12,2);
  declare cost4 decimal(12,2);
  declare cost5 decimal(12,2);
  declare cost6 decimal(12,2);
  declare cost7 decimal(12,2);
  set cost1 = newdata.R3209;
  if(cost1 is null) then
    set cost1 = 0.0;
  end if;
  set cost2 = newdata.R3212;
  if(cost2 is null) then
    set cost2 = 0.0;
  end if;
  set cost3 = newdata.R3215;
  if(cost3 is null) then
    set cost3 = 0.0;
  end if;
  set cost4 = newdata.R3218;
  if(cost4 is null) then
    set cost4 = 0.0;
  end if;
  set cost5 = newdata.R3221;
  if(cost5 is null) then
    set cost5 = 0.0;
  end if;
  set cost6 = newdata.R3224;
  if(cost6 is null) then
    set cost6 = 0.0;
  end if;
  set cost7 = newdata.R3227;
  if(cost7 is null) then
    set cost7 = 0.0;
  end if;
  set newdata.R3232=(cost1 + cost2 + cost3 + cost4 + cost5 + cost6 + cost7);
end;;
comment on trigger repair.rep_i_3232 is 'April 2003: Fluke ';;
/*
// =================================================================
//
// rep_i_3235 on repair
//
*/
call mtxdroptrigger('rep_i_3235', 'repair');;
CREATE trigger mt.rep_i_3235 before insert order 120 on mt.repair
referencing new as newdata
for each row
begin
  declare rate1 decimal(12,2);
  declare rate2 decimal(12,2);
  declare rate3 decimal(12,2);
  declare total decimal(12,2);
  declare time1 decimal(12,2);
  declare time2 decimal(12,2);
  set rate1=(select rate from
      mt.userlist where mtuser = newdata.R3233);
  if(rate1 is null) then
    set rate1=0.0
  end if;
  set rate2=(select rate from mt.userlist where mtuser = newdata.R3237);
  if(rate2 is null) then
    set rate2=0.0
  end if;
  set rate3=(select rate from mt.userlist where mtuser = newdata.R3236);
  if(rate3 is null) then
    set rate3=0.0
  end if;
  set time1 = newdata.R3239;
  if(time1 is null) then
    set time1 = 0.0;
  end if;
  set time2 = newdata.R3238;
  if(time2 is null) then
    set time2 = 0.0;
  end if;
  set total = (time1 + time2);
  set newdata.R3229=total;
  set newdata.R3235=((time1*rate1)+(time2*rate2)+(total*rate3));
end;;
comment on trigger repair.rep_i_3235 is 'April 2003: Fluke ';;
/*
// =================================================================
//
// rep_i_3252 on repair
//
*/
call mtxdroptrigger('rep_i_3252', 'repair');;
CREATE trigger mt.rep_i_3252 before insert order 140 on mt.repair
referencing new as newdata
for each row
begin
  declare cost1 decimal(12,2);
  declare cost2 decimal(12,2);
  declare cost3 decimal(12,2);
  set cost1 = newdata.R3235;
  if(cost1 is null) then
    set cost1 = 0.0;
  end if;
  set cost2 = newdata.R3232;
  if(cost2 is null) then
    set cost2 = 0.0;
  end if;
  set cost3 = newdata.R3231;
  if(cost3 is null) then
    set cost3 = 0.0;
  end if;
  set newdata.R3252=(cost1+cost2+cost3);
end;;
comment on trigger repair.rep_i_3252 is 'April 2003: Fluke ';;
/*
//
// ================================================================
// rep_row_update on repair
//
// since the repair archive trigger has reverted back, we need to create a new one to handle row updates
*/
call mtxdroptrigger('rep_row_update', 'repair');;
CREATE trigger mt.rep_row_update BEFORE UPDATE OF "R3201", "R3204", "R3207", "R3208", "R3209", "R3210", "R3211", "R3212", 
    "R3213", "R3214", "R3215", "R3216", "R3217", "R3218", "R3219", "R3220", "R3221", "R3222", "R3223", "R3224", "R3225", 
    "R3226", "R3227", "R3229", "R3230", "R3231", "R3232", "R3233", "R3235", "R3236", "R3237", "R3238", "R3239", "R3240", 
    "R3241", "R3246", "R3247", "R3248", "R3249", "R3250", "R3251", "rdsrc", "R3252", "R3253", "R3254", "R3255", "R3256", 
    "R3257", "R3258", "R3259", "R3260", "R3261", "R3262", "R3263", "R3264", "R3265", "R3266", "R3267", "R3268", "R3269", 
    "R3270"
    order 10 on mt.repair
    referencing new as newdata
    old as olddata
    for each row
    when ((isnull(olddata.R3244,'1970-01-01') = isnull(newdata.R3244,'1970-01-01')) AND (isnull(olddata.R3245, ' ') = isnull(newdata.R3245,' ')))
begin
    set newdata.R3244=(select now(*));
    set newdata.R3245=(current user); 
end;;
/*
//
// ================================================================
// REP_TAG_TRIG on repair
//
*/
call mtxdroptrigger('rep_tag_trig', 'repair');;
//
CREATE trigger mt.rep_tag_trig before insert on mt.repair
referencing new as indata
for each row
begin
  declare inasset char(80);
  declare xmtag char(80);
  declare xasset char(80);
  declare xtime char(30);
  declare xx integer;
  declare yy integer;
  set xasset=indata.mtag;
  if(indata.R3241 is null) then
    set indata.R3241=current time
  end if;
  if(indata.R3247 is not null) then
    if(indata.R3248 is null) then
      set indata.R3248=indata.R3247
    end if
  end if;
  set xtime=seconds('1970-01-01',indata.R3230)+seconds(current date,indata.R3241);
  if(byte_length(ltrim(indata.rtag)) > 0) then
    return
  end if;
  set xx=locate(xasset,':');
  set yy=1;
  set xmtag=null;
  if(xx > 0) then
    set xmtag=substr(xasset,yy,xx-1)
  else
    set xmtag=xasset
  end if;
  set xmtag=string(xmtag,':');
  set xmtag=string(xmtag,xtime);
  set indata.rtag=xmtag;
end;;
//
comment on trigger repair.rep_tag_trig is 'April 2002: Fluke';;
/*
// =================================================================
//
// rep_u_3232 on repair
//
*/
call mtxdroptrigger('rep_u_3232', 'repair');;
CREATE trigger mt.rep_u_3232 before update order 130 on mt.repair
referencing new as newdata
for each row
begin
  declare cost1 decimal(12,2);
  declare cost2 decimal(12,2);
  declare cost3 decimal(12,2);
  declare cost4 decimal(12,2);
  declare cost5 decimal(12,2);
  declare cost6 decimal(12,2);
  declare cost7 decimal(12,2);
  set cost1 = newdata.R3209;
  if(cost1 is null) then
    set cost1 = 0.0;
  end if;
  set cost2 = newdata.R3212;
  if(cost2 is null) then
    set cost2 = 0.0;
  end if;
  set cost3 = newdata.R3215;
  if(cost3 is null) then
    set cost3 = 0.0;
  end if;
  set cost4 = newdata.R3218;
  if(cost4 is null) then
    set cost4 = 0.0;
  end if;
  set cost5 = newdata.R3221;
  if(cost5 is null) then
    set cost5 = 0.0;
  end if;
  set cost6 = newdata.R3224;
  if(cost6 is null) then
    set cost6 = 0.0;
  end if;
  set cost7 = newdata.R3227;
  if(cost7 is null) then
    set cost7 = 0.0;
  end if;
  set newdata.R3232=(cost1 + cost2 + cost3 + cost4 + cost5 + cost6 + cost7);
end;;
comment on trigger repair.rep_u_3232 is 'April 2003: Fluke ';;
/*
// =================================================================
//
// rep_u_3235 on repair
//
*/
call mtxdroptrigger('rep_u_3235', 'repair');;
CREATE trigger mt.rep_u_3235 before update of R3233,R3237,R3236,R3239,R3238 order 120 on mt.repair
referencing new as newdata
for each row
begin
  declare rate1 decimal(12,2);
  declare rate2 decimal(12,2);
  declare rate3 decimal(12,2);
  declare total decimal(12,2);
  declare time1 decimal(12,2);
  declare time2 decimal(12,2);
  set rate1=(select rate from
      mt.userlist where mtuser = newdata.R3233);
  if(rate1 is null) then
    set rate1=0.0
  end if;
  set rate2=(select rate from mt.userlist where mtuser = newdata.R3237);
  if(rate2 is null) then
    set rate2=0.0
  end if;
  set rate3=(select rate from mt.userlist where mtuser = newdata.R3236);
  if(rate3 is null) then
    set rate3=0.0
  end if;
  set time1 = newdata.R3239;
  if(time1 is null) then
    set time1 = 0.0;
  end if;
  set time2 = newdata.R3238;
  if(time2 is null) then
    set time2 = 0.0;
  end if;
  set total = (time1 + time2);
  set newdata.R3229=total;
  set newdata.R3235=((time1*rate1)+(time2*rate2)+(total*rate3));
end;;
comment on trigger repair.rep_u_3235 is 'April 2003: Fluke ';;
/*
// =================================================================
//
// rep_u_3252 on repair
//
*/
call mtxdroptrigger('rep_u_3252', 'repair');;
CREATE trigger mt.rep_u_3252 before update order 140 on mt.repair
referencing new as newdata
for each row
begin
  declare cost1 decimal(12,2);
  declare cost2 decimal(12,2);
  declare cost3 decimal(12,2);
  set cost1 = newdata.R3235;
  if(cost1 is null) then
    set cost1 = 0.0;
  end if;
  set cost2 = newdata.R3232;
  if(cost2 is null) then
    set cost2 = 0.0;
  end if;
  set cost3 = newdata.R3231;
  if(cost3 is null) then
    set cost3 = 0.0;
  end if;
  set newdata.R3252=(cost1+cost2+cost3);
end;;
comment on trigger repair.rep_u_3252 is 'April 2003: Fluke ';;
/*
// =================================================================
//
// fresults_update_mod on results
//
*/
call mtxdroptrigger('fresults_update_mod', 'results');;
CREATE TRIGGER fresults_update_mod BEFORE UPDATE OF "row_num", "test_desc", "fixq", "fixq_p", "fixq_u", 
	"varq", "varq_p", "varq_u", "lower_limit", "lower_limit_p", "lower_limit_u", "upper_limit", "upper_limit_p", "upper_limit_u", 
	"test_status", "exp_uncert", "exp_uncert_p", "exp_uncert_u", "std_uncert", "std_uncert_p", "std_uncert_u", "cov_fac", 
	"condition", "remark", "cpt", "cpt_p", "cpt_u", "fix_flag", "nominal", "nominal_p", "nominal_u", "mod1", "mod1_p", "mod1_u", 
	"sys_actual", "sys_actual_p", "sys_actual_u", "corr_flag", "uut_ind", "uut_ind_p", "uut_ind_u", "expv", "expv_p", "expv_u", 
	"measurement", "measurement_p", "measurement_u", "meas_flag", "dev", "dev_p", "dev_u", "error", "error_p", "error_u", 
	"rel_err", "rel_err_p", "rel_err_u", "corr", "corr_p", "corr_u", "corr_unc", "corr_unc_p", "corr_unc_u", "tol_ref", 
	"tol_neg", "tol_neg_p", "tol_neg_u", "tol_pos", "tol_pos_p", "tol_pos_u", "tol", "tol_p", "tol_u", "tur", 
	"tol_err", "tol_err_p", "tol_err_u", "uncert_method", "nthrow", "num_meas", "sdev", "sdev_p", "sdev_u", 
	"noisy_flag", "reliable_flag", "st_t", "st_t_flag", "ws_flag", "dominant", "df1", "df2", "df3", "df4", "df5", 
	"df6", "df7", "df8", "df9", "df10", "deg_free", "u1", "u1_p", "u1_u", "u2", "u2_p", "u2_u", "u3", "u3_p", "u3_u", 
	"u4", "u4_p", "u4_u", "u5", "u5_p", "u5_u", "u6", "u6_p", "u6_u", "u7", "u7_p", "u7_u", "u8", "u8_p", "u8_u", 
	"u9", "u9_p", "u9_u", "u10", "u10_p", "u10_u", "c1", "c2", "c3", "c4", "c5", "c6", "c7", "c8", "c9", "c10", 
	"s1", "s1_p", "s1_u", "s2", "s2_p", "s2_u", "dom_uncert", "dom_uncert_p", "dom_uncert_u", "test_step", "fsc", 
	"result_type", "accred", "guardband_meth", "guardband_ll", "guardband_ll_p", "guardband_ll_u", 
	"guardband_ul", "guardband_ul_p", "guardband_ul_u", "sys_acc", "sys_acc_p", "sys_acc_u", "sys_cov_fac", 
	"uut_range", "uut_range_p", "uut_range_u", "uut_res", "uut_res_p", "uut_res_u", "sense", "i_imped", "i_imped_p", "i_imped_u", 
	"o_imped1", "o_imped1_p", "o_imped1_u", "o_imped2", "o_imped2_p", "o_imped2_u", "wave1", "ampl1", "ampl1_p", "ampl1_u", 
	"freq1", "freq1_p", "freq1_u", "per1", "per1_p", "per1_u", "pulse_width", "pulse_width_p", "pulse_width_u", 
	"dc_offset", "dc_offset_p", "dc_offset_u", "duty_cycle", "duty_cycle_p", "duty_cycle_u", "rise", "rise_p", "rise_u", 
	"fall", "fall_p", "fall_u", "trigger_skew", "trigger_skew_p", "trigger_skew_u", "video", "polarity", "rtd_type", 
	"rtd_nom_res", "rtd_nom_res_p", "rtd_nom_res_u", "tc_type", "mod_source", "am_depth", "am_depth_p", "am_depth_u", 
	"fm_dev", "fm_dev_p", "fm_dev_u", "phase_dev", "phase_dev_p", "phase_dev_u", "wave2", "ampl2", "ampl2_p", "ampl2_u", 
	"freq2", "freq2_p", "freq2_u", "per2", "per2_p", "per2_u", "power", "power_p", "power_u", "phase", "phase_p", "phase_u", 
	"dpf", "dpf_polarity", "mtag", "ctag", "test_step2"
	ORDER 1 ON "mt"."results"
	REFERENCING NEW AS newdata
    OLD AS olddata
	FOR EACH ROW
    WHEN ((isnull(olddata.editlogtime,'1970-01-01') = isnull(newdata.editlogtime,'1970-01-01')) AND (isnull(olddata.modifiedby,' ') = isnull(newdata.modifiedby,' ')))
BEGIN
	set newdata.editlogtime=(select now(*));
	set newdata.modifiedby=(current user);
END;;
comment on trigger results.fresults_update_mod is 'April 2002: Fluke updates the modified by logtime and user';;
/*
// =================================================================
//
// fresultsraw_update_mod on results
//
*/
call mtxdroptrigger('fresultsraw_update_mod', 'results_raw');;
CREATE TRIGGER fresultsraw_update_mod BEFORE UPDATE OF "row_num", "name", "value", "prefix", "units"
    ORDER 1 ON "mt"."results_raw"
    REFERENCING NEW AS newdata
    OLD AS olddata
    FOR EACH ROW
    WHEN ((isnull(olddata.logtime,'1970-01-01') = isnull(newdata.logtime,'1970-01-01')) AND (isnull(olddata.modifiedby,' ') = isnull(newdata.modifiedby,' ')))
BEGIN
    set newdata.logtime=(select now(*));
    set newdata.modifiedby=(current user); 
END
;;
comment on trigger results_raw.fresultsraw_update_mod is 'April 2004: Fluke updates the modified by logtime and user. Corrected to be non-recursive.';;
/*
// =================================================================
//
// mt_update_std_uses on standards
//
*/
call mtxdroptrigger('mt_update_std_uses', 'standards');;
CREATE trigger mt.mt_update_std_uses after insert on mt.standards
referencing new as newdata
for each row
begin
  declare err_notfound exception for sqlstate value '02000';
  declare currep dynamic scroll cursor for select I4228,I4230 from
      mt.inventory where inventory.mtag = newdata.C2430;
  declare inv_type char(4);
  declare inv_use integer;
  declare cmd char(128);
  open currep;
  fetch next currep into inv_type,inv_use;
  if sqlstate <> err_notfound then
    if(inv_type = 'U') then
      set inv_use=inv_use+1;
      set inv_type=inv_use;
      set cmd='update inventory set I4230='''+inv_type+''' where mtag = '''+newdata.C2430+'''';
      execute immediate cmd
    end if
  end if;
  close currep
end;;
comment on trigger standards.mt_update_std_uses is 'April 2002: Fluke ';;
//
// /* Clean up the V5 licenses */
delete from mt.license where dbversion < 1003;;
/*
// =================================================================
//
// std_update_mod on standards
//
*/
call mtxdroptrigger('std_update_mod', 'standards');;
CREATE TRIGGER std_update_mod AFTER UPDATE
	ORDER 1 ON "mt"."Standards"
	REFERENCING NEW AS newdata
	FOR EACH ROW
BEGIN
	update mt.calibration set C2337= now(*), C2338=(current user) where ctag=newdata.ctag;
END;;
comment on trigger standards.std_update_mod is 'April 2002: Fluke updates the modified by logtime and user';;
/*
//
// ================================================================
*/
commit;
