//

//BEGIN FILE HEADER
//
//  NAME
//  patch1.sql
// DESCRIPTION
//
//Copyright Fluke Corporation  1989, 2002
// A/ll Rights Reserved.
//
//END FILE HEADER
//
//
// ================================================================
message 'patch1 : Starting';;
call mtxmsg('patch1','patch1 : Version 2002-03-27  Starting');;
//
// ================================================================
// index and primary key changes for SQL Remote
//
// drop the update triggers. This speeds things up a lot.
call mtxdroptrigger('cal_archive_update', 'calibration');;
call mtxdroptrigger('loc_archive_update', 'location');;
call mtxdroptrigger('rep_archive_update', 'repair');;
/*
//
// delete foreign keys and indices to prevent alteration conflicts 
// and speed procedure.
*/
begin
    /*  indexes  */
    if (exists (select index_name from sys.sysindex where index_name ='idx_cal')) then
        drop index idx_cal;
    end if;
    if (exists (select index_name from sys.sysindex where index_name ='idx_loc')) then
        drop index idx_loc;
    end if;
    if (exists (select index_name from sys.sysindex where index_name ='idx_rep')) then
        drop index idx_rep;
    end if;
    if (exists (select index_name from sys.sysindex where index_name ='idx_calres')) then
        drop index idx_calres;
    end if;
    if (exists (select index_name from sys.sysindex where index_name ='idx_std2')) then
        drop index idx_std2;
    end if;
    if (exists (select index_name from sys.sysindex where index_name ='idx_std')) then
        drop index idx_std;
    end if;
    if (exists (select index_name from sys.sysindex where index_name ='fastresult')) then
        drop index fastresult
    end if;
    if (exists (select index_name from sys.sysindex where index_name ='fastrawresult')) then
        drop index fastrawresult;
    end if;

    /*  indexes - unique guarantors  */
    if (exists (select index_name from sys.sysindex where index_name ='Calibration UNIQUE (CTAG)')) then
        alter table mt.calibration delete unique (ctag);
    end if;
    if (exists (select index_name from sys.sysindex where index_name ='Location UNIQUE (LTAG)')) then
        alter table mt.location delete unique (ltag);
    end if;
    if (exists (select index_name from sys.sysindex where index_name ='Repair UNIQUE (RTAG)')) then
        alter table mt.repair delete unique (rtag);
    end if;
    if (exists (select index_name from sys.sysindex where index_name ='Inventory UNIQUE (MTAG)')) then
        alter table mt.inventory delete unique (mtag);
    end if;
    if (exists (select index_name from sys.sysindex where index_name ='Inventory UNIQUE (IPUBLISH,I4201)')) then
        alter table mt.inventory delete unique (IPUBLISH,I4201);
    end if;
    if (exists (select index_name from sys.sysindex where index_name ='Inventory UNIQUE (I4201,IPUBLISH)')) then
        alter table mt.inventory delete unique (I4201,IPUBLISH);
    end if;
    if (exists (select index_name from sys.sysindex where index_name ='Inventory UNIQUE (I4201)')) then
        alter table mt.inventory delete unique (I4201);
    end if;
    if (exists (select index_name from sys.sysindex where index_name ='Results UNIQUE (CTAG,row_num)')) then
        alter table mt.Results delete unique (CTAG,row_num);
    end if;
    if (exists (select index_name from sys.sysindex where index_name ='Results UNIQUE (row_num,CTAG)')) then
        alter table mt.Results delete unique (row_num,CTAG);
    end if;


    /*  foreign keys  */
    if (exists (select role from sys.sysforeignkeys where foreign_tname ='standards' and role ='inventory')) then
        alter table mt.standards delete foreign key inventory;
    end if;
    if (exists (select role from sys.sysforeignkeys where foreign_tname ='standards' and role ='mtag')) then
        alter table mt.standards delete foreign key mtag;
    end if;
    if (exists (select role from sys.sysforeignkeys where foreign_tname ='standards' and role ='calibration')) then
        alter table mt.standards delete foreign key calibration;
    end if;
    if (exists (select role from sys.sysforeignkeys where foreign_tname ='inventory' and role ='ktag')) then
        alter table mt.inventory drop foreign key  ktag;
    end if;
    if (exists (select role from sys.sysforeignkeys where foreign_tname ='calresults' and role ='calibration')) then
        alter table mt.calresults delete foreign key calibration;
    end if;
    if (exists (select role from sys.sysforeignkeys where foreign_tname ='calibration' and role ='inventory')) then
        alter table mt.calibration delete foreign key inventory;
    end if;
    if (exists (select role from sys.sysforeignkeys where foreign_tname ='location' and role ='inventory')) then
        alter table mt.location delete foreign key inventory;
    end if;
    if (exists (select role from sys.sysforeignkeys where foreign_tname ='repair' and role ='inventory')) then
        alter table mt.repair delete foreign key  inventory;
    end if;
    if (exists (select role from sys.sysforeignkeys where foreign_tname ='assethistory' and role ='inventory')) then
        alter table mt.assethistory delete foreign key inventory;
    end if;
    if (exists (select role from sys.sysforeignkeys where foreign_tname ='results' and role ='calibration')) then
        alter table mt.results delete foreign key calibration;
    end if;
    if (exists (select role from sys.sysforeignkeys where foreign_tname ='results_raw' and role ='calibration')) then
        alter table mt.results_raw delete foreign key calibration;
    end if;
    if (exists (select role from sys.sysforeignkeys where foreign_tname ='results_raw' and role ='results')) then
        alter table mt.results_raw delete foreign key results;
    end if;
    if (exists (select role from sys.sysforeignkeys where foreign_tname ='user1' and role ='inventory')) then
        alter table mt.user1 delete foreign key inventory;
    end if;
    if (exists (select role from sys.sysforeignkeys where foreign_tname ='user2' and role ='inventory')) then
        alter table mt.user2 delete foreign key inventory;
    end if;
    if (exists (select role from sys.sysforeignkeys where foreign_tname ='user3' and role ='inventory')) then
        alter table mt.user3 delete foreign key inventory;
    end if;


    if (exists (select tname from sys.syscatalog where tname='location' and primary_key='Y'))then
        alter table mt.location delete primary key;
    end if;
    if (exists (select tname from sys.syscatalog where tname='calibration' and primary_key='Y'))then
        alter table mt.calibration delete primary key;
    end if;
    if (exists (select tname from sys.syscatalog where tname='repair' and primary_key='Y'))then
        alter table mt.repair delete primary key;
    end if;
    if (exists (select tname from sys.syscatalog where tname='inventory' and primary_key='Y'))then
        alter table mt.inventory delete primary key;
    end if;
    if (exists (select tname from sys.syscatalog where tname='results' and primary_key='Y'))then
        alter table mt.results delete primary key;
    end if;
    if (exists (select tname from sys.syscatalog where tname='results_raw' and primary_key='Y'))then
        alter table mt.results_raw delete primary key;
    end if;

    if (exists (select index_name from sys.sysindex where index_name ='Customers UNIQUE (KTAG)')) then
        alter table mt.customers delete unique (ktag);
    end if;
    if (exists (select index_name  from sys.sysindex where index_name ='Customers UNIQUE (K4601,KPUBLISH)')) then
        alter table mt.customers delete unique(K4601,KPUBLISH);
    end if;
    if (exists (select index_name  from sys.sysindex where index_name ='Customers UNIQUE (KPUBLISH,K4601)')) then
        alter table mt.customers delete unique(KPUBLISH,K4601);
    end if;
    if (exists (select index_name  from sys.sysindex where index_name ='Customers UNIQUE (K4601)')) then
        alter table mt.customers delete unique(K4601);
    end if;
    if (exists (select tname from sys.syscatalog where tname='customers' and primary_key='Y'))then
        alter table mt.customers delete primary key;
    end if;
end;;
begin
    if (exists(select cname from sys.syscolumns where cname='IPUBLISH' and tname='inventory'))then
        alter table mt.inventory modify IPUBLISH default 'mtrack';
        alter table mt.inventory modify IPUBLISH null;
    end if;
    if (exists(select cname from sys.syscolumns where cname='LPUBLISH' and tname='location'))then
        alter table mt.location modify LPUBLISH default 'mtrack';
        alter table mt.location modify LPUBLISH null;
    end if;
    if (exists(select cname from sys.syscolumns where cname='CPUBLISH' and tname='calibration'))then
        alter table mt.calibration modify CPUBLISH default 'mtrack';
        alter table mt.calibration modify CPUBLISH null;
    end if;
    if (exists(select cname from sys.syscolumns where cname='RPUBLISH' and tname='repair'))then
        alter table mt.repair modify RPUBLISH default 'mtrack';
        alter table mt.repair modify RPUBLISH null;
    end if;
    if (exists(select cname from sys.syscolumns where cname='KPUBLISH' and tname='customers'))then
        alter table mt.customers modify KPUBLISH default 'mtrack';
        alter table mt.customers modify KPUBLISH null;
    end if;

end;;
//
//
// =============================================================================
//
// If the publication is there, and the dbversion is 2PLUS1, 
// then this is a BETA DB. So kill the publication.
begin
    if exists(select publication_name from sys.syspublication where publication_name = 'fluke_metrology') then
            drop publication fluke_metrology;
    end if
end;;
// ==========================================================
// Modify the dbconfig and mt.customiz tables
//
begin
    // ====================================================
    // dbconfig table
    //
    declare sbuf char(20);

    //========== aserv

    if not exists (select cname from sys.syscolumns where cname ='aserv' and tname ='dbconfig')
    then
        alter table mt.dbconfig add aserv char(16);
        update mt.dbconfig set aserv='C';
        alter table dbconfig modify aserv not null;
    else
        alter table mt.dbconfig modify aserv char(16);
        update mt.dbconfig set aserv='C';

    end if;
    //========== b_cal_p

    if not exists (select cname from sys.syscolumns where cname ='b_cal_p' and tname ='dbconfig')
    then
        alter table mt.dbconfig add b_cal_p char(1);
        update mt.dbconfig set b_cal_p='1' where rowid=1;
    end if;
    //========== cfgedit

    if not exists (select cname from sys.syscolumns where cname ='cfgedit' and tname ='dbconfig')
    then
        alter table mt.dbconfig  add cfgedit char (1);
        update mt.dbconfig set cfgedit = '3' where rowid = 1;
        ALTER TABLE mt.dbconfig MODIFY cfgedit CHECK ( cfgedit IN ( '1','2','3','4','5' ) );
    end if;
    //========== combcal
    if not exists (select cname from sys.syscolumns where cname ='combcal' and tname ='dbconfig')
    then
        alter table mt.dbconfig add combcal char(1);
        update mt.dbconfig set combcal='Y' where rowid=1;
    end if;
    //========== dbremote

    if not exists (select cname from sys.syscolumns where cname ='dbremote' and tname ='dbconfig')
    then
        alter table mt.dbconfig add dbremote integer default 0;
        alter table mt.dbconfig add dbremmax integer default 0;
    end if;
    //========== defcolor

    if not exists (select cname from sys.syscolumns where cname= 'defcolor' and tname='dbconfig')
    then
        alter table mt.dbconfig add defcolor char(20);
        update mt.dbconfig set defcolor ='cyan';
    end if;
    //========== f_data_face
    if not exists (select cname from sys.syscolumns where cname ='f_data_face' and tname ='dbconfig')
    then
        alter table mt.dbconfig add f_data_face char(60);
        update mt.dbconfig set f_data_face='Courier New' where rowid=1;
    end if;
    //========== f_data_point
    if not exists (select cname from sys.syscolumns where cname ='f_data_point' and tname ='dbconfig')
    then
        alter table mt.dbconfig add f_data_point integer;
        update mt.dbconfig set f_data_point=10 where rowid=1;
    end if;
    //========== f_data_weight
    if not exists (select cname from sys.syscolumns where cname ='f_data_weight' and tname ='dbconfig')
    then
        alter table mt.dbconfig add f_data_weight integer;
        update mt.dbconfig set f_data_weight=400 where rowid=1;
    end if;
    //========== f_title_face
    if not exists (select cname from sys.syscolumns where cname ='f_title_face' and tname ='dbconfig')
    then
        alter table mt.dbconfig add f_title_face char(60);
        update mt.dbconfig set f_title_face  = 'Comic Sans MS' where rowid = 1;
    end if;
    //========== f_title_point
    if not exists (select cname from sys.syscolumns where cname ='f_title_point' and tname ='dbconfig')
    then
        alter table mt.dbconfig add f_title_point integer;
        update mt.dbconfig set f_title_point=10 where rowid=1;
    end if;
    //========== f_title_weight
    if not exists (select cname from sys.syscolumns where cname ='f_title_weight' and tname ='dbconfig')
    then
        alter table mt.dbconfig add f_title_weight integer;
        update mt.dbconfig set f_title_weight=700 where rowid=1;
    end if;
    //========== mtdba

    if not exists (select cname from sys.syscolumns where cname ='mtdba' and tname ='dbconfig')
    then
        alter table mt.dbconfig  add mtdba integer default 0;
        update mt.dbconfig set mtdba=1004;
    end if;
    //========== mtdbb

    if not exists (select cname from sys.syscolumns where cname ='mtdbb' and tname ='dbconfig')
    then
        alter table mt.dbconfig  add mtdbb integer default 0;
        update mt.dbconfig set mtdbb=1004;
    end if;
    //========== p2increment

    if not exists (select cname from sys.syscolumns where cname='p2increment' and tname='dbconfig')
    then
        alter table mt.dbconfig add p2increment char(48) default '';
        update mt.dbconfig set p2increment='';
    end if;
    //========== passwd_chg

    if not exists (select cname from sys.syscolumns where cname ='passwd_chg' and tname ='dbconfig')
    then
        alter table mt.dbconfig add passwd_chg char(1) default 0;
        update mt.dbconfig set passwd_chg='1' where rowid=1;
        alter table mt.dbconfig modify passwd_chg check (passwd_chg in ('0','1'));

    end if;
    //========== password_tout

    if not exists (select cname from sys.syscolumns where cname ='password_tout' and tname ='dbconfig')
    then
        alter table mt.dbconfig add password_tout integer;
        update mt.dbconfig set password_tout=0 where rowid=1;
    end if;
    //========== password_warn

    if not exists (select cname from sys.syscolumns where cname ='password_warn' and tname ='dbconfig')
    then
        alter table mt.dbconfig add password_warn integer;
        update mt.dbconfig set password_warn=0 where rowid=1;
    end if;
    //========== procedit

    if not exists (select cname from sys.syscolumns where cname ='procedit' and tname ='dbconfig')
    then
        alter table mt.dbconfig add procedit char(1);
        update mt.dbconfig set procedit='4' where rowid=1;
        alter table mt.dbconfig MODIFY procedit CHECK (procedit IN ('1','2','3','4','5'));
    end if;
    //========== req_cal

    if not exists (select cname from sys.syscolumns where cname='req_cal' and tname='dbconfig')
    then
        alter table mt.dbconfig add req_cal char(1) default 'N';
        update mt.dbconfig set req_cal='N';
    end if;
    //========== req_loc

    if not exists (select cname from sys.syscolumns where cname='req_loc' and tname='dbconfig')
    then
        alter table mt.dbconfig add req_loc char(1) default 'N';
        update mt.dbconfig set req_loc='N';
    end if;
    //========== reqcolor

    if not exists (select cname from sys.syscolumns where cname= 'reqcolor' and tname='dbconfig')
    then
        alter table mt.dbconfig add reqcolor char(20);
        update mt.dbconfig set reqcolor='green';
    end if;
    //========== rowid
    // Remove AutoIncrement on RowID
    alter table mt.dbconfig modify "rowid" default null;
    //========== rtconfig
    if not exists (select cname from sys.syscolumns where cname ='rtconfig' and tname ='dbconfig')
    then
        alter table mt.dbconfig add rtconfig char(1);
        update mt.dbconfig set rtconfig='5' where rowid=1;
        ALTER TABLE mt.dbconfig MODIFY rtconfig CHECK ( rtconfig IN ( '1','2','3','4','5' ) );
    end if;
    //========== std_src
    if not exists (select cname from sys.syscolumns where cname ='std_src' and tname ='dbconfig')
    then
        alter table mt.dbconfig add std_src char(5);
        update mt.dbconfig set std_src='table';
    end if;
    //========== un_st
    if not exists (select cname from sys.syscolumns where cname ='un_st' and tname ='dbconfig')
    then
        alter table mt.dbconfig add un_st char(1);
        update mt.dbconfig set un_st='N' where rowid=1;
    end if;
    //========== un_coverage
    if not exists (select cname from sys.syscolumns where cname ='un_coverage' and tname ='dbconfig')
    then
        alter table mt.dbconfig add un_coverage decimal(12,8);
        update mt.dbconfig set un_coverage=2.0 where rowid=1;
    end if;
    //========== un_digits
    if not exists (select cname from sys.syscolumns where cname ='un_digits' and tname ='dbconfig')
    then
        alter table mt.dbconfig add un_digits integer;
        update mt.dbconfig set un_digits=2 where rowid=1;
    end if;
    //========== un_nmeas
    if not exists (select cname from sys.syscolumns where cname ='un_nmeas' and tname ='dbconfig')
    then
        alter table mt.dbconfig add un_nmeas integer;
        update mt.dbconfig set un_nmeas=0 where rowid=1;
    end if;
    //========= user data fields cannot be null
    update mt.dbconfig set user1 = 'User Configurable String 1' where user1 is null;
    update mt.dbconfig set user2 = 'User Configurable String 2' where user2 is null;
    update mt.dbconfig set user3 = 'User Configurable String 3' where user3 is null;
    update mt.dbconfig set user4 = 'User Configurable String 4' where user4 is null;
    update mt.dbconfig set user5 = 'User Configurable String 5' where user5 is null;
    //========== valedit
    if not exists (select cname from sys.syscolumns where cname ='valedit' and tname ='dbconfig')
    then
        alter table mt.dbconfig add valedit char(1);
        update mt.dbconfig set valedit='3' where rowid=1;
        alter table  mt.dbconfig modify valedit CHECK (valedit in ('1','2','3','4','5'));
    end if;

    //========== Update the database version number
    /* if the previous version number is less than 6 then add 65 to all mt.customiz.row values to compensate for the toolbar */
    set sbuf = (select version from mt.dbconfig);
    if (sbuf < '6') then
        update mt.customiz set row = (row+70);
    end if;

    update mt.dbconfig set version='7.01';
end;;
begin
    declare ntmp integer;
    //========== primary key management
    if (exists (select tname from sys.syscatalog where tname='customiz' and primary_key='Y'))then
        alter table mt.customiz drop primary key;
    end if;

    if exists(select tname from sys.sysindexes where iname = 'idx_cust') then
        drop index idx_cust;
    end if;
    if exists(select tname from sys.sysindexes where iname = 'customiz UNIQUE (fldnum)' and tname = 'customiz') then
        alter table mt.customiz drop unique (fldnum)
    else
        if exists (select tname from sys.sysindexes where iname = 'customiz UNIQUE (fldnum,fform)' and tname = 'customiz') then
            alter table mt.customiz drop unique (fldnum,fform)
        end if
    end if;
    message 'customiz block 1: ', 'start';
    // ========================================
    // mt.customiz table
    //
    //========== scopy
    if not exists (select cname from sys.syscolumns where cname='scopy' and tname='customiz') then
        alter table mt.customiz add scopy char(10) default 'OFF';
        update mt.customiz set scopy='';
    else
        alter table mt.customiz modify scopy char(10) default 'OFF';
        update mt.customiz set scopy='' where scopy is null;
    end if;
    update mt.customiz set scopy = 'OFF' where scopy is null;
    update mt.customiz set scopy = 'OFF' where scopy = 'off';
    update mt.customiz set scopy = 'ON' where scopy = 'on';
    update mt.customiz set scopy = 'OFF' where scopy = '';
    //========== nextfld
    update mt.customiz set nextfld = 0 where fldnum = '4201';
    //========== tooltip
    if not exists (select cname from sys.syscolumns where cname='tooltip' and tname='customiz') then
        alter table mt.customiz add tooltip char(48) default '';
        update mt.customiz set tooltip='';
    end if;
    //========== datacol
    if not exists (select cname from sys.syscolumns where cname='datacol' and tname='customiz') then
        alter table mt.customiz add datacol char(20) default NULL;
    end if;
    //========== ftype
    if not exists (select cname from sys.syscolumns where cname='ftype' and tname='customiz') then
        alter table mt.customiz add ftype char(8) default NULL;
        update mt.customiz set ftype = 'SPVAL' where ftype = 'BOOL';
    end if;
    //========== fform
    if not exists (select cname from sys.syscolumns where cname='fform' and tname='customiz') then
        alter table mt.customiz add fform integer default 0;
    end if;
    //========== postitle
    if not exists (select cname from sys.syscolumns where cname='postitle' and tname='customiz') then
        alter table mt.customiz add postitle char(1) default 'T';
    end if;
    //========== maxlen
    if not exists (select cname from sys.syscolumns where cname='maxlen' and tname='customiz') then
        alter table mt.customiz add maxlen integer default 1;
    end if;

    //========== dcopy
    if not exists (select cname from sys.syscolumns where cname='dcopy' and tname='customiz') then
        alter table mt.customiz add dcopy char(4) default 'OFF';
        update mt.customiz set dcopy = 'off';
    end if;
    update mt.customiz set dcopy = 'OFF' where dcopy is null;
    update mt.customiz set dcopy = 'OFF' where fldnum = '2320';
    update mt.customiz set dcopy = 'OFF' where dcopy = 'off';
    update mt.customiz set dcopy = 'OFF' where dcopy = '';
    //========== chkfunc
    if not exists (select cname from sys.syscolumns where cname='chkfunc' and tname='customiz')
    then
        // a column to tell if the field has a special "check function". ex: field 2303 has a special function to compute the due-date
        alter table mt.customiz add chkfunc char(1) default 'N';
        update mt.customiz set chkfunc = 'N';
    end if;
    //========== title2
    if not exists(select cname from sys.syscolumns where cname='title2' and tname='customiz') then
        alter table mt.customiz add title2 char(40);
    end if;
    //========== title3
    if not exists(select cname from sys.syscolumns where cname='title3' and tname='customiz') then
        alter table mt.customiz add title3 char(40);
    end if;
    //========== title4
    if not exists(select cname from sys.syscolumns where cname='title4' and tname='customiz') then
        alter table mt.customiz add title4 char(40);
    end if;
    //========== title5
    if not exists(select cname from sys.syscolumns where cname='title5' and tname='customiz') then
        alter table mt.customiz add title5 char(40);
    end if;
    //========== qrow
    if not exists (select cname from sys.syscolumns where cname='qrow' and tname='customiz')
    then
        alter table mt.customiz add qrow integer default 0;
        update mt.customiz set qrow = 0 where qrow is null;
        alter table mt.customiz modify qrow not null;
    end if;
    //========== qcol
    if not exists (select cname from sys.syscolumns where cname='qcol' and tname='customiz')
    then
        alter table mt.customiz add qcol integer default 0;
        update mt.customiz set qcol = 0 where qcol is null;
        alter table mt.customiz modify qcol not null;
    end if;
    //========== qsupp
    if not exists (select cname from sys.syscolumns where cname='qsupp' and tname='customiz') then
        alter table mt.customiz add qsupp char(1) default 'Y';
        update mt.customiz set qsupp = 'Y' where qsupp is null;
        alter table mt.customiz modify qsupp not null;
    end if;
    //========== desktop
    if exists (select cname from sys.syscolumns where cname='desktop' and tname='customiz') then
        alter table mt.customiz drop desktop;
    end if;

    update mt.customiz set fform='-1' where fform is null;
    alter table mt.customiz modify fldnum char(15);
    alter table mt.customiz modify fform integer not null default '-1';
    alter table mt.customiz add primary key (fldnum,fform);
    message 'customiz block 1: ', 'fini';

end;;
message 'customiz block 1: ', 'at commit';;
commit;;
// ==================================================
// This next block may seem redundant, but we needed to ensure all of the above 
// columns existed before we executed the following code which makes sure that all 
// of the colums in the mt.customiz table are arranged in the same order.  This 
// facilitates the use of the load table command.
//
begin
    declare vFldnum        	char(15);
    declare vtitle 			char(40);
    declare vsuppressed    	char(1);
    declare vIlevels       	char(3);
    declare vIreq  			char(1);
    declare vIdefault      	char(50);
    declare vSlevels       	char(3);
    declare vSreq  			char(1);
    declare vSdefault      	char(50);
    declare vScopy 			char(10);
    declare vvalidation    	char(8);
    declare vmerge 			char(1);
    declare vrow   			integer;
    declare vcol   			integer;
    declare vlen   			integer;
    declare vdatalen       	integer;
    declare vnextfld       	integer;
    declare vtooltip       	char(48);
    declare vdatacol       	char(20);
    declare vftype 			char(8);
    declare vfform 			integer;
    declare vpostitle      	char(1);
    declare vmaxlen        	integer;
    declare vdcopy 			char(4);
    declare vchkfunc       	char(1);
    declare vtitle2        	char(40);
    declare vtitle3        	char(40);
    declare vtitle4        	char(40);
    declare vtitle5        	char(40);
    declare vqrow  			integer;
    declare vqcol  			integer;
    declare vqsupp 			char(1);
    declare vUser           char(32);
    declare sout            char(30720);
	declare err_notfound exception for sqlstate value '02000';
    declare curcust dynamic scroll cursor for select "Fldnum","title" ,"suppressed","Ilevels","Ireq","Idefault",
        "Slevels","Sreq","Sdefault","Scopy","validation","merge","row",
        "col","len","datalen","nextfld","tooltip","datacol","ftype",
        "fform","postitle","maxlen","dcopy","chkfunc","title2","title3",
        "title4","title5","qrow","qcol","qsupp" from mt.customiz;
    declare curusers dynamic scroll cursor for select mtuser from mt.userlist;
 
    if (exists(select table_name from sys.systable where table_name = 'customiztemp' and table_type = 'BASE')) then
        drop table "mt"."customiztemp"
    end if;
    CREATE TABLE "mt"."customiztemp"
    (
	    "Fldnum"        	char(15) NOT NULL,
	    "title" 			char(40) NULL,
	    "suppressed"    	char(1) NOT NULL DEFAULT 'N',
	    "Ilevels"       	char(3) NULL DEFAULT '',
	    "Ireq"  			char(1) NOT NULL DEFAULT 'N',
	    "Idefault"      	char(50) NULL DEFAULT '',
	    "Slevels"       	char(3) NULL DEFAULT '',
	    "Sreq"  			char(1) NOT NULL DEFAULT 'N',
	    "Sdefault"      	char(50) NULL DEFAULT '',
	    "Scopy" 			char(10) NOT NULL DEFAULT 'OFF',
	    "validation"    	char(8) NULL DEFAULT 'never',
	    "merge" 			char(1) NULL DEFAULT 'X',
	    "row"   			integer NOT NULL DEFAULT 0,
	    "col"   			integer NOT NULL DEFAULT 0,
	    "len"   			integer NOT NULL DEFAULT 0,
	    "datalen"       	integer NOT NULL DEFAULT 0,
	    "nextfld"       	integer NOT NULL DEFAULT 0,
	    "tooltip"       	char(48) NULL DEFAULT '',
	    "datacol"       	char(20) NULL,
	    "ftype" 			char(8) NULL,
	    "fform" 			integer NOT NULL DEFAULT '-1',
	    "postitle"      	char(1) NULL DEFAULT 'T',
	    "maxlen"        	integer NULL DEFAULT 1,
	    "dcopy" 			char(4) NULL DEFAULT 'OFF',
	    "chkfunc"       	char(1) NULL DEFAULT 'N',
	    "title2"        	char(40) NULL,
	    "title3"        	char(40) NULL,
	    "title4"        	char(40) NULL,
	    "title5"        	char(40) NULL,
	    "qrow"  			integer NOT NULL DEFAULT 0,
	    "qcol"  			integer NOT NULL DEFAULT 0,
	    "qsupp" 			char(1) NOT NULL DEFAULT 'Y',
    );
    
    open curcust;
    zcopyloop: loop


        fetch next curcust into vFldnum,vtitle,vsuppressed,vIlevels,vIreq,vIdefault,
                vSlevels,vSreq,vSdefault,vScopy,vvalidation,vmerge,vrow,
                vcol,vlen,vdatalen,vnextfld,vtooltip,vdatacol,vftype,
                vfform,vpostitle,vmaxlen,vdcopy,vchkfunc,vtitle2,vtitle3,
                vtitle4,vtitle5,vqrow,vqcol,vqsupp;
        
        if sqlstate = err_notfound then
            leave zcopyloop
        end if;

        insert into "mt"."customiztemp" values (vFldnum,vtitle,vsuppressed,vIlevels,vIreq,vIdefault,
                vSlevels,vSreq,vSdefault,vScopy,vvalidation,vmerge,vrow,
                vcol,vlen,vdatalen,vnextfld,vtooltip,vdatacol,vftype,
                vfform,vpostitle,vmaxlen,vdcopy,vchkfunc,vtitle2,vtitle3,
                vtitle4,vtitle5,vqrow,vqcol,vqsupp);

    end loop zcopyloop;
    close curcust;

    drop table "mt"."customiz";

    CREATE TABLE "mt"."customiz"
    (
	    "Fldnum"        	char(15) NOT NULL,
	    "title" 			char(40) NULL,
	    "suppressed"    	char(1) NOT NULL DEFAULT 'N',
	    "Ilevels"       	char(3) NULL DEFAULT '',
	    "Ireq"  			char(1) NOT NULL DEFAULT 'N',
	    "Idefault"      	char(50) NULL DEFAULT '',
	    "Slevels"       	char(3) NULL DEFAULT '',
	    "Sreq"  			char(1) NOT NULL DEFAULT 'N',
	    "Sdefault"      	char(50) NULL DEFAULT '',
	    "Scopy" 			char(10) NOT NULL DEFAULT 'OFF',
	    "validation"    	char(8) NULL DEFAULT 'never',
	    "merge" 			char(1) NULL DEFAULT 'X',
	    "row"   			integer NOT NULL DEFAULT 0,
	    "col"   			integer NOT NULL DEFAULT 0,
	    "len"   			integer NOT NULL DEFAULT 0,
	    "datalen"       	integer NOT NULL DEFAULT 0,
	    "nextfld"       	integer NOT NULL DEFAULT 0,
	    "tooltip"       	char(48) NULL DEFAULT '',
	    "datacol"       	char(20) NULL,
	    "ftype" 			char(8) NULL,
	    "fform" 			integer NOT NULL DEFAULT '-1',
	    "postitle"      	char(1) NULL DEFAULT 'T',
	    "maxlen"        	integer NULL DEFAULT 1,
	    "dcopy" 			char(4) NULL DEFAULT 'OFF',
	    "chkfunc"       	char(1) NULL DEFAULT 'N',
	    "title2"        	char(40) NULL,
	    "title3"        	char(40) NULL,
	    "title4"        	char(40) NULL,
	    "title5"        	char(40) NULL,
	    "qrow"  			integer NOT NULL DEFAULT 0,
	    "qcol"  			integer NOT NULL DEFAULT 0,
	    "qsupp" 			char(1) NOT NULL DEFAULT 'Y',
	    PRIMARY KEY ("Fldnum", "fform")
    );

    COMMENT ON COLUMN "mt"."customiz"."Fldnum" IS
	    'Field ID.';
    COMMENT ON COLUMN "mt"."customiz"."title" IS
	    'Field Title.';
    COMMENT ON COLUMN "mt"."customiz"."suppressed" IS
	    'Suppressed field.';
    COMMENT ON COLUMN "mt"."customiz"."Ilevels" IS
	    'Creation access levels.';
    COMMENT ON COLUMN "mt"."customiz"."Ireq" IS
	    'Required on Creation.';
    COMMENT ON COLUMN "mt"."customiz"."Idefault" IS
	    'Creation default.';
    COMMENT ON COLUMN "mt"."customiz"."Slevels" IS
	    'access levels.';
    COMMENT ON COLUMN "mt"."customiz"."Sreq" IS
	    'required.';
    COMMENT ON COLUMN "mt"."customiz"."Sdefault" IS
	    'default value.';
    COMMENT ON COLUMN "mt"."customiz"."Scopy" IS
	    'Source Copy FieldTooltip Text';
    COMMENT ON COLUMN "mt"."customiz"."validation" IS
	    'Validation filename.';
    COMMENT ON COLUMN "mt"."customiz"."merge" IS
	    'Unused.';
    COMMENT ON COLUMN "mt"."customiz"."row" IS
	    'Display row.';
    COMMENT ON COLUMN "mt"."customiz"."col" IS
	    'Display Column.';
    COMMENT ON COLUMN "mt"."customiz"."len" IS
	    'length on display.';
    COMMENT ON COLUMN "mt"."customiz"."datalen" IS
	    'Number chars user can enter.';
    COMMENT ON COLUMN "mt"."customiz"."nextfld" IS
	    'Tab order.';
    COMMENT ON COLUMN "mt"."customiz"."tooltip" IS
	    'Tooltip Text';
    COMMENT ON COLUMN "mt"."customiz"."datacol" IS
	    'Column name in data table';
    COMMENT ON COLUMN "mt"."customiz"."ftype" IS
	    'The type of column';
    COMMENT ON COLUMN "mt"."customiz"."fform" IS
	    'The table the colummn is in';
    COMMENT ON COLUMN "mt"."customiz"."postitle" IS
	    'Is the title on the top(T) or on the left(L)';
    COMMENT ON COLUMN "mt"."customiz"."maxlen" IS
	    'maximum field length';
    COMMENT ON COLUMN "mt"."customiz"."dcopy" IS
	    'Destination Copy Field';
    
    COMMENT ON TABLE "mt"."customiz" IS
	    'Fluke Field customization Information.';

    open curusers;

    Zeroloop: loop
        fetch next curusers into vUser;
        if sqlstate = err_notfound then 
            leave Zeroloop
        end if;
		set sout = sout + 'GRANT SELECT ON "mt"."customiz" to ' + vUser + ';';
    end loop Zeroloop;
    close curusers;
    message sout;
    execute immediate (sout);

    execute immediate 'insert into "mt"."customiz" select * from "mt"."customiztemp"';

    drop table "mt"."customiztemp";
end;;

begin
    if (not exists (select table_id from sys.systable where table_name = 'valfield')) then 
        CREATE TABLE valfield
        (
	        Fldnum	char(15) NOT NULL,
	        val	char(128) default ' ',
        );
        grant select,insert,update,delete on mt.valfield to mtreports;
        // end create valfield
    end if;
    // ========================
    // add validation list item "Procedure" as an accepted value for TOL_REF
    delete from mt.valfield where fldnum=2318 and val like 'PROC%';
    insert into mt.valfield (Fldnum, val) values('2318', 'PROCEDURE');
    // ========================
end;;
begin
    if not exists (select table_id from sys.systable where table_name = 'vallink') then 
        create table vallink
        (
	        root char(15) PRIMARY KEY,
	        link1 char(15),
	        link2 char(15),
	        link3 char(15),
	        link4 char(15),
	        link5 char(15),
	        link6 char(15),
	        link7 char(15),
	        link8 char(15),
	        link9 char(15),
	        link10 char(15)
        );
        grant select on vallink to mtreports;
        //
    end if;
    if not exists (select table_id from sys.systable where table_name = 'vallinkdata') then
        create table vallinkdata
        (
	        root char(15) ,
	        rootdata char(64),
	        data1 char(64),
	        data2 char(64),
	        data3 char(64),
	        data4 char(64),
	        data5 char(64),
	        data6 char(64),
	        data7 char(64),
	        data8 char(64),
	        data9 char(64),
	        data10 char(64)
        );
        grant select,insert,update,delete on vallinkdata to mtreports;
    end if;
    if not exists (select table_id from sys.systable where table_name = 'holidays') then
        create table holidays
        (
	        holiday	date default current timestamp primary key
        );
        grant select on holidays to mtreports;
    end if;
    if not exists (select table_id from sys.systable where table_name = 'nonworkdays') then
        create table nonworkdays
        (
	        dayofweek char(10) default 'Sunday' primary key
        );
        grant select on nonworkdays to mtreports;
        //
    end if;
end;;
// ===============================================
// update the newer mtx stored procedures which are
// dependent on the dbconfig and mt.customiz tables.
// mtx_newcust
// mtx_add_or_alter_field
// mtx_cust_up
begin
    // =======================================
    // modify mtx_newcust
    //
    call mtxdropprocedure('mtx_newcust');
    CREATE procedure mt.mtx_newcust(in sfldnumber char(15),in sdatacol char(20),in stitle char(40),in sval char(8),in smerge char(1),in sfform char(4),in sftype char(8),in smaxlen char(5),in ssup char(1))
    begin
        if(exists(select fldnum from mt.customiz where fldnum = sfldnumber)) then
            message 'field exists',sfldnumber;
            return
        end if;
        insert into mt.customiz(fldnum,datacol,title,tooltip,suppressed,validation,merge,len,datalen,
                maxlen,fform,ftype) values(
                sfldnumber,sdatacol,stitle,stitle,ssup,sval,smerge,smaxlen,
                smaxlen,smaxlen,sfform,sftype);
        call mt.mtxmsg('mtx_newcust:',sfldnumber)
    end;
end;;
begin
    // =======================================
    // modify mtx_cust_up
    //
    call mtxdropprocedure('mtx_cust_up');
    CREATE procedure mt.mtx_cust_up(in sfldnum char(15),in sdatacol char(20),in sftype char(8),in smaxlen char(3),in sfform char(4))
    begin
        /*
        updates the datacol, ftype, maxlen and fform data in the database.
        designed for use after adding these new fields to the database.
        */
        update mt.customiz set datacol = sdatacol where fldnum = sfldnum and(datacol = '' or datacol is null);
        update mt.customiz set ftype = sftype where fldnum = sfldnum and(ftype = '' or ftype is null);
        update mt.customiz set maxlen = smaxlen where fldnum = sfldnum and(maxlen = 1 or maxlen is null);
        update mt.customiz set fform = sfform where fldnum = sfldnum and(fform < 1 or fform is null);
        call mtxmsg('mtx_cust_up:',sfldnum)
    end;
end;;
begin
    // =======================================
    // modify mtx_add_alter_field
    //
    call mtxdropprocedure('mtx_add_or_alter_field');
    CREATE procedure mt.mtx_add_or_alter_field(in sdatacol char(30),in stable char(50),in stype char(30),in sfldnumber char(15),in stitle char(40),in sval char(8),in smerge char(1),in sfform char(4),in sftype char(8),in smaxlen char(5),in ssup char(1))
    begin
        declare scmd char(2048);
        if(exists(select cname from sys.syscolumns where cname = sdatacol and tname = stable)) then
            /* // the column already exists so alter the atributes for the column and in the mt.customiz table.
            // note that the variable stype may contain any default value desired.
            */
            set scmd='alter table mt.'+stable+' modify '+sdatacol+' '+stype;
            execute immediate scmd;
            set scmd='update mt.customiz set maxlen='''+smaxlen+''' where fldnum='''+sfldnumber+'''';
            execute immediate scmd
        else
            set scmd='alter table mt.'+stable+' add '+sdatacol+' '+stype;
            execute immediate scmd;
            call mtx_newcust(sfldnumber,sdatacol,stitle,sval,smerge,sfform,sftype,smaxlen,ssup)
        end if
    end;
end;;
// ===============================================
// modify the table structure
//
begin
    declare ntmp integer;
    // ========================================
    // modify the standards table
    //
    set ntmp = (select length from sys.syscolumns where cname = 'mtag' and tname = 'standards' and creator = 'mt');
    if (ntmp < 80) then
        alter table mt.standards modify mtag char(80);
    end if;
    set ntmp = (select length from sys.syscolumns where cname = 'ctag' and tname = 'standards' and creator = 'mt');
    if (ntmp < 80) then
        alter table mt.standards modify ctag char(80);
    end if;
    set ntmp = (select length from sys.syscolumns where cname = 'C2430' and tname = 'standards' and creator = 'mt');
    if (ntmp < 80) then
        alter table mt.standards modify c2430 char(80);
    end if;
end;;
begin
    // ========================================
    // cal results
    //
    declare ntmp integer;
    // ========================================
    set ntmp = (select length from sys.syscolumns where cname = 'C2501' and tname = 'calresults' and creator = 'mt');
    if (ntmp <> 254) then
        alter table mt.calresults modify C2501 char(254);
    end if;
    update mt.customiz set maxlen='254',datalen='254' where fldnum='2501';
    call mtx_cust_up('2501', 'C2501','STRING', '254','64');
    // ========================================
    set ntmp = (select length from sys.syscolumns where cname = 'mtag' and tname = 'calresults' and creator = 'mt');
    if (ntmp < 80) then
        alter table mt.calresults modify mtag char(80);
    end if;
    // ========================================
    set ntmp = (select length from sys.syscolumns where cname = 'ctag' and tname = 'calresults' and creator = 'mt');
    if (ntmp < 80) then
        alter table mt.calresults modify ctag char(80);
    end if;
end;;
begin
    // ========================================
    // auxresults
    //
    call mtxdroptable('auxresults');
end;;
begin
    if (not exists (select table_name from sys.systable where table_name='calcombine' and table_type='BASE')) then
        create table mt.calcombine
            (
            "Order" char(3) default '',
            "Cal-Date" date default '',
            "Cal-Time" char(8) default '',
            "Pass" char(1) default '',
            "Procedure" char(128) default '',
            CTAG char(80) default ''
            );
        grant all on mt.calcombine to public;
    end if;

end;;
begin
    // ========================================
    //  Asset_Correlation 
    //;
    if (not exists (select table_name from sys.systable where table_name='Asset_Correlation' and table_type='BASE')) then
        create table mt.Asset_Correlation
            (
            ac_asset char(128) default '',
            ac_correlate char(128) default ''
            );
        grant all on mt.Asset_Correlation to mtreports;
        comment on table mt.Asset_Correlation is 'July 2002: Correlates existing asset names with alternate names.';
    end if;
end;;
begin
    call mtxdroptable('uncert_contr');
    // ========================================
    // results_raw
    //;
    if (not exists (select table_name from sys.systable where table_name='results_raw' and table_type='BASE')) then
        create table mt.results_raw
            (
            mtag char(80) default '',
            ctag char(80) not null,
            row_num integer not null,
            name char(32) not null,
            value char(32) default '',
            prefix char(1) default '',
            units char(16) default '',
            created timestamp default current timestamp,
            createdby char(16) default current user,
            logtime timestamp DEFAULT current timestamp,
            modifiedby char(16) default current user
            );
        grant all on mt.results_raw to mtreports;
        call mtx_newcust('name','name','name','never','X',128, 'SPVAL', 32,'Y');
        call mtx_newcust('value','value','value','never','X',128, 'SPVAL', 32,'Y');
        call mtx_newcust('prefix','prefix','prefix','never','X',128, 'SPVAL', 1,'Y');
        call mtx_newcust('units','units','units','never','X',128, 'SPVAL', 16,'Y');
        comment on table mt.results_raw is 'September 2001: uncertainty contribution table stores test uncertainties used by Fluke applications.';
    end if;
end;;
begin
    declare ntmp integer;
    // ========================================
    // results
    //
    if (not exists (select table_id from sys.systable where table_name = 'results' and table_type='base'))
	    then
	     create table mt.results
 		    (
		    row_num integer not null default -1,

		    test_desc char(254) default '',

            fixq char(32) default '',
            fixq_p char(1) default '',
            fixq_u char(16) default '',

            varq char(32) default '',
            varq_p char(1) default '',
            varq_u char(16) default '',

		    lower_limit char(32) default '',
		    lower_limit_p char(1) default '',
		    lower_limit_u char(16) default '',

		    upper_limit char(32) default '',
		    upper_limit_p char(1) default '',
		    upper_limit_u char(16) default '',

		    test_status char(32) default '',

		    exp_uncert char(32) default '',
		    exp_uncert_p char(1) default '',
		    exp_uncert_u char(16) default '',		

		    std_uncert char(32) default '',
		    std_uncert_p char(1) default '',
		    std_uncert_u char(16) default '',
		    
		    cov_fac char(32) default '',
		    condition char(32) default '',
		    remark char(254) default '',

            cpt char(32) default '',
            cpt_p char(1) default '',
            cpt_u char(16) default '',

            fix_flag integer default '1',

		    nominal char(32) default '',
		    nominal_p char(1) default '',
		    nominal_u char(16) default '',

		    mod1 char(32) default '',
		    mod1_p char(1) default '',
		    mod1_u char(16) default '',		

		    sys_actual char(32) default '',
		    sys_actual_p char(1) default '',
		    sys_actual_u char(16) default '',

		    corr_flag integer default '0',

		    uut_ind char(32) default '',
		    uut_ind_p char(1) default '',
		    uut_ind_u char(16) default '',

            expv char(32) default '',
            expv_p char(1) default '',
            expv_u char(16) default '',

		    measurement char(32) default '',
		    measurement_p char(1) default '',
		    measurement_u char(16) default '',

            meas_flag integer default '1',

            dev char(32) default '',
            dev_p char(1) default '',
            dev_u char(16) default '',

		    error char(32) default '',
		    error_p char(1) default '',
		    error_u char(16) default '',

            rel_err char(32) default '',
            rel_err_p char(1) default '',
            rel_err_u char(16) default '',

		    corr char(32) default '',
		    corr_p char(1) default '',
		    corr_u char(16) default '',

            corr_unc char(32) default '',
            corr_unc_p char(1) default '',
            corr_unc_u char(16) default '',

		    tol_ref char(32) default '',

		    tol_neg char(32) default '',
		    tol_neg_p char(1) default '',
		    tol_neg_u char(16) default '',	

		    tol_pos char(32) default '',
		    tol_pos_p char(1) default '',
		    tol_pos_u char(16) default '',		

		    tol char(32) default '',
		    tol_p char(1) default '',
		    tol_u char(16) default '',	

		    tur char(32) default '',

            tol_err char(32) default '',
            tol_err_p char(1) default '',
            tol_err_u char(16) default '',

            uncert_method char(32) default '',

            nthrow integer default '0',
            num_meas integer default '0',
		    
		    sdev char(32) default '',
		    sdev_p char(1) default '',
		    sdev_u char(16) default '',	
		    
		    noisy_flag integer default '0',

		    reliable_flag integer default '0',

            st_t char(32) default '',
            st_t_flag integer default '0',
            ws_flag integer default '0',

		    dominant integer default '0',
            
            df1 char(16) default '',
            df2 char(16) default '',
            df3 char(16) default '',
            df4 char(16) default '',
            df5 char(16) default '',
            df6 char(16) default '',
            df7 char(16) default '',
            df8 char(16) default '',
            df9 char(16) default '',
            df10 char(16) default '',
		    deg_free char(16) default '',

            u1 char(32) default '',
            u1_p char(1) default '',
            u1_u char(16) default '',

            u2 char(32) default '',
            u2_p char(1) default '',
            u2_u char(16) default '',

            u3 char(32) default '',
            u3_p char(1) default '',
            u3_u char(16) default '',

            u4 char(32) default '',
            u4_p char(1) default '',
            u4_u char(16) default '',

            u5 char(32) default '',
            u5_p char(1) default '',
            u5_u char(16) default '',

            u6 char(32) default '',
            u6_p char(1) default '',
            u6_u char(16) default '',

            u7 char(32) default '',
            u7_p char(1) default '',
            u7_u char(16) default '',

            u8 char(32) default '',
            u8_p char(1) default '',
            u8_u char(16) default '',

            u9 char(32) default '',
            u9_p char(1) default '',
            u9_u char(16) default '',

            u10 char(32) default '',
            u10_p char(1) default '',
            u10_u char(16) default '',

            c1 char(32) default '',
            c2 char(32) default '',
            c3 char(32) default '',
            c4 char(32) default '',
            c5 char(32) default '',
            c6 char(32) default '',
            c7 char(32) default '',
            c8 char(32) default '',
            c9 char(32) default '',
            c10 char(32) default '',

		    s1 char(32) default '',
		    s1_p char(1) default '',
		    s1_u char(16) default '',		

		    s2 char(32) default '',
		    s2_p char(1) default '',
		    s2_u char(16) default '',		

		    dom_uncert char(32) default '',
		    dom_uncert_p char(1) default '',
		    dom_uncert_u char(16) default '',

		    test_step char(128) default '',
		    fsc char(16) default '',
		    result_type char(32) default '',
            accred integer default '1',
            
            guardband_meth char(32) default '',

            guardband_ll char(32) default '',
            guardband_ll_p char(1) default '',
            guardband_ll_u char(16) default '',

            guardband_ul char(32) default '',
            guardband_ul_p char(1) default '',
            guardband_ul_u char(16) default '',

		    sys_acc char(32) default '',
		    sys_acc_p char(1) default '',
		    sys_acc_u char(16) default '',
		    
		    sys_cov_fac char(32) default '',

		    uut_range char(32) default '',
		    uut_range_p char(1) default '',
		    uut_range_u char(16) default '',

		    uut_res char(32) default '',
		    uut_res_p char(1) default '',
		    uut_res_u char(16) default '',

            sense char(32) default '',

            i_imped char(32) default '',
            i_imped_p char(1) default '',
            i_imped_u char(16) default '',

            o_imped1 char(32) default '',
            o_imped1_p char(1) default '',
            o_imped1_u char(16) default '',

            o_imped2 char(32) default '',
            o_imped2_p char(1) default '',
            o_imped2_u char(16) default '',

            wave1 char(32) default '',
            ampl1 char(32) default '',
            ampl1_p char(1) default '',
            ampl1_u char(16) default '',

            freq1 char(32) default '',
            freq1_p char(1) default '',
            freq1_u char(16) default '',

            per1 char(32) default '',
            per1_p char(1) default '',
            per1_u char(16) default '',

            pulse_width char(32) default '',
            pulse_width_p char(1) default '',
            pulse_width_u char(16) default '',

            dc_offset char(32) default '',
            dc_offset_p char(1) default '',
            dc_offset_u char(16) default '',

            duty_cycle char(32) default '',
            duty_cycle_p char(1) default '',
            duty_cycle_u char(16) default '',

            rise char(32) default '',
            rise_p char(1) default '',
            rise_u char(16) default '',

            fall char(32) default '',
            fall_p char(1) default '',
            fall_u char(16) default '',
            
            trigger_skew char(32) default '',
            trigger_skew_p char(1) default '',
            trigger_skew_u char(16) default '',

            video char(32) default '',
            polarity char(16) default '',

            rtd_type char(16) default '',
            rtd_nom_res char(32) default '',
            rtd_nom_res_p char(1) default '',
            rtd_nom_res_u char(16) default '',

            tc_type char(32) default '',

            mod_source char(16) default '',

            am_depth char(32) default '',
            am_depth_p char(1) default '',
            am_depth_u char(16) default '',

            fm_dev char(32) default '',
            fm_dev_p char(1) default '',
            fm_dev_u char(16) default '',

            phase_dev char(32) default '',
            phase_dev_p char(1) default '',
            phase_dev_u char(16) default '',

            wave2 char(32) default '',
            ampl2 char(32) default '',
            ampl2_p char(1) default '',
            ampl2_u char(16) default '',

            freq2 char(32) default '',
            freq2_p char(1) default '',
            freq2_u char(16) default '',

            per2 char(32) default '',
            per2_p char(1) default '',
            per2_u char(16) default '',

            "power" char(32) default '',
            power_p char(1) default '',
            power_u char(16) default '',

            phase char(32) default '',
            phase_p char(1) default '',
            phase_u char(16) default '',

            dpf char(16) default '',
            dpf_polarity char(16) default '',

		    mtag char(80) not null default '',
		    ctag char(80) not null default '',

            created timestamp default current timestamp,
            createdby char(16) default current user,
		    editlogtime timestamp default current timestamp,
            modifiedby char(16) default current user,

            test_step2 char(16) default ''
            
		    );
	    grant all on mt.results to mtreports;
        // ================================================================
        // note the args for mtx_newcust(omiz) are (fldnum, datacol, title, validation, merge, form, type, maxlen, suppressed)
	    //
        call mtx_newcust('accred','accred','Accredited','never','X','64', 'INT', '4','Y');
	    call mtx_newcust('am_depth','am_depth','AM Depth','never','X','64', 'SPVAL','32','Y');
	    call mtx_newcust('am_depth_p','am_depth_p','Prefix','never','X','64', 'SPVAL','1','Y');
	    call mtx_newcust('am_depth_u','am_depth_u','Units','never','X','64', 'SPVAL','16','Y');
	    call mtx_newcust('ampl1','ampl1','Amplitude 1','never','X','64', 'SPVAL','32','Y');
	    call mtx_newcust('ampl1_p','ampl1_p','Prefix','never','X','64', 'SPVAL','1','Y');
	    call mtx_newcust('ampl1_u','ampl1_u','Units','never','X','64', 'SPVAL','16','Y');
	    call mtx_newcust('ampl2','ampl2','Amplitude 2','never','X','64', 'SPVAL','32','Y');
	    call mtx_newcust('ampl2_p','ampl2_p','Prefix','never','X','64', 'SPVAL','1','Y');
	    call mtx_newcust('ampl2_u','ampl2_u','Units','never','X','64', 'SPVAL','16','Y');
        call mtx_newcust('c1','c1','Sensitivity 1','never','X','64','SPVAL','32','Y');
        call mtx_newcust('c2','c2','Sensitivity 2','never','X','64','SPVAL','32','Y');
        call mtx_newcust('c3','c3','Sensitivity 3','never','X','64','SPVAL','32','Y');
        call mtx_newcust('c4','c4','Sensitivity 4','never','X','64','SPVAL','32','Y');
        call mtx_newcust('c5','c5','Sensitivity 5','never','X','64','SPVAL','32','Y');
        call mtx_newcust('c6','c6','Sensitivity 6','never','X','64','SPVAL','32','Y');
        call mtx_newcust('c7','c7','Sensitivity 7','never','X','64','SPVAL','32','Y');
        call mtx_newcust('c8','c8','Sensitivity 8','never','X','64','SPVAL','32','Y');
        call mtx_newcust('c9','c9','Sensitivity 9','never','X','64','SPVAL','32','Y');
        call mtx_newcust('c10','c10','Sensitivity 10','never','X','64','SPVAL','32','Y');
	    call mtx_newcust('condition','condition','Condition','never','X','64', 'SPVAL','32','Y');
	    call mtx_newcust('corr_flag','corr_flag','Correction Flag','never','X','64', 'INT','1','Y');
	    call mtx_newcust('corr','corr','Correction','never','X','64', 'SPVAL','32','Y');
	    call mtx_newcust('corr_p','corr_p','Correction Prefix','never','X','64', 'SPVAL','1','Y');
	    call mtx_newcust('corr_u','corr_u','Correction Units','never','X','64', 'SPVAL','16','Y');
	    call mtx_newcust('corr_unc','corr_unc','Correction Uncertainty','never','X','64', 'SPVAL','32','Y');
	    call mtx_newcust('corr_unc_p','corr_unc_p','Prefix','never','X','64', 'SPVAL','1','Y');
	    call mtx_newcust('corr_unc_u','corr_unc_u','Units','never','X','64', 'SPVAL','16','Y');
	    call mtx_newcust('cov_fac','cov_fac','','never','X','64', 'SPVAL','32','Y');
	    call mtx_newcust('cpt','cpt','Cardinal Point','never','X','64', 'SPVAL','32','Y');
	    call mtx_newcust('cpt_p','cpt_p','Prefix','never','X','64', 'SPVAL','1','Y');
	    call mtx_newcust('cpt_u','cpt_u','Units','never','X','64', 'SPVAL','16','Y');
        call mtx_newcust('FCTAG','ctag','Unique Cal ID','never','X','64','SPVAL','80','Y');
	    call mtx_newcust('dc_offset','dc_offset','DC Offset','never','X','64', 'SPVAL','32','Y');
	    call mtx_newcust('dc_offset_p','dc_offset_p','Prefix','never','X','64', 'SPVAL','1','Y');
	    call mtx_newcust('dc_offset_u','dc_offset_u','Units','never','X','64', 'SPVAL','16','Y');
	    call mtx_newcust('dev','dev','Deviation','never','X','64', 'SPVAL','32','Y');
	    call mtx_newcust('dev_p','dev_p','dev_p','never','X','64', 'SPVAL','1','Y');
	    call mtx_newcust('dev_u','dev_u','dev_u','never','X','64', 'SPVAL','16','Y');
	    call mtx_newcust('deg_free','deg_free','deg_free','never','X','64', 'SPVAL','16','Y');
        call mtx_newcust('df1','df1','Degrees of Freedom 1','never','X','64','SPVAL','16','Y');
        call mtx_newcust('df2','df2','Degrees of Freedom 2','never','X','64','SPVAL','16','Y');
        call mtx_newcust('df3','df3','Degrees of Freedom 3','never','X','64','SPVAL','16','Y');
        call mtx_newcust('df4','df4','Degrees of Freedom 4','never','X','64','SPVAL','16','Y');
        call mtx_newcust('df5','df5','Degrees of Freedom 5','never','X','64','SPVAL','16','Y');
        call mtx_newcust('df6','df6','Degrees of Freedom 6','never','X','64','SPVAL','16','Y');
        call mtx_newcust('df7','df7','Degrees of Freedom 7','never','X','64','SPVAL','16','Y');
        call mtx_newcust('df8','df8','Degrees of Freedom 8','never','X','64','SPVAL','16','Y');
        call mtx_newcust('df9','df9','Degrees of Freedom 9','never','X','64','SPVAL','16','Y');
        call mtx_newcust('df10','df10','Degrees of Freedom 10','never','X','64','SPVAL','16','Y');
	    call mtx_newcust('dom_uncert','dom_uncert','dom_uncert','never','X','64', 'SPVAL','32','Y');
	    call mtx_newcust('dom_uncert_p','dom_uncert_p','dom_uncert_p','never','X','64', 'SPVAL','1','Y');
	    call mtx_newcust('dom_uncert_u','dom_uncert_p','dom_uncert_p','never','X','64', 'SPVAL','16','Y');
	    call mtx_newcust('dominant','dominant','Dominant','never','X','64', 'INT','1','Y');
	    call mtx_newcust('dpf','dpf','Displacement Power Factor','never','X','64', 'SPVAL','16','Y');
	    call mtx_newcust('dpf_polarity','dpf_polarity','DPF Polarity','never','X','64', 'SPVAL','16','Y');
        call mtx_newcust('duty_cycle','duty_cycle','Duty Cycle','never','X','64','SPVAL','32','Y');
        call mtx_newcust('duty_cycle_p','duty_cycle_p','Prefix','never','X','64','SPVAL','1','Y');
        call mtx_newcust('duty_cycle_u','duty_cycle_u','Units','never','X','64','SPVAL','16','Y');
	    call mtx_newcust('error','error','error','never','X','64', 'SPVAL','32','Y');
	    call mtx_newcust('error_p','error_p','error_p','never','X','64', 'SPVAL', '1','Y');
	    call mtx_newcust('error_u','error_u','error_u','never','X','64', 'SPVAL', '16','Y');
	    call mtx_newcust('exp_uncert','exp_uncert','exp_uncert','never','X','64', 'SPVAL', '32','Y');
	    call mtx_newcust('exp_uncert_p','exp_uncert_p','exp_uncert_p','never','X','64', 'SPVAL', '1','Y');
	    call mtx_newcust('exp_uncert_u','exp_uncert_u','exp_uncert_u','never','X','64', 'SPVAL', '16','Y');
        call mtx_newcust('expv','expv','Expected Value','never','X','64','SPVAL','32','Y');
        call mtx_newcust('expv_p','expv_p','Prefix','never','X','64','SPVAL','1','Y');
        call mtx_newcust('expv_u','expv_u','Units','never','X','64','SPVAL','16','Y');
        call mtx_newcust('fall','fall','Fall Time','never','X','64','SPVAL','32','Y');
        call mtx_newcust('fall_p','fall_p','Prefix','never','X','64','SPVAL','1','Y');
        call mtx_newcust('fall_u','fall_u','Units','never','X','64','SPVAL','16','Y');
	    call mtx_newcust('fix_flag','fix_flag','Fixed Flag','never','X','64', 'INT','1','Y');
        call mtx_newcust('fixq','fixq','Fixed Quantity','never','X','64','SPVAL','32','Y');
        call mtx_newcust('fixq_p','fixq_p','Prefix','never','X','64','SPVAL','1','Y');
        call mtx_newcust('fixq_u','fixq_u','Units','never','X','64','SPVAL','16','Y');
        call mtx_newcust('fm_dev','fm_dev','FM Deviation','never','X','64','SPVAL','32','Y');
        call mtx_newcust('fm_dev_p','fm_dev_p','Prefix','never','X','64','SPVAL','1','Y');
        call mtx_newcust('fm_dev_u','fm_dev_u','Units','never','X','64','SPVAL','16','Y');
        call mtx_newcust('freq1','freq1','Frequency 1','never','X','64','SPVAL','32','Y');
        call mtx_newcust('freq1_p','freq1_p','Prefix','never','X','64','SPVAL','1','Y');
        call mtx_newcust('freq1_u','freq1_u','Units','never','X','64','SPVAL','16','Y');
        call mtx_newcust('freq2','freq2','Frequency 2','never','X','64','SPVAL','32','Y');
        call mtx_newcust('freq2_p','freq2_p','Prefix','never','X','64','SPVAL','1','Y');
        call mtx_newcust('freq2_u','freq2_u','Units','never','X','64','SPVAL','16','Y');
	    call mtx_newcust('fsc','fsc','fsc','never','X','64', 'SPVAL', '16','Y');
        call mtx_newcust('guardband_meth','guardband_meth','Guardband Method','never','X','64','SPVAL','32','Y');
        call mtx_newcust('guardband_ll','guardband_ll','Guardband Lower Limit','never','X','64','SPVAL','32','Y');
        call mtx_newcust('guardband_ll_p','guardband_ll_p','Prefix','never','X','64','SPVAL','1','Y');
        call mtx_newcust('guardband_ll_u','guardband_ll_u','Units','never','X','64','SPVAL','16','Y');
        call mtx_newcust('guardband_ul','guardband_ul','Guardband Upper Limit','never','X','64','SPVAL','32','Y');
        call mtx_newcust('guardband_ul_p','guardband_ul_p','Prefix','never','X','64','SPVAL','1','Y');
        call mtx_newcust('guardband_ul_u','guardband_ul_u','Units','never','X','64','SPVAL','16','Y');
        call mtx_newcust('i_imped','i_imped','Input Impedance','never','X','64','SPVAL','32','Y');
        call mtx_newcust('i_imped_p','i_imped_p','Prefix','never','X','64','SPVAL','1','Y');
        call mtx_newcust('i_imped_u','i_imped_u','Units','never','X','64','SPVAL','16','Y');
	    call mtx_newcust('lower_limit','lower_limit','lower_limit','never','X','64', 'SPVAL','32','Y');
	    call mtx_newcust('lower_limit_p','lower_limit_p','lower_limit_p','never','X','64', 'SPVAL','1','Y');
	    call mtx_newcust('lower_limit_u','lower_limit_u','lower_limit_u','never','X','64', 'SPVAL','16','Y');
        call mtx_newcust('meas_flag','meas_flag','Measurement Flag','never','X','64','INT','1','Y');
        call mtx_newcust('measurement','measurement','measurement','never','X','64', 'SPVAL','32','Y');
	    call mtx_newcust('measurement_p','measurement_p','measurement_p','never','X','64', 'SPVAL','1','Y');
	    call mtx_newcust('measurement_u','measurement_u','measurement_u','never','X','64', 'SPVAL','16','Y');
	    call mtx_newcust('mod1','mod1','mod1','never','X','64', 'SPVAL','32','Y');
	    call mtx_newcust('mod1_p','mod1_p','mod1_p','never','X','64', 'SPVAL','1','Y');
	    call mtx_newcust('mod1_u','mod1_u','mod1_u','never','X','64', 'SPVAL','16','Y');
	    call mtx_newcust('mod_source','mod_source','Modulation Source','never','X','64', 'SPVAL','16','Y');
        call mtx_newcust('FMTAG','mtag','Unique Asset ID','never','X','64','SPVAL','80','Y');
	    call mtx_newcust('noisy_flag','noisy_flag','Noisy Flag','never','X','64', 'INT','1','Y');
        call mtx_newcust('nominal','nominal','nominal','never','X','64', 'SPVAL','32','Y');
	    call mtx_newcust('nominal_p','nominal_p','nominal_p','never','X','64', 'SPVAL','1','Y');
	    call mtx_newcust('nominal_u','nominal_u','nominal_u','never','X','64', 'SPVAL','16','Y');
	    call mtx_newcust('nthrow','nthrow','Number of Measurements Discarded','never','X','64', 'INT', '4','Y');
	    call mtx_newcust('num_meas','num_meas','Number of Measurements','never','X','64', 'INT', '4','Y');
        call mtx_newcust('o_imped1','o_imped1','Output Impedance 1','never','X','64','SPVAL','32','Y');
        call mtx_newcust('o_imped1_p','o_imped1_p','Prefix','never','X','64','SPVAL','1','Y');
        call mtx_newcust('o_imped1_u','o_imped1_u','Units','never','X','64','SPVAL','16','Y');
        call mtx_newcust('o_imped2','o_imped2','Output Impedance 2','never','X','64','SPVAL','32','Y');
        call mtx_newcust('o_imped2_p','o_imped2_p','Prefix','never','X','64','SPVAL','1','Y');
        call mtx_newcust('o_imped2_u','o_imped2_u','Units','never','X','64','SPVAL','16','Y');
        call mtx_newcust('per1','per1','Period 1','never','X','64','SPVAL','32','Y');
        call mtx_newcust('per1_p','per1_p','Prefix','never','X','64','SPVAL','1','Y');
        call mtx_newcust('per1_u','per1_u','Units','never','X','64','SPVAL','16','Y');
        call mtx_newcust('per2','per2','Period 2','never','X','64','SPVAL','32','Y');
        call mtx_newcust('per2_p','per2_p','Prefix','never','X','64','SPVAL','1','Y');
        call mtx_newcust('per2_u','per2_u','Units','never','X','64','SPVAL','16','Y');
        call mtx_newcust('phase','phase','Phase','never','X','64','SPVAL','32','Y');
        call mtx_newcust('phase_p','phase_p','Prefix','never','X','64','SPVAL','1','Y');
        call mtx_newcust('phase_u','phase_u','Units','never','X','64','SPVAL','16','Y');
        call mtx_newcust('phase_dev','phase_dev','Phase Deviation','never','X','64','SPVAL','32','Y');
        call mtx_newcust('phase_dev_p','phase_dev_p','Prefix','never','X','64','SPVAL','1','Y');
        call mtx_newcust('phase_dev_u','phase_dev_u','Units','never','X','64','SPVAL','16','Y');
        call mtx_newcust('polarity','polarity','Polarity','never','X','64','SPVAL','16','Y');
        call mtx_newcust('power','power','Power','never','X','64','SPVAL','32','Y');
        call mtx_newcust('power_p','power_p','Prefix','never','X','64','SPVAL','1','Y');
        call mtx_newcust('power_u','power_u','Units','never','X','64','SPVAL','16','Y');
        call mtx_newcust('pulse_width','pulse_width','Pulse Width','never','X','64','SPVAL','32','Y');
        call mtx_newcust('pulse_width_p','pulse_width_p','Prefix','never','X','64','SPVAL','1','Y');
        call mtx_newcust('pulse_width_u','pulse_width_u','Units','never','X','64','SPVAL','16','Y');
        call mtx_newcust('rel_err','rel_err','Relative Error','never','X','64','SPVAL','32','Y');
        call mtx_newcust('rel_err_p','rel_err_p','Prefix','never','X','64','SPVAL','1','Y');
        call mtx_newcust('rel_err_u','rel_err_u','Units','never','X','64','SPVAL','16','Y');
	    call mtx_newcust('reliable_flag','reliable_flag','Reliable Flag','never','X','64', 'INT', '2','Y');
	    call mtx_newcust('remark','remark','remark','never','X','64', 'SPVAL', '254','Y');
	    call mtx_newcust('result_type','result_type','Result Type','never','X','64', 'SPVAL','32','Y');
        call mtx_newcust('rise','rise','Rise Time','never','X','64','SPVAL','32','Y');
        call mtx_newcust('rise_p','rise_p','Prefix','never','X','64','SPVAL','1','Y');
        call mtx_newcust('rise_u','rise_u','Units','never','X','64','SPVAL','16','Y');
        call mtx_newcust('row_num','row_num','Row ID','never','X','64', 'INT', '4','Y');
        call mtx_newcust('rtd_nom_res','rtd_nom_res','RTD Nominal Resistance','never','X','64','SPVAL','32','Y');
        call mtx_newcust('rtd_nom_res_p','rtd_nom_res_p','Prefix','never','X','64','SPVAL','1','Y');
        call mtx_newcust('rtd_nom_res_u','rtd_nom_res_u','Units','never','X','64','SPVAL','16','Y');
        call mtx_newcust('rtd_type','rtd_type','RTD Type','never','X','64','SPVAL','16','Y');
	    call mtx_newcust('s1','s1','s1','never','X','64', 'SPVAL','32','Y');
	    call mtx_newcust('s1_p','s1_p','s1_p','never','X','64', 'SPVAL','1','Y');
	    call mtx_newcust('s1_u','s1_u','s1_u','never','X','64', 'SPVAL','16','Y');
	    call mtx_newcust('s2','s2','s2','never','X','64', 'SPVAL','32','Y');
	    call mtx_newcust('s2_p','s2_p','s2_p','never','X','64', 'SPVAL','1','Y');
	    call mtx_newcust('s2_u','s2_u','s2_u','never','X','64', 'SPVAL','16','Y');
        call mtx_newcust('sense','sense','Sense','never','X','64','SPVAL','32','Y');
        call mtx_newcust('st_t','st_t','Students T','never','X','64','SPVAL','32','Y');
	    call mtx_newcust('st_t_flag','st_t_flag','Students T Flag','never','X','64', 'INT', '2','Y');
	    call mtx_newcust('sdev','sdev','sdev','never','X','64', 'SPVAL','32','Y');
	    call mtx_newcust('sdev_p','sdev_p','sdev_p','never','X','64', 'SPVAL','1','Y');
	    call mtx_newcust('sdev_u','sdev_u','sdev_u','never','X','64', 'SPVAL','16','Y');
	    call mtx_newcust('std_uncert','std_uncert','std_uncert','never','X','64', 'SPVAL','32','Y');
	    call mtx_newcust('std_uncert_p','std_uncert_p','std_uncert_p','never','X','64', 'SPVAL','1','Y');
	    call mtx_newcust('std_uncert_u','std_uncert_u','std_uncert_u','never','X','64', 'SPVAL','16','Y');
	    call mtx_newcust('sys_acc','sys_acc','sys_acc','never','X','64', 'SPVAL','32','Y');
	    call mtx_newcust('sys_acc_p','sys_acc_p','sys_acc_p','never','X','64', 'SPVAL','1','Y');
	    call mtx_newcust('sys_acc_u','sys_acc_u','sys_acc_u','never','X','64', 'SPVAL','16','Y');
	    call mtx_newcust('sys_actual','sys_actual','sys_actual','never','X','64', 'SPVAL','32','Y');
	    call mtx_newcust('sys_actual_p','sys_actual_p','sys_actual_p','never','X','64', 'SPVAL','1','Y');
	    call mtx_newcust('sys_actual_u','sys_actual_u','sys_actual_u','never','X','64', 'SPVAL','16','Y');
        call mtx_newcust('sys_cov_fac','sys_cov_fac','System Coverage Factor','never','X','64','SPVAL','32','Y');
        call mtx_newcust('tc_type','tc_type','Thermocouple Type','never','X','64','SPVAL','32','Y');
	    call mtx_newcust('test_desc','test_desc','test_desc','never','X','64', 'SPVAL', '254','Y');
	    call mtx_newcust('test_status','test_status','status','never','X','64', 'SPVAL','8','Y');
	    call mtx_newcust('test_step','test_step','test_step','never','X','64', 'SPVAL', '128','Y');
	    call mtx_newcust('test_step2','test_step2','test_step2','never','X','64', 'SPVAL', '16','Y');
	    call mtx_newcust('tol','tol','Test Tolerance','never','X','64', 'SPVAL','32','Y');
	    call mtx_newcust('tol_p','tol_p','Prefix','never','X','64', 'SPVAL','1','Y');
	    call mtx_newcust('tol_u','tol_u','Units','never','X','64', 'SPVAL','16','Y');
        call mtx_newcust('tol_err','tol_err','Tolerance Error','never','X','64','SPVAL','32','Y');
        call mtx_newcust('tol_err_p','tol_err_p','Prefix','never','X','64','SPVAL','1','Y');
        call mtx_newcust('tol_err_u','tol_err_u','Units','never','X','64','SPVAL','16','Y');
	    call mtx_newcust('tol_neg','tol_neg','tol_neg','never','X','64', 'SPVAL','32','Y');
	    call mtx_newcust('tol_neg_p','tol_neg_p','tol_neg_p','never','X','64', 'SPVAL','1','Y');
	    call mtx_newcust('tol_neg_u','tol_neg_u','tol_neg_u','never','X','64', 'SPVAL','16','Y');
	    call mtx_newcust('tol_pos','tol_pos','tol_pos','never','X','64', 'SPVAL','32','Y');
	    call mtx_newcust('tol_pos_p','tol_pos_p','tol_pos_p','never','X','64', 'SPVAL','1','Y');
	    call mtx_newcust('tol_pos_u','tol_pos_u','tol_pos_u','never','X','64', 'SPVAL','16','Y');
	    call mtx_newcust('tol_ref','tol_ref','tol_ref','never','X','64', 'SPVAL','32','Y');
        call mtx_newcust('trigger_skew','trigger_skew','Trigger Skew','never','X','64','SPVAL','32','Y');
        call mtx_newcust('trigger_skew_p','trigger_skew_p','Prefix','never','X','64','SPVAL','1','Y');
        call mtx_newcust('trigger_skew_u','trigger_skew_u','Units','never','X','64','SPVAL','16','Y');
	    call mtx_newcust('tur','tur','TUR','never','X','64', 'SPVAL','32','Y');
	    call mtx_newcust('u1','u1','u1','never','X','64', 'SPVAL','32','Y');
	    call mtx_newcust('u1_p','u1_p','Prefix','never','X','64', 'SPVAL','1','Y');
	    call mtx_newcust('u1_u','u1_u','Units','never','X','64', 'SPVAL','16','Y');
	    call mtx_newcust('u2','u2','u2','never','X','64', 'SPVAL','32','Y');
	    call mtx_newcust('u2_p','u2_p','Prefix','never','X','64', 'SPVAL','1','Y');
	    call mtx_newcust('u2_u','u2_u','Units','never','X','64', 'SPVAL','16','Y');
	    call mtx_newcust('u3','u3','u3','never','X','64', 'SPVAL','32','Y');
	    call mtx_newcust('u3_p','u3_p','Prefix','never','X','64', 'SPVAL','1','Y');
	    call mtx_newcust('u3_u','u3_u','Units','never','X','64', 'SPVAL','16','Y');
	    call mtx_newcust('u4','u4','u4','never','X','64', 'SPVAL','32','Y');
	    call mtx_newcust('u4_p','u4_p','Prefix','never','X','64', 'SPVAL','1','Y');
	    call mtx_newcust('u4_u','u4_u','Units','never','X','64', 'SPVAL','16','Y');
	    call mtx_newcust('u5','u5','u5','never','X','64', 'SPVAL','32','Y');
	    call mtx_newcust('u5_p','u5_p','Prefix','never','X','64', 'SPVAL','1','Y');
	    call mtx_newcust('u5_u','u5_u','Units','never','X','64', 'SPVAL','16','Y');
	    call mtx_newcust('u6','u6','u6','never','X','64', 'SPVAL','32','Y');
	    call mtx_newcust('u6_p','u6_p','Prefix','never','X','64', 'SPVAL','1','Y');
	    call mtx_newcust('u6_u','u6_u','Units','never','X','64', 'SPVAL','16','Y');
	    call mtx_newcust('u7','u7','u7','never','X','64', 'SPVAL','32','Y');
	    call mtx_newcust('u7_p','u7_p','Prefix','never','X','64', 'SPVAL','1','Y');
	    call mtx_newcust('u7_u','u7_u','Units','never','X','64', 'SPVAL','16','Y');
	    call mtx_newcust('u8','u8','u8','never','X','64', 'SPVAL','32','Y');
	    call mtx_newcust('u8_p','u8_p','Prefix','never','X','64', 'SPVAL','1','Y');
	    call mtx_newcust('u8_u','u8_u','Units','never','X','64', 'SPVAL','16','Y');
	    call mtx_newcust('u9','u9','u9','never','X','64', 'SPVAL','32','Y');
	    call mtx_newcust('u9_p','u9_p','Prefix','never','X','64', 'SPVAL','1','Y');
	    call mtx_newcust('u9_u','u9_u','Units','never','X','64', 'SPVAL','16','Y');
	    call mtx_newcust('u10','u10','u10','never','X','64', 'SPVAL','32','Y');
	    call mtx_newcust('u10_p','u10_p','Prefix','never','X','64', 'SPVAL','1','Y');
	    call mtx_newcust('u10_u','u10_u','Units','never','X','64', 'SPVAL','16','Y');
        call mtx_newcust('uncert_method','uncert_method','Uncert Method','never','X','64','SPVAL','32','Y');
	    call mtx_newcust('upper_limit','upper_limit','Upper Limit','never','X','64', 'SPVAL','32','Y');
	    call mtx_newcust('upper_limit_p','upper_limit_p','Upper Limit_p','never','X','64', 'SPVAL','1','Y');
	    call mtx_newcust('upper_limit_u','upper_limit_u','Upper Limit_u','never','X','64', 'SPVAL','16','Y');
	    call mtx_newcust('uut_ind','uut_ind','uut_ind','never','X','64', 'SPVAL','32','Y');
	    call mtx_newcust('uut_ind_p','uut_ind_p','uut_ind_p','never','X','64', 'SPVAL','1','Y');
	    call mtx_newcust('uut_ind_u','uut_ind_u','uut_ind_u','never','X','64', 'SPVAL','16','Y');
	    call mtx_newcust('uut_range','uut_range','uut_range','never','X','64', 'SPVAL','32','Y');
	    call mtx_newcust('uut_range_p','uut_range_p','uut_range_p','never','X','64', 'SPVAL','1','Y');
	    call mtx_newcust('uut_range_u','uut_range_u','uut_range_u','never','X','64', 'SPVAL', '16','Y');
	    call mtx_newcust('uut_res','uut_res','uut_res','never','X','64', 'SPVAL','32','Y');
	    call mtx_newcust('uut_res_p','uut_res_p','uut_res_p','never','X','64', 'SPVAL','1','Y');
	    call mtx_newcust('uut_res_u','uut_res_u','uut_res_u','never','X','64', 'SPVAL','16','Y');
        call mtx_newcust('varq','varq','Variable Quantity','never','X','64','SPVAL','32','Y');
        call mtx_newcust('varq_p','varq_p','Prefix','never','X','64','SPVAL','1','Y');
        call mtx_newcust('varq_u','varq_u','Units','never','X','64','SPVAL','16','Y');
        call mtx_newcust('video','video','Video','never','X','64','SPVAL','32','Y');
        call mtx_newcust('wave1','wave1','Wave1','never','X','64','SPVAL','32','Y');
        call mtx_newcust('wave2','wave2','Wave2','never','X','64','SPVAL','32','Y');
	    call mtx_newcust('ws_flag','ws_flag','W-S Flag','never','X','64', 'INT', '2','Y');
        call mtx_newcust('created','created','Date Time Entered','never','X','64','RO','20','Y');
        call mtx_newcust('created','created','Entered by','never','X','64','RO','16','Y');
        call mtx_newcust('editlogtime','editlogtime','Date Time Modified','never','X','64','RO','20','Y');
        call mtx_newcust('modifiedby','mdifiedby','Modified by','never','X','64','RO','16','Y');
        comment on table mt.results is 'May 2002: full results table used by Fluke applications.';
    else
        set ntmp = (select length from sys.syscolumns where cname = 'remark' and tname = 'results' and creator = 'mt');
        if (ntmp <> 254) then
            alter table mt.results modify remark char(254) default '';
        end if;
        set ntmp = (select length from sys.syscolumns where cname = 'test_desc' and tname = 'results' and creator = 'mt');
        if (ntmp <> 254) then
            alter table mt.results modify test_desc char(254) default '';
        end if;
        set ntmp = (select length from sys.syscolumns where cname = 'test_step' and tname = 'results' and creator = 'mt');
        if (ntmp <> 128) then
            alter table mt.results modify test_step char(128) default '';
        end if;
        update mt.customiz set fform = 64 where datacol = 'test_step';
    end if;
end;;
// ================================================================
//  UserList
begin
    
    if (not exists(select cname from sys.syscolumns where tname = 'userlist' and cname = 'rate'))
    then
        alter table mt.userlist add rate decimal(12,2) default 0.00;
        update mt.userlist set rate = 0.00 where rate is null;
	end if;    
    if (not exists(select cname from sys.syscolumns where tname = 'userlist' and cname = 'ChangeDate'))
    then
        Alter table mt.userlist add ChangeDate Timestamp default current timestamp;
	    grant select, update("ChangeDate") on mt.userlist to public;
	end if;    
    if (not exists(select cname from sys.syscolumns where tname = 'userlist' and cname = 'ForceChange'))
    then
	    Alter table mt.userlist add ForceChange TinyInt;
	    grant select, update("ForceChange") on mt.userlist to public;
	    update mt.userlist set forcechange = '0';
	end if;    
    if (not exists(select cname from sys.syscolumns where tname = 'userlist' and cname = 'maxage'))
    then
        Alter table mt.userlist add MaxAge integer Default '0';
	    update mt.userlist set maxage = '0';
	end if;    
    if (not exists(select cname from sys.syscolumns where tname = 'userlist' and cname = 'MinAge'))
    then
	    Alter table mt.userlist add MinAge integer Default '0';
	    update mt.userlist set minage = '0';
	end if;    
    if (not exists(select cname from sys.syscolumns where tname = 'userlist' and cname = 'MinLength'))
    then
	    Alter table mt.userlist add MinLength integer Default '0';
	    update mt.userlist set minlength = '0';
	end if;    
    if (not exists(select cname from sys.syscolumns where tname = 'userlist' and cname = 'TaskPermission'))
    then
	    Alter table mt.userlist add TaskPermission integer Default '0';	
	    Update mt.userlist set TaskPermission = 7    where mtlevel = 0;
	    Update mt.userlist set TaskPermission = 31   where mtlevel = 1;
	    Update mt.userlist set TaskPermission = 263  where mtlevel = 2;
	    Update mt.userlist set TaskPermission = 895  where mtlevel = 3;
	    Update mt.userlist set TaskPermission = 1023 where mtlevel > 3;
	end if;    
    if (exists(select cname from sys.syscolumns where tname = 'userlist' and cname = 'LastDesktop'))
    then
	    Alter table mt.userlist drop LastDesktop;
	end if;    
end;;
begin
    declare ntmp integer;
    message 'calibration block 1: ', 'start';
    // ========================================
    // calibration
    // note the args for mtx_newcust(omiz) are (fldnum, datacol, title, validation, merge, form, type, maxlen, suppressed)
    //
    // ================================================================
    call mtx_newcust('CCTAG','CTAG','Cal Unique ID'   ,'never','X',4,  'RO','80','Y');
    call mtx_newcust('CMTAG','MTAG','Cal Asset  ID'   ,'never','X',4,  'RO','80','Y');
    call mtx_newcust('CDSRC','CDSRC','Cal Data Source','never','X','4','RO', '3','Y');
    call mtx_newcust('CPUBLISH','CPUBLISH','Publisher','never','X','4','RO','32','Y');
    // ================================================================
	if exists(select fldnum from mt.customiz where fldnum = '2390' and len = 5) then
        delete from customiz where fldnum like '2390';
    end if;
	if exists(select fldnum from mt.customiz where fldnum = '2391' and len = 5) then
        delete from customiz where fldnum like '2391';
    end if;
	if exists(select fldnum from mt.customiz where fldnum = '2392' and len = 5) then
        delete from customiz where fldnum like '2392';
    end if;
	if exists(select fldnum from mt.customiz where fldnum = '2393' and len = 5) then
        delete from customiz where fldnum like '2393';
    end if;
	if exists(select fldnum from mt.customiz where fldnum = '2394' and len = 5) then
        delete from customiz where fldnum like '2394';
    end if;
	if exists(select fldnum from mt.customiz where fldnum = '2395' and len = 5) then
        delete from customiz where fldnum like '2395';
    end if;

    set ntmp = (select length from sys.syscolumns where cname = 'ctag' and tname = 'calibration' and creator = 'mt');
    if (ntmp < 80) then
        alter table mt.calibration modify ctag char(80);
        update mt.customiz set maxlen='80' where fldnum='CCTAG';
    end if;
    // ================================================================
    set ntmp = (select length from sys.syscolumns where cname = 'mtag' and tname = 'calibration' and creator = 'mt');
    if (ntmp < 80) then
        alter table mt.calibration modify mtag char(80);
        update mt.customiz set maxlen='80' where fldnum='CMTAG';
    end if;
    // ================================================================
    if (not exists(select cname from sys.syscolumns where cname='CPUBLISH' and tname='calibration'))then
        alter table mt.calibration add CPUBLISH char(32);
        update mt.calibration set cpublish  = 'mtrack';
    end if;
    alter table mt.calibration modify CPUBLISH null;
    // ================================================================
    if exists (select cname from sys.syscolumns where cname = 'DSRC' and tname = 'calibration'  and creator = 'mt') then
        alter table calibration rename dsrc to cdsrc;
    end if;
    if not exists  ( select cname from sys.syscolumns where cname = 'CDSRC' and tname = 'calibration' ) then
        alter table mt.calibration add CDSRC char(3) default NULL;
        update mt.calibration set CDSRC = 'PRE';
    end if;
    // ================================================================
    call mtx_cust_up('2301' ,'C2301','DATE'     ,'10', '4');
    update mt.customiz set validation='never' where fldnum='2301';
    // ================================================================
    call mtx_cust_up('2302' ,'C2302','INT'       , '3', '4');
    update mt.customiz set ftype = 'INT',maxlen=4,datalen=4 where fldnum='2302';
    // ================================================================
    call mtx_cust_up('2303' ,'C2303','DATE'     ,'10', '4');
    call mtx_cust_up('2304' ,'C2304','SPVAL'    , '3', '4');
    call mtx_cust_up('2306' ,'C2306','DATE'     ,'10', '4');
    // ================================================================
    set ntmp = (select length from sys.syscolumns where cname = 'C2307' and tname='calibration' and creator = 'mt');
    if (ntmp < 20) then
        alter table mt.calibration modify C2307 char(20);
        update mt.customiz set maxlen='20',datalen='20' where fldnum='2307';
    end if;
    call mtx_cust_up('2307' ,'C2307','SPVAL'    ,'20', '4');
    // ================================================================
    if (not exists(select cname from sys.syscolumns where cname='C2308' and tname='calibration'))then
        alter table mt.calibration add C2308 char(10);
	    call mtx_newcust('2308','C2308','Found/Left','fixed','X',4, 'SPVAL', 10,'Y');
    end if;
    call mtx_cust_up('2308' ,'C2308','SPVAL'    ,'10', '4');
    update mt.customiz set validation='fixed' where fldnum='2308';
    // ================================================================
    set ntmp = (select length from sys.syscolumns where cname = 'C2309' and tname = 'calibration' and creator = 'mt');
    if (ntmp < 12) then
        alter table mt.calibration modify C2309 decimal(12, 2) default NULL;
        update mt.customiz set maxlen = '13' where fldnum='2309';
    end if;
    call mtx_cust_up('2309' ,'C2309','RO'       ,'10', '4');
    // ================================================================
    set ntmp = (select length from sys.syscolumns where cname = 'C2310' and tname = 'calibration' and creator = 'mt');
    alter table mt.calibration modify C2310 decimal(5, 1) default NULL;
    update mt.customiz set maxlen = '6' where fldnum='2310';
    call mtx_cust_up('2310' ,'C2310','RO'       , '5', '4');
    // ================================================================
    set ntmp = (select length from sys.syscolumns where cname = 'C2311' and tname = 'calibration' and creator = 'mt');
    alter table mt.calibration modify C2311 decimal(6, 2) default NULL;
    update mt.customiz set maxlen = '8',datalen='8',len='5' where fldnum='2311';
    call mtx_cust_up('2311' ,'C2311','DECIMAL4' , '7', '4');
    // ================================================================
    set ntmp = (select length from sys.syscolumns where cname = 'C2312' and tname = 'calibration' and creator = 'mt');
    if (ntmp < 6) then
        alter table mt.calibration modify C2312 decimal(6, 2) default NULL;
        update mt.customiz set maxlen = '8',datalen='8',len='5' where fldnum='2312';
    end if;
    call mtx_cust_up('2312' ,'C2312','INT'      , '7', '4');
    // ================================================================
    set ntmp = (select length from sys.syscolumns where cname = 'C2313' and tname='calibration' and creator='mt');
    if (ntmp < 15) then
        alter table mt.calibration modify C2313 char(15);
        update mt.customiz set maxlen='15' where fldnum='2313';
    end if;
    call mtx_cust_up('2313' ,'C2313','SPVAL'    ,'15', '4');
    // ================================================================
    set ntmp = (select length from sys.syscolumns where cname = 'C2314' and tname='calibration' and creator='mt');
    if (ntmp < 16) then
        alter table mt.calibration modify C2314 char(16);
        update mt.customiz set maxlen='16',datalen='16' where fldnum='2314';
    end if;
    call mtx_cust_up('2314' ,'C2314','SPVAL'    ,'16', '4');
    // ================================================================
    if (not exists(select cname from sys.syscolumns where cname = 'C2315' and tname = 'calibration' and creator = 'mt')) then
        alter table mt.calibration add C2315 decimal(5,1) default NULL;
        call mt.mtx_newcust('2315','C2315','TUR Limit','never','X','4','DECIMAL4','6','Y');
    else
        set ntmp = (select length from sys.syscolumns where cname = 'C2315' and tname = 'calibration' and creator = 'mt');
        alter table mt.calibration modify C2315 decimal(5, 1) default NULL;
        update mt.customiz set maxlen = '6' where fldnum='2315';
    end if;
    call mtx_cust_up('2315' ,'C2315','DECIMAL4' , '6', '4');
    // ================================================================
    call mtx_cust_up('2316' ,'C2316','DATE'     ,'10', '4');
    // ================================================================
    if (not exists(select cname from sys.syscolumns where cname = 'C2317' and tname = 'calibration' and creator = 'mt')) then
        alter table mt.calibration add C2317 decimal(5,1) default NULL;
        call mt.mtx_newcust('2317','C2317','OOT Limit','never','X','4','DECIMAL4','6','Y');
    else
        set ntmp = (select length from sys.syscolumns where cname = 'C2317' and tname = 'calibration' and creator = 'mt');
        alter table mt.calibration modify C2317 decimal(5, 1) default NULL;
        update mt.customiz set maxlen = '6' where fldnum='2317';
    end if;
    call mtx_cust_up('2317' ,'C2317','DECIMAL4' , '6', '4');
    // ================================================================
    if (not exists(select cname from sys.syscolumns where cname = 'C2318' and tname = 'calibration' and creator = 'mt')) then
        alter table mt.calibration add C2318 char(13) default NULL;
        call mt.mtx_newcust('2318','C2318','Tol ref','fixed','X','4','SPVAL','13','Y');
    end if;
    call mtx_cust_up('2318' ,'C2318','SPVAL'    ,'13', '4');
    // ================================================================
    if not exists  ( select cname from sys.syscolumns where cname = 'C2319' and tname = 'calibration' and creator = 'mt') then
        alter table mt.calibration add C2319 char(1) DEFAULT 'N';
        update mt.calibration set C2319 = 'N';
        call mt.mtx_newcust('2319','C2319','Pass100','fixed','X','4','SPVAL','1','Y');
    end if;
    call mtx_cust_up('2319' ,'C2319','SPVAL'    , '1', '4');
    // ================================================================
    set ntmp = (select length from sys.syscolumns where cname = 'C2320' and tname='calibration' and creator='mt');
    if (ntmp < 128) then
        alter table mt.calibration modify C2320 char(128);
        update mt.customiz set maxlen='128',datalen='128' where fldnum='2320';
    end if;
    call mtx_cust_up('2320' ,'C2320','SPVAL'   ,'128', '4');
    // ================================================================
    set ntmp = (select length from sys.syscolumns where cname='C2321' and tname ='calibration' and creator = 'mt');
    if (ntmp < 55) then
        alter table mt.calibration modify C2321 char(55);
        update mt.customiz set maxlen='55' where fldnum='2321';
    end if;
    call mtx_cust_up('2321' ,'C2321','SPVAL'    ,'55', '4');
    // ================================================================
    call mtx_cust_up('2322' ,'C2322','SPVAL'    , '1', '4');
    update mt.customiz set validation='simple' where fldnum='2322';
    call mtx_cust_up('2323' ,'C2323','SPVAL'    , '1', '4');
    delete from mt.valfield where fldnum='2322';
    insert into mt.valfield (fldnum,val) values( '2322', 'Y');
    insert into mt.valfield (fldnum,val) values( '2322', 'N');
    insert into mt.valfield (fldnum,val) values( '2322', 'X');
    // ================================================================
    set ntmp = (select length from sys.syscolumns where cname = 'C2324' and tname = 'calibration' and creator = 'mt');
    alter table mt.calibration modify C2324 decimal(5, 1) default 0;
    update mt.customiz set maxlen = '6' where fldnum='2324';
    call mtx_cust_up('2324' ,'C2324','DECIMAL4' , '6', '4');
    // ================================================================
    if not exists  ( select cname from sys.syscolumns where cname = 'C2325' and tname = 'calibration' and creator = 'mt') then
        alter table mt.calibration add C2325 char(1) DEFAULT 'N';
        update mt.calibration set C2325 = 'N';
        call mt.mtx_newcust('2325','C2325','Bad Std','fixed','X','4','SPVAL','1','Y');
    end if;
    call mtx_cust_up('2325' ,'C2325','SPVAL'    , '1', '4');
    // ================================================================
    call mtx_cust_up('2326' ,'C2326','SPVAL'    ,'44', '4');
    // ================================================================
    set ntmp = (select length from sys.syscolumns where cname = 'C2327' and tname ='calibration' and creator= 'mt');
    if (ntmp < 20) then
        alter table mt.calibration modify C2327 char(20);
        update mt.customiz set maxlen='20',datalen='20' where fldnum = '2327';
    end if;
    call mtx_cust_up('2327' ,'C2327','SPVAL'    ,'20', '4');
    // ================================================================
    set ntmp = (select length from sys.syscolumns where cname = 'C2328' and tname = 'calibration' and creator = 'mt');
    alter table mt.calibration modify C2328 decimal(5, 1) default 0;
    update mt.customiz set maxlen = '6' where fldnum='2328';
    call mtx_cust_up('2328' ,'C2328','DECIMAL4' , '6', '4');
    // ================================================================
    call mtx_cust_up('2329' ,'C2329','SPVAL'    ,'44', '4');
    call mtx_cust_up('2330' ,'C2330','SPVAL'    ,'10', '4');
    call mtx_cust_up('2331' ,'C2331','SPVAL'       , '1', '4');
    call mtx_cust_up('2332' ,'C2332','INT'      , '2', '4');
    call mtx_cust_up('2333' ,'C2333','TIME'     , '8', '4');
    call mtx_cust_up('2334' ,'C2334','TIME'     , '8', '4');
    // ================================================================
    call mtx_newcust('2335','C2335','DateTime Entered' ,'never','X','4', 'RO',   '15','Y');
    call mtx_newcust('2336','C2336','Who Entered'      ,'never','X','4', 'RO',   '16','Y');
    call mtx_newcust('2337','C2337','DateTime Modified' ,'never','X','4', 'RO',   '15','Y');
    call mtx_newcust('2338','C2338','Who Modified'      ,'never','X','4', 'RO',   '16','Y');
    call mtx_newcust('2339','C2339','Current Record'   ,'never','X','4', 'RO',    '1','Y');
    update mt.customiz set title='DateTime Entered',tooltip='DateTime Entered' where fldnum='2335';
    alter table mt.calibration modify C2335 default current timestamp;
    update mt.customiz set title='Who Entered',tooltip='Who Entered' where fldnum='2336';
    update mt.customiz set title='DateTime Modified',tooltip='DateTime Modified' where fldnum='2337';
    alter table mt.calibration modify C2337 default current timestamp;
    update mt.customiz set title='Who Modified',tooltip='Who Modified' where fldnum='2338';
    alter table mt.calibration modify C2339 default '0';
    COMMENT ON COLUMN mt.calibration.C2335 IS 'Who Entered';
    COMMENT ON COLUMN mt.calibration.C2336 IS 'DateTime Entered';
    COMMENT ON COLUMN mt.calibration.C2337 IS 'Who Modified';
    COMMENT ON COLUMN mt.calibration.C2338 IS 'DateTime Modified';
    // ================================================================
    call mtx_cust_up('2340' ,'C2340','STANDARD','150', '4');
    // ================================================================
    if not exists(select cname from sys.syscolumns where cname='C2342' and tname='calibration' and creator='mt') then
	    alter table mt.calibration add C2342 date;
	    call mtx_newcust('2342','C2342','End Date','never','X',   '4', 'DATE', '10','Y');
    end if;
    call mtx_cust_up('2341' ,'C2341','SPVAL'   ,'254', '4');
    // ================================================================
    call mtx_cust_up('2342' ,'C2342','DATE'     ,'10', '4');
    // ================================================================
    if (not exists (select cname from sys.syscolumns where cname = 'C2343' and tname = 'calibration' and creator = 'mt')) then
        alter table mt.calibration add C2343 char(8) DEFAULT '00:00:00';
        call mtx_newcust('2343','C2343','','never','X','4', 'TIME','8','Y');
    end if;
    call mtx_cust_up('2343' ,'C2343','TIME'     , '8', '4');
    // ================================================================
    if not exists(select cname from sys.syscolumns where cname='C2344' and tname='calibration' and creator='mt') then
	    alter table mt.calibration add C2344 integer;
	    call mtx_newcust('2344','C2344','Total Passes','never','X',   '4', 'INT','5','Y');
    end if;
    // ================================================================
    if not exists(select cname from sys.syscolumns where cname='C2345' and tname='calibration' and creator='mt') then
	    alter table mt.calibration add C2345 integer;
	    call mtx_newcust('2345','C2345','Significantly Within Tolerance','never','X',   '4', 'INT', '5','Y');
    end if;
    // ================================================================
    if not exists(select cname from sys.syscolumns where cname='C2346' and tname='calibration' and creator='mt') then
	    alter table mt.calibration add C2346 integer;
	    call mtx_newcust('2346','C2346','Within Tolerance','never','X',   '4', 'INT', '5','Y');
    end if;
    // ================================================================
    if not exists(select cname from sys.syscolumns where cname='C2347' and tname='calibration' and creator='mt') then
	    alter table mt.calibration add C2347 integer;
	    call mtx_newcust('2347','C2347','Out of Tolerance','never','X',   '4', 'INT', '5','Y');
    end if;
    // ================================================================
    if not exists(select cname from sys.syscolumns where cname='C2350' and tname='calibration' and creator='mt') then
	    alter table mt.calibration add C2350 integer;
	    call mtx_newcust('2350','C2350','Marginal Tests','never','X',   '4', 'INT', '5','Y');
    end if;
    update mt.customiz set datalen='5'where fldnum like '2350';
    call mtx_cust_up('2350' ,'C2350','INT'      , '5', '4');
    // ================================================================
    if not exists(select cname from sys.syscolumns where cname='C2351' and tname='calibration' and creator='mt') then
	    alter table mt.calibration add C2351 integer;
	    call mtx_newcust('2351','C2351','Notify User','never','X',   '4', 'INT', '5','Y');
    end if;
    update mt.customiz set datalen='5'where fldnum like '2351';
    call mtx_cust_up('2351' ,'C2351','INT'      , '5', '4');
    // ================================================================
    if not exists(select cname from sys.syscolumns where cname='C2352' and tname='calibration' and creator='mt') then
	    alter table mt.calibration add C2352 integer;
	    call mtx_newcust('2352','C2352','Failed Tests','never','X',   '4', 'INT', '5','Y');
    end if;
    update mt.customiz set datalen='5'where fldnum like '2352';
    call mtx_cust_up('2352' ,'C2352','INT'      , '5', '4');
    // ================================================================
    if not exists(select cname from sys.syscolumns where cname='C2353' and tname='calibration' and creator='mt') then
	    alter table mt.calibration add C2353 integer;
	    call mtx_newcust('2353','C2353','Adjustments','never','X',   '4', 'INT', '5','Y');
    end if;
    update mt.customiz set datalen='5'where fldnum like '2353';
    call mtx_cust_up('2353' ,'C2353','INT'      , '5', '4');
    // ================================================================
    if (not exists(select cname from sys.syscolumns where cname='C2354' and tname='calibration' and creator='mt'))then
        alter table mt.calibration add C2354 char(64);
        call mtx_newcust('2354','C2354','User Defined','none','N','4','SPVAL','64','Y');
    end if;
    call mtx_cust_up('2354' ,'C2354','SPVAL'    ,'64', '4');
    // ================================================================
    if (not exists(select cname from sys.syscolumns where cname='C2355' and tname='calibration' and creator='mt'))then
        alter table mt.calibration add C2355 char(64);
        call mtx_newcust('2355','C2355','User Defined','none','N','4','SPVAL','64','Y');
    end if;
    call mtx_cust_up('2355' ,'C2355','SPVAL'    ,'64', '4');
    // ================================================================
    if (not exists(select cname from sys.syscolumns where cname='C2356' and tname='calibration' and creator='mt'))then
        alter table mt.calibration add C2356 char(64);
        call mtx_newcust('2356','C2356','User Defined','none','N','4','SPVAL','64','Y');
    end if;
    call mtx_cust_up('2356' ,'C2356','SPVAL'    ,'64', '4');
    // ================================================================
    if (not exists(select cname from sys.syscolumns where cname='C2357' and tname='calibration' and creator='mt'))then
        alter table mt.calibration add C2357 char(64);
        call mtx_newcust('2357','C2357','User Defined','none','N','4','SPVAL','64','Y');
    end if;
    call mtx_cust_up('2357' ,'C2357','SPVAL'    ,'64', '4');
    // ================================================================
    if (not exists(select cname from sys.syscolumns where cname='C2358' and tname='calibration' and creator='mt'))then
        alter table mt.calibration add C2358 char(64);
        call mtx_newcust('2358','C2358','User Defined','none','N','4','SPVAL','64','Y');
    end if;
    call mtx_cust_up('2358' ,'C2358','SPVAL'    ,'64', '4');
    // ================================================================
    if (not exists(select cname from sys.syscolumns where cname='C2359' and tname='calibration' and creator='mt'))then
        alter table mt.calibration add C2359 char(64);
        call mtx_newcust('2359','C2359','User Defined','none','N','4','SPVAL','64','Y');
    end if;
    call mtx_cust_up('2359' ,'C2359','SPVAL'    ,'64', '4');
    // ================================================================
    if (not exists(select cname from sys.syscolumns where cname='C2360' and tname='calibration' and creator='mt'))then
        alter table mt.calibration add C2360 char(64);
        call mtx_newcust('2360','C2360','User Defined','none','N','4','SPVAL','64','Y');
    end if;
    call mtx_cust_up('2360' ,'C2360','SPVAL'    ,'64', '4');
    // ================================================================
    if (not exists(select cname from sys.syscolumns where cname='C2361' and tname='calibration' and creator = 'mt'))then
        alter table mt.calibration add C2361 char(64);
        call mtx_newcust('2361','C2361','User Defined','none','N','4','SPVAL','64','Y');
    end if;
    call mtx_cust_up('2361' ,'C2361','SPVAL'    ,'64', '4');
    // ================================================================
    if (not exists(select cname from sys.syscolumns where cname='C2362' and tname='calibration' and creator='mt'))then
        alter table mt.calibration add C2362 integer default 0;
	    call mtx_newcust('2362','C2362','Reliability','none','N','4', 'INT', '3','Y');
    end if;
    call mtx_cust_up('2362' ,'C2362','INT'      , '3', '4');
    // ================================================================
    if not exists  ( select cname from sys.syscolumns where cname = 'C2363' and tname = 'calibration' and creator = 'mt') then
        alter table mt.calibration add C2363 char(1) default 'N';
        update mt.calibration set C2363 = 'N';
        call mt.mtx_newcust('2363', 'C2363','Cal Aborted','fixed','X','4','SPVAL','1','Y');
    end if;
    call mtx_cust_up('2363' ,'C2363','SPVAL'    , '1', '4');
    // ================================================================
    if not exists  ( select cname from sys.syscolumns where cname = 'C2363' and tname = 'calibration' and creator = 'mt') then
        alter table mt.calibration add C2363 char(1) default 'N';
        update mt.calibration set C2363 = 'N';
        call mt.mtx_newcust('2363', 'C2363','Cal Aborted','fixed','X','4','SPVAL','1','Y');
    end if;
    // ================================================================
    call mtxdoadd('C2364','calibration','alter table calibration add C2364 char(48) default NULL','');
    call mtx_newcust('2364','C2364','unused string'    ,'none' ,'N','4', 'SPVAL','48','Y');
    COMMENT ON COLUMN mt.Calibration.C2364 IS 'Auxiliary.';
    // ================================================================
    call mtxdoadd('C2365','calibration','alter table calibration add C2365 char(48) default NULL','');
    call mtx_newcust('2365','C2365','unused string'    ,'none' ,'N','4', 'SPVAL','48','Y');
    COMMENT ON COLUMN mt.Calibration.C2365 IS 'Auxiliary.';
    // ================================================================
    call mtxdoadd('C2366','calibration','alter table calibration add C2366 char(48) default NULL','');
    call mtx_newcust('2366','C2366','unused string'    ,'none' ,'N','4', 'SPVAL','48','Y');
    COMMENT ON COLUMN mt.Calibration.C2366 IS 'Auxiliary.';
    // ================================================================
    call mtxdoadd('C2367','calibration','alter table calibration add C2367 char(48) default NULL','');
    call mtx_newcust('2367','C2367','unused string'    ,'none' ,'N','4', 'SPVAL','48','Y');
    COMMENT ON COLUMN mt.Calibration.C2367 IS 'Auxiliary.';
    // ================================================================
    call mtxdoadd('C2368','calibration','alter table calibration add C2368 char(48) default NULL','');
    call mtx_newcust('2368','C2368','unused string'    ,'none' ,'N','4', 'SPVAL','48','Y');
    COMMENT ON COLUMN mt.Calibration.C2368 IS 'Auxiliary.';
    // ================================================================
    call mtxdoadd('C2369','calibration','alter table calibration add C2369 char(48) default NULL','');
    call mtx_newcust('2369','C2369','unused string'    ,'none' ,'N','4', 'SPVAL','48','Y');
    COMMENT ON COLUMN mt.Calibration.C2369 IS 'Auxiliary.';
    // ================================================================
    call mtxdoadd('C2370','calibration','alter table calibration add C2370 char(48) default NULL','');
    call mtx_newcust('2370','C2370','unused string'    ,'none' ,'N','4', 'SPVAL','48','Y');
    COMMENT ON COLUMN mt.Calibration.C2370 IS 'Auxiliary.';
    // ================================================================
    call mtxdoadd('C2371','calibration','alter table calibration add C2371 date default NULL','');
    call mtx_newcust('2371','C2371','unused date'      ,'never','X','4', 'DATE' , '10','Y');
    COMMENT ON COLUMN mt.Calibration.C2371 IS 'Auxiliary.';
    // ================================================================
    call mtxdoadd('C2372','calibration','alter table calibration add C2372 date default NULL','');
    call mtx_newcust('2372','C2372','unused date'      ,'never','X','4', 'DATE' , '10','Y');
    COMMENT ON COLUMN mt.Calibration.C2372 IS 'Auxiliary.';
    // ================================================================
    call mtxdoadd('C2373','calibration','alter table calibration add C2373 date default NULL','');
    call mtx_newcust('2373','C2373','unused date'      ,'never','X','4', 'DATE' , '10','Y');
    COMMENT ON COLUMN mt.Calibration.C2373 IS 'Auxiliary.';
    // ================================================================
    call mtxdoadd('C2374','calibration','alter table calibration add C2374 date default NULL','');
    call mtx_newcust('2374','C2374','unused date'      ,'never','X','4', 'DATE' , '10','Y');
    COMMENT ON COLUMN mt.Calibration.C2374 IS 'Auxiliary.';
    // ================================================================
    call mtxdoadd('C2375','calibration','alter table calibration add C2375 decimal(12,2) default NULL','');
    call mtx_newcust('2375','C2375','unused number'    ,'never','X','4', 'RTDBL','10','Y');
    COMMENT ON COLUMN mt.Calibration.C2375 IS 'Auxiliary.';
    // ================================================================
    call mtxdoadd('C2376','calibration','alter table calibration add C2376 decimal(12,2) default NULL','');
    call mtx_newcust('2376','C2376','unused number'    ,'never','X','4', 'RTDBL','10','Y');
    COMMENT ON COLUMN mt.Calibration.C2376 IS 'Auxiliary.';
    // ================================================================
    call mtxdoadd('C2377','calibration','alter table calibration add C2377 decimal(12,2) default NULL','');
    call mtx_newcust('2377','C2377','unused number'    ,'never','X','4', 'RTDBL','10','Y');
    COMMENT ON COLUMN mt.Calibration.C2377 IS 'Auxiliary.';
    // ================================================================
    call mtxdoadd('C2378','calibration','alter table calibration add C2378 decimal(12,2) default NULL','');
    call mtx_newcust('2378','C2378','unused number'    ,'never','X','4', 'RTDBL','10','Y');
    COMMENT ON COLUMN mt.Calibration.C2378 IS 'Auxiliary.';
    // ================================================================
    call mtxdoadd('C2379','calibration','alter table calibration add C2379 decimal(12,2) default NULL','');
    call mtx_newcust('2379','C2379','unused number'    ,'never','X','4', 'RTDBL','10','Y');
    COMMENT ON COLUMN mt.Calibration.C2379 IS 'Auxiliary.';
    // ================================================================
    if (not exists(select cname from sys.syscolumns where cname='C2380' and tname='calibration' and creator='mt'))then
        call mtx_newcust('2380','C2380','Abeyance date'    ,'never','X','4', 'RO' ,'10','Y');
        alter table calibration add C2380 date default NULL;
        COMMENT ON COLUMN mt.Calibration.C2380 IS 'Abeyance date.';
    end if;
    update mt.customiz set ftype='RO_DATE' where fldnum='2380';
    // ================================================================
    if (not exists(select cname from sys.syscolumns where cname='C2381' and tname='calibration' and creator='mt'))then
        alter table mt.calibration add C2381 char(8) default '00:00:00';
        call mtx_newcust('2381','C2381','Abeyance time'    ,'never','X','4', 'RO','8','Y');
        COMMENT ON COLUMN mt.Calibration.C2381 IS 'Abeyance time.';
    end if;
    // ================================================================
    if (not exists(select cname from sys.syscolumns where cname='C2382' and tname='calibration' and creator='mt'))then
        alter table mt.calibration add C2382 char(1) default 'N';
        call mtx_newcust('2382','C2382','abeyance state'   ,'never','X','4', 'RO','1','Y');
    end if;
    // ================================================================
    if (not exists(select cname from sys.syscolumns where cname='C2383' and tname='calibration' and creator='mt'))then
        alter table calibration add C2383 integer default 0;
        call mtx_newcust('2383','C2383','abeyance interval','never','X','4', 'RO','3','Y');
    end if;
    // ================================================================
    if (not exists(select cname from sys.syscolumns where cname='C2384' and tname='calibration' and creator='mt')) then
        alter table mt.calibration add C2384 long varchar default '';
        call mt.mtx_newcust('2384','C2384','Engineers Notes','never','X','4','MEMO','32767','Y');
    end if;
    // ================================================================
    if (not exists(select cname from sys.syscolumns where cname='C2385' and tname='calibration' and creator='mt')) then
        alter table mt.calibration add C2385 char(128) default NULL;
        call mt.mtx_newcust('2385','C2385','OLE Document','never','X','4','RO','128','Y');
    end if;
    // ================================================================
    if not exists(select cname from sys.syscolumns where cname='C2386' and tname='calibration' and creator='mt') then
	    alter table mt.calibration add C2386 numeric(5,1);
	    call mtx_newcust('2386','C2386','Temperature Tolerance','never','X',   '4', 'DECIMAL4', '4','Y');
    end if;
    // ================================================================
    if not exists(select cname from sys.syscolumns where cname='C2387' and tname='calibration' and creator='mt') then
	    alter table mt.calibration add C2387 numeric(5,1);
	    call mtx_newcust('2387','C2387','Humidity Tolerance','never','X',   '4', 'DECIMAL4', '4','Y');
    end if;
    // ================================================================
    if not exists(select cname from sys.syscolumns where cname='C2388' and tname='calibration' and creator='mt') then
	    alter table mt.calibration add C2388 numeric(9,2);
	    call mtx_newcust('2388','C2388','TUR Reporting Threshold','never','X',   '4', 'DECIMAL4', '4','Y');
    end if;
    // ================================================================
    if not exists(select cname from sys.syscolumns where cname='C2389' and tname='calibration' and creator='mt') then
	    alter table mt.calibration add C2389 numeric(7,2);
	    call mtx_newcust('2389','C2389','Borderline Threshold','never','X',   '4', 'DECIMAL4', '4','Y');
    end if;
    // ================================================================
    if not exists(select cname from sys.syscolumns where cname='C2390' and tname='calibration' and creator='mt') then
	    alter table mt.calibration add C2390 numeric(9,2);
	    call mtx_newcust('2390','C2390','SOT Threshold','never','X',   '4', 'DECIMAL4', '4','Y');
    end if;
    if not exists(select fldnum from mt.customiz where datacol = 'C2390') then
        call mtx_newcust('2390','C2390','SOT Threshold','never','X',   '4', 'DECIMAL4', '4','Y');
    end if;
    // ================================================================
    if not exists(select cname from sys.syscolumns where cname='C2391' and tname='calibration' and creator='mt') then
	    alter table mt.calibration add C2391 numeric(7,2);
	    call mtx_newcust('2391','C2391','SWT Threshold','never','X',   '4', 'DECIMAL4', '4','Y');
    end if;
    if not exists(select fldnum from mt.customiz where datacol = 'C2391') then
        call mtx_newcust('2391','C2391','SWT Threshold','never','X',   '4', 'DECIMAL4', '4','Y');
    end if;
    update mt.customiz set title='SWT Threshold', tooltip='SWT Threshold' where datacol='C2391' and title = 'SOT Threshold';
    // ================================================================
    if not exists(select cname from sys.syscolumns where cname='C2392' and tname='calibration' and creator='mt') then
	    alter table mt.calibration add C2392 numeric(2,0);
	    call mtx_newcust('2392','C2392','Reported Uncert. Conf. Level','never','X',   '4', 'DECIMAL4', '4','Y');
    end if;
    if not exists(select fldnum from mt.customiz where datacol = 'C2392') then
	    call mtx_newcust('2392','C2392','Reported Uncert. Conf. Level','never','X',   '4', 'DECIMAL4', '4','Y');
    end if;
    // ================================================================
    if not exists(select cname from sys.syscolumns where cname='C2393' and tname='calibration' and creator='mt') then
	    alter table mt.calibration add C2393 char(1) check ( C2393 IN ('1', '0', NULL)) default NULL;
	    call mtx_newcust('2393','C2393','Use Dominance Test','never','X',   '4', 'SPVAL', '2','Y');
    end if;
    if not exists(select fldnum from mt.customiz where datacol = 'C2393') then
	    call mtx_newcust('2393','C2393','Use Dominance Test','never','X',   '4', 'SPVAL', '2','Y');
    end if;
    // ================================================================
    if not exists(select cname from sys.syscolumns where cname='C2394' and tname='calibration' and creator='mt') then
	    alter table mt.calibration add C2394 char(1) check ( C2394 IN ('1', '0', NULL)) default NULL;
	    call mtx_newcust('2394','C2394','Use Reliability Test','never','X',   '4', 'SPVAL', '2','Y');
    end if;
    if not exists(select fldnum from mt.customiz where datacol = 'C2394') then
	    call mtx_newcust('2394','C2394','Use Reliability Test','never','X',   '4', 'SPVAL', '2','Y');
    end if;
    // ================================================================
    if not exists(select cname from sys.syscolumns where cname='C2395' and tname='calibration' and creator='mt') then
	    alter table mt.calibration add C2395 char(10) default NULL;
	    call mtx_newcust('2395','C2395','Certificate Number','never','N','4','SPVAL','10','Y');
    end if;
    if not exists(select fldnum from mt.customiz where datacol = 'C2395') then
	    call mtx_newcust('2395','C2395','Certificate Number','never','N','4','SPVAL','10','Y');
    end if;
    // ================================================================
    if not exists(select cname from sys.syscolumns where cname='C2396' and tname='calibration' and creator='mt') then
	    alter table mt.calibration add C2396 char(16) default NULL;
	    call mtx_newcust('2396','C2396','Order Number','never','N','4','SPVAL','16','Y');
    end if;
    // ================================================================
    if not exists(select cname from sys.syscolumns where cname='combine' and tname='calibration' and creator='mt') then
	    alter table mt.calibration add combine char(3) default '';
    end if;
    grant update (combine) on mt.calibration to public;
    update mt.calibration set C2302 = 0 where C2302 = null;
    update mt.calibration set C2328 = 0 where C2328 = null;
    update mt.calibration set C2324 = 0 where C2324 = null;
    update mt.calibration set C2362 = 0 where C2362 = null;
    update mt.calibration set C2382 = 'N' where C2382 = null;
    update mt.calibration set C2333 = '00:00:00' where C2333 = null;
    update mt.calibration set C2334 = C2333 where C2334 = null and C2303 != null;
end;;
begin
    // ========================================
    // location
    //
    declare ntmp integer;
    // ================================================================
    // location LDSRC (Location Data SouRCe)

	if exists(select fldnum from mt.customiz where fldnum = '2890' and len = 5) then
        delete from customiz where fldnum like '2890'; 
    end if;
	if exists(select fldnum from mt.customiz where fldnum = '2891' and len = 5) then
        delete from customiz where fldnum like '2891'; 
    end if;
	if exists(select fldnum from mt.customiz where fldnum = '2892' and len = 5) then
        delete from customiz where fldnum like '2892'; 
    end if;
	if exists(select fldnum from mt.customiz where fldnum = '2893' and len = 5) then
        delete from customiz where fldnum like '2893'; 
    end if;
	if exists(select fldnum from mt.customiz where fldnum = '2894' and len = 5) then
        delete from customiz where fldnum like '2894'; 
    end if;
	if exists(select fldnum from mt.customiz where fldnum = '2895' and len = 5) then
        delete from customiz where fldnum like '2895'; 
    end if;

    call mtx_newcust('LLTAG','LTAG','Loc Unique ID'    ,'never','X','8', 'RO','15','Y');
    call mtx_newcust('LMTAG','MTAG','Loc Asset  ID'    ,'never','X','8', 'RO','15','Y');
    call mtx_newcust('LDSRC','LDSRC','Cal Data Source' ,'never','X','8', 'RO', '3','Y');
    if exists (select cname from sys.syscolumns where cname = 'DSRC' and tname = 'location' and creator = 'mt') then
        alter table location rename dsrc to ldsrc;
    end if;
    if not exists (select cname from sys.syscolumns where cname = 'LDSRC' and tname = 'location' and creator = 'mt') then
        alter table mt.location add LDSRC char(3) default NULL;
        update mt.location set LDSRC = 'PRE';
    end if;
    // ================================================================
    set ntmp = (select length from sys.syscolumns where cname = 'L2801' and tname = 'location' and creator = 'mt');
    if (ntmp < 20) then
        alter table mt.location modify L2801 char(20);
        update mt.customiz set datalen='20', maxlen='20' where fldnum like '2801';
    end if;
    call mtx_cust_up('2801' ,'L2801','SPVAL' ,'20', '8');
    // ================================================================
    set ntmp = (select length from sys.syscolumns where cname = 'L2802' and tname = 'location' and creator = 'mt');
    if (ntmp < 20) then
        alter table mt.location modify L2802 char(20);
        update mt.customiz set datalen='20', maxlen='20' where fldnum like '2802';
    end if;
    call mtx_cust_up('2802' ,'L2802','SPVAL' ,'20', '8');
    // ================================================================
    call mtx_cust_up('2803' ,'L2803','SPVAL' ,'20', '8');
    call mtx_cust_up('2804' ,'L2804','SPVAL' ,'10', '8');
    call mtx_cust_up('2805' ,'L2805','SPVAL' , '8', '8');
    call mtx_cust_up('2806' ,'L2806','DATE'  ,'10', '8');
    call mtx_cust_up('2807' ,'L2807','DATE'  ,'10', '8');
    call mtx_cust_up('2808' ,'L2808','INT'   , '3', '8');
    call mtx_cust_up('2809' ,'L2809','DATE'  ,'10', '8');
    call mtx_cust_up('2810' ,'L2810','TIME'  , '8', '8');
    // ================================================================
    call mtx_newcust('2811','L2811','DateTime Created','never','X','8', 'RO','15','Y');
    call mtx_newcust('2812','L2812','Who Created'     ,'never','X','8', 'RO','16','Y');
    call mtx_newcust('2813','L2813','DateTime Modified' ,'never','X','8', 'RO','15','Y');
    call mtx_newcust('2814','L2814','Who Modified'      ,'never','X','8', 'RO','16','Y');
    call mtx_newcust('2815','L2815','Current Record'   ,'never','X','8', 'RO', '1','Y');
    update mt.customiz set title='DateTime Entered',tooltip='DateTime Entered' where fldnum='2811';
    alter table mt.location modify L2811 default current timestamp;
    update mt.customiz set title='Who Entered',tooltip='Who Entered' where fldnum='2812';
    update mt.customiz set title='DateTime Modified',tooltip='DateTime Modified' where fldnum='2813';
    alter table mt.location modify L2811 default current timestamp;
    update mt.customiz set title='Who Modified',tooltip='Who Modified' where fldnum='2814';
    alter table mt.location modify L2815 default '0';
    COMMENT ON COLUMN mt.location.L2811 IS 'DateTimeEntered';
    COMMENT ON COLUMN mt.location.L2812 IS 'Who Entered';
    COMMENT ON COLUMN mt.location.L2813 IS 'DateTime Modified';
    COMMENT ON COLUMN mt.location.L2814 IS 'Who Modified';
    // ================================================================
    call mtx_newcust('2816','L2816','Loan Cost','none','N','8','SPVAL','15','Y');
    if (not exists(select cname from sys.syscolumns where cname='L2816' and tname='location' and creator='mt'))then
        alter table mt.location add L2816 char(15);
        call mtx_newcust('2816','L2816','Shop'   ,'none','N','8', 'SPVAL', '15','Y');
    end if;
    call mtx_cust_up('2816' ,'L2816','SPVAL' ,'15', '8');
    // ================================================================
    call mtx_newcust('2817','L2817','Loan Cost','none','N','8','RTDBL','13','Y');
    if (not exists(select cname from sys.syscolumns where cname='L2817' and tname='location' and creator='mt'))then
        alter table mt.location add L2817 decimal(12,2)default NULL;
        update mt.location set L2817='0';
    else
        set ntmp = (select length from sys.syscolumns where cname='L2817' and tname='location' and creator='mt');
        if (ntmp < 80)then
            alter table mt.location modify L2817 decimal(12, 2) default NULL;
            update mt.customiz set maxlen=13 where fldnum='2817';
        end if
    end if;
    call mtx_cust_up('2817' ,'L2817','RTDBL' ,'13', '8');
    // ================================================================
    if (not exists(select cname from sys.syscolumns where cname='L2818' and tname='location' and creator='mt'))then
        alter table mt.location add L2818 decimal(12,2) default NULL;
        call mtx_newcust('2818','L2818','unused number'    ,'never','X','8', 'RTDBL','10','Y');
        COMMENT ON COLUMN mt.Location.L2818 IS 'Auxiliary.';
    end if;
    // ================================================================
    if (not exists(select cname from sys.syscolumns where cname='L2819' and tname='location' and creator='mt'))then
        alter table mt.location add L2819 decimal(12,2) default NULL;
        call mtx_newcust('2819','L2819','unused number'    ,'never','X','8', 'RTDBL','10','Y');
        COMMENT ON COLUMN mt.Location.L2819 IS 'Auxiliary.';
    end if;
    // ================================================================
    if (not exists(select cname from sys.syscolumns where cname='L2820' and tname='location' and creator='mt'))then
        alter table mt.location add L2820 decimal(12,2) default NULL;
        call mtx_newcust('2820','L2820','unused number'    ,'never','X','8', 'RTDBL','10','Y');
        COMMENT ON COLUMN mt.Location.L2820 IS 'Auxiliary.';
    end if;
    // ================================================================
    if (not exists(select cname from sys.syscolumns where cname='L2821' and tname='location' and creator='mt'))then
        alter table mt.location add L2821 decimal(12,2) default NULL;
        call mtx_newcust('2821','L2821','unused number'    ,'never','X','8', 'RTDBL','10','Y');
        COMMENT ON COLUMN mt.Location.L2821 IS 'Auxiliary.';
    end if;
    // ================================================================
    if (not exists(select cname from sys.syscolumns where cname='L2822' and tname='location' and creator='mt'))then
        alter table mt.location add L2822 date default NULL;
        call mtx_newcust('2822','L2822','unused date'      ,'never','X','8', 'DATE' ,'10','Y');
        COMMENT ON COLUMN mt.Location.L2822 IS 'Auxiliary.';
    end if;
    // ================================================================
    if (not exists(select cname from sys.syscolumns where cname='L2823' and tname='location' and creator='mt'))then
        alter table mt.location add L2823 date default NULL;
        call mtx_newcust('2823','L2823','unused date'      ,'never','X','8', 'DATE' ,'10','Y');
        COMMENT ON COLUMN mt.Location.L2823 IS 'Auxiliary.';
    end if;
    // ================================================================
    if (not exists(select cname from sys.syscolumns where cname='L2824' and tname='location' and creator='mt'))then
        alter table mt.location add L2824 date default NULL;
        call mtx_newcust('2824','L2824','unused date'      ,'never','X','8', 'DATE' ,'10','Y');
        COMMENT ON COLUMN mt.Location.L2824 IS 'Auxiliary.';
    end if;
    // ================================================================
    if (not exists(select cname from sys.syscolumns where cname='L2825' and tname='location' and creator='mt'))then
        alter table mt.location add L2825 date default NULL;
        call mtx_newcust('2825','L2825','unused date'      ,'never','X','8', 'DATE' ,'10','Y');
        COMMENT ON COLUMN mt.Location.L2825 IS 'Auxiliary.';
    end if;
    // ================================================================
    if (not exists(select cname from sys.syscolumns where cname='L2826' and tname='location' and creator='mt'))then
        alter table mt.location add L2826 char(48) default NULL;
        call mtx_newcust('2826','L2826','unused string'    ,'none' ,'N','8', 'SPVAL','48','Y');
        COMMENT ON COLUMN mt.Location.L2826 IS 'Auxiliary.';
    else
        set ntmp = (select length from sys.syscolumns where cname = 'L2826' and tname = 'location' and creator = 'mt');
        if (ntmp < 48) then
            alter table mt.location modify L2826 char(48);
            update mt.customiz set maxlen='48' where fldnum like '2826';
        end if;
    end if;
    // ================================================================
    if (not exists(select cname from sys.syscolumns where cname='L2827' and tname='location' and creator='mt'))then
        alter table mt.location add L2827 char(48) default NULL;
        call mtx_newcust('2827','L2827','unused string'    ,'none' ,'N','8', 'SPVAL','48','Y');
        COMMENT ON COLUMN mt.Location.L2827 IS 'Auxiliary.';
    else
        set ntmp = (select length from sys.syscolumns where cname = 'L2827' and tname = 'location' and creator = 'mt');
        if (ntmp < 48) then
            alter table mt.location modify L2827 char(48);
            update mt.customiz set maxlen='48' where fldnum like '2827';
        end if;
    end if;
    // ================================================================
    if (not exists(select cname from sys.syscolumns where cname='L2828' and tname='location' and creator='mt'))then
        alter table mt.location add L2828 char(48) default NULL;
        call mtx_newcust('2828','L2828','unused string'    ,'none' ,'N','8', 'SPVAL','48','Y');
        COMMENT ON COLUMN mt.Location.L2828 IS 'Auxiliary.';
    else
        set ntmp = (select length from sys.syscolumns where cname = 'L2828' and tname = 'location' and creator = 'mt');
        if (ntmp < 48) then
            alter table mt.location modify L2828 char(48);
            update mt.customiz set maxlen='48' where fldnum like '2828';
        end if;
    end if;
    // ================================================================
    if (not exists(select cname from sys.syscolumns where cname='L2829' and tname='location' and creator='mt'))then
        alter table mt.location add L2829 char(48) default NULL;
        call mtx_newcust('2829','L2829','unused string'    ,'none' ,'N','8', 'SPVAL','48','Y');
        COMMENT ON COLUMN mt.Location.L2829 IS 'Auxiliary.';
    else
        set ntmp = (select length from sys.syscolumns where cname = 'L2829' and tname = 'location' and creator = 'mt');
        if (ntmp < 48) then
            alter table mt.location modify L2829 char(48);
            update mt.customiz set maxlen='48' where fldnum like '2829';
        end if;
    end if;
    // ================================================================
    if (not exists(select cname from sys.syscolumns where cname='L2830' and tname='location' and creator='mt'))then
        alter table mt.location add L2830 char(48) default NULL;
        call mtx_newcust('2830','L2830','unused string'    ,'none' ,'N','8', 'SPVAL','48','Y');
        COMMENT ON COLUMN mt.Location.L2830 IS 'Auxiliary.';
    else
        set ntmp = (select length from sys.syscolumns where cname = 'L2830' and tname = 'location' and creator = 'mt');
        if (ntmp < 48) then
            alter table mt.location modify L2830 char(48);
            update mt.customiz set maxlen='48' where fldnum like '2830';
        end if;
    end if;
    // ================================================================
    if (not exists(select cname from sys.syscolumns where cname='L2831' and tname='location' and creator='mt'))then
        alter table mt.location add L2831 char(48) default NULL;
        call mtx_newcust('2831','L2831','unused string'    ,'none' ,'N','8', 'SPVAL','48','Y');
        COMMENT ON COLUMN mt.Location.L2831 IS 'Auxiliary.';
    else
        set ntmp = (select length from sys.syscolumns where cname = 'L2831' and tname = 'location' and creator = 'mt');
        if (ntmp < 48) then
            alter table mt.location modify L2831 char(48);
            update mt.customiz set maxlen='48' where fldnum like '2831';
        end if;
    end if;
    // ================================================================
    if (not exists(select cname from sys.syscolumns where cname='L2832' and tname='location' and creator='mt'))then
        alter table mt.location add L2832 char(48) default NULL;
        call mtx_newcust('2832','L2832','unused string'    ,'none' ,'N','8', 'SPVAL','48','Y');
        COMMENT ON COLUMN mt.Location.L2832 IS 'Auxiliary.';
    else
        set ntmp = (select length from sys.syscolumns where cname = 'L2832' and tname = 'location' and creator = 'mt');
        if (ntmp < 48) then
            alter table mt.location modify L2832 char(48);
            update mt.customiz set maxlen='48' where fldnum like '2832';
        end if;
    end if;
    // ================================================================
    if (not exists(select cname from sys.syscolumns where cname='L2833' and tname='location' and creator='mt'))then
        alter table mt.location add L2833 char(48) default NULL;
        call mtx_newcust('2833','L2833','unused string'    ,'none' ,'N','8', 'SPVAL','48','Y');
        COMMENT ON COLUMN mt.Location.L2833 IS 'Auxiliary.';
    else
        set ntmp = (select length from sys.syscolumns where cname = 'L2833' and tname = 'location' and creator = 'mt');
        if (ntmp < 48) then
            alter table mt.location modify L2833 char(48);
            update mt.customiz set maxlen='48' where fldnum like '2833';
        end if;
    end if;
    // ================================================================
    if (not exists(select cname from sys.syscolumns where cname='L2834' and tname='location' and creator='mt'))then
        alter table mt.location add L2834 char(48) default NULL;
        call mtx_newcust('2834','L2834','unused string'    ,'none' ,'N','8', 'SPVAL','48','Y');
        COMMENT ON COLUMN mt.Location.L2834 IS 'Auxiliary.';
    else
        set ntmp = (select length from sys.syscolumns where cname = 'L2834' and tname = 'location' and creator = 'mt');
        if (ntmp < 48) then
            alter table mt.location modify L2834 char(48);
            update mt.customiz set maxlen='48' where fldnum like '2834';
        end if;
    end if;
    // ================================================================
    if (not exists(select cname from sys.syscolumns where cname='L2835' and tname='location' and creator='mt'))then
        alter table mt.location add L2835 char(48) default NULL;
        call mtx_newcust('2835','L2835','unused string'    ,'none' ,'N','8', 'SPVAL','48','Y');
        COMMENT ON COLUMN mt.Location.L2835 IS 'Auxiliary.';
    else
        set ntmp = (select length from sys.syscolumns where cname = 'L2835' and tname = 'location' and creator = 'mt');
        if (ntmp < 48) then
            alter table mt.location modify L2835 char(48);
            update mt.customiz set maxlen='48' where fldnum like '2835';
        end if;
    end if;
    // ================================================================
    if (not exists(select cname from sys.syscolumns where cname='L2836' and tname='location' and creator='mt')) then
        alter table mt.location add L2836 long varchar default '';
        call mt.mtx_newcust('2836','L2836','Engineers Notes','never','X','8','MEMO','32767','Y');
    end if;
    // ================================================================
    if (not exists(select cname from sys.syscolumns where cname='L2837' and tname='location' and creator='mt')) then
        alter table mt.location add L2837 char(128) default NULL;
        call mt.mtx_newcust('2837','L2837','OLE Document','never','X','8','RO','128','Y');
    end if;
    // ================================================================
    set ntmp = (select length from sys.syscolumns where cname='mtag' and tname='location' and creator='mt');
    if (ntmp < 80)then
        alter table mt.location modify mtag char(80);
    end if;
    // ================================================================
    set ntmp = (select length from sys.syscolumns where cname='ltag' and tname='location' and creator='mt');
    if (ntmp < 80)then
        alter table mt.location modify ltag char(80);
    end if;
    // ================================================================
    if (not exists(select cname from sys.syscolumns where cname='LPUBLISH' and tname='location'))then
        alter table mt.location add LPUBLISH char(32);
        update mt.location set lpublish = 'mtrack';
        call mtx_newcust('LPUBLISH','LPUBLISH','Publisher' ,'never','X','8', 'RO','32','Y');
    end if;
   alter table mt.location modify LPUBLISH null;

    // ================================================================
    message 'calibration block 1: ', 'fini';

end;;
begin
    declare ntmp integer;
    message 'Repair block 1: ', 'start';
    // ========================================
    // Repair
    //
    // ================================================================
	if exists(select fldnum from mt.customiz where fldnum = '3290' and len = 5) then
        delete from customiz where fldnum like '3290'; 
    end if;
	if exists(select fldnum from mt.customiz where fldnum = '3291' and len = 5) then
        delete from customiz where fldnum like '3291'; 
    end if;
	if exists(select fldnum from mt.customiz where fldnum = '3292' and len = 5) then
        delete from customiz where fldnum like '3292'; 
    end if;
	if exists(select fldnum from mt.customiz where fldnum = '3293' and len = 5) then
        delete from customiz where fldnum like '3293'; 
    end if;
	if exists(select fldnum from mt.customiz where fldnum = '3294' and len = 5) then
        delete from customiz where fldnum like '3294'; 
    end if;
	if exists(select fldnum from mt.customiz where fldnum = '3295' and len = 5) then
        delete from customiz where fldnum like '3295'; 
    end if;

    call mtx_newcust('RMTAG','MTAG','Rep Asset  ID'    ,'never','X','16', 'RO','80','Y');
    set ntmp = (select length from sys.syscolumns where cname='mtag' and tname='repair' and creator='mt');
    if (ntmp < 80)then
        alter table mt.repair modify mtag char(80);
        update mt.customiz set maxlen=80 where fldnum='RMTAG';
    end if;
    // ================================================================
    call mtx_newcust('RRTAG','RTAG','Rep Unique ID'    ,'never','X','16', 'RO','80','Y');
    set ntmp = (select length from sys.syscolumns where cname='rtag' and tname='repair' and creator='mt');
    if (ntmp < 80)then
        alter table mt.repair modify rtag char(80);
        update mt.customiz set maxlen=80 where fldnum='RRTAG';
    end if;
    // ================================================================
    call mtx_newcust('RPUBLISH','RPUBLISH','Publisher' ,'never','X','16', 'RO','32','Y'); 
    if (not exists(select cname from sys.syscolumns where cname='RPUBLISH' and tname='repair'))then
        alter table mt.repair add RPUBLISH char(32);
        update mt.repair set rpublish = 'mtrack';
    end if;
    alter table mt.repair modify RPUBLISH null;
    // ==============================================================================
    // repair DSRC
    call mtx_newcust('RDSRC','RDSRC','Rep Data Source' ,'never','X','16', 'RO', '3','Y');
    if exists (select cname from sys.syscolumns where cname = 'DSRC' and tname = 'repair' and creator = 'mt') then
        alter table repair rename dsrc to rdsrc;
    end if;
    if not exists (select cname from sys.syscolumns where cname = 'RDSRC' and tname = 'repair' and creator = 'mt') then
        alter table mt.repair add RDSRC char(3) default NULL;
        update mt.repair set RDSRC = 'PRE';
    end if;
    // ================================================================
    call mtx_cust_up('3201' ,'R3201','SPVAL'   ,'102','16');
    call mtx_cust_up('3204' ,'R3204','SPVAL'   ,'102','16');
    call mtx_cust_up('3207' ,'R3207','SPVAL'    ,'15','16');
    call mtx_cust_up('3208' ,'R3208','SPVAL'    ,'14','16');
    // ================================================================
    call mtx_cust_up('3209' ,'R3209','RTDBL'    ,'13','16');
    set ntmp = (select length from sys.syscolumns where cname = 'R3209' and tname = 'repair' and creator = 'mt');
    if (ntmp < 12) then
        alter table mt.repair modify R3209 decimal(12, 2) default 0;
        update mt.customiz set maxlen=13 where fldnum='3209';
    end if;
    // ================================================================
    call mtx_cust_up('3210' ,'R3210','SPVAL'    ,'15','16');
    call mtx_cust_up('3211' ,'R3211','SPVAL'    ,'14','16');
    // ================================================================
    call mtx_cust_up('3212' ,'R3212','RTDBL'    ,'13','16');
    set ntmp = (select length from sys.syscolumns where cname = 'R3212' and tname = 'repair' and creator = 'mt');
    if (ntmp < 12) then
        alter table mt.repair modify R3212 decimal(12, 2) default 0;
        update mt.customiz set maxlen=13 where fldnum='3212';
    end if;
    // ================================================================
    call mtx_cust_up('3213' ,'R3213','SPVAL'    ,'15','16');
    call mtx_cust_up('3214' ,'R3214','SPVAL'    ,'14','16');
    // ================================================================
    call mtx_cust_up('3215' ,'R3215','RTDBL'    ,'13','16');
    set ntmp = (select length from sys.syscolumns where cname = 'R3215' and tname = 'repair' and creator = 'mt');
    if (ntmp < 12) then
        alter table mt.repair modify R3215 decimal(12, 2) default 0;
        update mt.customiz set maxlen=13 where fldnum='3215';
    end if;
    // ================================================================
    call mtx_cust_up('3216' ,'R3216','SPVAL'    ,'15','16');
    call mtx_cust_up('3217' ,'R3217','SPVAL'    ,'14','16');
    // ================================================================
    call mtx_cust_up('3218' ,'R3218','RTDBL'    ,'13','16');
    set ntmp = (select length from sys.syscolumns where cname = 'R3218' and tname = 'repair' and creator = 'mt');
    if (ntmp < 12) then
        alter table mt.repair modify R3218 decimal(12, 2) default 0;
        update mt.customiz set maxlen=13 where fldnum='3218';
    end if;
    // ================================================================
    call mtx_cust_up('3219' ,'R3219','SPVAL'    ,'15','16');
    call mtx_cust_up('3220' ,'R3220','SPVAL'    ,'14','16');
    // ================================================================
    call mtx_cust_up('3221' ,'R3221','RTDBL'    ,'13','16');
    set ntmp = (select length from sys.syscolumns where cname = 'R3221' and tname = 'repair' and creator = 'mt');
    if (ntmp < 12) then
        alter table mt.repair modify R3221 decimal(12, 2) default 0;
        update mt.customiz set maxlen=13 where fldnum='3221';
    end if;
    // ================================================================
    call mtx_cust_up('3222' ,'R3222','SPVAL'    ,'15','16');
    call mtx_cust_up('3223' ,'R3223','SPVAL'    ,'14','16');
    // ================================================================
    call mtx_cust_up('3224' ,'R3224','RTDBL'    ,'13','16');
    set ntmp = (select length from sys.syscolumns where cname = 'R3224' and tname = 'repair' and creator = 'mt');
    if (ntmp < 12) then
        alter table mt.repair modify R3224 decimal(12, 2) default 0;
        update mt.customiz set maxlen=13 where fldnum='3224';
    end if;
    // ================================================================
    call mtx_cust_up('3225' ,'R3225','SPVAL'    ,'15','16');
    call mtx_cust_up('3226' ,'R3226','SPVAL'    ,'14','16');
    // ================================================================
    call mtx_cust_up('3227' ,'R3227','RTDBL'    ,'13','16');
    set ntmp = (select length from sys.syscolumns where cname = 'R3227' and tname = 'repair' and creator = 'mt');
    if (ntmp < 12) then
        alter table mt.repair modify R3227 decimal(12, 2) default 0;
        update mt.customiz set maxlen=13 where fldnum='3227';
    end if;
    // ================================================================
    call mtx_cust_up('3229' ,'R3229','RO'       , '6','16');
    set ntmp = (select length from sys.syscolumns where cname = 'R3229' and tname = 'repair' and creator = 'mt');
    if (ntmp < 5) then
        alter table mt.repair modify R3229 decimal(5, 1) default 0;
        update mt.customiz set maxlen=6 where fldnum='3229';
    end if;
    // ================================================================
    call mtx_cust_up('3230' ,'R3230','DATE'     ,'10','16');
    // ================================================================
    call mtx_cust_up('3231' ,'R3231','RTDBL'    ,'13','16');
    set ntmp = (select length from sys.syscolumns where cname = 'R3231' and tname = 'repair' and creator = 'mt');
    if (ntmp < 12) then
        alter table mt.repair modify R3231 decimal(12, 2) default 0;
        update mt.customiz set maxlen=13 where fldnum='3231';
    end if;
    // ================================================================
    call mtx_cust_up('3232' ,'R3232','RO'       ,'13','16');
    set ntmp = (select length from sys.syscolumns where cname = 'R3232' and tname = 'repair' and creator = 'mt');
    if (ntmp < 12) then
        alter table mt.repair modify R3232 decimal(12, 2) default 0;
        update mt.customiz set maxlen=13 where fldnum='3232';
    end if;
    // ================================================================
    call mtx_cust_up('3233' ,'R3233','SPVAL'    ,'15','16');
    set ntmp = (select length from sys.syscolumns where cname = 'R3233' and tname = 'repair' and creator = 'mt');
    if (ntmp < 15) then
        alter table mt.repair modify R3233 char(15);
        update mt.customiz set maxlen='15' where fldnum='3233';
    end if;
    // ================================================================
    call mtx_cust_up('3235' ,'R3235','RO'       ,'15','16');
    set ntmp = (select length from sys.syscolumns where cname = 'R3235' and tname = 'repair' and creator = 'mt');
    if (ntmp < 12) then
        alter table mt.repair modify R3235 decimal(12, 2) default 0;
        update mt.customiz set maxlen=13 where fldnum='3235';
    end if;
    // ================================================================
    call mtx_cust_up('3236' ,'R3236','SPVAL'    ,'15','16');
    set ntmp = (select length from sys.syscolumns where cname = 'R3236' and tname = 'repair' and creator = 'mt');
    if (ntmp < 15) then
        alter table mt.repair modify R3236 char(15);
        update mt.customiz set maxlen='15' where fldnum='3236';
    end if;
    // ================================================================
    call mtx_cust_up('3237' ,'R3237','SPVAL'    ,'15','16');
    set ntmp = (select length from sys.syscolumns where cname = 'R3237' and tname = 'repair' and creator = 'mt');
    if (ntmp < 15) then
        alter table mt.repair modify R3237 char(15);
        update mt.customiz set maxlen='15' where fldnum='3237';
    end if;
    // ================================================================
    call mtx_cust_up('3238' ,'R3238','DECIMAL4' , '6','16');
    set ntmp = (select length from sys.syscolumns where cname = 'R3238' and tname = 'repair' and creator = 'mt');
    if (ntmp < 5) then
        alter table mt.repair modify R3238 decimal(5, 1) default 0;
        update mt.customiz set maxlen=6 where fldnum='3238';
    end if;
    // ================================================================
    call mtx_cust_up('3239' ,'R3239','DECIMAL4' , '6','16');
    set ntmp = (select length from sys.syscolumns where cname = 'R3239' and tname = 'repair' and creator = 'mt');
    if (ntmp < 5) then
        alter table mt.repair modify R3239 decimal(5, 1) default 0;
        update mt.customiz set maxlen=6 where fldnum='3239';
    end if;
    // ================================================================
    call mtx_cust_up('3240' ,'R3240','SPVAL'    ,'12','16');
    call mtx_cust_up('3241' ,'R3241','TIME'     , '8','16');
    // ================================================================
    call mtx_newcust('3242','R3242','DateTime Entered','never','X','16', 'RO','15','Y');
    
    update mt.customiz set title='DateTime Entered',tooltip='DateTime Entered' where fldnum='3242';
    alter table mt.repair modify R3242 default current timestamp;
    call mtx_newcust('3243','R3243','Who Entered'     ,'never','X','16', 'RO','16','Y');
    
    update mt.customiz set title='Who Entered',tooltip='Who Entered' where fldnum='3243';
    call mtx_newcust('3244','R3244','DateTime Modified' ,'never','X','16', 'RO','15','Y');
    
    update mt.customiz set title='DateTime Modified',tooltip='DateTime Modified' where fldnum='3244';
    alter table mt.repair modify R3244 default current timestamp;
    call mtx_newcust('3245','R3245','Who Modified'      ,'never','X','16', 'RO','16','Y');
    
    update mt.customiz set title='Who Modified',tooltip='Who Modified' where fldnum='3245';
    call mtx_newcust('3246','R3246','Current Record'   ,'never','X','16', 'RO','1','Y');
    
    alter table mt.repair modify R3246 default '0';
    COMMENT ON COLUMN mt.repair.R3242 IS 'DateTime Entered';
    COMMENT ON COLUMN mt.repair.R3243 IS 'Who Entered';
    COMMENT ON COLUMN mt.repair.R3244 IS 'DateTime Modified';
    COMMENT ON COLUMN mt.repair.R3245 IS 'Who Modified';
    // ================================================================
    call mtx_cust_up('3247' ,'R3247','DATE'     ,'10','16');
    call mtx_cust_up('3248' ,'R3248','TIME'     , '8','16');
    call mtx_cust_up('3249' ,'R3249','INT'      , '4','16');
    call mtx_cust_up('3250' ,'R3250','SPVAL'    , '1','16');
    call mtx_cust_up('3251' ,'R3251','SPVAL'    , '1','16');
    // ================================================================
    if (not exists(select cname from sys.syscolumns where cname='R3252' and tname='repair' and creator='mt')) then
        alter table mt.repair add R3252 decimal(12, 2) default NULL;
        call mtx_newcust('3252','R3252','Total Cost','never','X','16','RO','13','Y');
    end if;
    call mtx_newcust('3252','R3252','Total Cost','never','X','16', 'RO','13','Y');
    // ================================================================
    if (not exists(select cname from sys.syscolumns where cname='R3253' and tname='repair' and creator='mt')) then
        alter table mt.repair add R3253 long varchar default '';
        call mt.mtx_newcust('3253','R3253','Engineers Notes','never','X','16','MEMO','32767','Y');
    end if;
    // ================================================================
    if (not exists(select cname from sys.syscolumns where cname='R3254' and tname='repair' and creator='mt')) then
        alter table mt.repair add R3254 char(48);
        call mt.mtx_newcust('3254','R3254','unused string','never','X','16','SPVAL','48','Y');
    else
        set ntmp = (select length from sys.syscolumns where cname = 'R3254' and tname = 'repair' and creator = 'mt');
        if (ntmp < 48) then
            alter table mt.repair modify R3254 char(48);
            update mt.customiz set maxlen=48 where fldnum='3254';
        end if;
    end if;
    // ================================================================
    if (not exists(select cname from sys.syscolumns where cname='R3255' and tname='repair' and creator='mt')) then
        alter table mt.repair add R3255 char(48);
        call mt.mtx_newcust('3255','R3255','unused string','never','X','16','SPVAL','48','Y');
    else
        set ntmp = (select length from sys.syscolumns where cname = 'R3255' and tname = 'repair' and creator = 'mt');
        if (ntmp < 48) then
            alter table mt.repair modify R3255 char(48);
            update mt.customiz set maxlen=48 where fldnum='3255';
        end if;
    end if;
    // ================================================================
    if (not exists(select cname from sys.syscolumns where cname='R3256' and tname='repair' and creator='mt')) then
        alter table mt.repair add R3256 char(48);
        call mt.mtx_newcust('3256','R3256','unused string','never','X','16','SPVAL','48','Y');
    else
        set ntmp = (select length from sys.syscolumns where cname = 'R3256' and tname = 'repair' and creator = 'mt');
        if (ntmp < 48) then
            alter table mt.repair modify R3256 char(48);
            update mt.customiz set maxlen=48 where fldnum='3256';
        end if;
    end if;
    // ================================================================
    if (not exists(select cname from sys.syscolumns where cname='R3257' and tname='repair' and creator='mt')) then
        alter table mt.repair add R3257 char(48);
        call mt.mtx_newcust('3257','R3257','unused string','never','X','16','SPVAL','48','Y');
    else
        set ntmp = (select length from sys.syscolumns where cname = 'R3257' and tname = 'repair' and creator = 'mt');
        if (ntmp < 48) then
            alter table mt.repair modify R3257 char(48);
            update mt.customiz set maxlen=48 where fldnum='3257';
        end if;
    end if;
    // ================================================================
    if (not exists(select cname from sys.syscolumns where cname='R3258' and tname='repair' and creator='mt')) then
        alter table mt.repair add R3258 char(48);
        call mt.mtx_newcust('3258','R3258','unused string','never','X','16','SPVAL','48','Y');
    else
        set ntmp = (select length from sys.syscolumns where cname = 'R3258' and tname = 'repair' and creator = 'mt');
        if (ntmp < 48) then
            alter table mt.repair modify R3258 char(48);
            update mt.customiz set maxlen=48 where fldnum='3258';
        end if;
    end if;
    // ================================================================
    if (not exists(select cname from sys.syscolumns where cname='R3259' and tname='repair' and creator='mt')) then
        alter table mt.repair add R3259 char(48);
        call mt.mtx_newcust('3259','R3259','unused string','never','X','16','SPVAL','48','Y');
    else
        set ntmp = (select length from sys.syscolumns where cname = 'R3259' and tname = 'repair' and creator = 'mt');
        if (ntmp < 48) then
            alter table mt.repair modify R3259 char(48);
            update mt.customiz set maxlen=48 where fldnum='3259';
        end if;
    end if;
    // ================================================================
    if (not exists(select cname from sys.syscolumns where cname='R3260' and tname='repair' and creator='mt')) then
        alter table mt.repair add R3260 char(48);
        call mt.mtx_newcust('3260','R3260','unused string','never','X','16','SPVAL','48','Y');
    else
        set ntmp = (select length from sys.syscolumns where cname = 'R3260' and tname = 'repair' and creator = 'mt');
        if (ntmp < 48) then
            alter table mt.repair modify R3260 char(48);
            update mt.customiz set maxlen=48 where fldnum='3260';
        end if;
    end if;
    // ================================================================
    if (not exists(select cname from sys.syscolumns where cname='R3261' and tname='repair' and creator='mt')) then
        alter table mt.repair add R3261 date;
        call mt.mtx_newcust('3261','R3261','unused date','never','X','16','DATE','10','Y');
    end if;
    // ================================================================
    if (not exists(select cname from sys.syscolumns where cname='R3262' and tname='repair' and creator='mt')) then
        alter table mt.repair add R3262 date;
        call mt.mtx_newcust('3262','R3262','unused date','never','X','16','DATE','10','Y');
    end if;
    // ================================================================
    if (not exists(select cname from sys.syscolumns where cname='R3263' and tname='repair' and creator='mt')) then
        alter table mt.repair add R3263 date;
        call mt.mtx_newcust('3263','R3263','unused date','never','X','16','DATE','10','Y');
    end if;
    // ================================================================
    if (not exists(select cname from sys.syscolumns where cname='R3264' and tname='repair' and creator='mt')) then
        alter table mt.repair add R3264 date;
        call mt.mtx_newcust('3264','R3264','unused date','never','X','16','DATE','10','Y');
    end if;
    // ================================================================
    if (not exists(select cname from sys.syscolumns where cname='R3265' and tname='repair' and creator='mt')) then
        alter table mt.repair add R3265 NUMERIC(12,2);
        call mt.mtx_newcust('3265','R3265','unused number','never','X','16','RTDBL','10','Y');
    end if;
    // ================================================================
    if (not exists(select cname from sys.syscolumns where cname='R3266' and tname='repair' and creator='mt')) then
        alter table mt.repair add R3266 NUMERIC(12,2);
        call mt.mtx_newcust('3266','R3266','unused number','never','X','16','RTDBL','10','Y');
    end if;
    // ================================================================
    if (not exists(select cname from sys.syscolumns where cname='R3267' and tname='repair' and creator='mt')) then
        alter table mt.repair add R3267 NUMERIC(12,2);
        call mt.mtx_newcust('3267','R3267','unused number','never','X','16','RTDBL','10','Y');
    end if;
    // ================================================================
    if (not exists(select cname from sys.syscolumns where cname='R3268' and tname='repair' and creator='mt')) then
        alter table mt.repair add R3268 NUMERIC(12,2);
        call mt.mtx_newcust('3268','R3268','unused number','never','X','16','RTDBL','10','Y');
    end if;
    // ================================================================
    if (not exists(select cname from sys.syscolumns where cname='R3269' and tname='repair' and creator='mt')) then
        alter table mt.repair add R3269 NUMERIC(12,2);
        call mt.mtx_newcust('3269','R3269','unused number','never','X','16','RTDBL','10','Y');
    end if;
    // ================================================================
    if (not exists(select cname from sys.syscolumns where cname='R3270' and tname='repair' and creator='mt')) then
        alter table mt.repair add R3270 char(128) default NULL;
        call mt.mtx_newcust('3270','R3270','OLE Document','never','X','16','RO','128','Y');
    end if;
    // ================================================================
    update mt.repair set R3209 = 0 where R3209 is null;
    update mt.repair set R3212 = 0 where R3212 is null;
    update mt.repair set R3215 = 0 where R3215 is null;
    update mt.repair set R3218 = 0 where R3218 is null;
    update mt.repair set R3221 = 0 where R3221 is null;
    update mt.repair set R3224 = 0 where R3224 is null;
    update mt.repair set R3227 = 0 where R3227 is null;
    update mt.repair set R3231 = 0 where R3231 is null;
    update mt.repair set R3232 = 0 where R3232 is null;
    update mt.repair set R3235 = 0 where R3235 is null;
    update mt.repair set R3229 = 0 where R3229 is null;
    update mt.repair set R3238 = 0 where R3238 is null;
    update mt.repair set R3239 = 0 where R3239 is null;
    message 'repair block 1: ', 'fini';
end;;
begin
    declare ntmp integer;
    message 'inventory block 1: ', 'start';
    // ========================================
    // inventory
    //

	if exists(select fldnum from mt.customiz where fldnum = '2890' and len = 5) then
        delete from customiz where fldnum like '2890';
    end if;
	if exists(select fldnum from mt.customiz where fldnum = '2891' and len = 5) then
        delete from customiz where fldnum like '2891';
    end if;
	if exists(select fldnum from mt.customiz where fldnum = '2892' and len = 5) then
        delete from customiz where fldnum like '2892';
    end if;
	if exists(select fldnum from mt.customiz where fldnum = '2893' and len = 5) then
        delete from customiz where fldnum like '2893';
    end if;
	if exists(select fldnum from mt.customiz where fldnum = '2894' and len = 5) then
        delete from customiz where fldnum like '2894';
    end if;
	if exists(select fldnum from mt.customiz where fldnum = '2895' and len = 5) then
        delete from customiz where fldnum like '2895';
    end if;

    call mtx_newcust('IMTAG','MTAG','Unique ID'        ,'never','X','2', 'RO','15','Y');
    set ntmp = (select length from sys.syscolumns where cname = 'mtag' and tname='inventory' and creator='mt');
    if (ntmp < 80) then
        alter table mt.inventory modify mtag char(80);
        update mt.customiz set maxlen='80' where fldnum='imtag';
    end if;
    if exists(select cname from sys.syscolumns where cname = 'ktag' and tname = 'inventory') then
        set ntmp = (select length from sys.syscolumns where cname = 'ktag' and tname='inventory' and creator='mt');
        if (ntmp < 80) then
            alter table mt.inventory modify ktag char(80);
            update mt.customiz set maxlen='80' where fldnum='iktag';
        end if;
    else
        alter table mt.inventory add ktag char(80);
        call mtx_newcust('IKTAG','KTAG','Unique ID'       ,'never','X' ,'2', 'RO','60','Y');
    end if;
    // ================================================================
    set ntmp = (select length from sys.syscolumns where cname = 'I4202' and tname='inventory' and creator='mt');
    if (ntmp < 30)
    then
        alter table mt.inventory modify I4202 char(30);
        call mtxmsg('alter table','I4202 now 30');
    end if;
    // ================================================================
    call mtx_cust_up('4201', 'I4201','RO' ,60, 2);
    update mt.customiz set datalen = 60, ilevels='123' where fldnum='4201';
    // ================================================================
    set ntmp = (select length from sys.syscolumns where cname = 'I4203' and tname='inventory' and creator='mt');
    if (ntmp < 30)
    then
        alter table mt.inventory modify I4203 char(30);
        call mtxmsg('alter table','I4203 now 30');
    end if;
    call mtx_cust_up('4202', 'I4202','SPVAL' ,'30', '2');
    // ================================================================
    call mtx_cust_up('4203', 'I4203','SPVAL' ,'30', '2');
    // ================================================================
    set ntmp = (select length from sys.syscolumns where cname = 'I4204' and tname='inventory' and creator='mt');
    if (ntmp < 60)
    then
        alter table mt.inventory modify I4204 char(60);
        call mtxmsg('alter table','I4204 now 60');
    end if;
    call mtx_cust_up('4204', 'I4204','SPVAL' ,'60', '2');
    // ================================================================
    call mtx_cust_up('4205', 'I4205','SPVAL' , '1', '2');
    // ================================================================
    set ntmp = (select length from sys.syscolumns where cname = 'I4206' and tname='inventory' and creator='mt');
    if (ntmp < 30)
    then
        alter table mt.inventory modify I4206 char(30);
        call mtxmsg('alter table','I4206 now 30');
    end if;
    call mtx_cust_up('4206', 'I4206','SPVAL' ,'30', '2');
    // ================================================================
    call mtx_cust_up('4207', 'I4207','SPVAL' ,'24', '2');
    call mtx_cust_up('4208', 'I4208','SPVAL' ,'29', '2');
    call mtx_cust_up('4209', 'I4209','SPVAL' , '1', '2');
    call mtx_cust_up('4210', 'I4210','SPVAL' ,'12', '2');
    call mtx_cust_up('4211', 'I4211','SPVAL' ,'15', '2');
    call mtx_cust_up('4212', 'I4212','DATE'  ,'10', '2');
    call mtx_cust_up('4213', 'I4213','SPVAL' ,'10', '2');
    call mtx_cust_up('4214', 'I4214','SPVAL' , '8', '2');
    call mtx_cust_up('4215', 'I4215','SPVAL' , '5', '2');
    call mtx_cust_up('4216', 'I4216','SPVAL' , '5', '2');
    // ================================================================
    set ntmp = (select length from sys.syscolumns where cname = 'I4217' and tname='inventory' and creator='mt');
    if (ntmp < 60)
    then
        alter table mt.inventory modify I4217 char(60);
        update mt.customiz set datalen=60,maxlen=60 where fldnum='4217';
    end if;
    call mtx_cust_up('4217', 'I4217','UCVAL' ,'60', '2');
    // ================================================================
    call mtx_cust_up('4218', 'I4218','SPVAL' , '4', '2');
    // ================================================================
    set ntmp = (select length from sys.syscolumns where cname = 'I4219' and tname='inventory' and creator='mt');
    if (ntmp < 12) then
        alter table mt.inventory modify I4219 decimal(12, 2) default NULL;
        update mt.customiz set maxlen='13' where fldnum='4219';
    end if;
    call mtx_cust_up('4219', 'I4219','RTDBL' ,'12', '2');
    // ================================================================
    call mtx_cust_up('4220', 'I4220','INT'   , '3', '2');
    call mtx_cust_up('4221', 'I4221','DATE'  ,'10', '2');
    call mtx_cust_up('4222', 'I4222','SPVAL' ,'12', '2');
    call mtx_cust_up('4223', 'I4223','SPVAL' ,'16', '2');
    call mtx_cust_up('4224', 'I4224','DATE'  ,'10', '2');
    call mtx_cust_up('4225', 'I4225','SPVAL' , '8', '2');
    call mtx_cust_up('4226', 'I4226','SPVAL' , '1', '2');
    call mtx_cust_up('4228', 'I4228','SPVAL' , '1', '2');
    call mtx_cust_up('4229', 'I4229','INT'   , '3', '2');
    call mtx_cust_up('4230', 'I4230','INT'   , '3', '2');
    call mtx_cust_up('4231', 'I4231','SPVAL' ,'32', '2');
    call mtx_cust_up('4232', 'I4232','SPVAL' ,'32', '2');
    call mtx_cust_up('4233', 'I4233','SPVAL' ,'32', '2');
    call mtx_cust_up('4234', 'I4234','SPVAL' ,'32', '2');
    call mtx_cust_up('4235', 'I4235','SPVAL' ,'32', '2');
    // ================================================================
    call mtx_newcust('4236','I4236','DateTime Entered','never','X','2', 'RO','15','Y');
    update mt.customiz set title= 'DateTime Entered',tooltip='DateTime Entered' where fldnum='4236';
    
    COMMENT ON COLUMN mt.inventory.I4236 IS 'DateTime Entered';
    call mtx_newcust('4237','I4237','Who Entered'     ,'never','X','2', 'RO','16','Y');
    alter table mt.inventory modify I4236 default current timestamp;
    
    update mt.customiz set title= 'Who Entered',tooltip='Who Entered' where fldnum='4237';
    COMMENT ON COLUMN mt.inventory.I4237 IS 'Who Entered';

    call mtx_newcust('4238','I4238','DateTime Modified' ,'never','X','2', 'RO','15','Y');
    update mt.customiz set title= 'DateTime Modified',tooltip='DateTime Modified' where fldnum='4238';
    COMMENT ON COLUMN mt.inventory.I4238 IS 'DateTime Modified';

    alter table mt.inventory modify I4238 default current timestamp;
    call mtx_newcust('4239','I4239','Who Modified'      ,'never','X','2', 'RO','16','Y');
    update mt.customiz set title= 'Who Modified',tooltip='Who Modified' where fldnum='4239';
    COMMENT ON COLUMN mt.Inventory.I4239 IS 'Who Modified';
    // ================================================================
    if (not exists(select cname from sys.syscolumns where cname='I4241' and tname='inventory' and creator='mt')) then
        alter table mt.inventory add I4241 char(80) default '';
        call mt.mtx_newcust('4241','I4241','Default Calibration Procedure','none','N','2','SPVAL','80','Y');
    else
        set ntmp = (select length from sys.syscolumns where cname = 'I4241' and tname='inventory' and creator='mt');
        if (ntmp < 80) then
            alter table mt.inventory modify I4241 char(80) default '';
            update mt.customiz set maxlen='80' where fldnum='4241';
        end if
    end if;
    call mtx_cust_up('4240', 'I4240','SPVAL' , '8', '2');
    // ================================================================
    call mtx_newcust('4241','I4241','Master Procedure','none','N','2','SPVAL','80','Y');
    call mtx_cust_up('4241', 'I4241','SPVAL' ,'80', '2');
    // ================================================================
    if (not exists(select cname from sys.syscolumns where cname='I4242' and tname='inventory' and creator='mt')) then
        alter table mt.inventory add I4242 char(80) default '';
        call mt.mtx_newcust('4242','I4242','User Defined','none','N','2','SPVAL','80','Y');
    else
        set ntmp = (select length from sys.syscolumns where cname = 'I4242' and tname='inventory' and creator='mt');
        if (ntmp < 80) then
            alter table mt.inventory modify I4242 char(80) default '';
            update mt.customiz set maxlen='80' where fldnum='4242';
        end if
    end if;
    call mtx_newcust('4242','I4242','User Defined','none','N','2','SPVAL','80','Y');
    call mtx_cust_up('4242', 'I4242','SPVAL' ,'80', '2');
    // ================================================================
    if (not exists(select cname from sys.syscolumns where cname='I4243' and tname='inventory' and creator='mt')) then
        alter table mt.inventory add I4243 char(80) default '';
    else
        set ntmp = (select length from sys.syscolumns where cname = 'I4243' and tname='inventory' and creator='mt');
        if (ntmp < 80) then
            alter table mt.inventory modify I4243 char(80) default '';
            update mt.customiz set maxlen='80' where fldnum='4243';
        end if
    end if;
    call mt.mtx_newcust('4243','I4243','User Defined','none','N','2','SPVAL','80','Y');
    call mtx_cust_up('4243', 'I4243','SPVAL' ,'80', '2');
    // ================================================================
    if (not exists(select cname from sys.syscolumns where cname='I4244' and tname='inventory' and creator='mt')) then
        alter table mt.inventory add I4244 char(48) default NULL;
    end if;
    call mtx_newcust('4244','I4244','unused string'    ,'none' ,'N','2', 'SPVAL','48','Y');
    COMMENT ON COLUMN mt.Inventory.I4244 IS 'Auxiliary.';
    // ================================================================
    if (not exists(select cname from sys.syscolumns where cname='I4245' and tname='inventory' and creator='mt')) then
        alter table mt.inventory add I4245 char(48) default NULL;
    end if;
    call mtx_newcust('4245','I4245','unused string'    ,'none' ,'N','2', 'SPVAL','48','Y');
    COMMENT ON COLUMN mt.Inventory.I4245 IS 'Auxiliary.';
    // ================================================================
    if (not exists(select cname from sys.syscolumns where cname='I4246' and tname='inventory' and creator='mt')) then
        alter table mt.inventory add I4246 char(48) default NULL;
    end if;
    call mtx_newcust('4246','I4246','unused string'    ,'none' ,'N','2', 'SPVAL','48','Y');
    COMMENT ON COLUMN mt.Inventory.I4246 IS 'Auxiliary.';
    // ================================================================
    if (not exists(select cname from sys.syscolumns where cname='I4247' and tname='inventory' and creator='mt')) then
        alter table mt.inventory add I4247 char(48) default NULL;
    end if;
    call mtx_newcust('4247','I4247','unused string'    ,'none' ,'N','2', 'SPVAL','48','Y');
    COMMENT ON COLUMN mt.Inventory.I4247 IS 'Auxiliary.';
    // ================================================================
    if (not exists(select cname from sys.syscolumns where cname='I4248' and tname='inventory' and creator='mt')) then
        alter table mt.inventory add I4248 char(48) default NULL;
    end if;
    call mtx_newcust('4248','I4248','unused string'    ,'none' ,'N','2', 'SPVAL','48','Y');
    COMMENT ON COLUMN mt.Inventory.I4248 IS 'Auxiliary.';
    // ================================================================
    if (not exists(select cname from sys.syscolumns where cname='I4249' and tname='inventory' and creator='mt')) then
        alter table mt.inventory add I4249 char(48) default NULL;
    end if;
    call mtx_newcust('4249','I4249','unused string'    ,'none' ,'N','2', 'SPVAL','48','Y');
    COMMENT ON COLUMN mt.Inventory.I4249 IS 'Auxiliary.';
    // ================================================================
    if (not exists(select cname from sys.syscolumns where cname='I4250' and tname='inventory' and creator='mt')) then
        alter table mt.inventory add I4250 date default NULL;
    end if;
    call mtx_newcust('4250','I4250','unused date'      ,'never','X','2', 'DATE' , '8','Y');
    COMMENT ON COLUMN mt.Inventory.I4250 IS 'Auxiliary.';
    // ================================================================
    if (not exists(select cname from sys.syscolumns where cname='I4251' and tname='inventory' and creator='mt')) then
        alter table mt.inventory add I4251 date default NULL;
    end if;
    call mtx_newcust('4251','I4251','unused date'      ,'never','X','2', 'DATE' , '8','Y');
    COMMENT ON COLUMN mt.Inventory.I4251 IS 'Auxiliary.';
    // ================================================================
    if (not exists(select cname from sys.syscolumns where cname='I4252' and tname='inventory' and creator='mt')) then
        alter table mt.inventory add I4252 date default NULL;
    end if;
    call mtx_newcust('4252','I4252','unused date'      ,'never','X','2', 'DATE' , '8','Y');
    COMMENT ON COLUMN mt.Inventory.I4252 IS 'Auxiliary.';
    // ================================================================
    if (not exists(select cname from sys.syscolumns where cname='I4253' and tname='inventory' and creator='mt')) then
        alter table mt.inventory add I4253 date default NULL;
    end if;
    call mtx_newcust('4253','I4253','unused date'      ,'never','X','2', 'DATE' , '8','Y');
    COMMENT ON COLUMN mt.Inventory.I4253 IS 'Auxiliary.';
    // ================================================================
    if (not exists(select cname from sys.syscolumns where cname='I4254' and tname='inventory' and creator='mt')) then
        alter table mt.inventory add I4254 decimal(12,2) default NULL;
    end if;
    call mtx_newcust('4254','I4254','unused number'    ,'never','X','2', 'RTDBL','10','Y');
    COMMENT ON COLUMN mt.Inventory.I4254 IS 'Auxiliary.';
    // ================================================================
    if (not exists(select cname from sys.syscolumns where cname='I4255' and tname='inventory' and creator='mt')) then
        alter table mt.inventory add I4255 decimal(12,2) default NULL;
    end if;
    call mtx_newcust('4255','I4255','unused number'    ,'never','X','2', 'RTDBL','10','Y');
    COMMENT ON COLUMN mt.Inventory.I4255 IS 'Auxiliary.';
    // ================================================================
    if (not exists(select cname from sys.syscolumns where cname='I4256' and tname='inventory' and creator='mt')) then
        alter table mt.inventory add I4256 decimal(12,2) default NULL;
    end if;
    call mtx_newcust('4256','I4256','unused number'    ,'never','X','2', 'RTDBL','10','Y');
    COMMENT ON COLUMN mt.Inventory.I4256 IS 'Auxiliary.';
    // ================================================================
    if (not exists(select cname from sys.syscolumns where cname='I4257' and tname='inventory' and creator='mt')) then
        alter table mt.inventory add I4257 decimal(12,2) default NULL;
    end if;
    call mtx_newcust('4257','I4257','unused number'    ,'never','X','2', 'RTDBL','10','Y');
    COMMENT ON COLUMN mt.Inventory.I4257 IS 'Auxiliary.';
    // ================================================================
    if (not exists(select cname from sys.syscolumns where cname='I4258' and tname='inventory' and creator='mt')) then
        alter table mt.inventory add I4258 char(1) default '';
        call mt.mtx_newcust('4258','I4258','Abeyance State','none','N','2','SPVAL','1','Y');
        COMMENT ON COLUMN mt.Inventory.I4258 IS 'Abeyance bag state.';
    else
        set ntmp = (select length from sys.syscolumns where cname = 'I4258' and tname='inventory' and creator='mt');
        if (ntmp < 1) then
            alter table mt.inventory modify I4258 char(1) default 'N';
            update mt.customiz set maxlen='1' where fldnum='4258';
        end if
    end if;
    // ================================================================
    if (not exists(select cname from sys.syscolumns where cname='I4259' and tname='inventory' and creator='mt')) then
        alter table mt.inventory add I4259 int default '0';
        call mt.mtx_newcust('4259','I4259','Abeyance Interval','none','N','2','INT','4','Y');
        COMMENT ON COLUMN mt.Inventory.I4259 IS 'Abeyance interval.';
    else
        update mt.inventory set I4259='0' where ((I4259 is null) or (I4259 < 0) or (I4259 > 99999));
        set ntmp = (select length from sys.syscolumns where cname = 'I4259' and tname='inventory' and creator='mt');
        if (ntmp <> 4) then
            update mt.inventory set I4259='0' where I4259='N';
            alter table mt.inventory modify I4259 int default '0';
            update mt.customiz set len='4',datalen='4',maxlen='4',ftype='INT' where fldnum='4259';
            if (exists(select table_name from sys.syscolumns where table_name = "me2_customiz")) then
                update mt.me2_customiz set len='4',datalen='4',maxlen='4',ftype='INT' where fldnum='4259';
            end if;
        end if;
    end if;
    alter table mt.inventory modify I4259 default '0';
    // ================================================================
    if (not exists(select cname from sys.syscolumns where cname='I4260' and tname='inventory' and creator='mt')) then
        alter table mt.inventory add I4260 long varchar default '';
        call mt.mtx_newcust('4260','I4260','Inventory Notes','never','X','2','MEMO','32767','Y');
    end if;
    // ================================================================
    if (not exists(select cname from sys.syscolumns where cname='I4261' and tname='inventory' and creator='mt')) then
        alter table mt.inventory add I4261 char(128) default NULL;
        call mt.mtx_newcust('4261','I4261','OLE Document','never','X','2','RO','128','Y');
    end if;
    // ================================================================
    if (not exists(select cname from sys.syscolumns where cname='I4262' and tname='inventory' and creator='mt')) then
        alter table mt.inventory add I4262 char(128) default '';
        call mt.mtx_newcust('4262','I4262','Notes','none','N','2','SPVAL','80','Y');
    else
        set ntmp = (select length from sys.syscolumns where cname = 'I4262' and tname='inventory' and creator='mt');
        if (ntmp < 128) then
            alter table mt.inventory modify I4262 char(128) default '';
            update mt.customiz set maxlen='128' where fldnum='4262';
        end if
    end if;
    // ================================================================
    call mtx_cust_up('4299', 'I4299','SPVAL' , '1', '2');
    // ================================================================
    if (not exists(select cname from sys.syscolumns where cname='IPUBLISH' and tname='inventory'))then
        alter table mt.inventory add IPUBLISH char(32);
        update mt.inventory set ipublish = 'mtrack';
    end if;
    alter table mt.inventory modify IPUBLISH default 'mtrack';
    alter table mt.inventory modify IPUBLISH null;
    alter table mt.inventory modify I4228 default 'D';
    alter table mt.inventory modify I4229 default 0;
    alter table mt.inventory modify I4240 default 'MT';
    update inventory set I4258 = 'N' where I4258 is null;
    update inventory set ktag = NULL where ktag not in (select ktag from customers);
    // ================================================================
    // Sept 97, DSRC was renamed to IDSRC. Some databases may have DSRC, so it has to be renamed.
    if exists (select cname from sys.syscolumns where cname='DSRC' and tname='inventory' and creator='mt') then
        alter table inventory rename dsrc to idsrc;
    end if;
    if not exists  ( select cname from sys.syscolumns where cname='IDSRC' and tname='inventory' and creator='mt') then
        alter table mt.inventory add IDSRC char(3) default NULL;
        update mt.inventory set IDSRC = 'PRE';
        call mtx_newcust('IDSRC','IDSRC','Data Source'     ,'never','X','2', 'RO', '3','Y');
    end if;
    if not exists  ( select cname from sys.syscolumns where cname='replic' and tname = 'inventory' and creator = 'mt') then
        begin
            alter table mt.inventory add replic char(1) default NULL;
        end
    end if;
    update mt.inventory set ktag=NULL where ktag='';
    message 'inventory block 1: ', 'fini';
end;;
begin
    // ========================================
    //assethistory
    //
    alter table mt.assethistory modify mtag char(80);
end;;
begin
    // =========================================
    // customer table.
    //
    //
    declare ntmp integer;

    if (exists (select table_name from sys.systable where table_name='customers' and table_type='BASE'))
    then
        // modify the entire mt.customers table
        // =========================================
        alter table mt.customers modify ktag char(80) not null;
        // =========================================
        set ntmp = (select length from sys.syscolumns where tname='customers' and cname='KPUBLISH' and creator='mt');
        if (ntmp < 32) then
            alter table mt.customers modify KPUBLISH char(32);
        end if;
        alter table mt.customers modify KPUBLISH null;
        // =========================================
        set ntmp = (select length from sys.syscolumns where tname='customers' and cname='K4601' and creator='mt');
        if (ntmp < 48) then
            alter table mt.customers modify K4601 char(48);
            update mt.customiz set maxlen='48' where fldnum='4601';
        end if;
        // =========================================
        set ntmp = (select length from sys.syscolumns where tname='customers' and cname='K4602' and creator='mt');
        if (ntmp < 48) then
            alter table mt.customers modify K4602 char(48);
            update mt.customiz set maxlen='48' where fldnum='4602';
        end if;
        // =========================================
        set ntmp = (select length from sys.syscolumns where tname='customers' and cname='K4603' and creator='mt');
        if (ntmp < 48) then
            alter table mt.customers modify K4603 char(48);
            update mt.customiz set maxlen='48' where fldnum='4603';
        end if;
        // =========================================
        set ntmp = (select length from sys.syscolumns where tname='customers' and cname='K4604' and creator='mt');
        if (ntmp < 48) then
            alter table mt.customers modify K4604 char(48);
            update mt.customiz set maxlen='48' where fldnum='4604';
        end if;
        // =========================================
        set ntmp = (select length from sys.syscolumns where tname='customers' and cname='K4605' and creator='mt');
        if (ntmp < 48) then
            alter table mt.customers modify K4605 char(48);
        end if;
        update mt.customiz set maxlen='48' where fldnum='4605';
        // =========================================
        set ntmp = (select length from sys.syscolumns where tname='customers' and cname='K4606' and creator='mt');
        if (ntmp < 48) then
            alter table mt.customers modify K4606 char(48);
        end if;
        update mt.customiz set maxlen='48' where fldnum='4606';
        // =========================================
        set ntmp = (select length from sys.syscolumns where tname='customers' and cname='K4607' and creator='mt');
        if (ntmp < 48) then
            alter table mt.customers modify K4607 char(48);
        end if;
        update mt.customiz set maxlen='48' where fldnum='4607';
        // =========================================
        set ntmp = (select length from sys.syscolumns where tname='customers' and cname='K4608' and creator='mt');
        if (ntmp < 48) then
            alter table mt.customers modify K4608 char(48);
        end if;
        update mt.customiz set maxlen='48' where fldnum='4608';
        // =========================================
        set ntmp = (select length from sys.syscolumns where tname='customers' and cname='K4609' and creator='mt');
        if (ntmp < 48) then
            alter table mt.customers modify K4609 char(48);
        end if;
        update mt.customiz set maxlen='48' where fldnum='4609';
        // =========================================
        set ntmp = (select length from sys.syscolumns where tname='customers' and cname='K4610' and creator='mt');
        if (ntmp < 48) then
            alter table mt.customers modify K4610 char(48);
        end if;
        update mt.customiz set maxlen='48' where fldnum='4610';
        // =========================================
        set ntmp = (select length from sys.syscolumns where tname='customers' and cname='K4611' and creator='mt');
        if (ntmp < 48) then
            alter table mt.customers modify K4611 char(48);
            update mt.customiz set maxlen='48' where fldnum='4611';
        end if;
        // =========================================
        set ntmp = (select length from sys.syscolumns where tname='customers' and cname='K4612' and creator='mt');
        if (ntmp < 48) then
            alter table mt.customers modify K4612 char(48);
            update mt.customiz set maxlen='48' where fldnum='4612';
        end if;
        // =========================================
        set ntmp = (select length from sys.syscolumns where tname='customers' and cname='K4613' and creator='mt');
        if (ntmp < 48) then
            alter table mt.customers modify K4613 char(48);
            update mt.customiz set maxlen='48' where fldnum='4613';
        end if;
        // =========================================
        set ntmp = (select length from sys.syscolumns where tname='customers' and cname='K4614' and creator='mt');
        if (ntmp < 48) then
            alter table mt.customers modify K4614 char(48);
            update mt.customiz set maxlen='48' where fldnum='4614';
        end if;
        // =========================================
        set ntmp = (select length from sys.syscolumns where tname='customers' and cname='K4615' and creator='mt');
        if (ntmp < 48) then
            alter table mt.customers modify K4615 char(48);
            update mt.customiz set maxlen='48' where fldnum='4615';
        end if;
        // =========================================
        set ntmp = (select length from sys.syscolumns where tname='customers' and cname='K4616' and creator='mt');
        if (ntmp < 48) then
            alter table mt.customers modify K4616 char(48);
            update mt.customiz set maxlen='48' where fldnum='4616';
        end if;
        // =========================================
        set ntmp = (select length from sys.syscolumns where tname='customers' and cname='K4617' and creator='mt');
        if (ntmp < 48) then
            alter table mt.customers modify K4617 char(48);
            update mt.customiz set maxlen='48' where fldnum='4617';
        end if;
        // =========================================
        set ntmp = (select length from sys.syscolumns where tname='customers' and cname='K4618' and creator='mt');
        if (ntmp < 48) then
            alter table mt.customers modify K4618 char(48);
            update mt.customiz set maxlen='48' where fldnum='4618';
        end if;
        // =========================================
        set ntmp = (select length from sys.syscolumns where tname='customers' and cname='K4619' and creator='mt');
        if (ntmp < 48) then
            alter table mt.customers modify K4619 char(48);
            update mt.customiz set maxlen='48' where fldnum='4619';
        end if;
        // =========================================
        set ntmp = (select length from sys.syscolumns where tname='customers' and cname='K4620' and creator='mt');
        if (ntmp < 48) then
            alter table mt.customers modify K4620 char(48);
            update mt.customiz set maxlen='48' where fldnum='4620';
        end if;
        // =========================================
        set ntmp = (select length from sys.syscolumns where tname='customers' and cname='K4625' and creator='mt');
        if (ntmp < 12) then
            alter table mt.customers modify K4625 decimal(12,2) default NULL;
        end if;
        // =========================================
        set ntmp = (select length from sys.syscolumns where tname='customers' and cname='K4626' and creator='mt');
        if (ntmp < 12) then
            alter table mt.customers modify K4626 decimal(12,2) default NULL;
        end if;
        // =========================================
        set ntmp = (select length from sys.syscolumns where tname='customers' and cname='K4627' and creator='mt');
        if (ntmp < 12) then
            alter table mt.customers modify K4627 decimal(12,2) default NULL;
        end if;
        // =========================================
        set ntmp = (select length from sys.syscolumns where tname='customers' and cname='K4628' and creator='mt');
        if (ntmp < 12) then
            alter table mt.customers modify K4628 decimal(12,2) default NULL;
        end if;
        // =========================================
        call mtx_add_or_alter_field('K4629','customers','timestamp default current timestamp','4629','Who Entered','never','X',32, 'RO'  , 15,'Y');
        call mtx_add_or_alter_field('K4630','customers','char(16) default current user','4630','DateTime Entered'     ,'never','X',32, 'RO'  , 16,'Y');
        call mtx_add_or_alter_field('K4631','customers','timestamp default current timestamp','4631','DateTime Modified' ,'never','X',32, 'RO'  , 15,'Y');
        call mtx_add_or_alter_field('K4632','customers','char(16) default current user','4632','Who Modified'      ,'never','X',32, 'RO'  , 16,'Y');
        call mtx_add_or_alter_field('K4640','customers','char (8) not null default ''MT''','4640','Segregate', 'fixed','X',32, 'SPVAL'  , 8,'Y');
        call mtx_add_or_alter_field('K4633','customers','char(40) default NULL','4633','User Defined','never','X',32, 'SPVAL'  , 40,'Y');
        call mtx_add_or_alter_field('K4634','customers','char(30) default NULL','4634','User Defined','never','X',32, 'SPVAL'  , 30,'Y');
        call mtx_add_or_alter_field('K4635','customers','char(20) default NULL','4635','User Defined','never','X',32, 'SPVAL'  , 20,'Y');
        call mtx_add_or_alter_field('K4636','customers','char(20) default NULL','4636','User Defined','never','X',32, 'SPVAL'  , 20,'Y');
        call mtx_add_or_alter_field('K4637','customers','char(60) default NULL','4637','User Defined','never','X',32, 'SPVAL'  , 60,'Y');
        update mt.customiz set title='DateTime Entered',tooltip='DateTime Entered' where fldnum='4629';
        alter table mt.customers modify K4629 default current timestamp;
        update mt.customiz set title='Who Entered',tooltip='Who Entered' where fldnum='4630';
        update mt.customiz set title='DateTime Modified',tooltip='DateTime Modified' where fldnum='4631';
        alter table mt.customers modify K4631 default current timestamp;
        update mt.customiz set title='Who Modified',tooltip='Who Modified' where fldnum='4632';
        update mt.customiz set ftype='SPVAL' where datacol in ('K4633', 'K4634', 'K4635', 'K4636', 'K4637');
        COMMENT ON COLUMN mt.customers.K4629 IS 'DateTime Entered';
        COMMENT ON COLUMN mt.customers.K4630 IS 'DateTime Entered';
        COMMENT ON COLUMN mt.customers.K4631 IS 'DateTime Modified';
        COMMENT ON COLUMN mt.customers.K4632 IS 'DateTime Modified';

        // =========================================
        if not exists (select cname from sys.syscolumns where cname ='KDSRC' and tname ='customers') then
            alter table mt.customers add KDSRC char(3);
        end if;
        // =========================================
        if not exists (select cname from sys.syscolumns where cname ='kreplic' and tname ='customers') then
            alter table mt.customers add kreplic char(1);
        end if;
        // =========================================
        alter table mt.customers modify K4601 not null;
        // =========================================
    else
        // create the mt.customers table
        call mt.mtxmsg('customer_table','creating mt.customers table');
        create table mt.customers 
            (
            KTAG char(80) not null,
            KPUBLISH char(32),
            K4601 char(48) not null,
            K4602 char(48),
            K4603 char(48),
            K4604 char(48),
            K4605 char(48),
            K4606 char(48),
            K4607 char(48),
            K4608 char(48),
            K4609 char(48),
            K4610 char(48),
            K4611 char(48),
            K4612 char(48),
            K4613 char(48),
            K4614 char(48),
            K4615 char(48),
            K4616 char(48),
            K4617 char(48),
            K4618 char(48),
            K4619 char(48),
            K4620 char(48),
            K4621 date,
            K4622 date,
            K4623 date, 
            K4624 date,
            K4625 decimal(12,2),
            K4626 decimal(12,2),
            K4627 decimal(12,2),
            K4628 decimal(12,2),
            K4629 timestamp default current timestamp,
            K4630 char(16) default current user,
            K4631 timestamp,
            K4632  char(16),
            K4633 char(20) default null,
            K4634 char(20) default null,
            K4635 char(20) default null,
            K4636 char(20) default null,
            K4637 char(20) default null,
            KDSRC char(3),
            kreplic char(1),
            K4640 char (8)
            );
        alter table mt.customers modify KTAG not null;
        alter table mt.customers modify K4601 not null;
        alter table mt.customers modify K4640 not null default 'MT';
    end if;

    if (not exists(select table_name from sys.systable where table_name='customerlist' and table_type='view'))then
        create view mt.customerlist as select K4601,KTAG,kreplic from mt.customers;
    end if;
    call mtx_newcust('4601','K4601','Customer ID'    ,'never','X', '32', 'RO'   , '48','N');
    call mtx_newcust('4602','K4602','Customer Name'  ,'never','X', '32', 'SPVAL', '48','N');
    call mtx_newcust('4603','K4603','Street'         ,'none' ,'N', '32', 'SPVAL', '48','N');
    call mtx_newcust('4604','K4604','City'           ,'none' ,'N', '32', 'SPVAL', '48','N');
    call mtx_newcust('4605','K4605','State'          ,'none' ,'N', '32', 'SPVAL', '48','N');
    call mtx_newcust('4606','K4606','Zip'            ,'none' ,'N', '32', 'SPVAL', '48','N');
    call mtx_newcust('4607','K4607','Ship to:Street' ,'none' ,'N', '32', 'SPVAL', '48','N');
    call mtx_newcust('4608','K4608','Ship to:City'   ,'none' ,'N', '32', 'SPVAL', '48','N');
    call mtx_newcust('4609','K4609','Ship to:State'  ,'none' ,'N', '32', 'SPVAL', '48','N');
    call mtx_newcust('4610','K4610','Ship to:Zip'    ,'none' ,'N', '32', 'SPVAL', '48','N');
    call mtx_newcust('4611','K4611','Tax Status'     ,'none' ,'N', '32', 'SPVAL', '48','N');
    call mtx_newcust('4612','K4612','unused1'        ,'none' ,'N', '32', 'SPVAL', '48','N');
    call mtx_newcust('4613','K4613','unused2'        ,'none' ,'N', '32', 'SPVAL', '48','N');
    call mtx_newcust('4614','K4614','unused3'        ,'none' ,'N', '32', 'SPVAL', '48','N');
    call mtx_newcust('4615','K4615','unused4'        ,'none' ,'N', '32', 'SPVAL', '48','N');
    call mtx_newcust('4616','K4616','unused5'        ,'none' ,'N', '32', 'SPVAL', '48','N');
    call mtx_newcust('4617','K4617','unused6'        ,'none' ,'N', '32', 'SPVAL', '48','N');
    call mtx_newcust('4618','K4618','unused7'        ,'none' ,'N', '32', 'SPVAL', '48','N');
    call mtx_newcust('4619','K4619','unused8'        ,'none' ,'N', '32', 'SPVAL', '48','N');
    call mtx_newcust('4620','K4620','unused9'        ,'none' ,'N', '32', 'SPVAL', '48','N');
    call mtx_newcust('4621','K4621','Contract Start' ,'never','X', '32', 'DATE' , '10','N');
    call mtx_newcust('4622','K4622','Contract Stop'  ,'never','X', '32', 'DATE' , '10','N');
    call mtx_newcust('4623','K4623','unused date'    ,'never','X', '32', 'DATE' , '10','N');
    call mtx_newcust('4624','K4624','unused date'    ,'never','X', '32', 'DATE' , '10','N');
    call mtx_newcust('4625','K4625','number1'        ,'never','X', '32', 'RTDBL', '10','N');
    call mtx_newcust('4626','K4626','number2'        ,'never','X', '32', 'RTDBL', '10','N');
    call mtx_newcust('4627','K4627','number3'        ,'never','X', '32', 'RTDBL', '10','N');
    call mtx_newcust('4628','K4628','number4'        ,'never','X', '32', 'RTDBL', '10','N');
    call mtx_newcust('4629','K4629','DateTime Created','never','X','32', 'RO'   , '15','Y');
    call mtx_newcust('4630','K4630','Who Created'     ,'never','X','32', 'RO'   , '16','Y');
    call mtx_newcust('4631','K4631','DateTime Modifed','never','X','32', 'RO'   , '15','Y');
    call mtx_newcust('4632','K4632','Who Modifed'     ,'never','X','32', 'RO'   , '16','Y');
	call mtx_newcust('4633','K4633','User Defined'    ,'none','X', '32', 'SPVAL', '40','Y'); 
	call mtx_newcust('4634','K4634','User Defined'    ,'none','X', '32', 'SPVAL', '30','Y');
	call mtx_newcust('4635','K4635','User Defined'    ,'none','X', '32', 'SPVAL', '20','Y');
	call mtx_newcust('4636','K4636','User Defined'    ,'none','X', '32', 'SPVAL', '20','Y');
	call mtx_newcust('4637','K4637','User Defined'    ,'none','X', '32', 'SPVAL', '60','Y');
    call mtx_newcust('4640','K4640','Segregate'       ,'fixed','X','32', 'SPVAL', '8','Y');
    call mtx_newcust('KDSRC','KDSRC','Who Entered'    ,'never','X','32', 'RO'  ,  '3','Y');
    call mtx_newcust('KKTAG','KTAG','Unique ID'       ,'never','X','32', 'RO','30','Y');
    call mtx_newcust('KPUBLISH','KPUBLISH','Publisher','never','X','32', 'RO','32','Y');
    call mtx_newcust('kreplic','kreplic','dup flag'   ,'never','X', '1', 'RO', '1','Y');
    comment on column mt.customers.KTAG     is 'Customer unique tag';
    comment on column mt.customers.KPUBLISH is 'DB source publisher';
    comment on column mt.customers.K4601    is 'Customer ID';
    comment on column mt.customers.K4602    is 'Customer Name';
    comment on column mt.customers.K4603    is 'Street';
    comment on column mt.customers.K4604    is 'City';
    comment on column mt.customers.K4605    is 'State';
    comment on column mt.customers.K4606    is 'Zip';
    comment on column mt.customers.K4607    is 'Ship to:Street';
    comment on column mt.customers.K4608    is 'Ship to:City';
    comment on column mt.customers.K4609    is 'Ship to:State';
    comment on column mt.customers.K4610    is 'Ship to:Zip';
    comment on column mt.customers.K4611    is 'Tax Status';
    comment on column mt.customers.K4612    is 'unused1';
    comment on column mt.customers.K4613    is 'unused2';
    comment on column mt.customers.K4614    is 'unused3';
    comment on column mt.customers.K4615    is 'unused4';
    comment on column mt.customers.K4616    is 'unused5';
    comment on column mt.customers.K4617    is 'unused6';
    comment on column mt.customers.K4618    is 'unused7';
    comment on column mt.customers.K4619    is 'unused8';
    comment on column mt.customers.K4620    is 'unused9';
    comment on column mt.customers.K4621    is 'Contract Start';
    comment on column mt.customers.K4622    is 'Contract Stop';
    comment on column mt.customers.K4623    is 'unused date';
    comment on column mt.customers.K4624    is 'unused date';
    comment on column mt.customers.K4625    is 'number1';
    comment on column mt.customers.K4626    is 'number2';
    comment on column mt.customers.K4627    is 'number3';
    comment on column mt.customers.K4628    is 'number4';
    comment on column mt.customers.K4640    is 'segregate value';
    comment on column mt.customers.K4629    is 'DateTime inserted';
    comment on column mt.customers.K4630    is 'Who inserted';
    comment on column mt.customers.K4631    is 'DateTime modified';
    comment on column mt.customers.K4632    is 'Who modified';
    comment on column mt.customers.KDSRC    is 'core. data source';
    comment on column mt.customers.kreplic  is 'core. duplicate flag';
    update mt.customiz set suppressed ='N', row =144,col=13,len=48,datalen=48,nextfld=2 where fldnum ='4603';
    update mt.customiz set suppressed ='N', row =186,col=14,len=48,datalen=48,nextfld=3 where fldnum ='4604';
    update mt.customiz set suppressed ='N', row =60,col=13,len=32,datalen=32,nextfld=0 where fldnum ='4601';
    update mt.customiz set suppressed ='N', row =102,col=12,len=48,datalen=48,nextfld=1 where fldnum ='4602';
    update mt.customiz set suppressed ='N', row =228,col=15,len=2,datalen=2,nextfld=4 where fldnum ='4605';
    update mt.customiz set suppressed ='N', row =228,col=59,len=10,datalen=10,nextfld=5 where fldnum ='4606';
    update mt.customiz set suppressed ='N', row =291,col=15,len=48,datalen=48,nextfld=7 where fldnum ='4607';
    update mt.customiz set suppressed ='N', row =333,col=15,len=48,datalen=48,nextfld=8 where fldnum ='4608';
    update mt.customiz set suppressed ='N', row =375,col=13,len=2,datalen=2,nextfld=9 where fldnum ='4609';
    update mt.customiz set suppressed ='N', row =375,col=209,len=10,datalen=10,nextfld=11 where fldnum ='4610';
    update mt.customiz set suppressed ='N', row =375,col=101,len=10,datalen=10,nextfld=10 where fldnum ='4611';
    update mt.customiz set suppressed ='N', row =228,col=167,len=16,datalen=48,nextfld=6 where fldnum ='4612';
    update mt.customiz set suppressed ='Y', row =484,col=43,len=48,datalen=48,nextfld=0 where fldnum ='4613';
    update mt.customiz set suppressed ='Y', row =434,col=27,len=48,datalen=48,nextfld=0 where fldnum ='4614';
    update mt.customiz set suppressed ='Y', row =381,col=26,len=48,datalen=48,nextfld=0 where fldnum ='4615';
    update mt.customiz set suppressed ='Y', row =331,col=41,len=48,datalen=48,nextfld=0 where fldnum ='4616';
    update mt.customiz set suppressed ='Y', row =293,col=40,len=48,datalen=48,nextfld=0 where fldnum ='4617';
    update mt.customiz set suppressed ='Y', row =53,col=769,len=48,datalen=48,nextfld=0 where fldnum ='4618';
    update mt.customiz set suppressed ='Y', row =91,col=766,len=48,datalen=48,nextfld=0 where fldnum ='4619';
    update mt.customiz set suppressed ='Y', row =133,col=783,len=48,datalen=48,nextfld=0 where fldnum ='4620';
    update mt.customiz set suppressed ='N', row =375,col=317,len=10,datalen=10,nextfld=12 where fldnum ='4621';
    update mt.customiz set suppressed ='N', row =375,col=425,len=10,datalen=10,nextfld=13 where fldnum ='4622';
    update mt.customiz set suppressed ='Y', row =281,col=805,len=10,datalen=10,nextfld=0 where fldnum ='4623';
    update mt.customiz set suppressed ='Y', row =324,col=814,len=10,datalen=10,nextfld=0 where fldnum ='4624';
    update mt.customiz set suppressed ='Y', row =375,col=806,len=10,datalen=10,nextfld=0 where fldnum ='4625';
    update mt.customiz set suppressed ='Y', row =410,col=836,len=10,datalen=10,nextfld=0 where fldnum ='4626';
    update mt.customiz set suppressed ='Y', row =446,col=854,len=10,datalen=10,nextfld=0 where fldnum ='4627';
    update mt.customiz set suppressed ='Y', row =200,col=972,len=10,datalen=10,nextfld=0 where fldnum ='4628';
    update mt.customiz set suppressed ='Y', row =50,col=0,len=15,datalen=15,nextfld=0 where fldnum ='4629';
    update mt.customiz set suppressed ='Y', row =50,col=0,len=16,datalen=16,nextfld=0 where fldnum ='4630';
    update mt.customiz set suppressed ='Y', row =50,col=0,len=15,datalen=15,nextfld=0 where fldnum ='4631';
    update mt.customiz set suppressed ='Y', row =50,col=0,len=16,datalen=16,nextfld=0 where fldnum ='4632';
    update mt.customiz set suppressed ='Y', row =0,col=0,len=8,datalen=8,nextfld=0 where fldnum ='4640';
    update mt.customiz set suppressed ='Y', row =256,col=970,len=3,datalen=3,nextfld=0 where fldnum ='KDSRC';
    update mt.customiz set suppressed ='Y', row =299,col=971,len=32,datalen=32,nextfld=0 where fldnum ='KKTAG';
    update mt.customiz set suppressed ='Y', row =353,col=970,len=32,datalen=32,nextfld=0 where fldnum ='KPUBLISH';
    update mt.customiz set suppressed ='Y', row =0,col=0,len=3,datalen=3,nextfld=0 where fldnum ='SKDSRC';
    update mt.customiz set suppressed ='Y', row =0,col=0,len=30,datalen=30,nextfld=0 where fldnum ='SKKTAG';
    update mt.customiz set suppressed ='Y', row =0,col=0,len=32,datalen=32,nextfld=0 where fldnum ='SKPUBLISH';

end;;


// =================================================================
//  reports table

begin

    declare tmp integer;
    set tmp = (select width from sys.syscolumn where column_name = 'filename'
                    and table_id in (select table_id from sys.systable 
                    where table_name ='reports' and table_type = 'base' and column_id = 1));
    if (tmp < 128) then 
        alter table mt.reports modify filename char(128);
    end if;
    if not exists(select cname from sys.syscolumns where cname='gseg' and tname='reports' and creator='mt') then
        //%
        // modify the reports table
        alter table mt.reports add gseg char(8) default 'MT';
        update mt.reports set gseg = '<ANY>';
    end if;
    if (not exists(select cname from sys.syscolumns where tname = 'reports' and cname = 'subject' and creator = 'mt'))
    then
	    alter table MT.Reports add "Subject" Char (64);
    end if;
    if (not exists(select cname from sys.syscolumns where tname = 'reports' and cname = 'author' and creator = 'mt'))
    then
	    alter table MT.Reports add "Author" Char (64);
    end if;
    if (not exists(select cname from sys.syscolumns where tname = 'reports' and cname = 'Keywords' and creator = 'mt'))
    then
	    alter table MT.Reports add "Keywords" Char (64);
    end if;
    if (not exists(select cname from sys.syscolumns where tname = 'reports' and cname = 'comments' and creator = 'mt'))
    then
	    alter table MT.Reports add "Comments" Char (64);
    end if;
    if (not exists(select cname from sys.syscolumns where tname = 'reports' and cname = 'prompts' and creator = 'mt'))
    then
	    alter table MT.Reports add "Prompts" Char (1);
    end if;
    if (not exists(select cname from sys.syscolumns where tname = 'reports' and cname = 'reports' and creator = 'mt'))
    then
	    alter table MT.Reports add "Reports" tinyint;
    end if;
    if (not exists(select cname from sys.syscolumns where tname = 'reports' and cname = 'inv' and creator = 'mt'))
    then
	    alter table MT.Reports add "Inv" tinyint;
    end if;
    if (not exists(select cname from sys.syscolumns where tname = 'reports' and cname = 'cal' and creator = 'mt'))
    then
	    alter table MT.Reports add "cal" tinyint;
    end if;
    if (not exists(select cname from sys.syscolumns where tname = 'reports' and cname = 'loc' and creator = 'mt'))
    then
	    alter table MT.Reports add "Loc" tinyint;
    end if;
    if (not exists(select cname from sys.syscolumns where tname = 'reports' and cname = 'maint' and creator = 'mt'))
    then
	    alter table MT.Reports add "Maint" tinyint;
    end if;
    if (not exists(select cname from sys.syscolumns where tname = 'reports' and cname = 'cust' and creator = 'mt'))
    then
	    alter table MT.Reports add "Cust" tinyint;
    end if;
    if (not exists(select cname from sys.syscolumns where tname = 'reports' and cname = 'run-time' and creator = 'mt'))
    then
	    alter table MT.Reports add "Run-Time" tinyint;
    end if;
    update mt.reports set reports = 255 where rptype = 'gen';
    update mt.reports set inv = 255 where rptype = 'inv';
    update mt.reports set cal = 255 where rptype = 'cal';
    update mt.reports set loc = 255 where rptype = 'loc';
    update mt.reports set Cust = 255 where rptype = 'cst';
    update mt.reports set Maint = 255 where rptype = 'rep';
    update mt.reports set Prompts = 'Y' where rptype = 'run';
end;;
// ========================================================================
//
// 
// add the license table, if its not there.
//
begin
    if not exists ( select table_id from sys.systable where table_name ='license') then
        CREATE TABLE mt.license
        (
            pgm_type    char(5),
            serial      char(9),
            authorize       integer DEFAULT 0,
            tcheck      timestamp DEFAULT current timestamp,
            value       integer DEFAULT 0,
            lictag      integer NOT NULL DEFAULT autoincrement,
            version     char(5),
            dbversion   integer DEFAULT 0,
            dbremote integer default 0,
            primary key (pgm_type, serial)
        );
        grant select on license to mtreports;
    end if
end;;
//
comment on table mt.license is 'June 1997: Fluke';;
// =======================================================================
//
//
//add the inuse table, if its not there.
//
//
begin
    if not exists ( select table_id from sys.systable where table_name ='inuse') then
        CREATE TABLE mt.inuse
        (
            pgm_code    char(1),
            workstation char(30),
            tuser       char(15),
            conn1       integer,
            conn2       integer,
            conn3       integer,
            conn4       integer,
            conn5       integer,
            conn6       integer,
            conn7       integer,
            tcheck      timestamp DEFAULT current timestamp,
                       primary key(pgm_code, workstation)
        );
        grant select, insert, delete on inuse to mtreports;
    end if
end;;
//%
comment on table mt.license is 'April 2002: Fluke';;

/*
BEGIN FILE HEADER

  NAME
  DESCRIPTION

	Creates Tables:
	tblcalresloc : global temporary for stored procedure use.

	Creates Procedures:
	mccalresult : Gets inventory, cal summary, stds, and results for a CTAG.
	mccalresloc : Gets inv, cal summary, stds,results and loc for a CTAG.
	mccal : Gets cal summary, stds for asset, start date, end date.
	rep_asset : Gets repair summary for asset, start date, end date.
	rep_tech : Gets repair summary for technician, start date, end date.

 Copyright Fluke Corporation  1997, 1999
 All Rights Reserved.

END FILE HEADER
*/
begin
    if (exists(select * from sys.systable where table_name='tblcalresloc' and table_type='GBL TEMP'))then
        drop table mt.tblcalresloc;
    end if;
    //
    //
    // TBLCALRESLOC
    //
    call mtxmsg('','creating table tblctagcal');
    //
    CREATE GLOBAL TEMPORARY TABLE mt.tblcalresloc
    (
        SOURCE	char(3),
        C2301 date  ,
        C2302 integer ,
        C2303 date ,
        C2304 integer ,
        C2306 date ,
        C2307 char(20),
        C2308 char(10),
        C2309 numeric(12,2) ,
        C2310 numeric(5,1) ,
        C2311 numeric(6,2) ,
        C2312 numeric(6,2) ,
        C2313 char(15) ,
        C2314 char(16) ,
        C2315 numeric(5,1),
        C2316 date ,
        C2317 numeric(5,1),
        C2318 char(13),
        C2319 char(1),
        C2320 char(128) ,
        C2321 char(55) ,
        C2322 char(1) ,
        C2323 char(1) ,
        C2324 numeric(5,1) ,
        C2325 char(1),
        C2326 char(44) ,
        C2327 char(20) ,
        C2328 numeric(5,1) ,
        C2329 char(44) ,
        C2330 char(10) ,
        C2331 char(1)  ,
        C2332 integer  ,
        C2333 char(8) ,
        C2334 char(8) ,
        C2335 timestamp  ,
        C2336 char(16)  ,
        C2337 timestamp ,
        C2338 char(16) ,
        C2339 integer  ,
        C2341 char(254) ,
        C2342 date ,
        C2343 char(8)  ,
        C2344 integer,
        C2345 integer,
        C2346 integer,
        C2347 integer,
        C2350 integer  ,
        C2351 integer  ,
        C2352 integer  ,
        C2353 integer  ,
        C2354 char(64) ,
        C2355 char(64) ,
        C2356 char(64) ,
        C2357 char(64) ,
        C2358 char(64) ,
        C2359 char(64) ,
        C2360 char(64) ,
        C2361 char(64) ,
        C2362 integer  ,
        C2363 char(1)  ,
        C2364 char(48) ,
        C2365 char(48) ,
        C2366 char(48) ,
        C2367 char(48) ,
        C2368 char(48) ,
        C2369 char(48) ,
        C2370 char(48) ,
        C2371 date ,
        C2372 date ,
        C2373 date ,
        C2374 date ,
        C2375 numeric(12,2) ,
        C2376 numeric(12,2) ,
        C2377 numeric(12,2) ,
        C2378 numeric(12,2) ,
        C2379 numeric(12,2) ,
        C2380 date ,
        C2381 char(8)  ,
        C2382 char(1)  ,
        C2383 integer  ,
        C2384 long varchar,
        C2385 char(128),
        C2386 numeric(5,1),
        C2387 numeric(5,1),
        C2388 numeric(9,2),
        C2389 numeric(7,2),
        C2390 numeric(9,2),
        C2391 numeric(7,2),
        C2392 numeric(2,0),
        C2393 char(1),
        C2394 char(1),
        C2395 char(10),
        C2396 char(16),
        CPUBLISH   char(32) ,
        CTAG  char(80)  ,
        cdsrc char(3) ,
        I4201 char(60) ,
        I4202 char(30) ,
        I4203 char(30) ,
        I4204 char(60) ,
        I4205 char(1) ,
        I4206 char(30) ,
        I4207 char(24) ,
        I4208 char(29) ,
        I4209 char(1) ,
        I4210 char(12) ,
        I4211 char(15) ,
        I4212 date ,
        I4213 char(10) ,
        I4214 char(8) ,
        I4215 char(5) ,
        I4216 char(5) ,
        I4217 char(60) ,
        I4218 char(4) ,
        I4219 numeric(12,2) ,
        I4220 integer ,
        I4221 date ,
        I4222 char(12) ,
        I4223 char(16) ,
        I4224 date ,
        I4225 char(8) ,
        I4226 char(1) ,
        I4228 char(1) ,
        I4229 integer ,
        I4230 integer ,
        I4231 char(32) ,
        I4232 char(32) ,
        I4233 char(32) ,
        I4234 char(32) ,
        I4235 char(32) ,
        I4236 timestamp ,
        I4237 char(16) ,
        I4238 timestamp ,
        I4239 char(16) ,
        I4240 char(8) ,
        I4241 char(80) ,
        I4242 char(80) ,
        I4243 char(80) ,
        I4244 char(48) ,
        I4245 char(48) ,
        I4246 char(48) ,
        I4247 char(48) ,
        I4248 char(48) ,
        I4249 char(48) ,
        I4250 date ,
        I4251 date ,
        I4252 date ,
        I4253 date ,
        I4254 numeric(12,2) ,
        I4255 numeric(12,2) ,
        I4256 numeric(12,2) ,
        I4257 numeric(12,2) ,
        I4258 char(1) ,
        I4259 integer ,
        I4260 long varchar,
        I4261 char(128),
        I4262 char(128),
        I4299 char(1) ,
        MTAG  char(80) ,
        ktag  char(80) ,
        idsrc char(3) ,
        IPUBLISH  char(32),
        replic char(1),
        L2801 char(20),
        L2802 char(20),
        L2803 char(20),
        L2804 char(10),
        L2805 char(8),
        L2806 date,
        L2807 date,
        L2808 integer,
        L2809 date  ,
        L2810 char(8)  ,
        L2811 timestamp ,
        L2812 char(16) ,
        L2813 timestamp ,
        L2814 char(16),
        L2815 integer ,
        L2816 char(15),
        L2817 numeric(12,2),
        L2818 numeric(12,2),
        L2819 numeric(12,2),
        L2820 numeric(12,2),
        L2821 numeric(12,2),
        L2822 date,
        L2823 date,
        L2824 date,
        L2825 date,
        L2826 char(48),
        L2827 char(48),
        L2828 char(48),
        L2829 char(48),
        L2830 char(48),
        L2831 char(48),
        L2832 char(48),
        L2833 char(48),
        L2834 char(48),
        L2835 char(48),
        L2836 long varchar,
        L2837 char(128),
        LPUBLISH char(32),
        ltag  char(80) ,
        ldsrc char(3),
        C2430 char(80),
        C2501 char(254),
        C2502 integer,
        std_4201 char(60) ,
        std_4202 char(30) ,
        std_4203 char(30) ,
        std_4204 char(60) ,
        std_4205 char(1) ,
        std_4206 char(30) ,
        std_4207 char(24) ,
        std_4208 char(29) ,
        std_4241 char(80) ,
        std_4242 char(80) ,
        std_4243 char(80) ,
        std_4244 char(48) ,
        std_4245 char(48) ,
        std_2301 date,
        std_2333 char(8),
        std_2303 date,
        std_2334 char(8),
        std_2323 char(1),
        std_ctag char(80),
        std_2308 char(10),
        std_2354 char(64),
        std_2355 char(64),
        std_2356 char(64),
        K4601 char(48),
        K4602 char(48),
        K4603 char(48),
        K4604 char(48),
        K4605 char(48),
        K4606 char(48),
        K4607 char(48),
        K4608 char(48),
        K4609 char(48),
        K4610 char(48),
        K4611 char(48),
        K4612 char(48),
        K4613 char(48),
        K4614 char(48),
        K4615 char(48),
        K4616 char(48),
        K4617 char(48),
        K4618 char(48),
        K4619 char(48),
        K4620 char(48),
        K4621 date,
        K4622 date,
        K4623 date,
        K4624 date,
        K4625 numeric(12,2),
        K4626 numeric(12,2),
        K4627 numeric(12,2),
        K4628 numeric(12,2),
        K4629 timestamp ,
        K4630 char(16) ,
        K4631 timestamp ,
        K4632 char(16) ,
        K4633 char(40),
        K4634 char(30),
        K4635 char(20),
        K4636 char(20),
        K4637 char(60),
        K4640 char(8),
        KPUBLISH      char(32),
        KDSRC char(3),
        operator char(60),
        oper_level integer,
        oper_seg char(8)
    );
end;;
comment on table mt.tblcalresloc is 'April 2002: Fluke global temporary for stored procedure use.';
// ================================================================
//  create three user defineable tables keyed to MTAG
begin
    declare ntmp integer;
    if exists (select table_id from systable where table_name = 'user1') then
        set ntmp = (select length from sys.syscolumns where cname='mtag' and tname='user1');
        if (ntmp <80) then
            alter table mt.user1 modify mtag char(80);
        end if;

    else
        message 'creating user1 table';
        create table mt.user1 (
            MTAG char(80),
            UAPUBLISH char(32),
            U5101 char(60) default null,
            U5102 char(60) default null,
            U5103 char(60) default null,
            U5104 char(60) default null,
            U5105 char(60) default null,
            U5106 char(60) default null,
            U5107 char(60) default null,
            U5108 char(60) default null,
            U5109 char(60) default null,
            U5110 char(60) default null,
            U5111 char(60) default null,
            U5112 char(60) default null,
            U5113 char(60) default null,
            U5114 char(60) default null,
            U5115 char(60) default null,
            U5116 char(60) default null,
            U5117 char(60) default null,
            U5118 char(60) default null,
            U5119 char(60) default null,
            U5120 char(60) default null,
            U5121 date default null,
            U5122 date default null,
            U5123 date default null,
            U5124 date default null,
            U5125 date default null,
            U5126 date default null,
            U5127 date default null,
            U5128 date default null,
            U5129 date default null,
            U5130 date default null,
            U5131 double default null,
            U5132 double default null,
            U5133 double default null,
            U5134 double default null,
            U5135 double default null,
            U5136 double default null,
            U5137 double default null,
            U5138 double default null,
            U5139 double default null,
            U5140 double default null,
            U5141 double default null,
            PRIMARY KEY(U5101),
            );

        grant all on mt.user1 to mtreports;
    end if
end;;
begin
    declare ntmp integer;
    if exists (select table_id from systable where table_name = 'user2') then
        set ntmp = (select length from sys.syscolumns where cname='mtag' and tname='user2');
        if (ntmp <80) then
            alter table mt.user2 modify mtag char(80);
        end if;

    else
        message 'creating user2 table';
        create table mt.user2 (
            MTAG char(80),
            UBPUBLISH char(32),
            U5201 char(60) default null,
            U5202 char(60) default null,
            U5203 char(60) default null,
            U5204 char(60) default null,
            U5205 char(60) default null,
            U5206 char(60) default null,
            U5207 char(60) default null,
            U5208 char(60) default null,
            U5209 char(60) default null,
            U5210 char(60) default null,
            U5211 char(60) default null,
            U5212 char(60) default null,
            U5213 char(60) default null,
            U5214 char(60) default null,
            U5215 char(60) default null,
            U5216 char(60) default null,
            U5217 char(60) default null,
            U5218 char(60) default null,
            U5219 char(60) default null,
            U5220 char(60) default null,
            U5221 date default null,
            U5222 date default null,
            U5223 date default null,
            U5224 date default null,
            U5225 date default null,
            U5226 date default null,
            U5227 date default null,
            U5228 date default null,
            U5229 date default null,
            U5230 date default null,
            U5231 double default null,
            U5232 double default null,
            U5233 double default null,
            U5234 double default null,
            U5235 double default null,
            U5236 double default null,
            U5237 double default null,
            U5238 double default null,
            U5239 double default null,
            U5240 double default null,
            U5241 double default null,
            PRIMARY KEY(U5201),
            );
        grant all on mt.user2 to mtreports;
    end if
end;;
begin
    declare ntmp integer;
    if exists (select table_id from systable where table_name = 'user3') then
        set ntmp = (select length from sys.syscolumns where cname='mtag' and tname='user3');
        if (ntmp <80) then
            alter table mt.user3 modify mtag char(80);
        end if;

    else
        message 'creating user3 table';
        create table mt.user3 (
            MTAG char(80),
            UCPUBLISH char(32),
            U5301 char(60) default null,
            U5302 char(60) default null,
            U5303 char(60) default null,
            U5304 char(60) default null,
            U5305 char(60) default null,
            U5306 char(60) default null,
            U5307 char(60) default null,
            U5308 char(60) default null,
            U5309 char(60) default null,
            U5310 char(60) default null,
            U5311 char(60) default null,
            U5312 char(60) default null,
            U5313 char(60) default null,
            U5314 char(60) default null,
            U5315 char(60) default null,
            U5316 char(60) default null,
            U5317 char(60) default null,
            U5318 char(60) default null,
            U5319 char(60) default null,
            U5320 char(60) default null,
            U5321 date default null,
            U5322 date default null,
            U5323 date default null,
            U5324 date default null,
            U5325 date default null,
            U5326 date default null,
            U5327 date default null,
            U5328 date default null,
            U5329 date default null,
            U5330 date default null,
            U5331 double default null,
            U5332 double default null,
            U5333 double default null,
            U5334 double default null,
            U5335 double default null,
            U5336 double default null,
            U5337 double default null,
            U5338 double default null,
            U5339 double default null,
            U5340 double default null,
            U5341 double default null,
            PRIMARY KEY(U5301),
            );
        grant all on mt.user3 to mtreports;
    end if
end;;
/* ================================================================
// DESKTOP table
//
// Create the DESKTOP table if its not there.
*/
begin
    if (exists (select table_id from sys.systable where table_name = 'desktop'))
	    then
	    message 'desktop table exists';
    else
	    message 'creating desktop table';

	    Create table MT.DeskTop 
		    ( 
		    Desktop Char (32) primary key, 
 		    TitleFontName char(32) Default 'Arial', 
		    TitleFontSIze Char(2) Default '8', 
		    TitleFontBold Char(5) Default 'False', 
		    TitleFontItalic Char(5) Default 'False', 
		    TitleFontColor Char(12) Default  '0', 
		    FieldFontName Char(32) Default 'Arial', 
		    FieldFontSize Char(2) Default  8, 
		    FieldFontBold Char(5) Default  'False', 
		    FieldFontItalic Char(5) Default  'False', 
		    FieldFontColor Char(12) Default  '0', 
		    RequiredColor Char(12) Default  '65535', 
		    DefaultColor CHAR(12) Default '16777088'
		    );

	    Grant All on Desktop to Public;

        insert into mt.desktop (Desktop,TitleFontName,TitleFontSize,
            TitleFontBold,TitleFontItalic,TitleFontColor,FieldFontName,
            FieldFontSize,FieldFontBold,FieldFontItalic,FieldFontColor,
            RequiredColor,DefaultColor) values 
            ('Default','Arial','8','False','False','16711680',
            'Courier New','9','False','False','0','8454143','16777088');

    end if
end;;
comment on table mt.desktop is 'February 2002: desktop table contains customization for the desktops.';;
/* ================================================================
// DESKTOPUSER table
//
// Create the DESKTOPSUSER table if its not there.
*/
begin
    if (exists (select table_id from sys.systable where table_name = 'desktopuser' ))
	    then
	    message 'DeskTopUser table exists';
    else
	    message 'creating DeskTopUser table';

	    Create table mt.DeskTopUser 
		    (
		    "User"  char (32), 
		    "Desktop" char (32) Default 'Default'
		    );
	    Grant Select on DesktopUser to public;

        begin
            declare err_notfound exception for sqlstate value '02000';
            declare nextuser char(32);
            declare curusers dynamic scroll cursor for select mtuser from mt.userlist;
            open curusers;
            Zeroloop: loop
                fetch next curusers into nextuser;
                if sqlstate = err_notfound then 
                    leave Zeroloop
                end if;
                if (not exists(select "User" from mt.DeskTopUser where "User"=nextuser and Desktop='Default')) then
                    insert into mt.DeskTopUser ("User", Desktop) values (nextuser,'Default');
                end if;
            end loop Zeroloop;
            close curusers
        end;

    end if
end;;
comment on table mt.desktopuser is 'February 2002: desktopuser table correlates a user to his authorized desktops.';;
/* ================================================================
// DESKTOPLAST table
//
// Create the DESKTOPSLAST table if its not there.
*/
begin
    if (exists (select table_id from sys.systable where table_name = 'desktoplast' ))
	    then
	    message 'DeskTopLast table exists';
        Grant Select, Insert, Update on DeskTopLast to public;
    else
	    message 'creating DeskTopLast table';

	    Create table mt.DeskTopLast 
		    (
		    "DUser"  char (32), 
		    "LastDesktop" char (32) Default 'Default'
		    );
	    Grant Select, Insert, Update on DeskTopLast to public;

    end if
end;;
comment on table mt.desktoplast is 'February 2002: desktoplast table stores the last desktop used by each user.';;
/* ================================================================
// WORKORDERS and WORKORDERDETAILS tables
//
// Create the WORKORDERS and WORKORDERDETAILS tables if its not there.
*/
begin
    if (exists (select table_id from sys.systable where table_name = 'workorders'))
	    then
	    message 'WorkOrders table exists';
    else
	    message 'creating WorkOrders table';

	    Create table WorkOrders
		    (
		    WO_Number Char (24) Primary key not null default autoincrement,
		    Open_Date Timestamp default current timestamp ,
		    Received_By Char (24),
		    "Status" Char (32) default 'In-Process',
		    "Status Date" Date default current timestamp,
		    "Work_Type" Char (24)default 'Cal',
		    "WO_Notes" Char (128),
		    Ktag Char (80),
		    Purchace_Order Char (32),
		    Invoiced TinyInt default '0',
		    Invoice_Date Date,
		    Invoice_Number Char (32)
		    );
	    Grant All on WorkOrders to Public;
    end if
end;;
begin
    if (exists (select table_id from sys.systable where table_name = 'workorderdetails' ))
    then
	    message 'WorkOrderDetails table exists';
        Alter table mt.WorkOrderDetails modify mtag char(80);
    else
	    message 'creating WorkOrderDetails table';
	    
	    Create table WorkOrderDetails (
		    "WO_Number" Char (24),
		    "mtag" Char (80),
		    "Asset_No" Char (60),
		    "Mfg" Char (60),
		    "Model" Char (60),
		    "Serial Number" Char (60),
		    "Status" Char (40) default 'In-Process',
		    "Status Date" Date Default current timestamp,
		    "Asset_Notes" Char (128)
		    );

	    Grant All on WorkOrderDetails to Public

    end if
end;;
comment on table mt.workorders is 'February 2002: WorkOrders table enables implementation of future work on work order handling.';;
comment on table mt.workorderdetails is 'February 2002: WorkOrderDetails table enables implementation of future work on work order handling.';;
/*
// ===================================================
// Ver_7_Certificates.
//
*/
begin
    if (exists(select table_id from sys.systable where table_name = 'Ver_7_Certificates' and table_type = 'VIEW')) then
        drop view mt.Ver_7_Certificates;
    end if;

    CREATE view mt.Ver_7_Certificates(Calibration_CTAG,Results_ctag,row_num,
      
      /* Row_num and CTAG fields from the Results Table*/
      /* These are here for speed of access,  rest of Results Table Fields are */
      /* on further down in this View.*/
      /* Fields from the Calibration Table*/
      C2301,C2302,C2303,C2304,C2306,C2307,C2309,C2310,
      C2311,C2312,C2313,C2314,C2316,C2320,C2321,C2322,C2323,C2324,C2326,C2327,C2328,
      C2329,C2330,C2331,C2332,C2333,C2334,C2335,C2336,C2337,C2338,C2339,C2341,
      Calibration_MTAG,C2362,C2308,C2315,C2342,C2343,C2317,C2318,C2319,
      C2325,C2350,C2351,C2352,C2353,C2354,C2355,C2356,C2357,C2358,C2359,C2360,C2361,
      C2363,cdsrc,C2381,C2382,C2364,C2365,C2366,C2367,C2368,C2369,C2370,C2371,C2372,
      C2373,C2374,C2375,C2376,C2377,C2378,C2379,C2380,C2383,C2384,C2385,C2344,C2345,
      C2346,C2347,C2386,C2387,C2388,C2389,C2390,C2391,C2392,C2393,C2394,C2395,
      C2396,
      
      /* Fields from the Customers Table*/
      Customers_KTAG,K4601,K4602,K4603,K4604,K4605,K4606,K4607,K4608,K4609,K4610,K4611,K4612,
      K4613,K4614,K4615,K4616,K4617,K4618,K4619,K4620,K4621,K4622,K4623,K4624,K4625,
      K4626,K4627,K4628,K4640,K4629,K4630,K4631,K4632,KDSRC,kreplic,K4633,K4634,K4635,
      K4636,
      K4637,
      
      /* Fields from the Inventory Table*/
      I4201,I4202,I4203,I4204,I4205,I4206,I4207,I4208,I4209,I4210,I4211,I4212,I4213,
      I4214,I4215,I4216,I4217,I4218,I4219,I4220,I4221,I4222,I4223,I4224,I4225,I4226,
      I4228,I4229,I4230,I4231,I4232,I4233,I4234,I4235,I4236,I4237,I4238,I4239,I4240,
      I4299,Inventory_MTAG,I4241,I4242,I4243,idsrc,Inventory_ktag,replic,I4258,I4244,I4245,I4246,
      I4247,I4248,I4249,I4250,I4251,I4252,I4253,I4254,I4255,I4256,I4257,I4259,I4260,
      I4261,
      I4262,
      
      /* Fields from the Location Table*/
      L2801,L2802,L2803,L2804,L2805,L2806,L2807,L2808,L2809,L2810,L2811,L2812,L2813,
      L2814,L2815,Location_MTAG,ltag,ldsrc,L2816,L2817,L2818,L2819,L2820,L2821,L2822,
      L2823,L2824,L2825,L2826,L2827,L2828,L2829,L2830,L2831,L2832,L2833,L2834,L2835,
      L2836,
      L2837,
      
      /* Fields from the Results Table*/
      test_desc,fixq,fixq_p,fixq_u,varq,varq_p,varq_u,lower_limit,lower_limit_p,
      lower_limit_u,upper_limit,upper_limit_p,upper_limit_u,test_status,exp_uncert,exp_uncert_p,
      exp_uncert_u,std_uncert,std_uncert_p,std_uncert_u,cov_fac,condition,remark,cpt,cpt_p,
      cpt_u,fix_flag,nominal,nominal_p,nominal_u,mod1,mod1_p,mod1_u,sys_actual,sys_actual_p,
      sys_actual_u,corr_flag,uut_ind,uut_ind_p,uut_ind_u,expv,expv_p,expv_u,measurement,
      measurement_p,measurement_u,meas_flag,dev,dev_p,dev_u,error,error_p,error_u,rel_err,
      rel_err_p,rel_err_u,corr,corr_p,corr_u,corr_unc,corr_unc_p,corr_unc_u,tol_ref,tol_neg,
      tol_neg_p,tol_neg_u,tol_pos,tol_pos_p,tol_pos_u,tol,tol_p,tol_u,tur,tol_err,tol_err_p,
      tol_err_u,uncert_method,nthrow,num_meas,sdev,sdev_p,sdev_u,noisy_flag,reliable_flag,st_t,
      st_t_flag,ws_flag,dominant,df1,df2,df3,df4,df5,df6,df7,df8,df9,df10,deg_free,
      u1,u1_p,u1_u,u2,u2_p,u2_u,u3,u3_p,u3_u,u4,u4_p,u4_u,u5,u5_p,u5_u,u6,
      u6_p,u6_u,u7,u7_p,u7_u,u8,u8_p,u8_u,u9,u9_p,u9_u,u10,u10_p,u10_u,c1,c2,
      c3,c4,c5,c6,c7,c8,c9,c10,s1,s1_p,s1_u,s2,s2_p,s2_u,dom_uncert,dom_uncert_p,
      dom_uncert_u,test_step,fsc,result_type,accred,guardband_meth,guardband_ll,guardband_ll_p,
      guardband_ll_u,guardband_ul,guardband_ul_p,guardband_ul_u,sys_acc,sys_acc_p,sys_acc_u,sys_cov_fac,
      uut_range,uut_range_p,uut_range_u,uut_res,uut_res_p,uut_res_u,sense,i_imped,i_imped_p,i_imped_u,
      o_imped1,o_imped1_p,o_imped1_u,o_imped2,o_imped2_p,o_imped2_u,wave1,ampl1,ampl1_p,ampl1_u,
      freq1,freq1_p,freq1_u,per1,per1_p,per1_u,pulse_width,pulse_width_p,pulse_width_u,dc_offset,
      dc_offset_p,dc_offset_u,duty_cycle,duty_cycle_p,duty_cycle_u,rise,rise_p,rise_u,fall,fall_p,
      fall_u,trigger_skew,trigger_skew_p,trigger_skew_u,video,polarity,rtd_type,rtd_nom_res,rtd_nom_res_p,
      rtd_nom_res_u,tc_type,mod_source,am_depth,am_depth_p,am_depth_u,fm_dev,fm_dev_p,fm_dev_u,phase_dev,
      phase_dev_p,phase_dev_u,wave2,ampl2,ampl2_p,ampl2_u,freq2,freq2_p,freq2_u,per2,per2_p,per2_u,
      power,power_p,power_u,phase,phase_p,phase_u,dpf,dpf_polarity,Results_mtag,created,createdby,
      editlogtime,modifiedby,
      test_step2,
      
      /* Fields from the UserList Table*/
      Logon_User,User_level,User_Full_Name,User_Segregate,User_Rate)
      
      /*  mtuser,mtlevel,name,Userlist_I4240,rate)*/
      as select distinct
        /* Row_num and CTAG fields from the Results Table*/
        /* These are here for speed of access,  rest of Results Table Fields are */
        /* on further down in this View.*/
        Calibration.CTAG,Results.ctag,row_num,
        
        /* Fields from the Calibration Table*/
        C2301,C2302,C2303,C2304,C2306,C2307,C2309,C2310,C2311,C2312,C2313,C2314,
        C2316,C2320,C2321,C2322,C2323,C2324,C2326,C2327,C2328,C2329,C2330,C2331,C2332,
        C2333,C2334,C2335,C2336,C2337,C2338,C2339,C2341,Calibration.MTAG,
        C2362,C2308,C2315,C2342,C2343,C2317,C2318,C2319,C2325,C2350,C2351,C2352,C2353,
        C2354,C2355,C2356,C2357,C2358,C2359,C2360,C2361,C2363,cdsrc,C2381,C2382,C2364,
        C2365,C2366,C2367,C2368,C2369,C2370,C2371,C2372,C2373,C2374,C2375,C2376,C2377,
        C2378,C2379,C2380,C2383,C2384,C2385,C2344,C2345,C2346,C2347,C2386,C2387,C2388,
        C2389,C2390,C2391,C2392,C2393,C2394,C2395,C2396,
        
        /* Fields from the Customer Table*/
        Customers.KTAG,K4601,K4602,K4603,K4604,K4605,K4606,K4607,K4608,K4609,K4610,K4611,K4612,
        K4613,K4614,K4615,K4616,K4617,K4618,K4619,K4620,K4621,K4622,K4623,K4624,K4625,
        K4626,K4627,K4628,K4640,K4629,K4630,K4631,K4632,KDSRC,kreplic,K4633,K4634,K4635,
        K4636,K4637,
        
        /* Fields from the Inventory Table*/
        I4201,I4202,I4203,I4204,I4205,I4206,I4207,I4208,I4209,I4210,I4211,I4212,I4213,
        I4214,I4215,I4216,I4217,I4218,I4219,I4220,I4221,I4222,I4223,I4224,I4225,I4226,
        I4228,I4229,I4230,I4231,I4232,I4233,I4234,I4235,I4236,I4237,I4238,I4239,Inventory.I4240,
        I4299,Inventory.MTAG,I4241,I4242,I4243,idsrc,Inventory.ktag,replic,I4258,I4244,I4245,
        I4246,I4247,I4248,I4249,I4250,I4251,I4252,I4253,I4254,I4255,I4256,I4257,I4259,I4260,
        I4261,I4262,
        
        /* Fields from the Location Table*/
        L2801,L2802,L2803,L2804,L2805,L2806,L2807,L2808,L2809,L2810,L2811,L2812,L2813,
        L2814,L2815,Location.MTAG,ltag,ldsrc,L2816,L2817,L2818,L2819,L2820,L2821,L2822,
        L2823,L2824,L2825,L2826,L2827,L2828,L2829,L2830,L2831,L2832,L2833,L2834,L2835,
        L2836,L2837,
        
        /* Fields from the Results Table*/
        test_desc,fixq,fixq_p,fixq_u,varq,varq_p,varq_u,lower_limit,lower_limit_p,
        lower_limit_u,upper_limit,upper_limit_p,upper_limit_u,test_status,exp_uncert,exp_uncert_p,
        exp_uncert_u,std_uncert,std_uncert_p,std_uncert_u,cov_fac,condition,remark,cpt,cpt_p,
        cpt_u,fix_flag,nominal,nominal_p,nominal_u,mod1,mod1_p,mod1_u,sys_actual,sys_actual_p,
        sys_actual_u,corr_flag,uut_ind,uut_ind_p,uut_ind_u,expv,expv_p,expv_u,measurement,
        measurement_p,measurement_u,meas_flag,dev,dev_p,dev_u,error,error_p,error_u,rel_err,
        rel_err_p,rel_err_u,corr,corr_p,corr_u,corr_unc,corr_unc_p,corr_unc_u,tol_ref,tol_neg,
        tol_neg_p,tol_neg_u,tol_pos,tol_pos_p,tol_pos_u,tol,tol_p,tol_u,tur,tol_err,tol_err_p,
        tol_err_u,uncert_method,nthrow,num_meas,sdev,sdev_p,sdev_u,noisy_flag,reliable_flag,st_t,
        st_t_flag,ws_flag,dominant,df1,df2,df3,df4,df5,df6,df7,df8,df9,df10,deg_free,
        u1,u1_p,u1_u,u2,u2_p,u2_u,u3,u3_p,u3_u,u4,u4_p,u4_u,u5,u5_p,u5_u,u6,
        u6_p,u6_u,u7,u7_p,u7_u,u8,u8_p,u8_u,u9,u9_p,u9_u,u10,u10_p,u10_u,c1,c2,
        c3,c4,c5,c6,c7,c8,c9,c10,s1,s1_p,s1_u,s2,s2_p,s2_u,dom_uncert,dom_uncert_p,
        dom_uncert_u,test_step,fsc,result_type,accred,guardband_meth,guardband_ll,guardband_ll_p,
        guardband_ll_u,guardband_ul,guardband_ul_p,guardband_ul_u,sys_acc,sys_acc_p,sys_acc_u,sys_cov_fac,
        uut_range,uut_range_p,uut_range_u,uut_res,uut_res_p,uut_res_u,sense,i_imped,i_imped_p,
        i_imped_u,o_imped1,o_imped1_p,o_imped1_u,o_imped2,o_imped2_p,o_imped2_u,wave1,ampl1,ampl1_p,
        ampl1_u,freq1,freq1_p,freq1_u,per1,per1_p,per1_u,pulse_width,pulse_width_p,pulse_width_u,
        dc_offset,dc_offset_p,dc_offset_u,duty_cycle,duty_cycle_p,duty_cycle_u,rise,rise_p,rise_u,
        fall,fall_p,fall_u,trigger_skew,trigger_skew_p,trigger_skew_u,video,polarity,rtd_type,
        rtd_nom_res,rtd_nom_res_p,rtd_nom_res_u,tc_type,mod_source,am_depth,am_depth_p,am_depth_u,
        fm_dev,fm_dev_p,fm_dev_u,phase_dev,phase_dev_p,phase_dev_u,wave2,ampl2,ampl2_p,ampl2_u,
        freq2,freq2_p,freq2_u,per2,per2_p,per2_u,power,power_p,power_u,phase,phase_p,phase_u,
        dpf,dpf_polarity,Results.mtag,created,createdby,editlogtime,modifiedby,test_step2,
        /* Fields from the Userlist Table*/
        mtuser,mtlevel,name,userlist.I4240,rate from
        /* Joins the Calibration table to the Inventory table (MTAG)*/
        mt.Calibration join mt.Inventory on mt.Calibration.MTAG = mt.Inventory.MTAG,
        /* Joins the Results table to the Calibration table (CTAG) */
        mt.Calibration left outer join mt.Results on mt.Calibration.CTAG = mt.results.ctag,
        /* Joins the Inventory table to the Customer Table (KTAG)*/
        /* Left outer join is used so it pulls every Inventory record whether it has a*/
        /* matching Customer or not.*/
        mt.Inventory left outer join mt.Customers on mt.Inventory.KTAG = mt.customers.KTAG,
        /* Joins the Inventory table to the Location Table (LTAG) */
        /* Left outer join is used so it pulls every Inventory record whether it has a */
        /* matching Location or not.*/
        mt.Inventory left outer join mt.Location on mt.Inventory.MTAG = mt.Location.MTAG and
        /* This check for no location or current location only */
        (L2815 is null or L2815 = 1),
        /* Joins the Calibration table to the Userlist Table (C2336 to mtuser) */
        mt.Calibration join mt.userlist on
        (mt.Calibration.C2336 = mt.userlist.mtuser or mt.Calibration.C2336 = '');

    Grant select on mt.Ver_7_Certificates to mtreports;
end;;
/*
// ===================================================
// Std_Used view
//
*/
begin
    if (exists(select table_id from sys.systable where table_name = 'Stds_Used' and table_type = 'VIEW')) then
        drop view mt.Stds_Used;
    end if;
    CREATE VIEW mt."Stds_Used" (
        "Stds_Used_C2430", "Stds_Used_Standards_CTAG", 
 
        "Stds_Used_I4201", "Stds_Used_I4202", "Stds_Used_I4203", "Stds_Used_I4204", "Stds_Used_I4205", 
        "Stds_Used_I4206", "Stds_Used_I4207", "Stds_Used_I4208", "Stds_Used_I4209", "Stds_Used_I4210", 
        "Stds_Used_I4211", "Stds_Used_I4212", "Stds_Used_I4213", "Stds_Used_I4214", "Stds_Used_I4215", 
        "Stds_Used_I4216", "Stds_Used_I4217", "Stds_Used_I4218", "Stds_Used_I4219", "Stds_Used_I4220", 
        "Stds_Used_I4221", "Stds_Used_I4222", "Stds_Used_I4223", "Stds_Used_I4224", "Stds_Used_I4225", 
        "Stds_Used_I4226", "Stds_Used_I4228", "Stds_Used_I4229", "Stds_Used_I4230", "Stds_Used_I4231", 
        "Stds_Used_I4232", "Stds_Used_I4233", "Stds_Used_I4234", "Stds_Used_I4235", "Stds_Used_I4236", 
        "Stds_Used_I4237", "Stds_Used_I4238", "Stds_Used_I4239", "Stds_Used_I4240", "Stds_Used_I4299", 
        "Stds_Used_Inventory_MTAG", "Stds_Used_I4241", "Stds_Used_I4242", "Stds_Used_I4243","Stds_Used_ktag", 
        "Stds_Used_I4258", "Stds_Used_I4244", "Stds_Used_I4245", "Stds_Used_I4246", "Stds_Used_I4247", 
        "Stds_Used_I4248", "Stds_Used_I4249", "Stds_Used_I4250", "Stds_Used_I4251", "Stds_Used_I4252", 
        "Stds_Used_I4253", "Stds_Used_I4254", "Stds_Used_I4255", "Stds_Used_I4256", "Stds_Used_I4257", 
        "Stds_Used_I4259", "Stds_Used_I4260", "Stds_Used_I4261", "Stds_Used_I4262", 

        "Stds_Used_C2301", "Stds_Used_C2302", "Stds_Used_C2303", "Stds_Used_C2304", "Stds_Used_C2306", 
        "Stds_Used_C2307", "Stds_Used_C2309", "Stds_Used_C2310", "Stds_Used_C2311", "Stds_Used_C2312", 
        "Stds_Used_C2313", "Stds_Used_C2314", "Stds_Used_C2316", "Stds_Used_C2320", "Stds_Used_C2321", 
        "Stds_Used_C2322", "Stds_Used_C2323", "Stds_Used_C2324", "Stds_Used_C2326", "Stds_Used_C2327", 
        "Stds_Used_C2328", "Stds_Used_C2329", "Stds_Used_C2330", "Stds_Used_C2331", "Stds_Used_C2332", 
        "Stds_Used_C2333", "Stds_Used_C2334", "Stds_Used_C2335", "Stds_Used_C2336", "Stds_Used_C2337", 
        "Stds_Used_C2338", "Stds_Used_C2339", "Stds_Used_C2341", "Stds_Used_Calibration_MTAG", 
        "Stds_Used_Calibration_CTAG", "Stds_Used_C2362", "Stds_Used_C2308", "Stds_Used_C2315", 
        "Stds_Used_C2342", "Stds_Used_C2343", "Stds_Used_C2317", "Stds_Used_C2318", "Stds_Used_C2319", 
        "Stds_Used_C2325", "Stds_Used_C2350", "Stds_Used_C2351", "Stds_Used_C2352", "Stds_Used_C2353", 
        "Stds_Used_C2354", "Stds_Used_C2355", "Stds_Used_C2356", "Stds_Used_C2357", "Stds_Used_C2358", 
        "Stds_Used_C2359", "Stds_Used_C2360", "Stds_Used_C2361", "Stds_Used_C2363", "Stds_Used_cdsrc", 
        "Stds_Used_C2382", "Stds_Used_C2364", "Stds_Used_C2365", "Stds_Used_C2366", "Stds_Used_C2367", 
        "Stds_Used_C2368", "Stds_Used_C2369", "Stds_Used_C2370", "Stds_Used_C2371", "Stds_Used_C2372", 
        "Stds_Used_C2373", "Stds_Used_C2374", "Stds_Used_C2375", "Stds_Used_C2376", "Stds_Used_C2377", 
        "Stds_Used_C2378", "Stds_Used_C2379", "Stds_Used_C2380", "Stds_Used_C2383", "Stds_Used_C2384", 
        "Stds_Used_C2385", "Stds_Used_C2344", "Stds_Used_C2345", "Stds_Used_C2346", "Stds_Used_C2347", 
        "Stds_Used_C2386", "Stds_Used_C2387", "Stds_Used_C2388", "Stds_Used_C2389", "Stds_Used_C2390", 
        "Stds_Used_C2391", "Stds_Used_C2392", "Stds_Used_C2393", "Stds_Used_C2394", "Stds_Used_C2395", 
        "Stds_Used_C2396", "Stds_Used_combine",

        "Stds_Used_L2801" ,"Stds_Used_L2802" ,"Stds_Used_L2803" ,"Stds_Used_L2804" ,"Stds_Used_L2805" ,
        "Stds_Used_L2806" ,"Stds_Used_L2807" ,"Stds_Used_L2808" ,"Stds_Used_L2809" ,"Stds_Used_L2810" ,
        "Stds_Used_L2811" ,"Stds_Used_L2812" ,"Stds_Used_L2813" ,"Stds_Used_L2814" ,"Stds_Used_L2815" ,
        "Stds_Used_Location_MTAG" ,"Stds_Used_ltag" ,"Stds_Used_ldsrc" ,"Stds_Used_L2816" ,"Stds_Used_L2817" 
        ,"Stds_Used_L2818" ,"Stds_Used_L2819" ,"Stds_Used_L2820" ,"Stds_Used_L2821" ,"Stds_Used_L2822" ,
        "Stds_Used_L2823" ,"Stds_Used_L2824" ,"Stds_Used_L2825" ,"Stds_Used_L2826" ,"Stds_Used_L2827" ,
        "Stds_Used_L2828" ,"Stds_Used_L2829" ,"Stds_Used_L2830" ,"Stds_Used_L2831" ,"Stds_Used_L2832" ,
        "Stds_Used_L2833" ,"Stds_Used_L2834" ,"Stds_Used_L2835" ,"Stds_Used_L2836" ,"Stds_Used_L2837" 
         )

        AS
        SELECT 

        "C2430", "Standards"."CTAG",

        "I4201", "I4202", "I4203", "I4204", "I4205", "I4206", "I4207", "I4208", "I4209", 
        "I4210", "I4211", "I4212", "I4213", "I4214", "I4215", "I4216", "I4217", "I4218", 
        "I4219", "I4220", "I4221", "I4222", "I4223", "I4224", "I4225", "I4226", "I4228", 
        "I4229", "I4230", "I4231", "I4232", "I4233", "I4234", "I4235", "I4236", "I4237", 
        "I4238", "I4239", "I4240", "I4299", "Inventory"."MTAG", "I4241", "I4242", "I4243", 
        "ktag", "I4258", "I4244", "I4245", "I4246", "I4247", "I4248", "I4249", "I4250", 
        "I4251", "I4252", "I4253", "I4254", "I4255", "I4256", "I4257", "I4259", "I4260", 
        "I4261", "I4262", 

        "C2301", "C2302", "C2303", "C2304", "C2306", "C2307", "C2309", "C2310", "C2311", 
        "C2312", "C2313", "C2314", "C2316", "C2320", "C2321", "C2322", "C2323", "C2324", 
        "C2326", "C2327", "C2328", "C2329", "C2330", "C2331", "C2332", "C2333", "C2334", 
        "C2335", "C2336", "C2337", "C2338", "C2339", "C2341", "Calibration"."MTAG", "Calibration"."CTAG", 
        "C2362", "C2308", "C2315", "C2342", "C2343", "C2317", "C2318", "C2319", "C2325", 
        "C2350", "C2351", "C2352", "C2353", "C2354", "C2355", "C2356", "C2357", "C2358", 
        "C2359", "C2360", "C2361", "C2363", "cdsrc", "C2382", "C2364", "C2365", "C2366", 
        "C2367", "C2368", "C2369", "C2370", "C2371", "C2372", "C2373", "C2374", "C2375", 
        "C2376", "C2377", "C2378", "C2379", "C2380", "C2383", "C2384", "C2385", "C2344", 
        "C2345", "C2346", "C2347", "C2386", "C2387", "C2388", "C2389", "C2390", "C2391", 
        "C2392", "C2393", "C2394", "C2395", "C2396", "combine",

        "L2801" ,"L2802" ,"L2803" ,"L2804" ,"L2805" ,
        "L2806" ,"L2807" ,"L2808" ,"L2809" ,"L2810" ,
        "L2811" ,"L2812" ,"L2813" ,"L2814" ,"L2815" ,
        "Location"."MTAG" ,"ltag" ,"ldsrc" ,"L2816" ,"L2817" ,
        "L2818" ,"L2819" ,"L2820" ,"L2821" ,"L2822" ,
        "L2823" ,"L2824" ,"L2825" ,"L2826" ,"L2827" ,
        "L2828" ,"L2829" ,"L2830" ,"L2831" ,"L2832" ,
        "L2833" ,"L2834" ,"L2835" ,"L2836" ,"L2837" 

        FROM ( "mt"."Standards" JOIN "mt"."Inventory" ON "mt"."Standards"."C2430" = "mt"."Inventory"."MTAG" )
        LEFT OUTER JOIN "mt"."Calibration" ON "mt"."Inventory"."MTAG" = "mt"."Calibration"."MTAG" ,
        "mt"."Inventory" LEFT OUTER JOIN "mt"."Location" ON "mt"."Inventory"."MTAG" = "mt"."Location"."MTAG"
        and (L2815 is null or L2815=1);
    Grant select on mt.Stds_Used to mtreports;
end;;
/*
// ===================================================
//  a little bit of customization table dressing up
//
*/
begin
    if exists(select title2 from mt.customiz where ((title2='' or title2 is null) and fldnum = '4201')) then
        // FRENCH
        update mt.customiz set title2 = title;
    end if;
    update mt.customiz set title2 = title where title2 is null;
end;;
begin
    update mt.customiz set title3= 'DateTime Entered' where fldnum='4236';
    update mt.customiz set title3= 'Who Entered' where fldnum='4237';
    update mt.customiz set title3= 'DateTime Modified' where fldnum='4238';
    update mt.customiz set title3= 'Who Modified' where fldnum='4239';

    update mt.customiz set title3= 'DateTime Entered' where fldnum='2335';
    update mt.customiz set title3= 'Who Entered' where fldnum='2336';
    update mt.customiz set title3= 'DateTime Modified' where fldnum='2337';
    update mt.customiz set title3= 'Who Modified' where fldnum='2338';

    update mt.customiz set title3= 'DateTime Entered' where fldnum='2811';
    update mt.customiz set title3= 'Who Entered' where fldnum='2812';
    update mt.customiz set title3= 'DateTime Modified' where fldnum='2813';
    update mt.customiz set title3= 'Who Modified' where fldnum='2814';

    update mt.customiz set title3= 'DateTime Entered' where fldnum='3242';
    update mt.customiz set title3= 'Who Entered' where fldnum='3243';
    update mt.customiz set title3= 'DateTime Modified' where fldnum='3244';
    update mt.customiz set title3= 'Who Modified' where fldnum='3245';

    update mt.customiz set title3= 'DateTime Entered' where fldnum='4629';
    update mt.customiz set title3= 'Who Entered' where fldnum='4630';
    update mt.customiz set title3= 'DateTime Modified' where fldnum='4631';
    update mt.customiz set title3= 'Who Modified' where fldnum='4632';

    if exists(select title3 from mt.customiz where ((title3='' or title3 is null) and fldnum = '4201')) then
        // GERMAN
        update mt.customiz set title3= title;
    end if;
    update mt.customiz set title3 = title where title3 is null;
end;;
begin
    update mt.customiz set title4='DateTime Entered' where fldnum='4236';
    update mt.customiz set title4='Who Entered' where fldnum='4237';
    update mt.customiz set title4='DateTime Modified' where fldnum='4238';
    update mt.customiz set title4='Who Modified' where fldnum='4239';

    update mt.customiz set title4='DateTime Entered' where fldnum='2335';
    update mt.customiz set title4='Who Entered' where fldnum='2336';
    update mt.customiz set title4='DateTime Modified' where fldnum='2337';
    update mt.customiz set title4='Who Modified' where fldnum='2338';

    update mt.customiz set title4='DateTime Entered' where fldnum='2811';
    update mt.customiz set title4='Who Entered' where fldnum='2812';
    update mt.customiz set title4='DateTime Modified' where fldnum='2813';
    update mt.customiz set title4='Who Modified' where fldnum='2814';

    update mt.customiz set title4='DateTime Entered' where fldnum='3242';
    update mt.customiz set title4='Who Entered' where fldnum='3243';
    update mt.customiz set title4='DateTime Modified' where fldnum='3244';
    update mt.customiz set title4='Who Modified' where fldnum='3245';

    update mt.customiz set title4='DateTime Entered' where fldnum='4629';
    update mt.customiz set title4='Who Entered' where fldnum='4630';
    update mt.customiz set title4='DateTime Modified' where fldnum='4631';
    update mt.customiz set title4='Who Modified' where fldnum='4632';

    if exists(select title4 from mt.customiz where ((title4='' or title4 is null) and fldnum = '4201')) then
        // ITALIAN
        update mt.customiz set title4=title;
    end if;
    update mt.customiz set title4 = title where title4 is null;
end;;
begin
    if exists(select title5 from mt.customiz where ((title5='' or title5 is null) and fldnum = '4201')) then
        // SPANISH
        update mt.customiz set title5= title;
    end if;
    update mt.customiz set title5 = title where title5 is null;
end;;
begin
    update mt.customiz set tooltip = title where tooltip is null;
    update mt.customiz set datalen=80, maxlen=80, ftype='RO' where fldnum like '%TAG';
    update mt.customiz set row=0 where row is null;
    update mt.customiz set col=0 where col is null;
    update mt.customiz set len=0 where len is null;
    update mt.customiz set datalen=0 where datalen is null;
    update mt.customiz set nextfld=0 where nextfld is null;
    update mt.customiz set merge='X' where merge is null;
    update mt.customiz set Ilevels='' where Ilevels is null;
    update mt.customiz set Slevels='' where Slevels is null;
    update mt.customiz set Idefault='' where Idefault is null;
    update mt.customiz set Sdefault='' where Sdefault is null;
    update mt.customiz set idefault = '0' where fldnum ='4230';
    update mt.customiz set idefault = 'U_SEG' where fldnum ='4240';
    update mt.customiz set idefault = 'U_SEG' where fldnum ='4640';
    // misc customization tweaks for pteam 8494
    update mt.customiz set Ireq = 'Y', Sreq='Y' where fldnum = '3250';
    update mt.customiz set Ireq = 'Y', Sreq='Y' where fldnum = '3251';
    update mt.customiz set Ireq = 'Y', Sreq='Y' where fldnum = '3230';
    update mt.customiz set Ireq = 'Y', Sreq='Y' where fldnum = '3241';
    update mt.customiz set Ireq = 'Y', Sreq='Y' where fldnum = '2809';
    update mt.customiz set Ireq = 'Y', Sreq='Y' where fldnum = '2810';
    update mt.customiz set Ireq = 'Y', Sreq='Y' where fldnum = '2301';
    update mt.customiz set Ireq = 'Y', Sreq='Y' where fldnum = '2323';
    update mt.customiz set Ireq = 'Y', Sreq='Y' where fldnum = '2333';
    update mt.customiz set Ireq = 'Y', Sreq='Y' where fldnum = '4201';
    update mt.customiz set Ireq = 'Y', Sreq='Y' where fldnum = '4228';
    update mt.customiz set Ireq = 'Y', Sreq='Y' where fldnum = '4230';
    update mt.customiz set Ireq = 'Y', Sreq='Y' where fldnum = '4240';
    update mt.customiz set Ireq = 'Y', Sreq='Y' where fldnum = '4299';
    //
    update mt.customiz set merge = 'N' where merge is null ;
    update mt.customiz set postitle = 'T' where postitle is null;
    update mt.customiz set chkfunc = 'N' where chkfunc is null;
    update mt.customiz set suppressed = 'X' where fldnum = '4201';
    update mt.customiz set suppressed = 'X' where fldnum = '4228';
    update mt.customiz set suppressed = 'X' where fldnum = '4229';
    update mt.customiz set suppressed = 'X',maxlen=4,datalen=4 where fldnum = '3249';
    update mt.customiz set suppressed = 'X' where fldnum = '3250';
    update mt.customiz set suppressed = 'X' where fldnum = '3251';
    update mt.customiz set Ireq = 'X', Sreq = 'X' where fldnum = '4201';
    update mt.customiz set Ireq = 'X', Sreq = 'X' where fldnum = '4209';
    update mt.customiz set Ireq = 'X', Sreq = 'X' where fldnum = '4228';
    update mt.customiz set Ireq = 'X', Sreq = 'X' where fldnum = '4229';
    update mt.customiz set Ireq = 'X', Sreq = 'X' where fldnum = '4240';
    update mt.customiz set Ireq = 'X', Sreq = 'X' where fldnum = '4299';
    update mt.customiz set Ireq = 'X', Sreq = 'X' where fldnum = '3249';
    update mt.customiz set Ireq = 'X', Sreq = 'X' where fldnum = '3250';
    update mt.customiz set Ireq = 'X', Sreq = 'X' where fldnum = '3251';
    update mt.customiz set Ireq = 'N', Sreq = 'N' where fldnum = '2340';
    update mt.customiz set Sreq = 'N' where fldnum = '2311';
    update mt.customiz set Sreq = 'N' where fldnum = '2312';
    update mt.customiz set Sreq = 'N' where fform = 8;
    update mt.customiz set Sreq = 'Y' where fldnum = '2809';
    update mt.customiz set Sreq = 'Y' where fldnum = '2810';
    update mt.customiz set scopy = 'OFF' where fform =4 and scopy like '23%';
    update mt.customiz set scopy = 'OFF' where fform =1 and scopy like '21%';
    update mt.customiz set scopy = 'OFF' where fform =2 and scopy like '42%';
    update mt.customiz set scopy = 'OFF' where fform =8 and scopy like '28%';
    update mt.customiz set scopy = 'OFF' where fform =16 and scopy like '32%';
    update mt.customiz set scopy = 'OFF' where scopy ='off';
    update mt.customiz set scopy ='4228' where fldnum = '2331';
    update mt.customiz set suppressed ='N', ftype='SPVAL' where fldnum = '2331';
    update mt.customiz set scopy ='4229' where fldnum = '2302';
    update mt.customiz set suppressed ='N' where fldnum = '2302';
    update mt.customiz set scopy ='4224' where fldnum = '2316';
    update mt.customiz set scopy ='4241' where fldnum = '2320';
    update mt.customiz set scopy ='4226' where fldnum = '2322';
    update mt.customiz set scopy ='4258' where fldnum = '2382';
    update mt.customiz set scopy ='4259' where fldnum = '2383';
    update mt.customiz set merge = 'X' where fform = 1;
    update mt.customiz set merge = 'X' where fform = 128;
    update mt.customiz set merge = 'X' where fldnum ='2302';
    update mt.customiz set merge = 'X' where fldnum ='2325';
    update mt.customiz set merge = 'X' where fldnum ='2319';
    update mt.customiz set merge = 'X' where fldnum ='2323';
    update mt.customiz set merge = 'X' where fldnum ='4258';
    update mt.customiz set merge = 'X' where fldnum ='4228';
    update mt.customiz set merge = 'X' where fldnum ='4299';
    update mt.customiz set merge = 'X' where fldnum ='2318';
    update mt.customiz set merge = 'X' where fldnum ='2308';
    update mt.customiz set merge = 'X' where fldnum ='2363';
    update mt.customiz set merge = 'X' where fldnum ='3250';
    update mt.customiz set merge = 'X' where fldnum ='3251';
    update mt.customiz set merge = 'X' where fldnum ='4209';
    update mt.customiz set merge = 'X' where fldnum ='4240';
    update mt.customiz set merge = 'X' where fldnum ='2340';
    update mt.customiz set merge = 'X' where fldnum ='2322';
    update mt.customiz set merge = 'X' where fldnum ='2501';
    update mt.customiz set validation='never' where validation is null;
    update mt.customiz set validation = 'none' where validation = '';
    update mt.customiz set validation = 'never', merge = 'X' where ftype in 
        ('DATE','RTDBL','RO','BUTTON','DECIMAL4','DECIMAL','TIME','SRCHDATE','UCVAL');
    update mt.customiz set validation = 'never' where merge ='X' and fform in (1, 128);
    update mt.customiz set validation = 'fixed' where fldnum ='2308';
    update mt.customiz set validation = 'fixed' where fldnum ='2318';
    update mt.customiz set validation = 'fixed' where fldnum ='2319';
    update mt.customiz set validation = 'fixed' where fldnum ='2322';
    update mt.customiz set validation = 'fixed' where fldnum ='2323';
    update mt.customiz set validation = 'fixed' where fldnum ='2325';
    update mt.customiz set validation = 'fixed' where fldnum ='2363';
    update mt.customiz set validation = 'fixed' where fldnum ='3250';
    update mt.customiz set validation = 'fixed' where fldnum ='3251';
    update mt.customiz set validation = 'fixed' where fldnum ='4209';
    update mt.customiz set validation = 'fixed' where fldnum ='4228';
    update mt.customiz set validation = 'fixed' where fldnum ='4240';
    update mt.customiz set validation = 'fixed' where fldnum ='4258';
    update mt.customiz set validation = 'fixed' where fldnum ='4299';
    update mt.customiz set validation = 'fixed' where fldnum ='4640';
    update mt.customiz set sreq = 'N' where fldnum = '2816';
    update mt.customiz set Idefault = '0' where fldnum = '3249' and Idefault = '' ;
    delete from mt.customiz where ftype = 'BUTTON';
    delete from mt.customiz where ftype is null;
    update mt.customiz set maxlen=80 where fldnum like '%TAG';
end;;
begin
    declare ntmp integer;
    call mtxmsg ('customiz block 2: ', 'start');
    set ntmp = (select maxlen from mt.customiz where fldnum = '2326' and fform = 4);
    if (ntmp <> 44) then
        call mtxmsg ('customiz block 2: ', 'ntmp not 44');
        update mt.customiz set maxlen = 10 where fldnum = '2301';
        update mt.customiz set maxlen = 3 where fldnum = '2304';
        update mt.customiz set maxlen = 10 where fldnum = '2308';
        update mt.customiz set maxlen = 10 where fldnum = '2309';
        update mt.customiz set maxlen = 5 where fldnum = '2310';
        update mt.customiz set maxlen = 8 where fldnum = '2311';
        update mt.customiz set maxlen = 15 where fldnum = '2313';
        update mt.customiz set maxlen = 5 where fldnum = '2315';
        update mt.customiz set maxlen = 5 where fldnum = '2317';
        update mt.customiz set maxlen = 13 where fldnum = '2318';
        update mt.customiz set maxlen = 4 where fldnum = '2324';
        update mt.customiz set maxlen = 44 where fldnum = '2326';
        update mt.customiz set maxlen = 4 where fldnum = '2328';
        update mt.customiz set maxlen = 44 where fldnum = '2329';
        update mt.customiz set maxlen = 10 where fldnum = '2330';
        update mt.customiz set maxlen = 2 where fldnum = '2332';
        update mt.customiz set maxlen = 150 where fldnum = '2340';
        update mt.customiz set maxlen = 254 where fldnum = '2341';
        update mt.customiz set maxlen = 5 where fldnum = '2350';
        update mt.customiz set maxlen = 5 where fldnum = '2351';
        update mt.customiz set maxlen = 5 where fldnum = '2352';
        update mt.customiz set maxlen = 5 where fldnum = '2353';
        update mt.customiz set maxlen = 64 where fldnum = '2354';
        update mt.customiz set maxlen = 64 where fldnum = '2355';
        update mt.customiz set maxlen = 64 where fldnum = '2356';
        update mt.customiz set maxlen = 64 where fldnum = '2357';
        update mt.customiz set maxlen = 64 where fldnum = '2358';
        update mt.customiz set maxlen = 64 where fldnum = '2359';
        update mt.customiz set maxlen = 64 where fldnum = '2360';
        update mt.customiz set maxlen = 64 where fldnum = '2361';
        update mt.customiz set maxlen = 3 where fldnum = '2362';
        update mt.customiz set maxlen = 20 where fldnum = '2803';
        update mt.customiz set maxlen = 10 where fldnum = '2804';
        update mt.customiz set maxlen = 8 where fldnum = '2805';
        update mt.customiz set maxlen = 3 where fldnum = '2808';
        update mt.customiz set maxlen = 15 where fldnum = '2816';
        update mt.customiz set maxlen = 102 where fldnum = '3201';
        update mt.customiz set maxlen = 102 where fldnum = '3204';
        update mt.customiz set maxlen = 15 where fldnum = '3207';
        update mt.customiz set maxlen = 14 where fldnum = '3208';
        update mt.customiz set maxlen = 8 where fldnum = '3209';
        update mt.customiz set maxlen = 15 where fldnum = '3210';
        update mt.customiz set maxlen = 14 where fldnum = '3211';
        update mt.customiz set maxlen = 8 where fldnum = '3212';
        update mt.customiz set maxlen = 15 where fldnum = '3213';
        update mt.customiz set maxlen = 14 where fldnum = '3214';
        update mt.customiz set maxlen = 8 where fldnum = '3215';
        update mt.customiz set maxlen = 15 where fldnum = '3216';
        update mt.customiz set maxlen = 14 where fldnum = '3217';
        update mt.customiz set maxlen = 8 where fldnum = '3218';
        update mt.customiz set maxlen = 15 where fldnum = '3219';
        update mt.customiz set maxlen = 14 where fldnum = '3220';
        update mt.customiz set maxlen = 8 where fldnum = '3221';
        update mt.customiz set maxlen = 15 where fldnum = '3222';
        update mt.customiz set maxlen = 14 where fldnum = '3223';
        update mt.customiz set maxlen = 8 where fldnum = '3224';
        update mt.customiz set maxlen = 15 where fldnum = '3225';
        update mt.customiz set maxlen = 14 where fldnum = '3226';
        update mt.customiz set maxlen = 8 where fldnum = '3227';
        update mt.customiz set maxlen = 5 where fldnum = '3229';
        update mt.customiz set maxlen = 8 where fldnum = '3231';
        update mt.customiz set maxlen = 9 where fldnum = '3232';
        update mt.customiz set maxlen = 15 where fldnum = '3233';
        update mt.customiz set maxlen = 15 where fldnum = '3235';
        update mt.customiz set maxlen = 15 where fldnum = '3236';
        update mt.customiz set maxlen = 15 where fldnum = '3237';
        update mt.customiz set maxlen = 4 where fldnum = '3238';
        update mt.customiz set maxlen = 4 where fldnum = '3239';
        update mt.customiz set maxlen = 12 where fldnum = '3240';
        update mt.customiz set maxlen = 12 where fldnum = '3252';
        update mt.customiz set maxlen = 60 where fldnum = '4201';
        update mt.customiz set maxlen = 30 where fldnum = '4202';
        update mt.customiz set maxlen = 30 where fldnum = '4203';
        update mt.customiz set maxlen = 60 where fldnum = '4204';
        update mt.customiz set maxlen = 30 where fldnum = '4206';
        update mt.customiz set maxlen = 24 where fldnum = '4207';
        update mt.customiz set maxlen = 29 where fldnum = '4208';
        update mt.customiz set maxlen = 12 where fldnum = '4210';
        update mt.customiz set maxlen = 15 where fldnum = '4211';
        update mt.customiz set maxlen = 10 where fldnum = '4212';
        update mt.customiz set maxlen = 10 where fldnum = '4213';
        update mt.customiz set maxlen = 8 where fldnum = '4214';
        update mt.customiz set maxlen = 5 where fldnum = '4215';
        update mt.customiz set maxlen = 5 where fldnum = '4216';
        update mt.customiz set maxlen = 60 where fldnum = '4217';
        update mt.customiz set maxlen = 4 where fldnum = '4218';
        update mt.customiz set maxlen = 3 where fldnum = '4220';
        update mt.customiz set maxlen = 12 where fldnum = '4222';
        update mt.customiz set maxlen = 16 where fldnum = '4223';
        update mt.customiz set maxlen = 8 where fldnum = '4225';
        update mt.customiz set maxlen = 1 where fldnum = '4226';
        update mt.customiz set maxlen = 1 where fldnum = '4228';
        update mt.customiz set maxlen = 3 where fldnum = '4229';
        update mt.customiz set maxlen = 3 where fldnum = '4230';
        update mt.customiz set maxlen = 32 where fldnum = '4231';
        update mt.customiz set maxlen = 32 where fldnum = '4232';
        update mt.customiz set maxlen = 32 where fldnum = '4233';
        update mt.customiz set maxlen = 32 where fldnum = '4234';
        update mt.customiz set maxlen = 32 where fldnum = '4235';
        update mt.customiz set maxlen = 8 where fldnum = '4240';
        update mt.customiz set maxlen = 80 where fldnum = '4241';
        update mt.customiz set maxlen = 80 where fldnum = '4242';
        update mt.customiz set maxlen = 80 where fldnum = '4243';
        update mt.customiz set maxlen = 8 where fldnum = '4259';
        update mt.customiz set maxlen = 48 where fldnum = '4601';
    end if;
    call mtxmsg ('customiz block 2: ', 'fini');
end;;
call mtxmsg ('customiz block 2: ', 'between');;

begin
    declare stmp char(1024);
    /* correct items which  have invalid validation or merge values to version 5.xx */
    call mtxmsg ('customiz block 3: ', 'start');
    update mt.customiz set title2 = title where title2 is null;
    update mt.customiz set title3 = title where title3 is null;
    update mt.customiz set title4 = title where title4 is null;
    update mt.customiz set title5 = title where title5 is null;
    update mt.customiz set title2 = 'Prix d''achat' where title2 = 'Prix d''+B125''achat';
    update mt.customiz set tooltip = title where tooltip = '' or tooltip = ' ';
    update mt.customiz set merge = 'N' where merge = ' ';
    update mt.customiz set validation = 'none' where fldnum = '2304'and validation = 'never';
    update mt.customiz set merge = 'N' where fldnum = '2304'and merge = 'X';
    update mt.customiz set validation = 'none' where fldnum = '2307'and validation = 'never';
    update mt.customiz set merge = 'N' where fldnum = '2307'and merge = 'X';
    update mt.customiz set validation = 'simple' where fldnum = '2308'and validation = 'never';
    update mt.customiz set validation = 'none' where fldnum = '2312'and validation = 'never';
    update mt.customiz set merge = 'N' where fldnum = '2312'and merge = 'X';
    update mt.customiz set validation = 'none' where fldnum = '2313'and validation = 'never';
    update mt.customiz set merge = 'N' where fldnum = '2313'and merge = 'X';
    update mt.customiz set validation = 'none' where fldnum = '2314'and validation = 'never';
    update mt.customiz set merge = 'N' where fldnum = '2314'and merge = 'X';
    update mt.customiz set validation = 'none' where fldnum = '2320'and validation = 'never';
    update mt.customiz set merge = 'N' where fldnum = '2320'and merge = 'X';
    update mt.customiz set validation = 'none' where fldnum = '2321'and validation = 'never';
    update mt.customiz set merge = 'N' where fldnum = '2321'and merge = 'X';
    update mt.customiz set validation = 'none' where fldnum = '2326'and validation = 'never';
    update mt.customiz set merge = 'N' where fldnum = '2326'and merge = 'X';
    update mt.customiz set validation = 'none' where fldnum = '2327'and validation = 'never';
    update mt.customiz set merge = 'N' where fldnum = '2327'and merge = 'X';
    update mt.customiz set validation = 'none' where fldnum = '2329'and validation = 'never';
    update mt.customiz set merge = 'N' where fldnum = '2329'and merge = 'X';
    update mt.customiz set validation = 'none' where fldnum = '2330'and validation = 'never';
    update mt.customiz set merge = 'N' where fldnum = '2330'and merge = 'X';
    update mt.customiz set validation = 'none' where fldnum = '2332'and validation = 'never';
    update mt.customiz set merge = 'N' where fldnum = '2332'and merge = 'X';
    update mt.customiz set validation = 'none' where fldnum = '2341'and validation = 'never';
    update mt.customiz set merge = 'N' where fldnum = '2341'and merge = 'X';
    update mt.customiz set validation = 'none' where fldnum = '2350'and validation = 'never';
    update mt.customiz set merge = 'N' where fldnum = '2350'and merge = 'X';
    update mt.customiz set validation = 'none' where fldnum = '2351'and validation = 'never';
    update mt.customiz set merge = 'N' where fldnum = '2351'and merge = 'X';
    update mt.customiz set validation = 'none' where fldnum = '2352'and validation = 'never';
    update mt.customiz set merge = 'N' where fldnum = '2352'and merge = 'X';
    update mt.customiz set validation = 'none' where fldnum = '2353'and validation = 'never';
    update mt.customiz set merge = 'N' where fldnum = '2353'and merge = 'X';
    update mt.customiz set validation = 'none' where fldnum = '2354'and validation = 'never';
    update mt.customiz set merge = 'N' where fldnum = '2354'and merge = 'X';
    update mt.customiz set validation = 'none' where fldnum = '2355'and validation = 'never';
    update mt.customiz set merge = 'N' where fldnum = '2355'and merge = 'X';
    update mt.customiz set validation = 'none' where fldnum = '2356'and validation = 'never';
    update mt.customiz set merge = 'N' where fldnum = '2356'and merge = 'X';
    update mt.customiz set validation = 'none' where fldnum = '2357'and validation = 'never';
    update mt.customiz set merge = 'N' where fldnum = '2357'and merge = 'X';
    update mt.customiz set validation = 'none' where fldnum = '2358'and validation = 'never';
    update mt.customiz set merge = 'N' where fldnum = '2358'and merge = 'X';
    update mt.customiz set validation = 'none' where fldnum = '2359'and validation = 'never';
    update mt.customiz set merge = 'N' where fldnum = '2359'and merge = 'X';
    update mt.customiz set validation = 'none' where fldnum = '2360'and validation = 'never';
    update mt.customiz set merge = 'N' where fldnum = '2360'and merge = 'X';
    update mt.customiz set validation = 'none' where fldnum = '2361'and validation = 'never';
    update mt.customiz set merge = 'N' where fldnum = '2361'and merge = 'X';
    update mt.customiz set validation = 'none' where fldnum = '2362'and validation = 'never';
    update mt.customiz set merge = 'N' where fldnum = '2362'and merge = 'X';
    update mt.customiz set validation = 'none' where fldnum = '2364'and validation = 'never';
    update mt.customiz set merge = 'N' where fldnum = '2364'and merge = 'X';
    update mt.customiz set validation = 'none' where fldnum = '2365'and validation = 'never';
    update mt.customiz set merge = 'N' where fldnum = '2365'and merge = 'X';
    update mt.customiz set validation = 'none' where fldnum = '2366'and validation = 'never';
    update mt.customiz set merge = 'N' where fldnum = '2366'and merge = 'X';
    update mt.customiz set validation = 'none' where fldnum = '2367'and validation = 'never';
    update mt.customiz set merge = 'N' where fldnum = '2367'and merge = 'X';
    update mt.customiz set validation = 'none' where fldnum = '2368'and validation = 'never';
    update mt.customiz set merge = 'N' where fldnum = '2368'and merge = 'X';
    update mt.customiz set validation = 'none' where fldnum = '2369'and validation = 'never';
    update mt.customiz set merge = 'N' where fldnum = '2369'and merge = 'X';
    update mt.customiz set validation = 'none' where fldnum = '2370'and validation = 'never';
    update mt.customiz set merge = 'N' where fldnum = '2370'and merge = 'X';
    update mt.customiz set merge = 'N' where fldnum = '2395'and merge = 'X';
    update mt.customiz set merge = 'N' where fldnum = '2396'and merge = 'X';
    update mt.customiz set validation = 'none' where fldnum = '2801'and validation = 'never';
    update mt.customiz set merge = 'N' where fldnum = '2801'and merge = 'X';
    update mt.customiz set validation = 'none' where fldnum = '2802'and validation = 'never';
    update mt.customiz set merge = 'N' where fldnum = '2802'and merge = 'X';
    update mt.customiz set validation = 'none' where fldnum = '2803'and validation = 'never';
    update mt.customiz set merge = 'N' where fldnum = '2803'and merge = 'X';
    update mt.customiz set validation = 'none' where fldnum = '2804'and validation = 'never';
    update mt.customiz set merge = 'N' where fldnum = '2804'and merge = 'X';
    update mt.customiz set validation = 'none' where fldnum = '2805'and validation = 'never';
    update mt.customiz set merge = 'N' where fldnum = '2805'and merge = 'X';
    update mt.customiz set validation = 'none' where fldnum = '2808'and validation = 'never';
    update mt.customiz set merge = 'N' where fldnum = '2808'and merge = 'X';
    update mt.customiz set validation = 'none' where fldnum = '2816'and validation = 'never';
    update mt.customiz set merge = 'N' where fldnum = '2816'and merge = 'X';
    update mt.customiz set validation = 'none' where fldnum = '2826'and validation = 'never';
    update mt.customiz set merge = 'N' where fldnum = '2826'and merge = 'X';
    update mt.customiz set validation = 'none' where fldnum = '2827'and validation = 'never';
    update mt.customiz set merge = 'N' where fldnum = '2827'and merge = 'X';
    update mt.customiz set validation = 'none' where fldnum = '2828'and validation = 'never';
    update mt.customiz set merge = 'N' where fldnum = '2828'and merge = 'X';
    update mt.customiz set validation = 'none' where fldnum = '2829'and validation = 'never';
    update mt.customiz set merge = 'N' where fldnum = '2829'and merge = 'X';
    update mt.customiz set validation = 'none' where fldnum = '2830'and validation = 'never';
    update mt.customiz set merge = 'N' where fldnum = '2830'and merge = 'X';
    update mt.customiz set validation = 'none' where fldnum = '2831'and validation = 'never';
    update mt.customiz set merge = 'N' where fldnum = '2831'and merge = 'X';
    update mt.customiz set validation = 'none' where fldnum = '2832'and validation = 'never';
    update mt.customiz set merge = 'N' where fldnum = '2832'and merge = 'X';
    update mt.customiz set validation = 'none' where fldnum = '2833'and validation = 'never';
    update mt.customiz set merge = 'N' where fldnum = '2833'and merge = 'X';
    update mt.customiz set validation = 'none' where fldnum = '2834'and validation = 'never';
    update mt.customiz set merge = 'N' where fldnum = '2834'and merge = 'X';
    update mt.customiz set validation = 'none' where fldnum = '2835'and validation = 'never';
    update mt.customiz set merge = 'N' where fldnum = '2835'and merge = 'X';
    update mt.customiz set validation = 'none' where fldnum = '3201'and validation = 'never';
    update mt.customiz set merge = 'N' where fldnum = '3201'and merge = 'X';
    update mt.customiz set validation = 'none' where fldnum = '3204'and validation = 'never';
    update mt.customiz set merge = 'N' where fldnum = '3204'and merge = 'X';
    update mt.customiz set validation = 'none' where fldnum = '3207'and validation = 'never';
    update mt.customiz set merge = 'N' where fldnum = '3207'and merge = 'X';
    update mt.customiz set validation = 'none' where fldnum = '3208'and validation = 'never';
    update mt.customiz set merge = 'N' where fldnum = '3208'and merge = 'X';
    update mt.customiz set validation = 'none' where fldnum = '3210'and validation = 'never';
    update mt.customiz set merge = 'N' where fldnum = '3210'and merge = 'X';
    update mt.customiz set validation = 'none' where fldnum = '3211'and validation = 'never';
    update mt.customiz set merge = 'N' where fldnum = '3211'and merge = 'X';
    update mt.customiz set validation = 'none' where fldnum = '3213'and validation = 'never';
    update mt.customiz set merge = 'N' where fldnum = '3213'and merge = 'X';
    update mt.customiz set validation = 'none' where fldnum = '3214'and validation = 'never';
    update mt.customiz set merge = 'N' where fldnum = '3214'and merge = 'X';
    update mt.customiz set validation = 'none' where fldnum = '3216'and validation = 'never';
    update mt.customiz set merge = 'N' where fldnum = '3216'and merge = 'X';
    update mt.customiz set validation = 'none' where fldnum = '3217'and validation = 'never';
    update mt.customiz set merge = 'N' where fldnum = '3217'and merge = 'X';
    update mt.customiz set validation = 'none' where fldnum = '3219'and validation = 'never';
    update mt.customiz set merge = 'N' where fldnum = '3219'and merge = 'X';
    update mt.customiz set validation = 'none' where fldnum = '3220'and validation = 'never';
    update mt.customiz set merge = 'N' where fldnum = '3220'and merge = 'X';
    update mt.customiz set validation = 'none' where fldnum = '3222'and validation = 'never';
    update mt.customiz set merge = 'N' where fldnum = '3222'and merge = 'X';
    update mt.customiz set validation = 'none' where fldnum = '3223'and validation = 'never';
    update mt.customiz set merge = 'N' where fldnum = '3223'and merge = 'X';
    update mt.customiz set validation = 'none' where fldnum = '3225'and validation = 'never';
    update mt.customiz set merge = 'N' where fldnum = '3225'and merge = 'X';
    update mt.customiz set validation = 'none' where fldnum = '3226'and validation = 'never';
    update mt.customiz set merge = 'N' where fldnum = '3226'and merge = 'X';
    update mt.customiz set validation = 'none' where fldnum = '3233'and validation = 'never';
    update mt.customiz set merge = 'N' where fldnum = '3233'and merge = 'X';
    update mt.customiz set validation = 'none' where fldnum = '3236'and validation = 'never';
    update mt.customiz set merge = 'N' where fldnum = '3236'and merge = 'X';
    update mt.customiz set validation = 'none' where fldnum = '3237'and validation = 'never';
    update mt.customiz set merge = 'N' where fldnum = '3237'and merge = 'X';
    update mt.customiz set validation = 'none' where fldnum = '3240'and validation = 'never';
    update mt.customiz set merge = 'N' where fldnum = '3240'and merge = 'X';
    update mt.customiz set validation = 'none' where fldnum = '3249'and validation = 'never';
    update mt.customiz set merge = 'N' where fldnum = '3249'and merge = 'X';
    update mt.customiz set validation = 'none' where fldnum = '3254'and validation = 'never';
    update mt.customiz set merge = 'N' where fldnum = '3254'and merge = 'X';
    update mt.customiz set validation = 'none' where fldnum = '3255'and validation = 'never';
    update mt.customiz set merge = 'N' where fldnum = '3255'and merge = 'X';
    update mt.customiz set validation = 'none' where fldnum = '3256'and validation = 'never';
    update mt.customiz set merge = 'N' where fldnum = '3256'and merge = 'X';
    update mt.customiz set validation = 'none' where fldnum = '3257'and validation = 'never';
    update mt.customiz set merge = 'N' where fldnum = '3257'and merge = 'X';
    update mt.customiz set validation = 'none' where fldnum = '3258'and validation = 'never';
    update mt.customiz set merge = 'N' where fldnum = '3258'and merge = 'X';
    update mt.customiz set validation = 'none' where fldnum = '3259'and validation = 'never';
    update mt.customiz set merge = 'N' where fldnum = '3259'and merge = 'X';
    update mt.customiz set validation = 'none' where fldnum = '3260'and validation = 'never';
    update mt.customiz set merge = 'N' where fldnum = '3260'and merge = 'X';
    update mt.customiz set validation = 'none' where fldnum = '4202'and validation = 'never';
    update mt.customiz set merge = 'N' where fldnum = '4202'and merge = 'X';
    update mt.customiz set validation = 'none' where fldnum = '4203'and validation = 'never';
    update mt.customiz set merge = 'N' where fldnum = '4203'and merge = 'X';
    update mt.customiz set validation = 'none' where fldnum = '4204'and validation = 'never';
    update mt.customiz set merge = 'N' where fldnum = '4204'and merge = 'X';
    update mt.customiz set validation = 'none' where fldnum = '4205'and validation = 'never';
    update mt.customiz set merge = 'N' where fldnum = '4205'and merge = 'X';
    update mt.customiz set validation = 'none' where fldnum = '4206'and validation = 'never';
    update mt.customiz set merge = 'N' where fldnum = '4206'and merge = 'X';
    update mt.customiz set validation = 'none' where fldnum = '4207'and validation = 'never';
    update mt.customiz set merge = 'N' where fldnum = '4207'and merge = 'X';
    update mt.customiz set validation = 'none' where fldnum = '4208'and validation = 'never';
    update mt.customiz set merge = 'N' where fldnum = '4208'and merge = 'X';
    update mt.customiz set validation = 'none' where fldnum = '4210'and validation = 'never';
    update mt.customiz set merge = 'N' where fldnum = '4210'and merge = 'X';
    update mt.customiz set validation = 'none' where fldnum = '4211'and validation = 'never';
    update mt.customiz set merge = 'N' where fldnum = '4211'and merge = 'X';
    update mt.customiz set validation = 'none' where fldnum = '4213'and validation = 'never';
    update mt.customiz set merge = 'N' where fldnum = '4213'and merge = 'X';
    update mt.customiz set validation = 'none' where fldnum = '4214'and validation = 'never';
    update mt.customiz set merge = 'N' where fldnum = '4214'and merge = 'X';
    update mt.customiz set validation = 'none' where fldnum = '4215'and validation = 'never';
    update mt.customiz set merge = 'N' where fldnum = '4215'and merge = 'X';
    update mt.customiz set validation = 'none' where fldnum = '4216'and validation = 'never';
    update mt.customiz set merge = 'N' where fldnum = '4216'and merge = 'X';
    update mt.customiz set validation = 'none' where fldnum = '4218'and validation = 'never';
    update mt.customiz set merge = 'N' where fldnum = '4218'and merge = 'X';
    update mt.customiz set validation = 'none' where fldnum = '4220'and validation = 'never';
    update mt.customiz set merge = 'N' where fldnum = '4220'and merge = 'X';
    update mt.customiz set validation = 'none' where fldnum = '4222'and validation = 'never';
    update mt.customiz set merge = 'N' where fldnum = '4222'and merge = 'X';
    update mt.customiz set validation = 'none' where fldnum = '4223'and validation = 'never';
    update mt.customiz set merge = 'N' where fldnum = '4223'and merge = 'X';
    update mt.customiz set validation = 'none' where fldnum = '4225'and validation = 'never';
    update mt.customiz set merge = 'N' where fldnum = '4225'and merge = 'X';
    update mt.customiz set validation = 'none' where fldnum = '4226'and validation = 'never';
    update mt.customiz set merge = 'N' where fldnum = '4226'and merge = 'X';
    update mt.customiz set validation = 'none' where fldnum = '4229'and validation = 'never';
    update mt.customiz set merge = 'N' where fldnum = '4229'and merge = 'X';
    update mt.customiz set validation = 'none' where fldnum = '4230'and validation = 'never';
    update mt.customiz set merge = 'N' where fldnum = '4230'and merge = 'X';
    update mt.customiz set validation = 'none' where fldnum = '4231'and validation = 'never';
    update mt.customiz set merge = 'N' where fldnum = '4231'and merge = 'X';
    update mt.customiz set validation = 'none' where fldnum = '4232'and validation = 'never';
    update mt.customiz set merge = 'N' where fldnum = '4232'and merge = 'X';
    update mt.customiz set validation = 'none' where fldnum = '4233'and validation = 'never';
    update mt.customiz set merge = 'N' where fldnum = '4233'and merge = 'X';
    update mt.customiz set validation = 'none' where fldnum = '4234'and validation = 'never';
    update mt.customiz set merge = 'N' where fldnum = '4234'and merge = 'X';
    update mt.customiz set validation = 'none' where fldnum = '4235'and validation = 'never';
    update mt.customiz set merge = 'N' where fldnum = '4235'and merge = 'X';
    update mt.customiz set validation = 'none' where fldnum = '4241'and validation = 'never';
    update mt.customiz set merge = 'N' where fldnum = '4241'and merge = 'X';
    update mt.customiz set validation = 'none' where fldnum = '4242'and validation = 'never';
    update mt.customiz set merge = 'N' where fldnum = '4242'and merge = 'X';
    update mt.customiz set validation = 'none' where fldnum = '4243'and validation = 'never';
    update mt.customiz set merge = 'N' where fldnum = '4243'and merge = 'X';
    update mt.customiz set validation = 'none' where fldnum = '4244'and validation = 'never';
    update mt.customiz set merge = 'N' where fldnum = '4244'and merge = 'X';
    update mt.customiz set validation = 'none' where fldnum = '4245'and validation = 'never';
    update mt.customiz set merge = 'N' where fldnum = '4245'and merge = 'X';
    update mt.customiz set validation = 'none' where fldnum = '4246'and validation = 'never';
    update mt.customiz set merge = 'N' where fldnum = '4246'and merge = 'X';
    update mt.customiz set validation = 'none' where fldnum = '4247'and validation = 'never';
    update mt.customiz set merge = 'N' where fldnum = '4247'and merge = 'X';
    update mt.customiz set validation = 'none' where fldnum = '4248'and validation = 'never';
    update mt.customiz set merge = 'N' where fldnum = '4248'and merge = 'X';
    update mt.customiz set validation = 'none' where fldnum = '4249'and validation = 'never';
    update mt.customiz set merge = 'N' where fldnum = '4249'and merge = 'X';
    update mt.customiz set validation = 'none' where fldnum = '4262'and validation = 'never';
    update mt.customiz set merge = 'N' where fldnum = '4262'and merge = 'X';
    update mt.customiz set validation = 'none' where fldnum = '4603'and validation = 'never';
    update mt.customiz set merge = 'N' where fldnum = '4603'and merge = 'X';
    update mt.customiz set validation = 'none' where fldnum = '4604'and validation = 'never';
    update mt.customiz set merge = 'N' where fldnum = '4604'and merge = 'X';
    update mt.customiz set validation = 'none' where fldnum = '4605'and validation = 'never';
    update mt.customiz set merge = 'N' where fldnum = '4605'and merge = 'X';
    update mt.customiz set validation = 'none' where fldnum = '4606'and validation = 'never';
    update mt.customiz set merge = 'N' where fldnum = '4606'and merge = 'X';
    update mt.customiz set validation = 'none' where fldnum = '4607'and validation = 'never';
    update mt.customiz set merge = 'N' where fldnum = '4607'and merge = 'X';
    update mt.customiz set validation = 'none' where fldnum = '4608'and validation = 'never';
    update mt.customiz set merge = 'N' where fldnum = '4608'and merge = 'X';
    update mt.customiz set validation = 'none' where fldnum = '4609'and validation = 'never';
    update mt.customiz set merge = 'N' where fldnum = '4609'and merge = 'X';
    update mt.customiz set validation = 'none' where fldnum = '4610'and validation = 'never';
    update mt.customiz set merge = 'N' where fldnum = '4610'and merge = 'X';
    update mt.customiz set validation = 'none' where fldnum = '4611'and validation = 'never';
    update mt.customiz set merge = 'N' where fldnum = '4611'and merge = 'X';
    update mt.customiz set validation = 'none' where fldnum = '4612'and validation = 'never';
    update mt.customiz set merge = 'N' where fldnum = '4612'and merge = 'X';
    update mt.customiz set validation = 'none' where fldnum = '4613'and validation = 'never';
    update mt.customiz set merge = 'N' where fldnum = '4613'and merge = 'X';
    update mt.customiz set validation = 'none' where fldnum = '4614'and validation = 'never';
    update mt.customiz set merge = 'N' where fldnum = '4614'and merge = 'X';
    update mt.customiz set validation = 'none' where fldnum = '4615'and validation = 'never';
    update mt.customiz set merge = 'N' where fldnum = '4615'and merge = 'X';
    update mt.customiz set validation = 'none' where fldnum = '4616'and validation = 'never';
    update mt.customiz set merge = 'N' where fldnum = '4616'and merge = 'X';
    update mt.customiz set validation = 'none' where fldnum = '4617'and validation = 'never';
    update mt.customiz set merge = 'N' where fldnum = '4617'and merge = 'X';
    update mt.customiz set validation = 'none' where fldnum = '4618'and validation = 'never';
    update mt.customiz set merge = 'N' where fldnum = '4618'and merge = 'X';
    update mt.customiz set validation = 'none' where fldnum = '4619'and validation = 'never';
    update mt.customiz set merge = 'N' where fldnum = '4619'and merge = 'X';
    update mt.customiz set validation = 'none' where fldnum = '4620'and validation = 'never';
    update mt.customiz set merge = 'N' where fldnum = '4620'and merge = 'X';

    set stmp = (select merge from mt.customiz where fldnum = '2802');
    if (stmp = 'Y') then
        if (not exists (select table_name from sys.systable where table_name = 'mrg2802')) then
            update mt.customiz set merge = 'N' where fldnum = '2802';
        end if;
    end if;

    set stmp = (select merge from mt.customiz where fldnum = '4202');
    if (stmp = 'Y') then
        if (not exists (select table_name from sys.systable where table_name = 'mrg4202')) then
            update mt.customiz set merge = 'N' where fldnum = '4202';
        end if;
    end if;

    set stmp = (select merge from mt.customiz where fldnum = '4218');
    if (stmp = 'Y') then
        if (not exists (select table_name from sys.systable where table_name = 'mrg4218')) then
            update mt.customiz set merge = 'N' where fldnum = '4218';
        end if;
    end if;

    call mtxmsg ('customiz block 3: ', 'fini');
end;;
begin
    declare ntmp integer;
    declare stmp char(1024);
    call mtxmsg ('customiz block 4: ', 'start');
    if (exists(select table_name from sys.systable where table_name = 'me2_customiz' and table_type = 'BASE')) then
        set ntmp = (select maxlen from mt.me2_customiz where fldnum='2326' and Desktop='Default' and fform=8);
        if (ntmp <> 44) then
            call mtxmsg ('customiz block 4: ', 'ntmp not 44');
            update mt.me2_customiz set maxlen = 10 where fldnum = '2301';
            update mt.me2_customiz set maxlen = 3 where fldnum = '2304';
            update mt.me2_customiz set maxlen = 10 where fldnum = '2308';
            update mt.me2_customiz set maxlen = 10 where fldnum = '2309';
            update mt.me2_customiz set maxlen = 5 where fldnum = '2310';
            update mt.me2_customiz set maxlen = 8 where fldnum = '2311';
            update mt.me2_customiz set maxlen = 15 where fldnum = '2313';
            update mt.me2_customiz set maxlen = 5 where fldnum = '2315';
            update mt.me2_customiz set maxlen = 5 where fldnum = '2317';
            update mt.me2_customiz set maxlen = 13 where fldnum = '2318';
            update mt.me2_customiz set maxlen = 4 where fldnum = '2324';
            update mt.me2_customiz set maxlen = 44 where fldnum = '2326';
            update mt.me2_customiz set maxlen = 4 where fldnum = '2328';
            update mt.me2_customiz set maxlen = 44 where fldnum = '2329';
            update mt.me2_customiz set maxlen = 10 where fldnum = '2330';
            update mt.me2_customiz set maxlen = 2 where fldnum = '2332';
            update mt.me2_customiz set maxlen = 150 where fldnum = '2340';
            update mt.me2_customiz set maxlen = 254 where fldnum = '2341';
            update mt.me2_customiz set maxlen = 5 where fldnum = '2350';
            update mt.me2_customiz set maxlen = 5 where fldnum = '2351';
            update mt.me2_customiz set maxlen = 5 where fldnum = '2352';
            update mt.me2_customiz set maxlen = 5 where fldnum = '2353';
            update mt.me2_customiz set maxlen = 64 where fldnum = '2354';
            update mt.me2_customiz set maxlen = 64 where fldnum = '2355';
            update mt.me2_customiz set maxlen = 64 where fldnum = '2356';
            update mt.me2_customiz set maxlen = 64 where fldnum = '2357';
            update mt.me2_customiz set maxlen = 64 where fldnum = '2358';
            update mt.me2_customiz set maxlen = 64 where fldnum = '2359';
            update mt.me2_customiz set maxlen = 64 where fldnum = '2360';
            update mt.me2_customiz set maxlen = 64 where fldnum = '2361';
            update mt.me2_customiz set maxlen = 3 where fldnum = '2362';
            update mt.me2_customiz set maxlen = 20 where fldnum = '2803';
            update mt.me2_customiz set maxlen = 10 where fldnum = '2804';
            update mt.me2_customiz set maxlen = 8 where fldnum = '2805';
            update mt.me2_customiz set maxlen = 3 where fldnum = '2808';
            update mt.me2_customiz set maxlen = 15 where fldnum = '2816';
            update mt.me2_customiz set maxlen = 102 where fldnum = '3201';
            update mt.me2_customiz set maxlen = 102 where fldnum = '3204';
            update mt.me2_customiz set maxlen = 15 where fldnum = '3207';
            update mt.me2_customiz set maxlen = 14 where fldnum = '3208';
            update mt.me2_customiz set maxlen = 8 where fldnum = '3209';
            update mt.me2_customiz set maxlen = 15 where fldnum = '3210';
            update mt.me2_customiz set maxlen = 14 where fldnum = '3211';
            update mt.me2_customiz set maxlen = 8 where fldnum = '3212';
            update mt.me2_customiz set maxlen = 15 where fldnum = '3213';
            update mt.me2_customiz set maxlen = 14 where fldnum = '3214';
            update mt.me2_customiz set maxlen = 8 where fldnum = '3215';
            update mt.me2_customiz set maxlen = 15 where fldnum = '3216';
            update mt.me2_customiz set maxlen = 14 where fldnum = '3217';
            update mt.me2_customiz set maxlen = 8 where fldnum = '3218';
            update mt.me2_customiz set maxlen = 15 where fldnum = '3219';
            update mt.me2_customiz set maxlen = 14 where fldnum = '3220';
            update mt.me2_customiz set maxlen = 8 where fldnum = '3221';
            update mt.me2_customiz set maxlen = 15 where fldnum = '3222';
            update mt.me2_customiz set maxlen = 14 where fldnum = '3223';
            update mt.me2_customiz set maxlen = 8 where fldnum = '3224';
            update mt.me2_customiz set maxlen = 15 where fldnum = '3225';
            update mt.me2_customiz set maxlen = 14 where fldnum = '3226';
            update mt.me2_customiz set maxlen = 8 where fldnum = '3227';
            update mt.me2_customiz set maxlen = 5 where fldnum = '3229';
            update mt.me2_customiz set maxlen = 8 where fldnum = '3231';
            update mt.me2_customiz set maxlen = 9 where fldnum = '3232';
            update mt.me2_customiz set maxlen = 15 where fldnum = '3233';
            update mt.me2_customiz set maxlen = 15 where fldnum = '3235';
            update mt.me2_customiz set maxlen = 15 where fldnum = '3236';
            update mt.me2_customiz set maxlen = 15 where fldnum = '3237';
            update mt.me2_customiz set maxlen = 4 where fldnum = '3238';
            update mt.me2_customiz set maxlen = 4 where fldnum = '3239';
            update mt.me2_customiz set maxlen = 12 where fldnum = '3240';
            update mt.me2_customiz set maxlen = 12 where fldnum = '3252';
            update mt.me2_customiz set maxlen = 60 where fldnum = '4201';
            update mt.me2_customiz set maxlen = 30 where fldnum = '4202';
            update mt.me2_customiz set maxlen = 30 where fldnum = '4203';
            update mt.me2_customiz set maxlen = 60 where fldnum = '4204';
            update mt.me2_customiz set maxlen = 30 where fldnum = '4206';
            update mt.me2_customiz set maxlen = 24 where fldnum = '4207';
            update mt.me2_customiz set maxlen = 29 where fldnum = '4208';
            update mt.me2_customiz set maxlen = 12 where fldnum = '4210';
            update mt.me2_customiz set maxlen = 15 where fldnum = '4211';
            update mt.me2_customiz set maxlen = 10 where fldnum = '4212';
            update mt.me2_customiz set maxlen = 10 where fldnum = '4213';
            update mt.me2_customiz set maxlen = 8 where fldnum = '4214';
            update mt.me2_customiz set maxlen = 5 where fldnum = '4215';
            update mt.me2_customiz set maxlen = 5 where fldnum = '4216';
            update mt.me2_customiz set maxlen = 60 where fldnum = '4217';
            update mt.me2_customiz set maxlen = 4 where fldnum = '4218';
            update mt.me2_customiz set maxlen = 3 where fldnum = '4220';
            update mt.me2_customiz set maxlen = 12 where fldnum = '4222';
            update mt.me2_customiz set maxlen = 16 where fldnum = '4223';
            update mt.me2_customiz set maxlen = 8 where fldnum = '4225';
            update mt.me2_customiz set maxlen = 1 where fldnum = '4226';
            update mt.me2_customiz set maxlen = 1 where fldnum = '4228';
            update mt.me2_customiz set maxlen = 3 where fldnum = '4229';
            update mt.me2_customiz set maxlen = 3 where fldnum = '4230';
            update mt.me2_customiz set maxlen = 32 where fldnum = '4231';
            update mt.me2_customiz set maxlen = 32 where fldnum = '4232';
            update mt.me2_customiz set maxlen = 32 where fldnum = '4233';
            update mt.me2_customiz set maxlen = 32 where fldnum = '4234';
            update mt.me2_customiz set maxlen = 32 where fldnum = '4235';
            update mt.me2_customiz set maxlen = 8 where fldnum = '4240';
            update mt.me2_customiz set maxlen = 80 where fldnum = '4241';
            update mt.me2_customiz set maxlen = 80 where fldnum = '4242';
            update mt.me2_customiz set maxlen = 80 where fldnum = '4243';
            update mt.me2_customiz set maxlen = 8 where fldnum = '4259';
            update mt.me2_customiz set maxlen = 48 where fldnum = '4601';
        end if;
        update mt.me2_customiz set validation = 'fixed' where fldnum ='2308';
        update mt.me2_customiz set validation = 'fixed' where fldnum ='2318';
        update mt.me2_customiz set validation = 'fixed' where fldnum ='2319';
        update mt.me2_customiz set validation = 'fixed' where fldnum ='2322';
        update mt.me2_customiz set validation = 'fixed' where fldnum ='2323';
        update mt.me2_customiz set validation = 'fixed' where fldnum ='2325';
        update mt.me2_customiz set validation = 'fixed' where fldnum ='2363';
        update mt.me2_customiz set validation = 'fixed' where fldnum ='3250';
        update mt.me2_customiz set validation = 'fixed' where fldnum ='3251';
        update mt.me2_customiz set validation = 'fixed' where fldnum ='4209';
        update mt.me2_customiz set validation = 'fixed' where fldnum ='4228';
        update mt.me2_customiz set validation = 'fixed' where fldnum ='4240';
        update mt.me2_customiz set validation = 'fixed' where fldnum ='4258';
        update mt.me2_customiz set validation = 'fixed' where fldnum ='4299';
        update mt.me2_customiz set validation = 'fixed' where fldnum ='4640';
        update mt.me2_customiz set ftype = 'SPVAL' where fldnum = '2331';
        update mt.me2_customiz set tooltip = title where tooltip = '' or tooltip = ' ';
        update mt.me2_customiz set merge = 'N' where merge = ' ';
        update mt.me2_customiz set validation = 'none' where fldnum = '2304'and validation = 'never';
        update mt.me2_customiz set merge = 'N' where fldnum = '2304'and merge = 'X';
        update mt.me2_customiz set validation = 'none' where fldnum = '2307'and validation = 'never';
        update mt.me2_customiz set merge = 'N' where fldnum = '2307'and merge = 'X';
        update mt.me2_customiz set validation = 'simple' where fldnum = '2308'and validation = 'never';
        update mt.me2_customiz set validation = 'none' where fldnum = '2312'and validation = 'never';
        update mt.me2_customiz set merge = 'N' where fldnum = '2312'and merge = 'X';
        update mt.me2_customiz set validation = 'none' where fldnum = '2313'and validation = 'never';
        update mt.me2_customiz set merge = 'N' where fldnum = '2313'and merge = 'X';
        update mt.me2_customiz set validation = 'none' where fldnum = '2314'and validation = 'never';
        update mt.me2_customiz set merge = 'N' where fldnum = '2314'and merge = 'X';
        update mt.me2_customiz set validation = 'none' where fldnum = '2320'and validation = 'never';
        update mt.me2_customiz set merge = 'N' where fldnum = '2320'and merge = 'X';
        update mt.me2_customiz set validation = 'none' where fldnum = '2321'and validation = 'never';
        update mt.me2_customiz set merge = 'N' where fldnum = '2321'and merge = 'X';
        update mt.me2_customiz set validation = 'none' where fldnum = '2326'and validation = 'never';
        update mt.me2_customiz set merge = 'N' where fldnum = '2326'and merge = 'X';
        update mt.me2_customiz set validation = 'none' where fldnum = '2327'and validation = 'never';
        update mt.me2_customiz set merge = 'N' where fldnum = '2327'and merge = 'X';
        update mt.me2_customiz set validation = 'none' where fldnum = '2329'and validation = 'never';
        update mt.me2_customiz set merge = 'N' where fldnum = '2329'and merge = 'X';
        update mt.me2_customiz set validation = 'none' where fldnum = '2330'and validation = 'never';
        update mt.me2_customiz set merge = 'N' where fldnum = '2330'and merge = 'X';
        update mt.me2_customiz set validation = 'none' where fldnum = '2332'and validation = 'never';
        update mt.me2_customiz set merge = 'N' where fldnum = '2332'and merge = 'X';
        update mt.me2_customiz set validation = 'none' where fldnum = '2341'and validation = 'never';
        update mt.me2_customiz set merge = 'N' where fldnum = '2341'and merge = 'X';
        update mt.me2_customiz set validation = 'none' where fldnum = '2350'and validation = 'never';
        update mt.me2_customiz set merge = 'N' where fldnum = '2350'and merge = 'X';
        update mt.me2_customiz set validation = 'none' where fldnum = '2351'and validation = 'never';
        update mt.me2_customiz set merge = 'N' where fldnum = '2351'and merge = 'X';
        update mt.me2_customiz set validation = 'none' where fldnum = '2352'and validation = 'never';
        update mt.me2_customiz set merge = 'N' where fldnum = '2352'and merge = 'X';
        update mt.me2_customiz set validation = 'none' where fldnum = '2353'and validation = 'never';
        update mt.me2_customiz set merge = 'N' where fldnum = '2353'and merge = 'X';
        update mt.me2_customiz set validation = 'none' where fldnum = '2354'and validation = 'never';
        update mt.me2_customiz set merge = 'N' where fldnum = '2354'and merge = 'X';
        update mt.me2_customiz set validation = 'none' where fldnum = '2355'and validation = 'never';
        update mt.me2_customiz set merge = 'N' where fldnum = '2355'and merge = 'X';
        update mt.me2_customiz set validation = 'none' where fldnum = '2356'and validation = 'never';
        update mt.me2_customiz set merge = 'N' where fldnum = '2356'and merge = 'X';
        update mt.me2_customiz set validation = 'none' where fldnum = '2357'and validation = 'never';
        update mt.me2_customiz set merge = 'N' where fldnum = '2357'and merge = 'X';
        update mt.me2_customiz set validation = 'none' where fldnum = '2358'and validation = 'never';
        update mt.me2_customiz set merge = 'N' where fldnum = '2358'and merge = 'X';
        update mt.me2_customiz set validation = 'none' where fldnum = '2359'and validation = 'never';
        update mt.me2_customiz set merge = 'N' where fldnum = '2359'and merge = 'X';
        update mt.me2_customiz set validation = 'none' where fldnum = '2360'and validation = 'never';
        update mt.me2_customiz set merge = 'N' where fldnum = '2360'and merge = 'X';
        update mt.me2_customiz set validation = 'none' where fldnum = '2361'and validation = 'never';
        update mt.me2_customiz set merge = 'N' where fldnum = '2361'and merge = 'X';
        update mt.me2_customiz set validation = 'none' where fldnum = '2362'and validation = 'never';
        update mt.me2_customiz set merge = 'N' where fldnum = '2362'and merge = 'X';
        update mt.me2_customiz set validation = 'none' where fldnum = '2364'and validation = 'never';
        update mt.me2_customiz set merge = 'N' where fldnum = '2364'and merge = 'X';
        update mt.me2_customiz set validation = 'none' where fldnum = '2365'and validation = 'never';
        update mt.me2_customiz set merge = 'N' where fldnum = '2365'and merge = 'X';
        update mt.me2_customiz set validation = 'none' where fldnum = '2366'and validation = 'never';
        update mt.me2_customiz set merge = 'N' where fldnum = '2366'and merge = 'X';
        update mt.me2_customiz set validation = 'none' where fldnum = '2367'and validation = 'never';
        update mt.me2_customiz set merge = 'N' where fldnum = '2367'and merge = 'X';
        update mt.me2_customiz set validation = 'none' where fldnum = '2368'and validation = 'never';
        update mt.me2_customiz set merge = 'N' where fldnum = '2368'and merge = 'X';
        update mt.me2_customiz set validation = 'none' where fldnum = '2369'and validation = 'never';
        update mt.me2_customiz set merge = 'N' where fldnum = '2369'and merge = 'X';
        update mt.me2_customiz set validation = 'none' where fldnum = '2370'and validation = 'never';
        update mt.me2_customiz set merge = 'N' where fldnum = '2370'and merge = 'X';
        update mt.me2_customiz set merge = 'N' where fldnum = '2395'and merge = 'X';
        update mt.me2_customiz set validation = 'none' where fldnum = '2801'and validation = 'never';
        update mt.me2_customiz set merge = 'N' where fldnum = '2801'and merge = 'X';
        update mt.me2_customiz set validation = 'none' where fldnum = '2802'and validation = 'never';
        update mt.me2_customiz set merge = 'N' where fldnum = '2802'and merge = 'X';
        update mt.me2_customiz set validation = 'none' where fldnum = '2803'and validation = 'never';
        update mt.me2_customiz set merge = 'N' where fldnum = '2803'and merge = 'X';
        update mt.me2_customiz set validation = 'none' where fldnum = '2804'and validation = 'never';
        update mt.me2_customiz set merge = 'N' where fldnum = '2804'and merge = 'X';
        update mt.me2_customiz set validation = 'none' where fldnum = '2805'and validation = 'never';
        update mt.me2_customiz set merge = 'N' where fldnum = '2805'and merge = 'X';
        update mt.me2_customiz set validation = 'none' where fldnum = '2808'and validation = 'never';
        update mt.me2_customiz set merge = 'N' where fldnum = '2808'and merge = 'X';
        update mt.me2_customiz set validation = 'none' where fldnum = '2816'and validation = 'never';
        update mt.me2_customiz set merge = 'N' where fldnum = '2816'and merge = 'X';
        update mt.me2_customiz set validation = 'none' where fldnum = '2826'and validation = 'never';
        update mt.me2_customiz set merge = 'N' where fldnum = '2826'and merge = 'X';
        update mt.me2_customiz set validation = 'none' where fldnum = '2827'and validation = 'never';
        update mt.me2_customiz set merge = 'N' where fldnum = '2827'and merge = 'X';
        update mt.me2_customiz set validation = 'none' where fldnum = '2828'and validation = 'never';
        update mt.me2_customiz set merge = 'N' where fldnum = '2828'and merge = 'X';
        update mt.me2_customiz set validation = 'none' where fldnum = '2829'and validation = 'never';
        update mt.me2_customiz set merge = 'N' where fldnum = '2829'and merge = 'X';
        update mt.me2_customiz set validation = 'none' where fldnum = '2830'and validation = 'never';
        update mt.me2_customiz set merge = 'N' where fldnum = '2830'and merge = 'X';
        update mt.me2_customiz set validation = 'none' where fldnum = '2831'and validation = 'never';
        update mt.me2_customiz set merge = 'N' where fldnum = '2831'and merge = 'X';
        update mt.me2_customiz set validation = 'none' where fldnum = '2832'and validation = 'never';
        update mt.me2_customiz set merge = 'N' where fldnum = '2832'and merge = 'X';
        update mt.me2_customiz set validation = 'none' where fldnum = '2833'and validation = 'never';
        update mt.me2_customiz set merge = 'N' where fldnum = '2833'and merge = 'X';
        update mt.me2_customiz set validation = 'none' where fldnum = '2834'and validation = 'never';
        update mt.me2_customiz set merge = 'N' where fldnum = '2834'and merge = 'X';
        update mt.me2_customiz set validation = 'none' where fldnum = '2835'and validation = 'never';
        update mt.me2_customiz set merge = 'N' where fldnum = '2835'and merge = 'X';
        update mt.me2_customiz set validation = 'none' where fldnum = '3201'and validation = 'never';
        update mt.me2_customiz set merge = 'N' where fldnum = '3201'and merge = 'X';
        update mt.me2_customiz set validation = 'none' where fldnum = '3204'and validation = 'never';
        update mt.me2_customiz set merge = 'N' where fldnum = '3204'and merge = 'X';
        update mt.me2_customiz set validation = 'none' where fldnum = '3207'and validation = 'never';
        update mt.me2_customiz set merge = 'N' where fldnum = '3207'and merge = 'X';
        update mt.me2_customiz set validation = 'none' where fldnum = '3208'and validation = 'never';
        update mt.me2_customiz set merge = 'N' where fldnum = '3208'and merge = 'X';
        update mt.me2_customiz set validation = 'none' where fldnum = '3210'and validation = 'never';
        update mt.me2_customiz set merge = 'N' where fldnum = '3210'and merge = 'X';
        update mt.me2_customiz set validation = 'none' where fldnum = '3211'and validation = 'never';
        update mt.me2_customiz set merge = 'N' where fldnum = '3211'and merge = 'X';
        update mt.me2_customiz set validation = 'none' where fldnum = '3213'and validation = 'never';
        update mt.me2_customiz set merge = 'N' where fldnum = '3213'and merge = 'X';
        update mt.me2_customiz set validation = 'none' where fldnum = '3214'and validation = 'never';
        update mt.me2_customiz set merge = 'N' where fldnum = '3214'and merge = 'X';
        update mt.me2_customiz set validation = 'none' where fldnum = '3216'and validation = 'never';
        update mt.me2_customiz set merge = 'N' where fldnum = '3216'and merge = 'X';
        update mt.me2_customiz set validation = 'none' where fldnum = '3217'and validation = 'never';
        update mt.me2_customiz set merge = 'N' where fldnum = '3217'and merge = 'X';
        update mt.me2_customiz set validation = 'none' where fldnum = '3219'and validation = 'never';
        update mt.me2_customiz set merge = 'N' where fldnum = '3219'and merge = 'X';
        update mt.me2_customiz set validation = 'none' where fldnum = '3220'and validation = 'never';
        update mt.me2_customiz set merge = 'N' where fldnum = '3220'and merge = 'X';
        update mt.me2_customiz set validation = 'none' where fldnum = '3222'and validation = 'never';
        update mt.me2_customiz set merge = 'N' where fldnum = '3222'and merge = 'X';
        update mt.me2_customiz set validation = 'none' where fldnum = '3223'and validation = 'never';
        update mt.me2_customiz set merge = 'N' where fldnum = '3223'and merge = 'X';
        update mt.me2_customiz set validation = 'none' where fldnum = '3225'and validation = 'never';
        update mt.me2_customiz set merge = 'N' where fldnum = '3225'and merge = 'X';
        update mt.me2_customiz set validation = 'none' where fldnum = '3226'and validation = 'never';
        update mt.me2_customiz set merge = 'N' where fldnum = '3226'and merge = 'X';
        update mt.me2_customiz set validation = 'none' where fldnum = '3233'and validation = 'never';
        update mt.me2_customiz set merge = 'N' where fldnum = '3233'and merge = 'X';
        update mt.me2_customiz set validation = 'none' where fldnum = '3236'and validation = 'never';
        update mt.me2_customiz set merge = 'N' where fldnum = '3236'and merge = 'X';
        update mt.me2_customiz set validation = 'none' where fldnum = '3237'and validation = 'never';
        update mt.me2_customiz set merge = 'N' where fldnum = '3237'and merge = 'X';
        update mt.me2_customiz set validation = 'none' where fldnum = '3240'and validation = 'never';
        update mt.me2_customiz set merge = 'N' where fldnum = '3240'and merge = 'X';
        update mt.me2_customiz set validation = 'none' where fldnum = '3249'and validation = 'never';
        update mt.me2_customiz set merge = 'N' where fldnum = '3249'and merge = 'X';
        update mt.me2_customiz set validation = 'none' where fldnum = '3254'and validation = 'never';
        update mt.me2_customiz set merge = 'N' where fldnum = '3254'and merge = 'X';
        update mt.me2_customiz set validation = 'none' where fldnum = '3255'and validation = 'never';
        update mt.me2_customiz set merge = 'N' where fldnum = '3255'and merge = 'X';
        update mt.me2_customiz set validation = 'none' where fldnum = '3256'and validation = 'never';
        update mt.me2_customiz set merge = 'N' where fldnum = '3256'and merge = 'X';
        update mt.me2_customiz set validation = 'none' where fldnum = '3257'and validation = 'never';
        update mt.me2_customiz set merge = 'N' where fldnum = '3257'and merge = 'X';
        update mt.me2_customiz set validation = 'none' where fldnum = '3258'and validation = 'never';
        update mt.me2_customiz set merge = 'N' where fldnum = '3258'and merge = 'X';
        update mt.me2_customiz set validation = 'none' where fldnum = '3259'and validation = 'never';
        update mt.me2_customiz set merge = 'N' where fldnum = '3259'and merge = 'X';
        update mt.me2_customiz set validation = 'none' where fldnum = '3260'and validation = 'never';
        update mt.me2_customiz set merge = 'N' where fldnum = '3260'and merge = 'X';
        update mt.me2_customiz set validation = 'none' where fldnum = '4202'and validation = 'never';
        update mt.me2_customiz set merge = 'N' where fldnum = '4202'and merge = 'X';
        update mt.me2_customiz set validation = 'none' where fldnum = '4203'and validation = 'never';
        update mt.me2_customiz set merge = 'N' where fldnum = '4203'and merge = 'X';
        update mt.me2_customiz set validation = 'none' where fldnum = '4204'and validation = 'never';
        update mt.me2_customiz set merge = 'N' where fldnum = '4204'and merge = 'X';
        update mt.me2_customiz set validation = 'none' where fldnum = '4205'and validation = 'never';
        update mt.me2_customiz set merge = 'N' where fldnum = '4205'and merge = 'X';
        update mt.me2_customiz set validation = 'none' where fldnum = '4206'and validation = 'never';
        update mt.me2_customiz set merge = 'N' where fldnum = '4206'and merge = 'X';
        update mt.me2_customiz set validation = 'none' where fldnum = '4207'and validation = 'never';
        update mt.me2_customiz set merge = 'N' where fldnum = '4207'and merge = 'X';
        update mt.me2_customiz set validation = 'none' where fldnum = '4208'and validation = 'never';
        update mt.me2_customiz set merge = 'N' where fldnum = '4208'and merge = 'X';
        update mt.me2_customiz set validation = 'none' where fldnum = '4210'and validation = 'never';
        update mt.me2_customiz set merge = 'N' where fldnum = '4210'and merge = 'X';
        update mt.me2_customiz set validation = 'none' where fldnum = '4211'and validation = 'never';
        update mt.me2_customiz set merge = 'N' where fldnum = '4211'and merge = 'X';
        update mt.me2_customiz set validation = 'none' where fldnum = '4213'and validation = 'never';
        update mt.me2_customiz set merge = 'N' where fldnum = '4213'and merge = 'X';
        update mt.me2_customiz set validation = 'none' where fldnum = '4214'and validation = 'never';
        update mt.me2_customiz set merge = 'N' where fldnum = '4214'and merge = 'X';
        update mt.me2_customiz set validation = 'none' where fldnum = '4215'and validation = 'never';
        update mt.me2_customiz set merge = 'N' where fldnum = '4215'and merge = 'X';
        update mt.me2_customiz set validation = 'none' where fldnum = '4216'and validation = 'never';
        update mt.me2_customiz set merge = 'N' where fldnum = '4216'and merge = 'X';
        update mt.me2_customiz set validation = 'none' where fldnum = '4218'and validation = 'never';
        update mt.me2_customiz set merge = 'N' where fldnum = '4218'and merge = 'X';
        update mt.me2_customiz set validation = 'none' where fldnum = '4220'and validation = 'never';
        update mt.me2_customiz set merge = 'N' where fldnum = '4220'and merge = 'X';
        update mt.me2_customiz set validation = 'none' where fldnum = '4222'and validation = 'never';
        update mt.me2_customiz set merge = 'N' where fldnum = '4222'and merge = 'X';
        update mt.me2_customiz set validation = 'none' where fldnum = '4223'and validation = 'never';
        update mt.me2_customiz set merge = 'N' where fldnum = '4223'and merge = 'X';
        update mt.me2_customiz set validation = 'none' where fldnum = '4225'and validation = 'never';
        update mt.me2_customiz set merge = 'N' where fldnum = '4225'and merge = 'X';
        update mt.me2_customiz set validation = 'none' where fldnum = '4226'and validation = 'never';
        update mt.me2_customiz set merge = 'N' where fldnum = '4226'and merge = 'X';
        update mt.me2_customiz set validation = 'none' where fldnum = '4229'and validation = 'never';
        update mt.me2_customiz set merge = 'N' where fldnum = '4229'and merge = 'X';
        update mt.me2_customiz set validation = 'none' where fldnum = '4230'and validation = 'never';
        update mt.me2_customiz set merge = 'N' where fldnum = '4230'and merge = 'X';
        update mt.me2_customiz set validation = 'none' where fldnum = '4231'and validation = 'never';
        update mt.me2_customiz set merge = 'N' where fldnum = '4231'and merge = 'X';
        update mt.me2_customiz set validation = 'none' where fldnum = '4232'and validation = 'never';
        update mt.me2_customiz set merge = 'N' where fldnum = '4232'and merge = 'X';
        update mt.me2_customiz set validation = 'none' where fldnum = '4233'and validation = 'never';
        update mt.me2_customiz set merge = 'N' where fldnum = '4233'and merge = 'X';
        update mt.me2_customiz set validation = 'none' where fldnum = '4234'and validation = 'never';
        update mt.me2_customiz set merge = 'N' where fldnum = '4234'and merge = 'X';
        update mt.me2_customiz set validation = 'none' where fldnum = '4235'and validation = 'never';
        update mt.me2_customiz set merge = 'N' where fldnum = '4235'and merge = 'X';
        update mt.me2_customiz set validation = 'none' where fldnum = '4241'and validation = 'never';
        update mt.me2_customiz set merge = 'N' where fldnum = '4241'and merge = 'X';
        update mt.me2_customiz set validation = 'none' where fldnum = '4242'and validation = 'never';
        update mt.me2_customiz set merge = 'N' where fldnum = '4242'and merge = 'X';
        update mt.me2_customiz set validation = 'none' where fldnum = '4243'and validation = 'never';
        update mt.me2_customiz set merge = 'N' where fldnum = '4243'and merge = 'X';
        update mt.me2_customiz set validation = 'none' where fldnum = '4244'and validation = 'never';
        update mt.me2_customiz set merge = 'N' where fldnum = '4244'and merge = 'X';
        update mt.me2_customiz set validation = 'none' where fldnum = '4245'and validation = 'never';
        update mt.me2_customiz set merge = 'N' where fldnum = '4245'and merge = 'X';
        update mt.me2_customiz set validation = 'none' where fldnum = '4246'and validation = 'never';
        update mt.me2_customiz set merge = 'N' where fldnum = '4246'and merge = 'X';
        update mt.me2_customiz set validation = 'none' where fldnum = '4247'and validation = 'never';
        update mt.me2_customiz set merge = 'N' where fldnum = '4247'and merge = 'X';
        update mt.me2_customiz set validation = 'none' where fldnum = '4248'and validation = 'never';
        update mt.me2_customiz set merge = 'N' where fldnum = '4248'and merge = 'X';
        update mt.me2_customiz set validation = 'none' where fldnum = '4249'and validation = 'never';
        update mt.me2_customiz set merge = 'N' where fldnum = '4249'and merge = 'X';
        update mt.me2_customiz set validation = 'none' where fldnum = '4262'and validation = 'never';
        update mt.me2_customiz set merge = 'N' where fldnum = '4262'and merge = 'X';
        update mt.me2_customiz set validation = 'none' where fldnum = '4603'and validation = 'never';
        update mt.me2_customiz set merge = 'N' where fldnum = '4603'and merge = 'X';
        update mt.me2_customiz set validation = 'none' where fldnum = '4604'and validation = 'never';
        update mt.me2_customiz set merge = 'N' where fldnum = '4604'and merge = 'X';
        update mt.me2_customiz set validation = 'none' where fldnum = '4605'and validation = 'never';
        update mt.me2_customiz set merge = 'N' where fldnum = '4605'and merge = 'X';
        update mt.me2_customiz set validation = 'none' where fldnum = '4606'and validation = 'never';
        update mt.me2_customiz set merge = 'N' where fldnum = '4606'and merge = 'X';
        update mt.me2_customiz set validation = 'none' where fldnum = '4607'and validation = 'never';
        update mt.me2_customiz set merge = 'N' where fldnum = '4607'and merge = 'X';
        update mt.me2_customiz set validation = 'none' where fldnum = '4608'and validation = 'never';
        update mt.me2_customiz set merge = 'N' where fldnum = '4608'and merge = 'X';
        update mt.me2_customiz set validation = 'none' where fldnum = '4609'and validation = 'never';
        update mt.me2_customiz set merge = 'N' where fldnum = '4609'and merge = 'X';
        update mt.me2_customiz set validation = 'none' where fldnum = '4610'and validation = 'never';
        update mt.me2_customiz set merge = 'N' where fldnum = '4610'and merge = 'X';
        update mt.me2_customiz set validation = 'none' where fldnum = '4611'and validation = 'never';
        update mt.me2_customiz set merge = 'N' where fldnum = '4611'and merge = 'X';
        update mt.me2_customiz set validation = 'none' where fldnum = '4612'and validation = 'never';
        update mt.me2_customiz set merge = 'N' where fldnum = '4612'and merge = 'X';
        update mt.me2_customiz set validation = 'none' where fldnum = '4613'and validation = 'never';
        update mt.me2_customiz set merge = 'N' where fldnum = '4613'and merge = 'X';
        update mt.me2_customiz set validation = 'none' where fldnum = '4614'and validation = 'never';
        update mt.me2_customiz set merge = 'N' where fldnum = '4614'and merge = 'X';
        update mt.me2_customiz set validation = 'none' where fldnum = '4615'and validation = 'never';
        update mt.me2_customiz set merge = 'N' where fldnum = '4615'and merge = 'X';
        update mt.me2_customiz set validation = 'none' where fldnum = '4616'and validation = 'never';
        update mt.me2_customiz set merge = 'N' where fldnum = '4616'and merge = 'X';
        update mt.me2_customiz set validation = 'none' where fldnum = '4617'and validation = 'never';
        update mt.me2_customiz set merge = 'N' where fldnum = '4617'and merge = 'X';
        update mt.me2_customiz set validation = 'none' where fldnum = '4618'and validation = 'never';
        update mt.me2_customiz set merge = 'N' where fldnum = '4618'and merge = 'X';
        update mt.me2_customiz set validation = 'none' where fldnum = '4619'and validation = 'never';
        update mt.me2_customiz set merge = 'N' where fldnum = '4619'and merge = 'X';
        update mt.me2_customiz set validation = 'none' where fldnum = '4620'and validation = 'never';
        update mt.me2_customiz set merge = 'N' where fldnum = '4620'and merge = 'X';

        set stmp = (select merge from mt.me2_customiz where fldnum = '2802' and desktop = 'default' and fform = 9);
        if (stmp = 'Y') then
            if (not exists (select table_name from sys.systable where table_name = 'mrg2802')) then
                update mt.me2_customiz set merge = 'N' where fldnum = '2802';
            end if;
        end if;

        set stmp = (select merge from mt.me2_customiz where fldnum = '4202' and desktop = 'default' and fform = 7);
        if (stmp = 'Y') then
            if (not exists (select table_name from sys.systable where table_name = 'mrg4202')) then
                update mt.me2_customiz set merge = 'N' where fldnum = '4202';
            end if;
        end if;

        set stmp = (select merge from mt.me2_customiz where fldnum = '4218' and desktop = 'default' and fform = 7);
        if (stmp = 'Y') then
            if (not exists (select table_name from sys.systable where table_name = 'mrg4218')) then
                update mt.me2_customiz set merge = 'N' where fldnum = '4218';
            end if;
        end if;

    end if;
    call mtxmsg ('customiz block 4: ', 'fini');
end;;
begin

    update mt.customiz set maxlen=10,len=10,datalen=10 where ftype='DATE';
    update mt.customiz set len = 80 where len > 32000;
    update mt.customiz set len=10, datalen=10, maxlen=10 where ftype = 'srchdate';
    update mt.customiz set len=8, datalen=8, maxlen=8 where ftype = 'time';
    update mt.customiz set maxlen=4,datalen=4 where fldnum='rowid';
    update mt.customiz set maxlen=4,datalen=4 where fldnum='num_meas';

    update mt.customiz set sdefault='' where fldnum like '23%';
    update mt.customiz set sdefault='' where fldnum like '28%';
    update mt.customiz set sdefault='' where fldnum like '32%';


    delete from mt.valfield where fldnum = '3250';
    insert into  mt.valfield (fldnum, val) values ('3250','D');
    insert into  mt.valfield (fldnum, val) values ('3250','W');
    insert into  mt.valfield (fldnum, val) values ('3250','M');
    insert into  mt.valfield (fldnum, val) values ('3250','N');
    insert into  mt.valfield (fldnum, val) values ('3250','U');

    delete from valfield where fldnum = '4228';
    insert into  valfield (fldnum, val) values ('4228','D');
    insert into  valfield (fldnum, val) values ('4228','W');
    insert into  valfield (fldnum, val) values ('4228','M');
    insert into  valfield (fldnum, val) values ('4228','N');
    insert into  valfield (fldnum, val) values ('4228','U');

    delete from valfield where fldnum = '4299';
    insert into  valfield (fldnum, val) values ('4299','A');
    insert into  valfield (fldnum, val) values ('4299','I');
    insert into  valfield (fldnum, val) values ('4299','D');

    delete from valfield where fldnum = '4258';
    insert into  valfield (fldnum, val) values ('4258','Y');
    insert into  valfield (fldnum, val) values ('4258','N');

    delete from valfield where fldnum = '2323';
    insert into  valfield (fldnum, val) values ('2323','Y');
    insert into  valfield (fldnum, val) values ('2323','N');
    insert into  valfield (fldnum, val) values ('2323','I');

    delete from valfield where fldnum = '2319';
    insert into  valfield (fldnum, val) values ('2319','Y');
    insert into  valfield (fldnum, val) values ('2319','N');

    delete from valfield where fldnum = '2325';
    insert into  valfield (fldnum, val) values ('2325','Y');
    insert into  valfield (fldnum, val) values ('2325','N');

    delete from valfield where fldnum = '2363';
    insert into  valfield (fldnum, val) values ('2363','Y');
    insert into  valfield (fldnum, val) values ('2363','N');

    delete from mt.valfield where fldnum='2322';
    insert into  valfield (fldnum, val) values ('2322','Y');
    insert into  valfield (fldnum, val) values ('2322','N');
    insert into  valfield (fldnum, val) values ('2322','X');

    delete from mt.valfield where fldnum='2308';
    insert into  valfield (fldnum, val) values ('2308','AS-FOUND');
    insert into  valfield (fldnum, val) values ('2308','AS-LEFT');
    insert into  valfield (fldnum, val) values ('2308','FOUND-LEFT');
    insert into  valfield (fldnum, val) values ('2308','');

    delete from valfield where fldnum = '2318';
    insert into  valfield (fldnum, val) values ('2318','NOMINAL');
    insert into  valfield (fldnum, val) values ('2318','UUT_INDICATED');
    insert into  valfield (fldnum, val) values ('2318','PROCEDURE');
    update mt.calibration set C2318='PROCEDURE' where C2318='PROCDURE';
end;;
begin
    
    if exists (select fldnum from mt.customiz where fldnum = '4601' and row = 0 and col = 0 and nextfld = 0)
    then
        update mt.customiz set suppressed ='N', row =144,col=13,len=48,datalen=48,nextfld=2 where fldnum ='4603';
        update mt.customiz set suppressed ='N', row =186,col=14,len=48,datalen=48,nextfld=3 where fldnum ='4604';
        update mt.customiz set suppressed ='N', row =60,col=13,len=32,datalen=32,nextfld=0 where fldnum ='4601';
        update mt.customiz set suppressed ='N', row =102,col=12,len=48,datalen=48,nextfld=1 where fldnum ='4602';
        update mt.customiz set suppressed ='N', row =228,col=15,len=2,datalen=2,nextfld=4 where fldnum ='4605';
        update mt.customiz set suppressed ='N', row =228,col=59,len=10,datalen=10,nextfld=5 where fldnum ='4606';
        update mt.customiz set suppressed ='N', row =291,col=15,len=48,datalen=48,nextfld=7 where fldnum ='4607';
        update mt.customiz set suppressed ='N', row =333,col=15,len=48,datalen=48,nextfld=8 where fldnum ='4608';
        update mt.customiz set suppressed ='N', row =375,col=13,len=2,datalen=2,nextfld=9 where fldnum ='4609';
        update mt.customiz set suppressed ='N', row =375,col=209,len=10,datalen=10,nextfld=11 where fldnum ='4610';
        update mt.customiz set suppressed ='N', row =375,col=101,len=10,datalen=10,nextfld=10 where fldnum ='4611';
        update mt.customiz set suppressed ='N', row =228,col=167,len=16,datalen=48,nextfld=6 where fldnum ='4612';
        update mt.customiz set suppressed ='Y', row =484,col=43,len=48,datalen=48,nextfld=0 where fldnum ='4613';
        update mt.customiz set suppressed ='Y', row =434,col=27,len=48,datalen=48,nextfld=0 where fldnum ='4614';
        update mt.customiz set suppressed ='Y', row =381,col=26,len=48,datalen=48,nextfld=0 where fldnum ='4615';
        update mt.customiz set suppressed ='Y', row =331,col=41,len=48,datalen=48,nextfld=0 where fldnum ='4616';
        update mt.customiz set suppressed ='Y', row =293,col=40,len=48,datalen=48,nextfld=0 where fldnum ='4617';
        update mt.customiz set suppressed ='Y', row =53,col=769,len=48,datalen=48,nextfld=0 where fldnum ='4618';
        update mt.customiz set suppressed ='Y', row =91,col=766,len=48,datalen=48,nextfld=0 where fldnum ='4619';
        update mt.customiz set suppressed ='Y', row =133,col=783,len=48,datalen=48,nextfld=0 where fldnum ='4620';
        update mt.customiz set suppressed ='N', row =375,col=317,len=10,datalen=10,nextfld=12 where fldnum ='4621';
        update mt.customiz set suppressed ='N', row =375,col=425,len=10,datalen=10,nextfld=13 where fldnum ='4622';
        update mt.customiz set suppressed ='Y', row =281,col=805,len=10,datalen=10,nextfld=0 where fldnum ='4623';
        update mt.customiz set suppressed ='Y', row =324,col=814,len=10,datalen=10,nextfld=0 where fldnum ='4624';
        update mt.customiz set suppressed ='Y', row =375,col=806,len=10,datalen=10,nextfld=0 where fldnum ='4625';
        update mt.customiz set suppressed ='Y', row =410,col=836,len=10,datalen=10,nextfld=0 where fldnum ='4626';
        update mt.customiz set suppressed ='Y', row =446,col=854,len=10,datalen=10,nextfld=0 where fldnum ='4627';
        update mt.customiz set suppressed ='Y', row =200,col=972,len=10,datalen=10,nextfld=0 where fldnum ='4628';
        update mt.customiz set suppressed ='Y', row =50,col=0,len=15,datalen=15,nextfld=0 where fldnum ='4629';
        update mt.customiz set suppressed ='Y', row =50,col=0,len=16,datalen=16,nextfld=0 where fldnum ='4630';
        update mt.customiz set suppressed ='Y', row =50,col=0,len=15,datalen=15,nextfld=0 where fldnum ='4631';
        update mt.customiz set suppressed ='Y', row =50,col=0,len=16,datalen=16,nextfld=0 where fldnum ='4632';
        update mt.customiz set suppressed ='Y', row =0,col=0,len=8,datalen=8,nextfld=0 where fldnum ='4640';
        update mt.customiz set suppressed ='Y', row =256,col=970,len=3,datalen=3,nextfld=0 where fldnum ='KDSRC';
        update mt.customiz set suppressed ='Y', row =299,col=971,len=32,datalen=32,nextfld=0 where fldnum ='KKTAG';
        update mt.customiz set suppressed ='Y', row =353,col=970,len=32,datalen=32,nextfld=0 where fldnum ='KPUBLISH';
        update mt.customiz set suppressed ='Y', row =0,col=0,len=3,datalen=3,nextfld=0 where fldnum ='SKDSRC';
        update mt.customiz set suppressed ='Y', row =0,col=0,len=30,datalen=30,nextfld=0 where fldnum ='SKKTAG';
        update mt.customiz set suppressed ='Y', row =0,col=0,len=32,datalen=32,nextfld=0 where fldnum ='SKPUBLISH';

    end if;
end;;
/* ===================================================
// create and initialize the mt.ME2_customiz table if it is not already there
*/
begin
    if (not exists(select table_name from sys.systable where table_name='ME2_Customiz' and table_type='BASE')) then
        create table mt.ME2_Customiz(
            Fldnum char(15) null,
            title char(40) null,
            suppressed char(1) null,
            Ilevels char(3) null,
            Ireq char(1) null,
            Idefault char(50) null,
            Slevels char(3) null,
            Sreq char(1) null,
            Sdefault char(50) null,
            Scopy char(10) null,
            validation char(8) null,
            merge char(1) null,
            row integer null,
            col integer null,
            len integer null,
            datalen integer null,
            nextfld integer null,
            tooltip char(48) null,
            datacol char(20) null,
            ftype char(8) null,
            fform integer null,
            postitle char(1) null,
            maxlen integer null,
            dcopy char(4) null,
            chkfunc char(1) null,
            title2 char(40) null,
            title3 char(40) null,
            title4 char(40) null,
            title5 char(40) null,
            qrow integer null,
            qcol integer null,
            qsupp char(1) null,
            MemoFieldSize char(32),
            Desktop char(32)
            );

        grant select on mt.me2_customiz to public;
        begin
          declare Rtn integer;
          declare FldList char(1024);
          set Rtn=-1;
          /* If the Temp table exists, drop it
          //
          */
          if exists(select cname from sys.syscolumns where tname = 'TheTemp') then
            execute immediate 'drop table TheTemp'
          end if;
          /*
          // Create a temporary table that is used to build the new ME2_Customiz table
          */
          create table mt.TheTemp(
            Fldnum char(15) null,
            title char(40) null,
            suppressed char(1) null,
            Ilevels char(3) null,
            Ireq char(1) null,
            Idefault char(50) null,
            Slevels char(3) null,
            Sreq char(1) null,
            Sdefault char(50) null,
            Scopy char(10) null,
            validation char(8) null,
            merge char(1) null,
            row integer null,
            col integer null,
            len integer null,
            datalen integer null,
            nextfld integer null,
            tooltip char(48) null,
            datacol char(20) null,
            ftype char(8) null,
            fform integer null,
            postitle char(1) null,
            maxlen integer null,
            dcopy char(4) null,
            chkfunc char(1) null,
            title2 char(40) null,
            title3 char(40) null,
            title4 char(40) null,
            title5 char(40) null,
            qrow integer null,
            qcol integer null,
            qsupp char(1) null
            );
          execute immediate 'delete from TheTemp';

          set FldList='select cast(Fldnum as char (15)), cast(title as char (40)) , cast(suppressed as char), 
                cast(Ilevels as char(3)), cast(Ireq char), cast(Idefault as char(50), cast(Slevels as char(3), 
                cast(Sreq as char(1), cast(Sdefault as char(50), cast(Scopy as char(10), cast(validation as char(8), 
                cast(merge as char), row, col, len, datalen, nextfld, cast(tooltip as char(48), 
                cast(datacol as char (20)), cast(ftype as char(8), fform, cast(postitle as char), maxlen, 
                cast(dcopy as char(4), cast(chkfunc as char), cast(title2 as char(40), cast(title3 as char(40), 
                cast(title4 as char(40), cast(title5 as char (40), \x0Aqrow, qcol, cast(qsupp as char) ';

          execute immediate 'insert TheTemp select * from mt.customiz where fform not in (1,64,128)';
          execute immediate 'update TheTemp set fform = 0';

          execute immediate 'insert TheTemp select * from customiz where fform not in (1,64,128)';
          execute immediate 'update TheTemp set fform = 1 where fform > 0';

          execute immediate 'insert TheTemp  Select * from mt.customiz where fform = 32';
          execute immediate 'update TheTemp set fform = 6 where fform = 32';

          execute immediate 'insert TheTemp  Select *  from mt.customiz where fform = 32';
          execute immediate 'update TheTemp set fform = 11 where fform = 32';

          execute immediate 'insert TheTemp  Select *  from mt.customiz where fform = 16';
          execute immediate 'update TheTemp set fform = 5 where fform = 16';

          execute immediate 'insert TheTemp  Select *  from mt.customiz where fform = 16';
          execute immediate 'update TheTemp set fform = 10 where fform = 16'; 
          // /* Add/Edit Repair */
          /* Copy calibration
          // =================
          */
          execute immediate 'insert TheTemp  Select *  from mt.customiz where fform = 4';
          execute immediate 'update TheTemp set fform = 3 where fform = 4'; 
          // /* Search Calibration */
          /* Add/Edit calibration 
          */
          execute immediate 'insert TheTemp  Select *  from mt.customiz where fform = 4';
          execute immediate 'update TheTemp set fform = 98 where fform = 4 ';
          /* Search location
          // ================== 
          */
          execute immediate 'insert TheTemp  Select *  from mt.customiz where fform = 8';
          execute immediate 'update TheTemp set fform = 9 where fform = 8';
          /* Add/Edit location 
          */
          execute immediate 'insert TheTemp  Select *  from mt.customiz where fform = 8';
          execute immediate 'update TheTemp set fform = 4 where fform = 8';
          execute immediate 'update TheTemp set fform = 8 where fform = 98'; 
          /* Add/Edit calibration */
          /* Copy inventory 
          // ================= 
          */
          execute immediate 'insert TheTemp  Select * from mt.customiz where fform = 2';
          execute immediate 'update TheTemp set fform = 7 where fform = 2'; 
          // /* Inventory / Entry */
          execute immediate 'insert TheTemp  Select *  from mt.customiz where fform = 2';
          execute immediate 'alter table TheTemp Add MemoFieldSize char(32)';
          execute immediate 'alter table TheTemp Add Desktop char(32)';
          execute immediate 'update TheTemp Set Desktop = ''Default'' ';
          execute immediate 'update TheTemp set MemoFieldSize = ''599/233'' where ftype = ''memo'' ';
          // /* Reset the search & Core screens */
          execute immediate 'update TheTemp  Set  suppressed = ''Y'' where fform < 5 ';
          /*
          // Preset the settings of the new tables 
          // Leave the 4 base tables in changed 
          //======================================================================
          */

          /*  Search form */
          execute immediate 'update TheTemp  Set row = 71,  col = 18, Len=20,  datalen=60, suppressed = ''N'', nextfld = 1 where fldnum = ''4201''  and fform = 0';
          execute immediate 'update TheTemp  Set row = 111, col = 18, Len=20,  suppressed = ''N'', nextfld = 2 where fldnum = ''4202''  and fform = 0';
          execute immediate 'update TheTemp  Set row = 151, col = 18, Len=20,  suppressed = ''N'', nextfld = 3 where fldnum = ''4203''  and fform = 0';
          execute immediate 'update TheTemp  Set row = 191, col = 18, Len=20,  suppressed = ''N'', nextfld = 4 where fldnum = ''4204''  and fform = 0';
          execute immediate 'update TheTemp  Set row = 234, col = 18, Len=1,   suppressed = ''N'', nextfld = 5 where fldnum = ''4299''  and fform = 0';

          execute immediate 'update TheTemp  Set row = 71,  col = 210, Len=20, suppressed = ''N'', nextfld = 6 where fldnum = ''2801''  and fform = 0';
          execute immediate 'update TheTemp  Set row = 111, col = 210, Len=20, suppressed = ''N'', nextfld = 7 where fldnum = ''2802''  and fform = 0';
          execute immediate 'update TheTemp  Set row = 151, col = 210, Len=20, suppressed = ''N'', nextfld = 8 where fldnum = ''2803'' and fform = 0';
          execute immediate 'update TheTemp  Set row = 191, col = 210, Len=10, suppressed = ''N'', nextfld = 9 where fldnum = ''2804''  and fform = 0';

          execute immediate 'update TheTemp  Set row = 71,  col = 400, Len=15, suppressed = ''N'', nextfld = 10 where fldnum = ''2307'' and fform = 0';
          execute immediate 'update TheTemp  Set row = 111, col = 400, Len=1,  suppressed = ''N'', nextfld = 11 where fldnum = ''2323'' and fform = 0';
          execute immediate 'update TheTemp  Set row = 151, col = 400, Len=6,  suppressed = ''N'', nextfld = 13 where fldnum = ''2320'' and fform = 0';

          /*  Core form */
          execute immediate 'update TheTemp  Set row = 69,  col = 18, Len=16,  datalen=60, suppressed = ''N'', nextfld = 1 where fldnum = ''4201''  and fform = 1';
          execute immediate 'update TheTemp  Set row = 111, col = 18, Len=16,  suppressed = ''N'', nextfld = 2 where fldnum = ''4202''  and fform = 1';
          execute immediate 'update TheTemp  Set row = 153, col = 18, Len=16,  suppressed = ''N'', nextfld = 3 where fldnum = ''4203''  and fform = 1';
          execute immediate 'update TheTemp  Set row = 195, col = 18, Len=16,  suppressed = ''N'', nextfld = 4 where fldnum = ''2801''  and fform = 1';
          execute immediate 'update TheTemp  Set row = 237, col = 18, Len=10,  suppressed = ''N'', nextfld = 5 where fldnum = ''2301''  and fform = 1';



           /*  Browse Inventory form */
          execute immediate 'update TheTemp  Set row = 69,  col = 17,  len = 16, datalen=60, suppressed = ''N'', nextfld = 1  where fldnum = ''4201'' and fform = 2';
          execute immediate 'update TheTemp  Set row = 70,  col = 164, len = 20, suppressed = ''N'', nextfld = 2  where fldnum = ''4202'' and fform = 2';
          execute immediate 'update TheTemp  Set row = 70,  col = 336, len = 15, suppressed = ''N'', nextfld = 3  where fldnum = ''4203'' and fform = 2';
          execute immediate 'update TheTemp  Set row = 109, col = 17,  len = 35, suppressed = ''N'', nextfld = 4  where fldnum = ''4204'' and fform = 2';
          execute immediate 'update TheTemp  Set row = 109, col = 296, len = 15, suppressed = ''N'', nextfld = 5  where fldnum = ''4206'' and fform = 2';
          execute immediate 'update TheTemp  Set row = 150, col = 17,  len = 3,  suppressed = ''N'', nextfld = 6  where fldnum = ''4229'' and fform = 2';
          execute immediate 'update TheTemp  Set row = 150, col = 98,  len = 1,  suppressed = ''N'', nextfld = 7  where fldnum = ''4228'' and fform = 2';
          execute immediate 'update TheTemp  Set row = 150, col = 173, len = 8,  suppressed = ''N'', nextfld = 8  where fldnum = ''4225'' and fform = 2';
          execute immediate 'update TheTemp  Set row = 150, col = 270, len = 1,  suppressed = ''N'', nextfld = 9  where fldnum = ''4299'' and fform = 2';
          execute immediate 'update TheTemp  Set row = 150, col = 353, len = 1,  suppressed = ''N'', nextfld = 10 where fldnum = ''4209'' and fform = 2';
          execute immediate 'update TheTemp  Set row = 189, col = 17,  len = 10,  suppressed = ''N'', nextfld = 11 where fldnum = ''4221'' and fform = 2';
          execute immediate 'update TheTemp  Set row = 189, col = 161, len = 12,  suppressed = ''N'', nextfld = 12 where fldnum = ''4222'' and fform = 2';
          execute immediate 'update TheTemp  Set row = 189, col = 277, len = 10,  suppressed = ''N'', nextfld = 13 where fldnum = ''4219'' and fform = 2';
          execute immediate 'update TheTemp  Set row = 189, col = 379, len = 10,  suppressed = ''N'', nextfld = 14 where fldnum = ''4224'' and fform = 2';
          execute immediate 'update TheTemp  Set row = 229, col = 17,  len = 30,  suppressed = ''N'', nextfld = 15 where fldnum = ''4241'' and fform = 2';
          execute immediate 'update TheTemp  Set row = 229, col = 265, len = 24,  suppressed = ''N'', nextfld = 16 where fldnum = ''4207'' and fform = 2';
          execute immediate 'update TheTemp  Set row = 229, col = 471, len = 4,   suppressed = ''N'', nextfld = 17 where fldnum = ''4240'' and fform = 2';


           /*  Browse Calibration form */
          execute immediate 'update TheTemp  Set row = 69,  col = 18,   suppressed = ''N'', nextfld = 1  where fldnum = ''2301''  and fform = 3';
          execute immediate 'update TheTemp  Set row = 69,  col = 167,  suppressed = ''N'', nextfld = 2  where fldnum = ''2323''  and fform = 3';
          execute immediate 'update TheTemp  Set row = 69,  col = 208,  suppressed = ''N'', nextfld = 3  where fldnum = ''2302''  and fform = 3';
          execute immediate 'update TheTemp  Set row = 69,  col = 262,  suppressed = ''N'', nextfld = 4  where fldnum = ''2331''  and fform = 3';
          execute immediate 'update TheTemp  Set row = 69,  col = 327,  suppressed = ''N'', nextfld = 5  where fldnum = ''2303''  and fform = 3';
          execute immediate 'update TheTemp  Set row = 109, col = 18,   suppressed = ''N'', nextfld = 6  where fldnum = ''2307''  and fform = 3';
          execute immediate 'update TheTemp  Set row = 109, col = 158,  suppressed = ''N'', nextfld = 7  where fldnum = ''2324''  and fform = 3';
          execute immediate 'update TheTemp  Set row = 109, col = 220,  suppressed = ''N'', nextfld = 8  where fldnum = ''2311''  and fform = 3';
          execute immediate 'update TheTemp  Set row = 109, col = 282,  suppressed = ''N'', nextfld = 9  where fldnum = ''2312''  and fform = 3';
          execute immediate 'update TheTemp  Set row = 109, col = 334,  suppressed = ''N'', nextfld = 10 where fldnum = ''2322''  and fform = 3';
          execute immediate 'update TheTemp  Set row = 153, col = 18,   suppressed = ''N'', nextfld = 11 where fldnum = ''2316''  and fform = 3';
          execute immediate 'update TheTemp  Set row = 195, col = 18,   suppressed = ''N'', nextfld = 12 where fldnum = ''2320''  and fform = 3';
          execute immediate 'update TheTemp  Set row = 237, col = 18,   suppressed = ''N'', nextfld = 13 where fldnum = ''2341''  and fform = 3';

           /*  Browse Location form */

          execute immediate 'update TheTemp  Set row = 69,  col = 18,  suppressed = ''N'', nextfld = 1 where fldnum = ''2801''  and fform = 4';
          execute immediate 'update TheTemp  Set row = 111, col = 18,  suppressed = ''N'', nextfld = 2 where fldnum = ''2802''  and fform = 4';
          execute immediate 'update TheTemp  Set row = 153, col = 18,  suppressed = ''N'', nextfld = 3 where fldnum = ''2816''  and fform = 4';          
          execute immediate 'update TheTemp  Set row = 195, col = 18,  suppressed = ''N'', nextfld = 4 where fldnum = ''2804''  and fform = 4';
          execute immediate 'update TheTemp  Set row = 237, col = 18,  suppressed = ''N'', nextfld = 5 where fldnum = ''2803''  and fform = 4';

          // /*Set new alignment...*/

          // /* Be sure the X's are correct- a field that cannot be suppressed */
          execute immediate 'update TheTemp Set   suppressed = ''X'' where fldnum  in (''4201'', ''4228'') and fform = 7 '; 
          execute immediate 'update TheTemp Set  suppressed = ''X'' where fldnum in (''3249'', ''3250'', ''3251'') and fform = 10';

          // /* Place all titles on top on Search & Browse Screens */
          execute immediate 'update TheTemp Set  postitle = ''T'' where fform < 7 ';

          // /* Any field on a Search & Browse form can be suppressed */
          execute immediate 'update TheTemp Set  suppressed = ''Y'' where (suppressed = ''X'' or suppressed = ''x'') and fform < 7 ';

          // /* Change I4226 - Cal Seals to fixed validation... */
          execute immediate 'update TheTemp Set validation = ''fixed'' where fldnum = ''4226'' ';

          // /* Change User name to Current User */
          execute immediate 'update TheTemp Set title = ''Current User'' where fldnum = ''2801'' and fform = 1 ';

          // /* Change Due-Date to next due-date */
          execute immediate 'update TheTemp Set title = ''Last Cal-Date'' where fldnum = ''2301'' and fform = 1 ';

          // /* Change Due-Date to next due-date */
          execute immediate 'update TheTemp Set title = ''Next Due-Date'' where fldnum = ''2303'' and fform = 1 ';

          // /* Get rid of references to C2340 - STDS everywhere but calibration - fform = 8 */
          execute immediate 'delete from TheTemp where fldnum = ''2340'' and fform <> 8 ';

          // /* Change Cal Date C2301 validation to none */
          execute immediate 'update TheTemp Set validation = ''none'' where fldnum = ''2301'' and fform = 8 ';

          // /* Clear out existing data */
          execute immediate ' delete from mt.me2_customiz';

          // /* Copy the data to me2_customiz */
          execute immediate 'insert me2_customiz select * from  TheTemp ';

          // /* Kill the temp Table */
          execute immediate 'drop table TheTemp ';
          // /* execute immediate 'commit work'; */
          //message 'Done';
          set Rtn=1
        end;
    else
        update mt.me2_customiz set datalen=60 where fldnum = '4201';
        update mt.me2_customiz set datalen=80, maxlen=80, ftype='RO' where fldnum like '%TAG';
        update mt.me2_customiz set validation = 'fixed' where fldnum = '4640';
        update mt.me2_customiz set tooltip = title where tooltip is null;
        update mt.me2_customiz set validation = 'fixed' where fldnum = '2308';
        update mt.me2_customiz set title2 = 'Prix d''achat' where title2 = 'Prix d''+B125''achat';
        update mt.me2_customiz set ftype='SPVAL' where datacol in ('K4633', 'K4634', 'K4635', 'K4636', 'K4637');
    end if;
end;;
/* add239x.sql the add of 2390-2395 customization to me2_customiz */
begin
    declare svdesktop char(256);
	declare err_notfound exception for sqlstate value '02000';
    declare cur_desks dynamic scroll cursor for select distinct(desktop) from mt.me2_customiz;

	open cur_desks;
	zloop: loop
		fetch next cur_desks into svdesktop;
		if sqlstate = err_notfound then
			leave zloop;
		end if;

        if not exists (select fldnum from mt.me2_customiz where fldnum = '2390' and fform = 0 and Desktop = svdesktop) then
            insert into mt.me2_customiz 
                (Fldnum,title,suppressed,Ilevels,Ireq,Idefault,Slevels,Sreq,Sdefault,Scopy,
                validation,merge,row,col,len,datalen,nextfld,tooltip,datacol,ftype,fform,
                postitle,maxlen,dcopy,chkfunc,title2,title3,title4,title5,qrow,qcol,qsupp,Desktop) 
                values 
                ('2390', 'SOT Threshold','Y'     ,''     ,'N' ,''      ,''     ,'N' ,''      ,'OFF',
                'never'  ,'X'  ,'600','0','4','4','0','SOT Threshold','C2390','DECIMAL4','0',
                'T','4'     ,'OFF','N'    ,'SOT Threshold','SOT Threshold','SOT Threshold','SOT Threshold','0','0','Y',svdesktop);
		end if;
        if not exists (select fldnum from mt.me2_customiz where fldnum = '2391' and fform = 0 and Desktop = svdesktop) then
            insert into mt.me2_customiz 
                (Fldnum,title,suppressed,Ilevels,Ireq,Idefault,Slevels,Sreq,Sdefault,Scopy,
                validation,merge,row,col,len,datalen,nextfld,tooltip,datacol,ftype,fform,
                postitle,maxlen,dcopy,chkfunc,title2,title3,title4,title5,qrow,qcol,qsupp,Desktop) 
                values 
                ('2391', 'SWT Threshold','Y'     ,''     ,'N' ,''      ,''     ,'N' ,''      ,'OFF',
                'never'  ,'X'  ,'600','0','4','4','0','SWT Threshold','C2391','DECIMAL4','0',
                'T','4'     ,'OFF','N'    ,'SWT Threshold','SWT Threshold','SWT Threshold','SWT Threshold','0','0','Y',svdesktop);
		end if;
        if not exists (select fldnum from mt.me2_customiz where fldnum = '2392' and fform = 0 and Desktop = svdesktop) then
            insert into mt.me2_customiz 
                (Fldnum,title,suppressed,Ilevels,Ireq,Idefault,Slevels,Sreq,Sdefault,Scopy,
                validation,merge,row,col,len,datalen,nextfld,tooltip,datacol,ftype,fform,
                postitle,maxlen,dcopy,chkfunc,title2,title3,title4,title5,qrow,qcol,qsupp,Desktop) 
                values 
                ('2392', 'Reported Unert. Conf.Level','Y'     ,''     ,'N' ,''      ,''     ,'N' ,''      ,'OFF',
                'never'  ,'X'  ,'600','0','4','4','0','Reported Unert. Conf.Level','C2392','DECIMAL4','0',
                'T','4'     ,'OFF','N'    ,'Reported Unert. Conf.Level','Reported Unert. Conf.Level','Reported Unert. Conf.Level','Reported Unert. Conf.Level','0','0','Y',svdesktop);
		end if;
        if not exists (select fldnum from mt.me2_customiz where fldnum = '2393' and fform = 0 and Desktop = svdesktop) then
            insert into mt.me2_customiz 
                (Fldnum,title,suppressed,Ilevels,Ireq,Idefault,Slevels,Sreq,Sdefault,Scopy,
                validation,merge,row,col,len,datalen,nextfld,tooltip,datacol,ftype,fform,
                postitle,maxlen,dcopy,chkfunc,title2,title3,title4,title5,qrow,qcol,qsupp,Desktop) 
                values 
                ('2393', 'Use Dominance Test','Y'     ,''     ,'N' ,''      ,''     ,'N' ,''      ,'OFF',
                'never'  ,'X'  ,'600','0','2','2','0','Use Dominance Test','C2393','SPVAL','0',
                'T','2'     ,'OFF','N'    ,'Use Dominance Test','Use Dominance Test','Use Dominance Test','Use Dominance Test','0','0','Y',svdesktop);
		end if;
        if not exists (select fldnum from mt.me2_customiz where fldnum = '2394' and fform = 0 and Desktop = svdesktop) then
            insert into mt.me2_customiz 
                (Fldnum,title,suppressed,Ilevels,Ireq,Idefault,Slevels,Sreq,Sdefault,Scopy,
                validation,merge,row,col,len,datalen,nextfld,tooltip,datacol,ftype,fform,
                postitle,maxlen,dcopy,chkfunc,title2,title3,title4,title5,qrow,qcol,qsupp,Desktop) 
                values 
                ('2394', 'Use Reliability Test','Y'     ,''     ,'N' ,''      ,''     ,'N' ,''      ,'OFF',
                'never'  ,'X'  ,'600','0','2','2','0','Use Reliability Test','C2394','SPVAL','0',
                'T','2'     ,'OFF','N'    ,'Use Reliability Test','Use Reliability Test','Use Reliability Test','Use Reliability Test','0','0','Y',svdesktop);
		end if;
        if not exists (select fldnum from mt.me2_customiz where fldnum = '2395' and fform = 0 and Desktop = svdesktop) then
            insert into mt.me2_customiz 
                (Fldnum,title,suppressed,Ilevels,Ireq,Idefault,Slevels,Sreq,Sdefault,Scopy,
                validation,merge,row,col,len,datalen,nextfld,tooltip,datacol,ftype,fform,
                postitle,maxlen,dcopy,chkfunc,title2,title3,title4,title5,qrow,qcol,qsupp,Desktop) 
                values 
                ('2395', 'Certificate Number','Y'     ,''     ,'N' ,''      ,''     ,'N' ,''      ,'OFF',
                'never'  ,'N'  ,'600','0','10','10','0','Certificate Number','C2395','SPVAL','0',
                'T','10'     ,'OFF','N'    ,'Certificate Number','Certificate Number','Certificate Number','Certificate Number','0','0','Y',svdesktop);
		end if;


        if not exists (select fldnum from mt.me2_customiz where fldnum = '2390' and fform = 1 and Desktop = svdesktop) then
            insert into mt.me2_customiz 
                (Fldnum,title,suppressed,Ilevels,Ireq,Idefault,Slevels,Sreq,Sdefault,Scopy,
                validation,merge,row,col,len,datalen,nextfld,tooltip,datacol,ftype,fform,
                postitle,maxlen,dcopy,chkfunc,title2,title3,title4,title5,qrow,qcol,qsupp,Desktop) 
                values 
                ('2390', 'SOT Threshold','Y'     ,''     ,'N' ,''      ,''     ,'N' ,''      ,'OFF',
                'never'  ,'X'  ,'600','0','4','4','0','SOT Threshold','C2390','DECIMAL4','1',
                'T','4'     ,'OFF','N'    ,'SOT Threshold','SOT Threshold','SOT Threshold','SOT Threshold','0','0','Y',svdesktop);
		end if;
        if not exists (select fldnum from mt.me2_customiz where fldnum = '2391' and fform = 1 and Desktop = svdesktop) then
            insert into mt.me2_customiz 
                (Fldnum,title,suppressed,Ilevels,Ireq,Idefault,Slevels,Sreq,Sdefault,Scopy,
                validation,merge,row,col,len,datalen,nextfld,tooltip,datacol,ftype,fform,
                postitle,maxlen,dcopy,chkfunc,title2,title3,title4,title5,qrow,qcol,qsupp,Desktop) 
                values 
                ('2391', 'SWT Threshold','Y'     ,''     ,'N' ,''      ,''     ,'N' ,''      ,'OFF',
                'never'  ,'X'  ,'600','0','4','4','0','SWT Threshold','C2391','DECIMAL4','1',
                'T','4'     ,'OFF','N'    ,'SWT Threshold','SWT Threshold','SWT Threshold','SWT Threshold','0','0','Y',svdesktop);
		end if;
        if not exists (select fldnum from mt.me2_customiz where fldnum = '2392' and fform = 1 and Desktop = svdesktop) then
            insert into mt.me2_customiz 
                (Fldnum,title,suppressed,Ilevels,Ireq,Idefault,Slevels,Sreq,Sdefault,Scopy,
                validation,merge,row,col,len,datalen,nextfld,tooltip,datacol,ftype,fform,
                postitle,maxlen,dcopy,chkfunc,title2,title3,title4,title5,qrow,qcol,qsupp,Desktop) 
                values 
                ('2392', 'Reported Unert. Conf.Level','Y'     ,''     ,'N' ,''      ,''     ,'N' ,''      ,'OFF',
                'never'  ,'X'  ,'600','0','4','4','0','Reported Unert. Conf.Level','C2392','DECIMAL4','1',
                'T','4'     ,'OFF','N'    ,'Reported Unert. Conf.Level','Reported Unert. Conf.Level','Reported Unert. Conf.Level','Reported Unert. Conf.Level','0','0','Y',svdesktop);
		end if;
        if not exists (select fldnum from mt.me2_customiz where fldnum = '2393' and fform = 1 and Desktop = svdesktop) then
            insert into mt.me2_customiz 
                (Fldnum,title,suppressed,Ilevels,Ireq,Idefault,Slevels,Sreq,Sdefault,Scopy,
                validation,merge,row,col,len,datalen,nextfld,tooltip,datacol,ftype,fform,
                postitle,maxlen,dcopy,chkfunc,title2,title3,title4,title5,qrow,qcol,qsupp,Desktop) 
                values 
                ('2393', 'Use Dominance Test','Y'     ,''     ,'N' ,''      ,''     ,'N' ,''      ,'OFF',
                'never'  ,'X'  ,'600','0','2','2','0','Use Dominance Test','C2393','SPVAL','1',
                'T','2'     ,'OFF','N'    ,'Use Dominance Test','Use Dominance Test','Use Dominance Test','Use Dominance Test','0','0','Y',svdesktop);
		end if;
        if not exists (select fldnum from mt.me2_customiz where fldnum = '2394' and fform = 1 and Desktop = svdesktop) then
            insert into mt.me2_customiz 
                (Fldnum,title,suppressed,Ilevels,Ireq,Idefault,Slevels,Sreq,Sdefault,Scopy,
                validation,merge,row,col,len,datalen,nextfld,tooltip,datacol,ftype,fform,
                postitle,maxlen,dcopy,chkfunc,title2,title3,title4,title5,qrow,qcol,qsupp,Desktop) 
                values 
                ('2394', 'Use Reliability Test','Y'     ,''     ,'N' ,''      ,''     ,'N' ,''      ,'OFF',
                'never'  ,'X'  ,'600','0','2','2','0','Use Reliability Test','C2394','SPVAL','1',
                'T','2'     ,'OFF','N'    ,'Use Reliability Test','Use Reliability Test','Use Reliability Test','Use Reliability Test','0','0','Y',svdesktop);
		end if;
        if not exists (select fldnum from mt.me2_customiz where fldnum = '2395' and fform = 1 and Desktop = svdesktop) then
            insert into mt.me2_customiz 
                (Fldnum,title,suppressed,Ilevels,Ireq,Idefault,Slevels,Sreq,Sdefault,Scopy,
                validation,merge,row,col,len,datalen,nextfld,tooltip,datacol,ftype,fform,
                postitle,maxlen,dcopy,chkfunc,title2,title3,title4,title5,qrow,qcol,qsupp,Desktop) 
                values 
                ('2395', 'Certificate Number','Y'     ,''     ,'N' ,''      ,''     ,'N' ,''      ,'OFF',
                'never'  ,'N'  ,'600','0','10','10','0','Certificate Number','C2395','SPVAL','1',
                'T','10'     ,'OFF','N'    ,'Certificate Number','Certificate Number','Certificate Number','Certificate Number','0','0','Y',svdesktop);
		end if;


        if not exists (select fldnum from mt.me2_customiz where fldnum = '2390' and fform = 3 and Desktop = svdesktop) then
            insert into mt.me2_customiz 
                (Fldnum,title,suppressed,Ilevels,Ireq,Idefault,Slevels,Sreq,Sdefault,Scopy,
                validation,merge,row,col,len,datalen,nextfld,tooltip,datacol,ftype,fform,
                postitle,maxlen,dcopy,chkfunc,title2,title3,title4,title5,qrow,qcol,qsupp,Desktop) 
                values 
                ('2390', 'SOT Threshold','Y'     ,''     ,'N' ,''      ,''     ,'N' ,''      ,'OFF',
                'never'  ,'X'  ,'600','0','4','4','0','SOT Threshold','C2390','DECIMAL4','3',
                'T','4'     ,'OFF','N'    ,'SOT Threshold','SOT Threshold','SOT Threshold','SOT Threshold','0','0','Y',svdesktop);
		end if;
        if not exists (select fldnum from mt.me2_customiz where fldnum = '2391' and fform = 3 and Desktop = svdesktop) then
            insert into mt.me2_customiz 
                (Fldnum,title,suppressed,Ilevels,Ireq,Idefault,Slevels,Sreq,Sdefault,Scopy,
                validation,merge,row,col,len,datalen,nextfld,tooltip,datacol,ftype,fform,
                postitle,maxlen,dcopy,chkfunc,title2,title3,title4,title5,qrow,qcol,qsupp,Desktop) 
                values 
                ('2391', 'SWT Threshold','Y'     ,''     ,'N' ,''      ,''     ,'N' ,''      ,'OFF',
                'never'  ,'X'  ,'600','0','4','4','0','SWT Threshold','C2391','DECIMAL4','3',
                'T','4'     ,'OFF','N'    ,'SWT Threshold','SWT Threshold','SWT Threshold','SWT Threshold','0','0','Y',svdesktop);
        end if;
        if not exists (select fldnum from mt.me2_customiz where fldnum = '2392' and fform = 3 and Desktop = svdesktop) then
            insert into mt.me2_customiz 
                (Fldnum,title,suppressed,Ilevels,Ireq,Idefault,Slevels,Sreq,Sdefault,Scopy,
                validation,merge,row,col,len,datalen,nextfld,tooltip,datacol,ftype,fform,
                postitle,maxlen,dcopy,chkfunc,title2,title3,title4,title5,qrow,qcol,qsupp,Desktop) 
                values 
                ('2392', 'Reported Unert. Conf.Level','Y'     ,''     ,'N' ,''      ,''     ,'N' ,''      ,'OFF',
                'never'  ,'X'  ,'600','0','4','4','0','Reported Unert. Conf.Level','C2392','DECIMAL4','3',
                'T','4'     ,'OFF','N'    ,'Reported Unert. Conf.Level','Reported Unert. Conf.Level','Reported Unert. Conf.Level','Reported Unert. Conf.Level','0','0','Y',svdesktop);
        end if;
        if not exists (select fldnum from mt.me2_customiz where fldnum = '2393' and fform = 3 and Desktop = svdesktop) then
            insert into mt.me2_customiz 
                (Fldnum,title,suppressed,Ilevels,Ireq,Idefault,Slevels,Sreq,Sdefault,Scopy,
                validation,merge,row,col,len,datalen,nextfld,tooltip,datacol,ftype,fform,
                postitle,maxlen,dcopy,chkfunc,title2,title3,title4,title5,qrow,qcol,qsupp,Desktop) 
                values 
                ('2393', 'Use Dominance Test','Y'     ,''     ,'N' ,''      ,''     ,'N' ,''      ,'OFF',
                'never'  ,'X'  ,'600','0','2','2','0','Use Dominance Test','C2393','SPVAL','3',
                'T','2'     ,'OFF','N'    ,'Use Dominance Test','Use Dominance Test','Use Dominance Test','Use Dominance Test','0','0','Y',svdesktop);
        end if;
        if not exists (select fldnum from mt.me2_customiz where fldnum = '2394' and fform = 3 and Desktop = svdesktop) then
            insert into mt.me2_customiz 
                (Fldnum,title,suppressed,Ilevels,Ireq,Idefault,Slevels,Sreq,Sdefault,Scopy,
                validation,merge,row,col,len,datalen,nextfld,tooltip,datacol,ftype,fform,
                postitle,maxlen,dcopy,chkfunc,title2,title3,title4,title5,qrow,qcol,qsupp,Desktop) 
                values 
                ('2394', 'Use Reliability Test','Y'     ,''     ,'N' ,''      ,''     ,'N' ,''      ,'OFF',
                'never'  ,'X'  ,'600','0','2','2','0','Use Reliability Test','C2394','SPVAL','3',
                'T','2'     ,'OFF','N'    ,'Use Reliability Test','Use Reliability Test','Use Reliability Test','Use Reliability Test','0','0','Y',svdesktop);
        end if;
        if not exists (select fldnum from mt.me2_customiz where fldnum = '2395' and fform = 3 and Desktop = svdesktop) then
            insert into mt.me2_customiz 
                (Fldnum,title,suppressed,Ilevels,Ireq,Idefault,Slevels,Sreq,Sdefault,Scopy,
                validation,merge,row,col,len,datalen,nextfld,tooltip,datacol,ftype,fform,
                postitle,maxlen,dcopy,chkfunc,title2,title3,title4,title5,qrow,qcol,qsupp,Desktop) 
                values 
                ('2395', 'Certificate Number','Y'     ,''     ,'N' ,''      ,''     ,'N' ,''      ,'OFF',
                'never'  ,'N'  ,'600','0','10','10','0','Certificate Number','C2395','SPVAL','3',
                'T','10'     ,'OFF','N'    ,'Certificate Number','Certificate Number','Certificate Number','Certificate Number','0','0','Y',svdesktop);
        end if;


        if not exists (select fldnum from mt.me2_customiz where fldnum = '2390' and fform = 8 and Desktop = svdesktop) then
            insert into mt.me2_customiz 
                (Fldnum,title,suppressed,Ilevels,Ireq,Idefault,Slevels,Sreq,Sdefault,Scopy,
                validation,merge,row,col,len,datalen,nextfld,tooltip,datacol,ftype,fform,
                postitle,maxlen,dcopy,chkfunc,title2,title3,title4,title5,qrow,qcol,qsupp,Desktop) 
                values 
                ('2390', 'SOT Threshold','Y'     ,''     ,'N' ,''      ,''     ,'N' ,''      ,'OFF',
                'never'  ,'X'  ,'600','0','4','4','0','SOT Threshold','C2390','DECIMAL4','8',
                'T','4'     ,'OFF','N'    ,'SOT Threshold','SOT Threshold','SOT Threshold','SOT Threshold','0','0','Y',svdesktop);
        end if;
        if not exists (select fldnum from mt.me2_customiz where fldnum = '2391' and fform = 8 and Desktop = svdesktop) then
            insert into mt.me2_customiz 
                (Fldnum,title,suppressed,Ilevels,Ireq,Idefault,Slevels,Sreq,Sdefault,Scopy,
                validation,merge,row,col,len,datalen,nextfld,tooltip,datacol,ftype,fform,
                postitle,maxlen,dcopy,chkfunc,title2,title3,title4,title5,qrow,qcol,qsupp,Desktop) 
                values 
                ('2391', 'SWT Threshold','Y'     ,''     ,'N' ,''      ,''     ,'N' ,''      ,'OFF',
                'never'  ,'X'  ,'600','0','4','4','0','SWT Threshold','C2391','DECIMAL4','8',
                'T','4'     ,'OFF','N'    ,'SWT Threshold','SWT Threshold','SWT Threshold','SWT Threshold','0','0','Y',svdesktop);
        end if;
        if not exists (select fldnum from mt.me2_customiz where fldnum = '2392' and fform = 8 and Desktop = svdesktop) then
            insert into mt.me2_customiz 
                (Fldnum,title,suppressed,Ilevels,Ireq,Idefault,Slevels,Sreq,Sdefault,Scopy,
                validation,merge,row,col,len,datalen,nextfld,tooltip,datacol,ftype,fform,
                postitle,maxlen,dcopy,chkfunc,title2,title3,title4,title5,qrow,qcol,qsupp,Desktop) 
                values 
                ('2392', 'Reported Unert. Conf.Level','Y'     ,''     ,'N' ,''      ,''     ,'N' ,''      ,'OFF',
                'never'  ,'X'  ,'600','0','4','4','0','Reported Unert. Conf.Level','C2392','DECIMAL4','8',
                'T','4'     ,'OFF','N'    ,'Reported Unert. Conf.Level','Reported Unert. Conf.Level','Reported Unert. Conf.Level','Reported Unert. Conf.Level','0','0','Y',svdesktop);
        end if;
        if not exists (select fldnum from mt.me2_customiz where fldnum = '2393' and fform = 8 and Desktop = svdesktop) then
            insert into mt.me2_customiz 
                (Fldnum,title,suppressed,Ilevels,Ireq,Idefault,Slevels,Sreq,Sdefault,Scopy,
                validation,merge,row,col,len,datalen,nextfld,tooltip,datacol,ftype,fform,
                postitle,maxlen,dcopy,chkfunc,title2,title3,title4,title5,qrow,qcol,qsupp,Desktop) 
                values 
                ('2393', 'Use Dominance Test','Y'     ,''     ,'N' ,''      ,''     ,'N' ,''      ,'OFF',
                'never'  ,'X'  ,'600','0','2','2','0','Use Dominance Test','C2393','SPVAL','8',
                'T','2'     ,'OFF','N'    ,'Use Dominance Test','Use Dominance Test','Use Dominance Test','Use Dominance Test','0','0','Y',svdesktop);
        end if;
        if not exists (select fldnum from mt.me2_customiz where fldnum = '2394' and fform = 8 and Desktop = svdesktop) then
            insert into mt.me2_customiz 
                (Fldnum,title,suppressed,Ilevels,Ireq,Idefault,Slevels,Sreq,Sdefault,Scopy,
                validation,merge,row,col,len,datalen,nextfld,tooltip,datacol,ftype,fform,
                postitle,maxlen,dcopy,chkfunc,title2,title3,title4,title5,qrow,qcol,qsupp,Desktop) 
                values 
                ('2394', 'Use Reliability Test','Y'     ,''     ,'N' ,''      ,''     ,'N' ,''      ,'OFF',
                'never'  ,'X'  ,'600','0','2','2','0','Use Reliability Test','C2394','SPVAL','8',
                'T','2'     ,'OFF','N'    ,'Use Reliability Test','Use Reliability Test','Use Reliability Test','Use Reliability Test','0','0','Y',svdesktop);
        end if;
        if not exists (select fldnum from mt.me2_customiz where fldnum = '2395' and fform = 8 and Desktop = svdesktop) then
            insert into mt.me2_customiz 
                (Fldnum,title,suppressed,Ilevels,Ireq,Idefault,Slevels,Sreq,Sdefault,Scopy,
                validation,merge,row,col,len,datalen,nextfld,tooltip,datacol,ftype,fform,
                postitle,maxlen,dcopy,chkfunc,title2,title3,title4,title5,qrow,qcol,qsupp,Desktop) 
                values 
                ('2395', 'Certificate Number','Y'     ,''     ,'N' ,''      ,''     ,'N' ,''      ,'OFF',
                'never'  ,'N'  ,'600','0','10','10','0','Certificate Number','C2395','SPVAL','8',
                'T','10'     ,'OFF','N'    ,'Certificate Number','Certificate Number','Certificate Number','Certificate Number','0','0','Y',svdesktop);

        end if;

	end loop zloop;
	close cur_desks;

    update mt.me2_customiz set title='SWT Threshold', tooltip='SWT Threshold' where datacol='C2391' and title = 'SOT Threshold';
    update mt.me2_customiz set sdefault='' where fldnum like '23%';
    update mt.me2_customiz set sdefault='' where fldnum like '28%';
    update mt.me2_customiz set sdefault='' where fldnum like '32%';


end;


/*
// ===================================================
//  put it all back together.
//
*/
begin
    ALTER TABLE mt.Inventory ADD UNIQUE (I4201);
    ALTER TABLE mt.customers add unique(K4601);
    ALTER TABLE mt.calibration add unique(CTAG);

    alter table mt.customers add primary key (ktag);
    alter table mt.inventory add primary key (mtag);
    alter table mt.calibration add primary key (C2301, C2333, MTAG);
    alter table mt.location add primary key (L2809, L2810, MTAG);
    alter table mt.repair add primary key (R3230, R3241, MTAG, R3251);
    alter table mt.results add primary key (CTAG, row_num);
    alter table mt.results_raw add primary key (ctag, row_num, name);

    ALTER TABLE mt.Inventory modify MTAG default NULL;
    ALTER TABLE mt.Location modify ltag default NULL;
    ALTER TABLE mt.Repair modify rtag default NULL;
    ALTER TABLE mt.calibration modify ctag default NULL;

    ALTER TABLE "mt"."Standards" ADD FOREIGN KEY "Inventory" ("C2430") REFERENCES "mt"."Inventory" ("MTAG");
    ALTER TABLE "mt"."Standards" ADD FOREIGN KEY "MTAG" ("MTAG") REFERENCES "mt"."Inventory" ("MTAG");
    ALTER TABLE "mt"."Standards" ADD FOREIGN KEY "Calibration" ("CTAG") REFERENCES "mt"."Calibration" ("CTAG");
    ALTER TABLE "mt"."Inventory" ADD FOREIGN KEY "KTAG" ("KTAG") REFERENCES "mt"."Customers" ("KTAG");
    ALTER TABLE "mt"."CalResults" ADD FOREIGN KEY "Calibration" ("CTAG") REFERENCES "mt"."Calibration" ("CTAG");
    ALTER TABLE "mt"."Calibration"  ADD FOREIGN KEY "Inventory" ("MTAG") REFERENCES "mt"."Inventory" ("MTAG");
    ALTER TABLE "mt"."Location" ADD FOREIGN KEY "Inventory" ("MTAG") REFERENCES "mt"."Inventory" ("MTAG");
    ALTER TABLE "mt"."Repair" ADD FOREIGN KEY "Inventory" ("MTAG") REFERENCES "mt"."Inventory" ("MTAG");
    ALTER TABLE "mt"."Results" ADD FOREIGN KEY "Calibration" ("CTAG") REFERENCES "mt"."Calibration" ("CTAG");
    ALTER TABLE "mt"."results_raw" ADD FOREIGN KEY "Calibration" ("CTAG") REFERENCES "mt"."Calibration" ("CTAG");
    ALTER TABLE "mt"."user1" ADD FOREIGN KEY "Inventory" ("MTAG") REFERENCES "mt"."Inventory" ("MTAG");
    ALTER TABLE "mt"."user2" ADD FOREIGN KEY "Inventory" ("MTAG") REFERENCES "mt"."Inventory" ("MTAG");
    ALTER TABLE "mt"."user3" ADD FOREIGN KEY "Inventory" ("MTAG") REFERENCES "mt"."Inventory" ("MTAG");

    ALTER TABLE "mt"."assethistory" ADD FOREIGN KEY "Inventory" ("MTAG") REFERENCES "mt"."Inventory" ("MTAG");
    CREATE INDEX "IDX_CAL" ON "mt"."Calibration"
        (
        "MTAG" ASC,
        "C2301" DESC,
        "C2333" DESC
        );
    CREATE INDEX "IDX_LOC" ON "mt"."Location"
        (
        "MTAG" ASC,
        "L2809" DESC,
        "L2810" DESC
        );
    CREATE INDEX "IDX_REP" ON "mt"."Repair"
        (
        "MTAG" ASC,
        "R3230" DESC,
        "R3241" DESC
        );
    CREATE INDEX "IDX_CALRES" ON "mt"."CalResults"
        (
        "CTAG" DESC
        );
    CREATE INDEX "IDX_STD2" ON "mt"."Standards"
        (
        "C2430" ASC,
        "MTAG" ASC
        );
    CREATE INDEX "IDX_STD" ON "mt"."Standards"
        (
        "CTAG" DESC,
        "C2430" ASC
        );

    CREATE INDEX "fastresult" ON "mt"."results"
        (
        "CTAG" DESC, 
        "row_num" ASC
        );

    CREATE INDEX "fastrawresult" ON "mt"."results_raw"
        (
        "CTAG" DESC, 
        "row_num" ASC, 
        "name"
        );

 

 

 

update inventory set ktag = NULL where ktag not in (select ktag from customers)






end;;
commit work;;

/*
// ================================================================
//
// cal_archive_update on calibration
//
//  this is here so that patch1 may be run by itself, but patch3 is 
//  the primary location for trigger modifications.  this code must 
//  synchronized with patch3.  Next idea is the possibility of running 
//  patch3 from within this file.
*/
call mtxdroptrigger('cal_archive_update', 'calibration');;
CREATE trigger mt.cal_archive_update after update on mt.calibration
referencing new as newdata
old as olddata
for each row
when ((isnull(olddata.C2339,'0') = isnull(newdata.C2339,'0')) AND ((isnull(olddata.C2337,'1970-01-01') = isnull(newdata.C2337,'1970-01-01'))) AND (isnull(olddata.C2338,' ') = isnull(newdata.C2338,' '))) 
begin
    declare err_notfound exception for sqlstate value '02000';
    declare curcal dynamic scroll cursor for select ctag from
    mt.calibration where
    mt.calibration.mtag = newdata.mtag order by
    C2301 desc,C2333 desc;
    declare cur_ctag char(128);
    open curcal;
    fetch next curcal into cur_ctag;
    if sqlstate = err_notfound then
        return
    end if;
    close curcal;
    update mt.calibration set C2339 = 0 where mtag = newdata.mtag and C2339 <> '0';
    update mt.calibration set C2337= now(*), C2338=(current user) where ctag=newdata.ctag;
    update mt.calibration set C2339 = 1 where ctag = cur_ctag;
end;;
comment on trigger cal_archive_update is 'April 2002: Fluke ';;
/*
// =================================================================
//
// loc_archive_update on location
//
//  this is here so that patch1 may be run by itself, but patch3 is 
//  the primary location for trigger modifications.  this code must 
//  synchronized with patch3.  Next idea is the possibility of running 
//  patch3 from within this file.
*/
call mtxdroptrigger('loc_archive_update', 'location');;
CREATE trigger mt.loc_archive_update after update on mt.location
referencing new as newdata
old as olddata
for each row
when ((isnull(olddata.L2815,'0') = isnull(newdata.L2815,'0')) AND (isnull(olddata.L2814,' ') = isnull(newdata.L2814,' ')) AND (isnull(olddata.L2813,'1970-01-01') = isnull(newdata.L2813,'1970-01-01')))
begin
    declare err_notfound exception for sqlstate value '02000';
    declare curloc2 dynamic scroll cursor for select ltag from
    mt.location where
    mt.location.mtag = newdata.mtag order by
    L2809 desc,L2810 desc;
    declare cur_ltag char(128);
    open curloc2;
    fetch next curloc2 into cur_ltag;
    if sqlstate = err_notfound then
        return
    end if;
    close curloc2;
    update mt.location set L2813 = now(*), L2814 =(current user) where ltag = newdata.ltag;
    update mt.location set L2815 = 0 where mtag = newdata.mtag and L2815 <> '0';
    update mt.location set L2815 = 1 where ltag = cur_ltag;
end;;
comment on trigger location.loc_archive_update is 'April 2002: Fluke ';;
/*
// =================================================================
//
// rep_archive_update on repair
//
//  this is here so that patch1 may be run by itself, but patch3 is 
//  the primary location for trigger modifications.  this code must 
//  synchronized with patch3.  Next idea is the possibility of running 
//  patch3 from within this file.
//
*/
call mtxdroptrigger('rep_archive_update', 'repair');;
CREATE trigger mt.rep_archive_update after update of R3230,R3241,R3251 on mt.repair
referencing new as newdata
for each row
begin
  declare err_notfound exception for sqlstate value '02000';
  declare currep dynamic scroll cursor for select rtag,R3251 from repair where repair.mtag=newdata.mtag order by R3251 asc,R3230 desc,R3241 desc;
  declare cur_rtag char(128);
  declare cur_flag integer;
  declare last3251 char(48);
  declare cur3251 char(48);
  set cur_flag=1;
  set last3251='';
  open currep;
  Zeroloop: loop
    fetch next currep into cur_rtag,cur3251;
    if sqlstate=err_notfound then
      leave Zeroloop
    end if;
    if(cur3251<>last3251) then
      set last3251=cur3251;
      set cur_flag=1
    end if;
    update repair set R3246=cur_flag where rtag=cur_rtag;
    if(cur_flag>0) then
      set cur_flag=0
    end if
  end loop Zeroloop;
  close currep
end;;
comment on trigger repair.rep_archive_update is 'April 2002: Fluke ';;
//
// ================================================================
//
// DROP MTREMLOG if there.
//
begin
    if exists ( select table_id from sys.systable where table_name ='mtremlog') then
        drop table mt.mtremlog;
    end if;
end;;
//

//
//
// =============================================================================
//
//
// DROP METREMOTES if  there.
// 
begin
    if exists ( select table_id from sys.systable where table_name ='metremotes') then
        drop table mt.metremotes;
    end if;
end;;
// =============================================================================
//
// TABLEDEF Table
//
begin

    if exists ( select table_id from sys.systable where table_name ='tabledef')
    then
        drop view mt.tabledef;
    end if;

    CREATE view mt.tabledef
      as select SYSCOLUMN.column_id,SYSCOLUMN.pkey,SYSCOLUMN.width,SYSCOLUMN.scale,SYSCOLUMN.column_name,SYSCOLUMN.remarks as col_remarks,
        SYSCOLUMN."default",SYSTABLE.table_id,SYSTABLE.creator,SYSTABLE.table_name,SYSTABLE.table_type,SYSTABLE.remarks as tbl_remarks,
        customiz.title,SYSDOMAIN.domain_name,SYSUSERPERM.user_name,SYSCOLUMN.NULLS from
        SYS.SYSCOLUMN as SYSCOLUMN left outer join
        mt.customiz as customiz on
        substr(SYSCOLUMN.column_name,2) = customiz.Fldnum,SYS.SYSTABLE as SYSTABLE,
        SYS.SYSDOMAIN as SYSDOMAIN,
        SYS.SYSUSERPERM where
        SYSCOLUMN.table_id = SYSTABLE.table_id and
        SYSCOLUMN.domain_id = SYSDOMAIN.domain_id and
        SYSTABLE.creator = SYSUSERPERM.user_id;
    grant select on mt.tabledef to mtreports;
end;;
//
comment on view mt.tabledef is 'Janurary 2002: Fluke:';;
commit;;
