/*
// patch2new.sql
//
// Services Stored-Procedures other than MTX___ which have
// have been created to been accessed by these patch files.
// Also services MT and STD views.
// =========================================================
*/



begin
    declare ntmp integer;
    set ntmp = (select user_id from sys.sysuserperm where user_name='mt');
    /* ================= */
    if (exists(select table_name from sys.systable where table_name='assetlist' and table_type='view' and creator=ntmp)) then
        drop view mt.assetlist;
    end if;
    CREATE view mt.assetlist as select I4201,I4228,MTAG,replic,I4202,I4203,i4204,I4240,I4299 from mt.inventory;
    comment on view mt.assetlist is 'August 2002: Fluke: Provides public reference for existence and type of asset';
    /* ================= */
    if (exists(select table_name from sys.systable where table_name='customerlist' and table_type='view' and creator=ntmp)) then
        drop view mt.customerlist;
    end if;
    create view mt.customerlist as select K4601,KTAG,kreplic from mt.customers;
    /* ================= */
    if (exists(select table_name from sys.systable where table_name='tabledef' and table_type='view' and creator=ntmp)) then
        drop view mt.tabledef;
    end if;
    create view mt.tabledef as select SYSCOLUMN.column_id,
        SYSCOLUMN.pkey,SYSCOLUMN.width,SYSCOLUMN.scale,SYSCOLUMN.column_name,
        SYSCOLUMN.remarks as col_remarks,SYSCOLUMN."default",SYSTABLE.table_id,
        SYSTABLE.creator,SYSTABLE.table_name,SYSTABLE.table_type,
        SYSTABLE.remarks as tbl_remarks,customiz.title,SYSDOMAIN.domain_name,
        SYSUSERPERM.user_name,SYSCOLUMN.NULLS from 
        SYS.SYSCOLUMN as SYSCOLUMN left outer join mt.customiz as customiz on substr(SYSCOLUMN.column_name,2)=customiz.Fldnum,
        SYS.SYSTABLE as SYSTABLE,SYS.SYSDOMAIN as SYSDOMAIN,
        SYS.SYSUSERPERM where 
        SYSCOLUMN.table_id=SYSTABLE.table_id and SYSCOLUMN.domain_id=SYSDOMAIN.domain_id and SYSTABLE.creator=SYSUSERPERM.user_id;
end;;

/*
//
//
//
// ================================================================
//
// pop_calcombine
//
*/
Call mtxdropprocedure('pop_calcombine');;
CREATE PROCEDURE mt."pop_calcombine" ( in_MTAG char(80), in_olddate char(10) )
BEGIN
	declare cur_2301 date;
	declare cur_2333 char(8);
	declare cur_2323 char(1);
	declare cur_2320 char(128);
	declare cur_ctag char(80);
	declare err_notfound exception for sqlstate value '02000';
	declare curcals dynamic scroll cursor for select C2301,C2333,C2323,C2320,CTAG from 
		calibration where mtag = in_MTAG and C2301 > in_olddate order by C2301 desc, C2333 desc;
	delete from mt.calcombine;
	open curcals;
	zloop: loop
		fetch next curcals into cur_2301,cur_2333,cur_2323,cur_2320,cur_ctag;
		if sqlstate = err_notfound then
			leave zloop;
		end if;
		insert into mt.calcombine("Cal-Date","Cal-Time","Pass","Procedure",CTAG)
			values (cur_2301,cur_2333,cur_2323,cur_2320,cur_ctag);

	end loop zloop;
	close curcals;
	
END;;
grant execute on mt.pop_calcombine to public;
comment on procedure mt.pop_calcombine is 'April 2002: Fluke : populates temporary table for combine calibration';;
/*
//
//
//
// ================================================================
//
// cal_archive
//
*/
Call mtxdropprocedure('cal_archive');;
CREATE procedure mt.cal_archive(in inv_mtag char(80))
begin
  declare err_notfound exception for sqlstate value '02000';
  declare curcal dynamic scroll cursor for select ctag from calibration where
      calibration.mtag = inv_mtag order by
      C2301 desc,C2333 desc;
  declare cur_ctag char(80);
  declare cur_flag integer;
  set cur_flag=1;
  open curcal;
  Zeroloop: loop
    fetch next curcal into cur_ctag;
    if sqlstate = err_notfound then
      leave Zeroloop
    end if;
    update calibration set C2339 = cur_flag where ctag = cur_ctag;
    if(cur_flag > 0) then
      set cur_flag=0
    end if
  end loop Zeroloop;
  close curcal
end;;
comment on procedure mt.cal_archive is 'April 2002: Fluke : Archive bit logic';;
/*
//
// =================================================================
//
// loc_archive
//
*/
call mtxdropprocedure('loc_archive');;
CREATE procedure mt.loc_archive(in inv_mtag char(80))
begin
  declare err_notfound exception for sqlstate value '02000';
  declare curloc dynamic scroll cursor for select ltag from
      mt.location where location.mtag = inv_mtag order by
      L2809 desc,L2810 desc;
  declare cur_ltag char(80);
  declare cur_flag integer;
  set cur_flag=1;
  open curloc;
  Zeroloop: loop
    fetch next curloc into cur_ltag;
    if sqlstate = err_notfound then
      leave Zeroloop
    end if;
    if sqlstate = err_notfound then
      leave Zeroloop
    end if;
    update location set L2815 = cur_flag where ltag = cur_ltag;
    if(cur_flag > 0) then
      set cur_flag=0
    end if
  end loop Zeroloop;
  close curloc
end;;
comment on procedure mt.loc_archive is 'April 2002: Fluke : Archive bit logic';;
/*
//
//
//
// ================================================================
//
// mc_assets
//
*/
Call mtxdropprocedure('mc_assets');;
CREATE procedure mt.mc_assets(in assetparam char(60) default '%')
result(I4201 char(60),C2303 date,K4601 char(48),R3201 char(102),R3204 char(102),R3207 char(15),
R3208 char(14),R3209 decimal(12,2),R3210 char(15),R3211 char(14),R3212 decimal(12,2),R3213 char(15),
R3214 char(14),R3215 decimal(12,2),R3216 char(15),R3217 char(14),R3218 decimal(12,2),R3219 char(15),
R3220 char(14),R3221 decimal(12,2),R3222 char(15),R3223 char(14),R3224 decimal(12,2),R3225 char(15),
R3226 char(14),R3227 decimal(12,2),R3229 decimal(5,1),R3230 date,R3231 decimal(12,2),R3232 decimal(12,2),
R3233 char(15),R3235 decimal(12,2),R3236 char(15),R3237 char(15),R3238 decimal(5,1),R3239 decimal(5,1),
R3240 char(12),R3241 char(8),R3242 timestamp,R3243 char(16),R3244 timestamp,R3245 char(16),R3246 integer,
R3247 date,R3248 char(8),R3249 integer,R3250 char(1),RMTAG char(80),R3251 char(1),rtag char(80),
rdsrc char(3),RPUBLISH char(32),R3252 decimal(12,2),R3253 long varchar,R3254 char(48),R3255 char(48),
R3256 char(48),R3257 char(48),R3258 char(48),R3259 char(48),R3260 char(48),R3261 date,R3262 date,
R3263 date,R3264 date,R3265 decimal(12,2),R3266 decimal(12,2),R3267 decimal(12,2),R3268 decimal(12,2),
R3269 decimal(12,2),R3270 char(128),
L2801 char(20),L2802 char(20),L2803 char(20),L2804 char(10),L2805 char(8),L2806 date,L2807 date,
L2808 integer,L2809 date,L2810 char(8),L2811 timestamp,L2812 char(16),L2813 timestamp,L2814 char(16),
L2815 integer,LMTAG char(80),ltag char(80),ldsrc char(3),L2816 char(15),L2817 decimal(12,2),
LPUBLISH char(32),L2818 decimal(12,2),L2819 decimal(12,2),L2820 decimal(12,2),L2821 decimal(12,2),
L2822 date,L2823 date,L2824 date,L2825 date,L2826 char(48),L2827 char(48),L2828 char(48),L2829 char(48),
L2830 char(48),L2831 char(48),L2832 char(48),L2833 char(48),L2834 char(48),L2835 char(48),
L2836 long varchar,L2837 char(128),
C2301 date,C2302 integer,C2304 integer,C2306 date,C2307 char(20),C2309 decimal(12,2),
C2310 decimal(5,1),C2311 decimal(5,1),C2312 integer,C2313 char(15),C2314 char(16),C2316 date,
C2320 char(128),C2321 char(55),C2322 char(1),C2323 char(1),C2324 decimal(5,1),C2326 char(44),
C2327 char(20),C2328 decimal(5,1),C2329 char(44),C2330 char(10),C2331 char(1),C2332 integer,
C2333 char(8),C2334 char(8),C2335 timestamp,C2336 char(16),C2337 timestamp,C2338 char(16),C2339 integer,
C2341 char(254),CMTAG char(80),CTAG char(80),C2362 integer,C2308 char(10),C2315 decimal(5,1),C2342 date,
C2343 char(8),C2317 decimal(5,1),C2318 char(13),C2319 char(1),C2325 char(1),C2350 integer,C2351 integer,
C2352 integer,C2353 integer,C2354 char(64),C2355 char(64),C2356 char(64),C2357 char(64),C2358 char(64),
C2359 char(64),C2360 char(64),C2361 char(64),C2363 char(1),cdsrc char(3),CPUBLISH char(32),C2381 char(8),
C2382 char(1),C2364 char(48),C2365 char(48),C2366 char(48),C2367 char(48),C2368 char(48),C2369 char(48),
C2370 char(48),C2371 date,C2372 date,C2373 date,C2374 date,C2375 decimal(12,2),C2376 decimal(12,2),
C2377 decimal(12,2),C2378 decimal(12,2),C2379 decimal(12,2),C2380 date,C2383 integer,C2384 long varchar,
C2385 char(128),
I4202 char(30),I4203 char(30),I4204 char(60),I4205 char(1),I4206 char(30),I4207 char(24),
I4208 char(29),I4209 char(1),I4210 char(12),I4211 char(15),I4212 date,I4213 char(10),I4214 char(8),
I4215 char(5),I4216 char(5),I4217 char(60),I4218 char(4),I4219 decimal(12,2),I4220 integer,I4221 date,
I4222 char(12),I4223 char(16),I4224 date,I4225 char(8),I4226 char(1),I4228 char(1),I4229 integer,
I4230 integer,I4231 char(32),I4232 char(32),I4233 char(32),I4234 char(32),I4235 char(32),I4236 timestamp,
I4237 char(16),I4238 timestamp,I4239 char(16),I4240 char(8),I4299 char(1),MTAG char(80),I4241 char(80),
I4242 char(80),I4243 char(80),idsrc char(3),IPUBLISH char(32),IKTAG char(80),replic char(1),
I4258 char(1),I4244 char(48),I4245 char(48),I4246 char(48),I4247 char(48),I4248 char(48),I4249 char(48),
I4250 date,I4251 date,I4252 date,I4253 date,I4254 decimal(12,2),I4255 decimal(12,2),I4256 decimal(12,2),
I4257 decimal(12,2),I4259 integer,I4260 long varchar,I4261 char(128),
KTAG char(80),KPUBLISH char(32),K4602 char(48),K4603 char(48),K4604 char(48),
K4605 char(48),K4606 char(48),K4607 char(48),K4608 char(48),K4609 char(48),K4610 char(48),K4611 char(48),
K4612 char(48),K4613 char(48),K4614 char(48),K4615 char(48),K4616 char(48),K4617 char(48),K4618 char(48),
K4619 char(48),K4620 char(48),K4621 date,K4622 date,K4623 date,K4624 date,K4625 decimal(12,2),
K4626 decimal(12,2),K4627 decimal(12,2),K4628 decimal(12,2),K4640 char(8),K4629 timestamp,K4630 char(16),
K4631 timestamp,K4632 char(16),KDSRC char(3),kreplic char(1))
begin
  select Inventory.I4201,Calibration.C2303,Customers.K4601,
    Repair.R3201,Repair.R3204,Repair.R3207,Repair.R3208,
    Repair.R3209,Repair.R3210,Repair.R3211,Repair.R3212,Repair.R3213,
    Repair.R3214,Repair.R3215,Repair.R3216,Repair.R3217,Repair.R3218,
    Repair.R3219,Repair.R3220,Repair.R3221,Repair.R3222,Repair.R3223,
    Repair.R3224,Repair.R3225,Repair.R3226,Repair.R3227,Repair.R3229,
    Repair.R3230,Repair.R3231,Repair.R3232,Repair.R3233,Repair.R3235,
    Repair.R3236,Repair.R3237,Repair.R3238,Repair.R3239,Repair.R3240,
    Repair.R3241,Repair.R3242,Repair.R3243,Repair.R3244,Repair.R3245,
    Repair.R3246,Repair.R3247,Repair.R3248,Repair.R3249,Repair.R3250,
    Repair.MTAG,Repair.R3251,Repair.rtag,Repair.rdsrc,Repair.RPUBLISH,
    Repair.R3252,Repair.R3253,Repair.R3254,Repair.R3255,Repair.R3256,
    Repair.R3257,Repair.R3258,Repair.R3259,Repair.R3260,Repair.R3261,
    Repair.R3262,Repair.R3263,Repair.R3264,Repair.R3265,Repair.R3266,
    Repair.R3267,Repair.R3268,Repair.R3269,Repair.R3270,
    Location.L2801,Location.L2802,Location.L2803,Location.L2804,
    Location.L2805,Location.L2806,Location.L2807,Location.L2808,
    Location.L2809,Location.L2810,Location.L2811,Location.L2812,
    Location.L2813,Location.L2814,Location.L2815,Location.MTAG,
    Location.ltag,Location.ldsrc,Location.L2816,Location.L2817,
    Location.LPUBLISH,Location.L2818,Location.L2819,Location.L2820,
    Location.L2821,Location.L2822,Location.L2823,Location.L2824,
    Location.L2825,Location.L2826,Location.L2827,Location.L2828,
    Location.L2829,Location.L2830,Location.L2831,Location.L2832,
    Location.L2833,Location.L2834,Location.L2835,Location.L2836,
    Location.L2837,
    Calibration.C2301,Calibration.C2302,Calibration.C2304,
    Calibration.C2306,Calibration.C2307,Calibration.C2309,Calibration.C2310,
    Calibration.C2311,Calibration.C2312,Calibration.C2313,Calibration.C2314,
    Calibration.C2316,Calibration.C2320,Calibration.C2321,Calibration.C2322,
    Calibration.C2323,Calibration.C2324,Calibration.C2326,Calibration.C2327,
    Calibration.C2328,Calibration.C2329,Calibration.C2330,Calibration.C2331,
    Calibration.C2332,Calibration.C2333,Calibration.C2334,Calibration.C2335,
    Calibration.C2336,Calibration.C2337,Calibration.C2338,Calibration.C2339,
    Calibration.C2341,Calibration.MTAG,Calibration.CTAG,Calibration.C2362,
    Calibration.C2308,Calibration.C2315,Calibration.C2342,Calibration.C2343,
    Calibration.C2317,Calibration.C2318,Calibration.C2319,Calibration.C2325,
    Calibration.C2350,Calibration.C2351,Calibration.C2352,Calibration.C2353,
    Calibration.C2354,Calibration.C2355,Calibration.C2356,Calibration.C2357,
    Calibration.C2358,Calibration.C2359,Calibration.C2360,Calibration.C2361,
    Calibration.C2363,Calibration.cdsrc,Calibration.CPUBLISH,Calibration.C2381,
    Calibration.C2382,Calibration.C2364,Calibration.C2365,Calibration.C2366,
    Calibration.C2367,Calibration.C2368,Calibration.C2369,Calibration.C2370,
    Calibration.C2371,Calibration.C2372,Calibration.C2373,Calibration.C2374,
    Calibration.C2375,Calibration.C2376,Calibration.C2377,Calibration.C2378,
    Calibration.C2379,Calibration.C2380,Calibration.C2383,Calibration.C2384,
    Calibration.C2385,
    Inventory.I4202,Inventory.I4203,Inventory.I4204,
    Inventory.I4205,Inventory.I4206,Inventory.I4207,Inventory.I4208,
    Inventory.I4209,Inventory.I4210,Inventory.I4211,Inventory.I4212,
    Inventory.I4213,Inventory.I4214,Inventory.I4215,Inventory.I4216,
    Inventory.I4217,Inventory.I4218,Inventory.I4219,Inventory.I4220,
    Inventory.I4221,Inventory.I4222,Inventory.I4223,Inventory.I4224,
    Inventory.I4225,Inventory.I4226,Inventory.I4228,Inventory.I4229,
    Inventory.I4230,Inventory.I4231,Inventory.I4232,Inventory.I4233,
    Inventory.I4234,Inventory.I4235,Inventory.I4236,Inventory.I4237,
    Inventory.I4238,Inventory.I4239,Inventory.I4240,Inventory.I4299,
    Inventory.MTAG,Inventory.I4241,Inventory.I4242,Inventory.I4243,
    Inventory.idsrc,Inventory.IPUBLISH,Inventory.ktag,Inventory.replic,
    Inventory.I4258,Inventory.I4244,Inventory.I4245,Inventory.I4246,
    Inventory.I4247,Inventory.I4248,Inventory.I4249,Inventory.I4250,
    Inventory.I4251,Inventory.I4252,Inventory.I4253,Inventory.I4254,
    Inventory.I4255,Inventory.I4256,Inventory.I4257,Inventory.I4259,
    Inventory.I4260,Inventory.I4261,
    customers.KTAG,customers.KPUBLISH,customers.K4601,customers.K4602,
    customers.K4603,customers.K4604,customers.K4605,customers.K4606,
    customers.K4607,customers.K4608,customers.K4609,customers.K4610,
    customers.K4611,customers.K4612,customers.K4613,customers.K4614,
    customers.K4615,customers.K4616,customers.K4617,customers.K4618,
    customers.K4619,customers.K4620,customers.K4621,customers.K4622,
    customers.K4623,customers.K4624,customers.K4625,customers.K4626,
    customers.K4627,customers.K4628,customers.K4640,customers.K4629,
    customers.K4630,customers.K4631,customers.K4632,customers.KDSRC,
    customers.kreplic from

    MT.Inventory LEFT OUTER JOIN mt.calibration ON MT.Inventory.mtag = MT.Calibration.mtag,
    MT.Inventory LEFT OUTER JOIN MT.Location ON MT.Inventory.mtag = MT.Location.mtag,
    MT.Inventory LEFT OUTER JOIN MT.Repair ON MT.Inventory.mtag = MT.Repair.mtag,
    MT.Inventory LEFT OUTER JOIN MT.customers ON MT.Inventory.Ktag = MT.Customers.ktag
    WHERE
    I4201 like assetparam and
    (C2339 = 1 or C2339 is null) and
    (L2815 = 1 or L2815 is null) and
    (R3246 = 1 or R3246 is null) and
    (customers.ktag = inventory.ktag or inventory.ktag is null)
end;;
grant execute on mt.mc_assets to mtreports;;
comment on procedure mt.mc_assets is 'April 2002: Fluke : All data for assets in the database';;
/*
//
// ================================================================
//
// mc_cal_due
//
*/
Call mtxdropprocedure('mc_cal_due');;
CREATE procedure mt.mc_cal_due(in duedate date default today(*))
result(I4201 char(60),C2303 date,C2301 date,C2302 integer,C2304 integer,
C2306 date,C2307 char(20),C2309 decimal(12,2),C2310 decimal(5,1),C2311 decimal(5,1),
C2312 integer,C2313 char(15),C2314 char(16),C2316 date,C2320 char(128),C2321 char(55),
C2322 char(1),C2323 char(1),C2324 decimal(5,1),C2326 char(44),C2327 char(20),C2328 decimal(5,1),
C2329 char(44),C2330 char(10),C2331 char(1),C2332 integer,C2333 char(8),C2334 char(8),
C2335 timestamp,C2336 char(16),C2337 timestamp,C2338 char(16),C2339 integer,C2341 char(254),
CMTAG char(80),CTAG char(80),C2362 integer,C2308 char(10),C2315 decimal(5,1),C2342 date,
C2343 char(8),C2317 decimal(5,1),C2318 char(13),C2319 char(1),C2325 char(1),C2350 integer,
C2351 integer,C2352 integer,C2353 integer,C2354 char(64),C2355 char(64),C2356 char(64),
C2357 char(64),C2358 char(64),C2359 char(64),C2360 char(64),C2361 char(64),C2363 char(1),
cdsrc char(3),CPUBLISH char(32),C2381 char(8),C2382 char(1),C2364 char(48),C2365 char(48),
C2366 char(48),C2367 char(48),C2368 char(48),C2369 char(48),C2370 char(48),C2371 date,C2372 date,
C2373 date,C2374 date,C2375 decimal(12,2),C2376 decimal(12,2),C2377 decimal(12,2),
C2378 decimal(12,2),C2379 decimal(12,2),C2380 date,C2383 integer,C2384 long varchar,
C2385 char(128),I4202 char(30),I4203 char(30),I4204 char(60),I4205 char(1),
I4206 char(30),I4207 char(24),I4208 char(29),I4209 char(1),I4210 char(12),I4211 char(15),
I4212 date,I4213 char(10),I4214 char(8),I4215 char(5),I4216 char(5),I4217 char(60),I4218 char(4),
I4219 decimal(12,2),I4220 integer,I4221 date,I4222 char(12),I4223 char(16),I4224 date,
I4225 char(8),I4226 char(1),I4228 char(1),I4229 integer,I4230 integer,I4231 char(32),
I4232 char(32),I4233 char(32),I4234 char(32),I4235 char(32),I4236 timestamp,I4237 char(16),
I4238 timestamp,I4239 char(16),I4240 char(8),I4299 char(1),MTAG char(80),I4241 char(80),
I4242 char(80),I4243 char(80),idsrc char(3),IPUBLISH char(32),KTAG char(80),replic char(1),
I4258 char(1),I4244 char(48),I4245 char(48),I4246 char(48),I4247 char(48),I4248 char(48),
I4249 char(48),I4250 date,I4251 date,I4252 date,I4253 date,I4254 decimal(12,2),I4255 decimal(12,2),
I4256 decimal(12,2),I4257 decimal(12,2),I4259 integer,I4260 long varchar,I4261 char(128))
begin
    select Inventory.I4201,Calibration.C2303,Calibration.C2301,Calibration.C2302,
    Calibration.C2304,Calibration.C2306,Calibration.C2307,Calibration.C2309,
    Calibration.C2310,Calibration.C2311,Calibration.C2312,Calibration.C2313,
    Calibration.C2314,Calibration.C2316,Calibration.C2320,Calibration.C2321,
    Calibration.C2322,Calibration.C2323,Calibration.C2324,Calibration.C2326,
    Calibration.C2327,Calibration.C2328,Calibration.C2329,Calibration.C2330,
    Calibration.C2331,Calibration.C2332,Calibration.C2333,Calibration.C2334,
    Calibration.C2335,Calibration.C2336,Calibration.C2337,Calibration.C2338,
    Calibration.C2339,Calibration.C2341,Calibration.MTAG,Calibration.CTAG,
    Calibration.C2362,Calibration.C2308,Calibration.C2315,Calibration.C2342,
    Calibration.C2343,Calibration.C2317,Calibration.C2318,Calibration.C2319,
    Calibration.C2325,Calibration.C2350,Calibration.C2351,Calibration.C2352,
    Calibration.C2353,Calibration.C2354,Calibration.C2355,Calibration.C2356,
    Calibration.C2357,Calibration.C2358,Calibration.C2359,Calibration.C2360,
    Calibration.C2361,Calibration.C2363,Calibration.cdsrc,Calibration.CPUBLISH,
    Calibration.C2381,Calibration.C2382,Calibration.C2364,Calibration.C2365,
    Calibration.C2366,Calibration.C2367,Calibration.C2368,Calibration.C2369,
    Calibration.C2370,Calibration.C2371,Calibration.C2372,Calibration.C2373,
    Calibration.C2374,Calibration.C2375,Calibration.C2376,Calibration.C2377,
    Calibration.C2378,Calibration.C2379,Calibration.C2380,Calibration.C2383,
    Calibration.C2384,Calibration.C2385,
    Inventory.I4202,Inventory.I4203,Inventory.I4204,Inventory.I4205,
    Inventory.I4206,Inventory.I4207,Inventory.I4208,Inventory.I4209,Inventory.I4210,
    Inventory.I4211,Inventory.I4212,Inventory.I4213,Inventory.I4214,Inventory.I4215,
    Inventory.I4216,Inventory.I4217,Inventory.I4218,Inventory.I4219,Inventory.I4220,
    Inventory.I4221,Inventory.I4222,Inventory.I4223,Inventory.I4224,Inventory.I4225,
    Inventory.I4226,Inventory.I4228,Inventory.I4229,Inventory.I4230,Inventory.I4231,
    Inventory.I4232,Inventory.I4233,Inventory.I4234,Inventory.I4235,Inventory.I4236,
    Inventory.I4237,Inventory.I4238,Inventory.I4239,Inventory.I4240,Inventory.I4299,
    Inventory.MTAG,Inventory.I4241,Inventory.I4242,Inventory.I4243,Inventory.idsrc,
    Inventory.IPUBLISH,Inventory.ktag,Inventory.replic,Inventory.I4258,Inventory.I4244,
    Inventory.I4245,Inventory.I4246,Inventory.I4247,Inventory.I4248,Inventory.I4249,
    Inventory.I4250,Inventory.I4251,Inventory.I4252,Inventory.I4253,Inventory.I4254,
    Inventory.I4255,Inventory.I4256,Inventory.I4257,Inventory.I4259,Inventory.I4260,
    Inventory.I4261 
    from
    MT.Inventory LEFT OUTER JOIN mt.calibration ON MT.Inventory.mtag = MT.Calibration.mtag
    WHERE
    inventory.I4228 <> 'N' and
   (calibration.C2339 = 1 or calibration.C2339 is null) and 
    calibration.C2303 <= duedate
end;;
grant execute on mt.mc_cal_due to mtreports;;
comment on procedure mt.mc_cal_due is 'April 2002: Fluke : ';;
/*
//
// =================================================================
//
// mc_cal_loc_due
//
*/
call mtxdropprocedure('mc_cal_loc_due');;
CREATE procedure mt.mc_cal_loc_due(in duedate date default today(*))
result(I4201 char(60),C2303 date,L2801 char(20),L2802 char(20),L2803 char(20),L2804 char(10),
L2805 char(8),L2806 date,L2807 date,L2808 integer,L2809 date,L2810 char(8),L2811 timestamp,
L2812 char(16),L2813 timestamp,L2814 char(16),L2815 integer,LMTAG char(80),ltag char(80),
ldsrc char(3),L2816 char(15),L2817 decimal(12,2),LPUBLISH char(32),L2818 decimal(12,2),
L2819 decimal(12,2),L2820 decimal(12,2),L2821 decimal(12,2),L2822 date,L2823 date,L2824 date,
L2825 date,L2826 char(48),L2827 char(48),L2828 char(48),L2829 char(48),L2830 char(48),
L2831 char(48),L2832 char(48),L2833 char(48),L2834 char(48),L2835 char(48),L2836 long varchar,
L2837 char(128),C2301 date,C2302 integer,C2304 integer,C2306 date,C2307 char(20),
C2309 decimal(12,2),C2310 decimal(5,1),C2311 decimal(5,1),C2312 integer,C2313 char(15),
C2314 char(16),C2316 date,C2320 char(128),C2321 char(55),C2322 char(1),C2323 char(1),
C2324 decimal(5,1),C2326 char(44),C2327 char(20),C2328 decimal(5,1),C2329 char(44),
C2330 char(10),C2331 char(1),C2332 integer,C2333 char(8),C2334 char(8),C2335 timestamp,
C2336 char(16),C2337 timestamp,C2338 char(16),C2339 integer,C2341 char(254),CMTAG char(80),
CTAG char(80),C2362 integer,C2308 char(10),C2315 decimal(5,1),C2342 date,C2343 char(8),
C2317 decimal(5,1),C2318 char(13),C2319 char(1),C2325 char(1),C2350 integer,C2351 integer,
C2352 integer,C2353 integer,C2354 char(64),C2355 char(64),C2356 char(64),C2357 char(64),
C2358 char(64),C2359 char(64),C2360 char(64),C2361 char(64),C2363 char(1),cdsrc char(3),
CPUBLISH char(32),C2381 char(8),C2382 char(1),C2364 char(48),C2365 char(48),C2366 char(48),
C2367 char(48),C2368 char(48),C2369 char(48),C2370 char(48),C2371 date,C2372 date,C2373 date,
C2374 date,C2375 decimal(12,2),C2376 decimal(12,2),C2377 decimal(12,2),C2378 decimal(12,2),
C2379 decimal(12,2),C2380 date,C2383 integer,C2384 long varchar,C2385 char(128),
I4202 char(30),I4203 char(30),I4204 char(60),I4205 char(1),I4206 char(30),
I4207 char(24),I4208 char(29),I4209 char(1),I4210 char(12),I4211 char(15),I4212 date,
I4213 char(10),I4214 char(8),I4215 char(5),I4216 char(5),I4217 char(60),I4218 char(4),
I4219 decimal(12,2),I4220 integer,I4221 date,I4222 char(12),I4223 char(16),I4224 date,
I4225 char(8),I4226 char(1),I4228 char(1),I4229 integer,I4230 integer,I4231 char(32),
I4232 char(32),I4233 char(32),I4234 char(32),I4235 char(32),I4236 timestamp,I4237 char(16),
I4238 timestamp,I4239 char(16),I4240 char(8),I4299 char(1),MTAG char(80),I4241 char(80),
I4242 char(80),I4243 char(80),idsrc char(3),IPUBLISH char(32),ktag char(80),replic char(1),
I4258 char(1),I4244 char(48),I4245 char(48),I4246 char(48),I4247 char(48),I4248 char(48),
I4249 char(48),I4250 date,I4251 date,I4252 date,I4253 date,I4254 decimal(12,2),
I4255 decimal(12,2),I4256 decimal(12,2),I4257 decimal(12,2),I4259 integer,I4260 long varchar,
I4261 char(128)) 
begin 
  select Inventory.I4201,Calibration.C2303,Location.L2801,Location.L2802,
    Location.L2803,Location.L2804,Location.L2805,Location.L2806,Location.L2807,
    Location.L2808,Location.L2809,Location.L2810,Location.L2811,Location.L2812,
    Location.L2813,Location.L2814,Location.L2815,Location.MTAG,Location.ltag,
    Location.ldsrc,Location.L2816,Location.L2817,Location.LPUBLISH,Location.L2818,
    Location.L2819,Location.L2820,Location.L2821,Location.L2822,Location.L2823,
    Location.L2824,Location.L2825,Location.L2826,Location.L2827,Location.L2828,
    Location.L2829,Location.L2830,Location.L2831,Location.L2832,Location.L2833,
    Location.L2834,Location.L2835,Location.L2836,Location.L2837,
    Calibration.C2301,Calibration.C2302,Calibration.C2303,Calibration.C2304,
    Calibration.C2306,Calibration.C2307,Calibration.C2309,Calibration.C2310,
    Calibration.C2311,Calibration.C2312,Calibration.C2313,Calibration.C2314,
    Calibration.C2316,Calibration.C2320,Calibration.C2321,Calibration.C2322,
    Calibration.C2323,Calibration.C2324,Calibration.C2326,Calibration.C2327,
    Calibration.C2328,Calibration.C2329,Calibration.C2330,Calibration.C2331,
    Calibration.C2332,Calibration.C2333,Calibration.C2334,Calibration.C2335,
    Calibration.C2336,Calibration.C2337,Calibration.C2338,Calibration.C2339,
    Calibration.C2341,Calibration.MTAG,Calibration.CTAG,Calibration.C2362,
    Calibration.C2308,Calibration.C2315,Calibration.C2342,Calibration.C2343,
    Calibration.C2317,Calibration.C2318,Calibration.C2319,Calibration.C2325,
    Calibration.C2350,Calibration.C2351,Calibration.C2352,Calibration.C2353,
    Calibration.C2354,Calibration.C2355,Calibration.C2356,Calibration.C2357,
    Calibration.C2358,Calibration.C2359,Calibration.C2360,Calibration.C2361,
    Calibration.C2363,Calibration.cdsrc,Calibration.CPUBLISH,Calibration.C2381,
    Calibration.C2382,Calibration.C2364,Calibration.C2365,Calibration.C2366,
    Calibration.C2367,Calibration.C2368,Calibration.C2369,Calibration.C2370,
    Calibration.C2371,Calibration.C2372,Calibration.C2373,Calibration.C2374,
    Calibration.C2375,Calibration.C2376,Calibration.C2377,Calibration.C2378,
    Calibration.C2379,Calibration.C2380,Calibration.C2383,Calibration.C2384,
    Calibration.C2385,
    Inventory.I4202,Inventory.I4203,Inventory.I4204,
    Inventory.I4205,Inventory.I4206,Inventory.I4207,Inventory.I4208,
    Inventory.I4209,Inventory.I4210,Inventory.I4211,Inventory.I4212,
    Inventory.I4213,Inventory.I4214,Inventory.I4215,Inventory.I4216,
    Inventory.I4217,Inventory.I4218,Inventory.I4219,Inventory.I4220,
    Inventory.I4221,Inventory.I4222,Inventory.I4223,Inventory.I4224,
    Inventory.I4225,Inventory.I4226,Inventory.I4228,Inventory.I4229,
    Inventory.I4230,Inventory.I4231,Inventory.I4232,Inventory.I4233,
    Inventory.I4234,Inventory.I4235,Inventory.I4236,Inventory.I4237,
    Inventory.I4238,Inventory.I4239,Inventory.I4240,Inventory.I4299,
    Inventory.MTAG,Inventory.I4241,Inventory.I4242,Inventory.I4243,
    Inventory.idsrc,Inventory.IPUBLISH,Inventory.ktag,Inventory.replic,
    Inventory.I4258,Inventory.I4244,Inventory.I4245,Inventory.I4246,
    Inventory.I4247,Inventory.I4248,Inventory.I4249,Inventory.I4250,
    Inventory.I4251,Inventory.I4252,Inventory.I4253,Inventory.I4254,
    Inventory.I4255,Inventory.I4256,Inventory.I4257,Inventory.I4259,
    Inventory.I4260,Inventory.I4261 from
    MT.Inventory LEFT OUTER JOIN mt.calibration ON MT.Inventory.mtag = MT.Calibration.mtag,
    MT.Inventory LEFT OUTER JOIN  MT.Location ON MT.Inventory.mtag = MT.Location.mtag
    WHERE
    I4228 <> 'N' and
    (C2339 = 1  or C2339 is null) and 
    C2303 <= duedate and
    (L2815 = 1 or L2815 is null)
end;;
grant execute on mt.mc_cal_loc_due to mtreports;;
comment on procedure mt.mc_cal_loc_due is 'April 2002: Fluke : data for calbration due reports';;
//
//
// ================================================================
//
// mc_cal_loc_due_range
//
Call mtxdropprocedure('mc_cal_loc_due_range');;
CREATE procedure mt.mc_cal_loc_due_range(in startdate date default today(*),in enddate date default today(*))

result(
I4201 char(60),C2303 date,K4601 char(48),L2801 char(20),L2802 char(20),L2803 char(20),L2804 char(10),L2805 char(8),L2806 date,
L2807 date,L2808 integer,L2809 date,L2810 char(8),L2811 timestamp,L2812 char(16),L2813 timestamp,L2814 char(16),L2815 integer,
LMTAG char(80),ltag char(80),ldsrc char(3),L2816 char(15),L2817 decimal(12,2),LPUBLISH char(32),L2818 decimal(12,2),L2819 decimal(12,2),
L2820 decimal(12,2),L2821 decimal(12,2),L2822 date,L2823 date,L2824 date,L2825 date,L2826 char(48),L2827 char(48),L2828 char(48),
L2829 char(48),L2830 char(48),L2831 char(48),L2832 char(48),L2833 char(48),L2834 char(48),L2835 char(48),L2836 long varchar,
L2837 char(128),C2301 date,C2302 integer,C2304 integer,C2306 date,C2307 char(20),C2309 decimal(12,2),C2310 decimal(5,1),
C2311 decimal(5,1),C2312 integer,C2313 char(15),C2314 char(16),C2316 date,C2320 char(128),C2321 char(55),C2322 char(1),C2323 char(1),
C2324 decimal(5,1),C2326 char(44),C2327 char(20),C2328 decimal(5,1),C2329 char(44),C2330 char(10),C2331 char(1),C2332 integer,
C2333 char(8),C2334 char(8),C2335 timestamp,C2336 char(16),C2337 timestamp,C2338 char(16),C2339 integer,C2341 char(254),CMTAG char(80),
CTAG char(80),C2362 integer,C2308 char(10),C2315 decimal(5,1),C2342 date,C2343 char(8),C2317 decimal(5,1),C2318 char(13),C2319 char(1),
C2325 char(1),C2350 integer,C2351 integer,C2352 integer,C2353 integer,C2354 char(64),C2355 char(64),C2356 char(64),C2357 char(64),
C2358 char(64),C2359 char(64),C2360 char(64),C2361 char(64),C2363 char(1),cdsrc char(3),CPUBLISH char(32),C2381 char(8),C2382 char(1),
C2364 char(48),C2365 char(48),C2366 char(48),C2367 char(48),C2368 char(48),C2369 char(48),C2370 char(48),C2371 date,C2372 date,
C2373 date,C2374 date,C2375 decimal(12,2),C2376 decimal(12,2),C2377 decimal(12,2),C2378 decimal(12,2),C2379 decimal(12,2),C2380 date,
C2383 integer,C2384 long varchar,C2385 char(128),I4202 char(30),I4203 char(30),I4204 char(60),I4205 char(1),
I4206 char(30),I4207 char(24),I4208 char(29),I4209 char(1),I4210 char(12),I4211 char(15),I4212 date,I4213 char(10),I4214 char(8),
I4215 char(5),I4216 char(5),I4217 char(60),I4218 char(4),I4219 decimal(12,2),I4220 integer,I4221 date,I4222 char(12),I4223 char(16),
I4224 date,I4225 char(8),I4226 char(1),I4228 char(1),I4229 integer,I4230 integer,I4231 char(32),I4232 char(32),I4233 char(32),
I4234 char(32),I4235 char(32),I4236 timestamp,I4237 char(16),I4238 timestamp,I4239 char(16),I4240 char(8),I4299 char(1),MTAG char(80),
I4241 char(80),I4242 char(80),I4243 char(80),idsrc char(3),IPUBLISH char(32),Iktag char(80),replic char(1),I4258 char(1),I4244 char(48),
I4245 char(48),I4246 char(48),I4247 char(48),I4248 char(48),I4249 char(48),I4250 date,I4251 date,I4252 date,I4253 date,I4254 decimal(12,2),
I4255 decimal(12,2),I4256 decimal(12,2),I4257 decimal(12,2),I4259 integer,I4260 long varchar,I4261 char(128),KTAG char(80),KPUBLISH char(32),
K4602 char(48),K4603 char(48),K4604 char(48),K4605 char(48),K4606 char(48),K4607 char(48),K4608 char(48),K4609 char(48),
K4610 char(48),K4611 char(48),K4612 char(48),K4613 char(48),K4614 char(48),K4615 char(48),K4616 char(48),K4617 char(48),K4618 char(48),
K4619 char(48),K4620 char(48),K4621 date,K4622 date,K4623 date,K4624 date,K4625 decimal(12,2),K4626 decimal(12,2),K4627 decimal(12,2),
K4628 decimal(12,2),K4640 char(8),K4629 timestamp,K4630 char(16),K4631 timestamp,K4632 char(16),KDSRC char(3),kreplic char(1))
begin 
  select I4201,C2303,K4601,Location.L2801,
    Location.L2802,Location.L2803,Location.L2804,Location.L2805,Location.L2806,Location.L2807,
    Location.L2808,Location.L2809,Location.L2810,Location.L2811,Location.L2812,Location.L2813,
    Location.L2814,Location.L2815,Location.MTAG,Location.ltag,Location.ldsrc,Location.L2816,
    Location.L2817,Location.LPUBLISH,Location.L2818,Location.L2819,Location.L2820,
    Location.L2821,Location.L2822,Location.L2823,Location.L2824,Location.L2825,Location.L2826,
    Location.L2827,Location.L2828,Location.L2829,Location.L2830,Location.L2831,
    Location.L2832,Location.L2833,Location.L2834,Location.L2835,Location.L2836,
    Location.L2837,Calibration.C2301,Calibration.C2302,Calibration.C2303,Calibration.C2304,
    Calibration.C2306,Calibration.C2307,Calibration.C2309,Calibration.C2310,Calibration.C2311,
    Calibration.C2312,Calibration.C2313,Calibration.C2314,Calibration.C2316,Calibration.C2320,
    Calibration.C2321,Calibration.C2322,Calibration.C2323,Calibration.C2324,Calibration.C2326,
    Calibration.C2327,Calibration.C2328,Calibration.C2329,Calibration.C2330,Calibration.C2331,
    Calibration.C2332,Calibration.C2333,Calibration.C2334,Calibration.C2335,Calibration.C2336,
    Calibration.C2337,Calibration.C2338,Calibration.C2339,Calibration.C2341,Calibration.MTAG,
    Calibration.CTAG,Calibration.C2362,Calibration.C2308,Calibration.C2315,Calibration.C2342,
    Calibration.C2343,Calibration.C2317,Calibration.C2318,Calibration.C2319,Calibration.C2325,
    Calibration.C2350,Calibration.C2351,Calibration.C2352,Calibration.C2353,Calibration.C2354,
    Calibration.C2355,Calibration.C2356,Calibration.C2357,Calibration.C2358,Calibration.C2359,
    Calibration.C2360,Calibration.C2361,Calibration.C2363,Calibration.cdsrc,Calibration.CPUBLISH,
    Calibration.C2381,Calibration.C2382,Calibration.C2364,Calibration.C2365,Calibration.C2366,
    Calibration.C2367,Calibration.C2368,Calibration.C2369,Calibration.C2370,Calibration.C2371,
    Calibration.C2372,Calibration.C2373,Calibration.C2374,Calibration.C2375,Calibration.C2376,
    Calibration.C2377,Calibration.C2378,Calibration.C2379,Calibration.C2380,Calibration.C2383,
    Calibration.C2384,Calibration.C2385,
    Inventory.I4201,Inventory.I4202,Inventory.I4203,Inventory.I4204,Inventory.I4205,
    Inventory.I4206,Inventory.I4207,Inventory.I4208,Inventory.I4209,Inventory.I4210,
    Inventory.I4211,Inventory.I4212,Inventory.I4213,Inventory.I4214,Inventory.I4215,
    Inventory.I4216,Inventory.I4217,Inventory.I4218,Inventory.I4219,Inventory.I4220,
    Inventory.I4221,Inventory.I4222,Inventory.I4223,Inventory.I4224,Inventory.I4225,
    Inventory.I4226,Inventory.I4228,Inventory.I4229,Inventory.I4230,Inventory.I4231,
    Inventory.I4232,Inventory.I4233,Inventory.I4234,Inventory.I4235,Inventory.I4236,
    Inventory.I4237,Inventory.I4238,Inventory.I4239,Inventory.I4240,Inventory.I4299,
    Inventory.MTAG,Inventory.I4241,Inventory.I4242,Inventory.I4243,Inventory.idsrc,
    Inventory.IPUBLISH,Inventory.ktag,Inventory.replic,Inventory.I4258,
    Inventory.I4244,Inventory.I4245,Inventory.I4246,Inventory.I4247,Inventory.I4248,
    Inventory.I4249,Inventory.I4250,Inventory.I4251,Inventory.I4252,Inventory.I4253,
    Inventory.I4254,Inventory.I4255,Inventory.I4256,Inventory.I4257,Inventory.I4259,
    Inventory.I4260,Inventory.I4261,
    customers.KTAG,customers.KPUBLISH,customers.K4601,customers.K4602,customers.K4603,
    customers.K4604,customers.K4605,customers.K4606,customers.K4607,customers.K4608,
    customers.K4609,customers.K4610,customers.K4611,customers.K4612,customers.K4613,
    customers.K4614,customers.K4615,customers.K4616,customers.K4617,customers.K4618,
    customers.K4619,customers.K4620,customers.K4621,customers.K4622,customers.K4623,
    customers.K4624,customers.K4625,customers.K4626,customers.K4627,customers.K4628,
    customers.K4640,customers.K4629,customers.K4630,customers.K4631,customers.K4632,
    customers.KDSRC,customers.kreplic 
    from
    MT.Inventory LEFT OUTER JOIN mt.calibration ON MT.Inventory.mtag = MT.Calibration.mtag,
    MT.Inventory LEFT OUTER JOIN  MT.Location ON MT.Inventory.mtag = MT.Location.mtag,
    MT.Inventory LEFT OUTER JOIN MT.customers ON MT.Inventory.Ktag = MT.Customers.ktag
    where
    inventory.I4228 <> 'N' and
    (calibration.C2339 = 1 or calibration.C2339 is null) and 
    (calibration.C2303 <= enddate and calibration.C2303 > startdate) and
    (location.L2815 = 1 or location.L2815 is null) and
    (customers.ktag = inventory.ktag or inventory.ktag is null)
end;;
grant execute on mt.mc_cal_loc_due_range to mtreports;;
comment on procedure mt.mc_cal_loc_due_range is 'April 2002: Fluke : data for calbration due reports';;
/*
//
//
//
//
// ================================================================
//
// mc_rep_loc_due_range
//
*/
Call mtxdropprocedure('mc_rep_loc_due_range');;
CREATE procedure mt.mc_rep_loc_due_range(in startdate date default today(*),
in enddate date default today(*),in reptype char(1) default '%')
result(I4201 char(60),R3230 date,K4601 char(48),L2801 char(20),L2802 char(20),L2803 char(20),
L2804 char(10),L2805 char(8),L2806 date,L2807 date,L2808 integer,L2809 date,L2810 char(8),
L2811 timestamp,L2812 char(16),L2813 timestamp,L2814 char(16),L2815 integer,LMTAG char(80),
ltag char(80),ldsrc char(3),L2816 char(15),L2817 decimal(12,2),LPUBLISH char(32),L2818 decimal(12,2),
L2819 decimal(12,2),L2820 decimal(12,2),L2821 decimal(12,2),L2822 date,L2823 date,L2824 date,
L2825 date,L2826 char(48),L2827 char(48),L2828 char(48),L2829 char(48),L2830 char(48),L2831 char(48),
L2832 char(48),L2833 char(48),L2834 char(48),L2835 char(48),L2836 long varchar,L2837 char(128),
R3201 char(102),R3204 char(102),R3207 char(15),R3208 char(14),R3209 decimal(12,2),R3210 char(15),
R3211 char(14),R3212 decimal(12,2),R3213 char(15),R3214 char(14),R3215 decimal(12,2),R3216 char(15),
R3217 char(14),R3218 decimal(12,2),R3219 char(15),R3220 char(14),R3221 decimal(12,2),R3222 char(15),
R3223 char(14),R3224 decimal(12,2),R3225 char(15),R3226 char(14),R3227 decimal(12,2),
R3229 decimal(5,1),R3231 decimal(12,2),R3232 decimal(12,2),R3233 char(15),
R3235 decimal(12,2),R3236 char(15),R3237 char(15),R3238 decimal(5,1),R3239 decimal(5,1),
R3240 char(12),R3241 char(8),R3242 timestamp,R3243 char(16),R3244 timestamp,R3245 char(16),
R3246 integer,R3247 date,R3248 char(8),R3249 integer,R3250 char(1),RMTAG char(80),R3251 char(1),
rtag char(80),rdsrc char(3),RPUBLISH char(32),R3252 decimal(12,2),R3253 long varchar,R3254 char(48),
R3255 char(48),R3256 char(48),R3257 char(48),R3258 char(48),R3259 char(48),R3260 char(48),
R3261 date,R3262 date,R3263 date,R3264 date,R3265 decimal(12,2),R3266 decimal(12,2),
R3267 decimal(12,2),R3268 decimal(12,2),R3269 decimal(12,2),R3270 char(128),
I4202 char(30),I4203 char(30),I4204 char(60),I4205 char(1),I4206 char(30),
I4207 char(24),I4208 char(29),I4209 char(1),I4210 char(12),I4211 char(15),I4212 date,I4213 char(10),
I4214 char(8),I4215 char(5),I4216 char(5),I4217 char(60),I4218 char(4),I4219 decimal(12,2),
I4220 integer,I4221 date,I4222 char(12),I4223 char(16),I4224 date,I4225 char(8),I4226 char(1),
I4228 char(1),I4229 integer,I4230 integer,I4231 char(32),I4232 char(32),I4233 char(32),
I4234 char(32),I4235 char(32),I4236 timestamp,I4237 char(16),I4238 timestamp,I4239 char(16),
I4240 char(8),I4299 char(1),MTAG char(80),I4241 char(80),I4242 char(80),I4243 char(80),
idsrc char(3),IPUBLISH char(32),IKTAG char(80),replic char(1),I4258 char(1),I4244 char(48),
I4245 char(48),I4246 char(48),I4247 char(48),I4248 char(48),I4249 char(48),I4250 date,I4251 date,
I4252 date,I4253 date,I4254 decimal(12,2),I4255 decimal(12,2),I4256 decimal(12,2),I4257 decimal(12,2),
I4259 integer,I4260 long varchar,I4261 char(128),KTAG char(80),KPUBLISH char(32),
K4602 char(48),K4603 char(48),K4604 char(48),K4605 char(48),K4606 char(48),K4607 char(48),
K4608 char(48),K4609 char(48),K4610 char(48),K4611 char(48),K4612 char(48),K4613 char(48),
K4614 char(48),K4615 char(48),K4616 char(48),K4617 char(48),K4618 char(48),K4619 char(48),
K4620 char(48),K4621 date,K4622 date,K4623 date,K4624 date,K4625 decimal(12,2),K4626 decimal(12,2),
K4627 decimal(12,2),K4628 decimal(12,2),K4640 char(8),K4629 timestamp,K4630 char(16),K4631 timestamp,
K4632 char(16),KDSRC char(3),kreplic char(1))
begin
  select I4201,R3230,K4601,Location.L2801,Location.L2802,Location.L2803,
    Location.L2804,Location.L2805,Location.L2806,Location.L2807,
    Location.L2808,Location.L2809,Location.L2810,Location.L2811,
    Location.L2812,Location.L2813,Location.L2814,Location.L2815,
    Location.MTAG,Location.ltag,Location.ldsrc,Location.L2816,
    Location.L2817,Location.LPUBLISH,Location.L2818,Location.L2819,
    Location.L2820,Location.L2821,Location.L2822,Location.L2823,
    Location.L2824,Location.L2825,Location.L2826,Location.L2827,
    Location.L2828,Location.L2829,Location.L2830,Location.L2831,
    Location.L2832,Location.L2833,Location.L2834,Location.L2835,
    Location.L2836,Location.L2837,
    Repair.R3201,Repair.R3204,Repair.R3207,Repair.R3208,Repair.R3209,
    Repair.R3210,Repair.R3211,Repair.R3212,Repair.R3213,Repair.R3214,
    Repair.R3215,Repair.R3216,Repair.R3217,Repair.R3218,Repair.R3219,
    Repair.R3220,Repair.R3221,Repair.R3222,Repair.R3223,Repair.R3224,
    Repair.R3225,Repair.R3226,Repair.R3227,Repair.R3229,Repair.R3230,
    Repair.R3231,Repair.R3232,Repair.R3233,Repair.R3235,Repair.R3236,
    Repair.R3237,Repair.R3238,Repair.R3239,Repair.R3240,Repair.R3241,
    Repair.R3242,Repair.R3243,Repair.R3244,Repair.R3245,Repair.R3246,
    Repair.R3247,Repair.R3248,Repair.R3249,Repair.R3250,Repair.MTAG,
    Repair.R3251,Repair.rtag,Repair.rdsrc,Repair.RPUBLISH,Repair.R3252,
    Repair.R3253,Repair.R3254,Repair.R3255,Repair.R3256,Repair.R3257,
    Repair.R3258,Repair.R3259,Repair.R3260,Repair.R3261,Repair.R3262,
    Repair.R3263,Repair.R3264,Repair.R3265,Repair.R3266,Repair.R3267,
    Repair.R3268,Repair.R3269,Repair.R3270,
    Inventory.I4201,Inventory.I4202,Inventory.I4203,Inventory.I4204,
    Inventory.I4205,Inventory.I4206,Inventory.I4207,Inventory.I4208,
    Inventory.I4209,Inventory.I4210,Inventory.I4211,Inventory.I4212,
    Inventory.I4213,Inventory.I4214,Inventory.I4215,Inventory.I4216,
    Inventory.I4217,Inventory.I4218,Inventory.I4219,Inventory.I4220,
    Inventory.I4221,Inventory.I4222,Inventory.I4223,Inventory.I4224,
    Inventory.I4225,Inventory.I4226,Inventory.I4228,Inventory.I4229,
    Inventory.I4230,Inventory.I4231,Inventory.I4232,Inventory.I4233,
    Inventory.I4234,Inventory.I4235,Inventory.I4236,Inventory.I4237,
    Inventory.I4238,Inventory.I4239,Inventory.I4240,Inventory.I4299,
    Inventory.MTAG,Inventory.I4241,Inventory.I4242,Inventory.I4243,
    Inventory.idsrc,Inventory.IPUBLISH,Inventory.ktag,Inventory.replic,
    Inventory.I4258,Inventory.I4244,Inventory.I4245,Inventory.I4246,
    Inventory.I4247,Inventory.I4248,Inventory.I4249,Inventory.I4250,
    Inventory.I4251,Inventory.I4252,Inventory.I4253,Inventory.I4254,
    Inventory.I4255,Inventory.I4256,Inventory.I4257,Inventory.I4259,
    Inventory.I4260,Inventory.I4261,
    customers.KTAG,customers.KPUBLISH,customers.K4601,customers.K4602,
    customers.K4603,customers.K4604,customers.K4605,customers.K4606,
    customers.K4607,customers.K4608,customers.K4609,customers.K4610,
    customers.K4611,customers.K4612,customers.K4613,customers.K4614,
    customers.K4615,customers.K4616,customers.K4617,customers.K4618,
    customers.K4619,customers.K4620,customers.K4621,customers.K4622,
    customers.K4623,customers.K4624,customers.K4625,customers.K4626,
    customers.K4627,customers.K4628,customers.K4640,customers.K4629,
    customers.K4630,customers.K4631,customers.K4632,customers.KDSRC,
    customers.kreplic 
    from
    MT.Inventory LEFT OUTER JOIN  MT.Location ON MT.Inventory.mtag = MT.Location.mtag,
    MT.Inventory LEFT OUTER JOIN MT.Repair ON MT.Inventory.mtag = MT.Repair.mtag,
    MT.Inventory LEFT OUTER JOIN MT.customers ON MT.Inventory.Ktag = MT.Customers.ktag
    where
    R3251 like reptype and
    (R3246 = 1  or R3246 is null )and 
    (R3247 <= enddate and R3247 > startdate) and
    (L2815 = 1 or L2815 is null) and
    (customers.ktag = inventory.ktag or inventory.ktag is null)
    end;;

    grant execute on mt.mc_rep_loc_due_range to mtreports;;
    comment on procedure mt.mc_rep_loc_due_range is 'April 2002: Fluke : data for Maintenance due reports';;

/*
//
// =================================================================
//
// mccalresloc
//
*/
call mtxdropprocedure('mccalresloc');;
CREATE procedure mt.mccalresloc(in asset_ctag char(80))
result(SOURCE char(3),C2301 date,C2302 integer,C2303 date,C2304 integer,C2306 date,
C2307 char(20),C2308 char(10),C2309 numeric(12,2),C2310 numeric(5,1),C2311 numeric(6,2),
C2312 numeric(6,2),C2313 char(15),C2314 char(16),C2315 numeric(5,1),C2316 date,
C2317 numeric(5,1),C2318 char(13),C2319 char(1),C2320 char(128),C2321 char(55),C2322 char(1),
C2323 char(1),C2324 numeric(5,1),C2325 char(1),C2326 char(44),C2327 char(20),C2328 numeric(5,1),
C2329 char(44),C2330 char(10),C2331 char(1),C2332 integer,C2333 char(8),C2334 char(8),
C2335 timestamp,C2336 char(16),C2337 timestamp,C2338 char(16),C2339 integer,
C2341 char(254),C2342 date,C2343 char(8),C2344 integer,C2345 integer,C2346 integer,
C2347 integer,C2350 integer,C2351 integer,C2352 integer,C2353 integer,C2354 char(64),
C2355 char(64),C2356 char(64),C2357 char(64),C2358 char(64),C2359 char(64),C2360 char(64),
C2361 char(64),C2362 integer,C2363 char(1),C2364 char(48),C2365 char(48),C2366 char(48),
C2367 char(48),C2368 char(48),C2369 char(48),C2370 char(48),C2371 date,C2372 date,
C2373 date,C2374 date,C2375 numeric(12,2),C2376 numeric(12,2),C2377 numeric(12,2),
C2378 numeric(12,2),C2379 numeric(12,2),
C2380 date,C2381 char(8),C2382 char(1),C2383 integer,C2384 long varchar,C2385 char(128),
C2386 numeric(5,1),C2387 numeric(5,1),C2388 numeric(9,2),C2389 numeric(7,2),C2390 numeric(9,2),
C2391 numeric(7,2),C2392 numeric(2,0),C2393 char(1),C2394 char(1),C2395 char(10),C2396 char(16),
CPUBLISH char(32),CTAG  char(80),cdsrc char(3),I4201 char(60),I4202 char(30),I4203 char(30),
I4204 char(60),I4205 char(1),I4206 char(30),I4207 char(24),I4208 char(29),I4209 char(1) ,
I4210 char(12),I4211 char(15),I4212 date,I4213 char(10),I4214 char(8),I4215 char(5),
I4216 char(5),I4217 char(60),I4218 char(4),I4219 numeric(12,2),I4220 integer,I4221 date,
I4222 char(12),I4223 char(16),I4224 date,I4225 char(8),I4226 char(1),I4228 char(1),
I4229 integer,I4230 integer,I4231 char(32),I4232 char(32),I4233 char(32),I4234 char(32),
I4235 char(32),I4236 timestamp,I4237 char(16),I4238 timestamp,I4239 char(16),I4240 char(8),
I4241 char(80),I4242 char(80),I4243 char(80),I4244 char(48),I4245 char(48),I4246 char(48),
I4247 char(48),I4248 char(48),I4249 char(48),I4250 date,I4251 date,I4252 date,I4253 date,
I4254 numeric(12,2),I4255 numeric(12,2),I4256 numeric(12,2),I4257 numeric(12,2),I4258 char(1),
I4259 integer,I4260 long varchar,I4261 char(128),I4262 char(128),I4299 char(1),MTAG  char(80),
ktag  char(80),idsrc char(3),IPUBLISH  char(32),replic char(1),L2801 char(20),L2802 char(20),
L2803 char(20),L2804 char(10),L2805 char(8),L2806 date,L2807 date,L2808 integer,L2809 date,
L2810 char(8),L2811 timestamp,L2812 char(16),L2813 timestamp,L2814 char(16),L2815 integer,
L2816 char(15),L2817 numeric(12,2),L2818 numeric(12,2),L2819 numeric(12,2),L2820 numeric(12,2),
L2821 numeric(12,2),L2822 date,L2823 date,L2824 date,L2825 date,L2826 char(48),L2827 char(48),
L2828 char(48),L2829 char(48),L2830 char(48),L2831 char(48),L2832 char(48),L2833 char(48),
L2834 char(48),L2835 char(48),L2836 long varchar,L2837 char(128),LPUBLISH char(32),ltag  char(80),
ldsrc char(3),C2430 char(80),C2501 char(254),C2502 integer,std_4201 char(60),std_4202 char(30),
std_4203 char(30),std_4204 char(60),std_4205 char(1),std_4206 char(30),std_4207 char(24),
std_4208 char(29),std_4241 char(80),std_4242 char(80),std_4243 char(80),std_4244 char(48),
std_4245 char(48),std_2301 date,std_2333 char(8),std_2303 date,std_2334 char(8),std_2323 char(1),
std_ctag char(80),std_2308 char(10),std_2354 char(64),std_2355 char(64),std_2356 char(64),
K4601 char(48),K4602 char(48),K4603 char(48),K4604 char(48),K4605 char(48),K4606 char(48),
K4607 char(48),K4608 char(48),K4609 char(48),K4610 char(48),K4611 char(48),K4612 char(48),
K4613 char(48),K4614 char(48),K4615 char(48),K4616 char(48),K4617 char(48),K4618 char(48),
K4619 char(48),K4620 char(48),K4621 date,K4622 date,K4623 date,K4624 date,K4625 numeric(12,2),
K4626 numeric(12,2),K4627 numeric(12,2),K4628 numeric(12,2),K4629 timestamp,K4630 char(16),
K4631 timestamp,K4632 char(16),K4633 char(40),K4634 char(30),K4635 char(20),K4636 char(20),
K4637 char(60),K4640 char(8),KPUBLISH char(32),KDSRC char(3),operator char(60),oper_level integer,
oper_seg char(8)
)
begin
	declare tmp_stdctag char(80);
	declare tmp_ktag char(80);
	declare tmp_c2430 char(80);
	declare my_mtag char(80);
	declare my_ctag char(80);
	declare tmp_std_2301 date;
	declare tmp_std_2333 char(8);
	declare tmp_std_2303 date;
	declare tmp_std_2334 char(8);
	declare tmp_std_2323 char(1);
	declare tmp_std_ctag char(80);
	declare tmp_std_2308 char(10);
	declare tmp_std_2354 char(64);
	declare tmp_std_2355 char(64);
	declare tmp_std_2356 char(64);
	declare tmp_K4601 char(48);
	declare tmp_K4602 char(48);
	declare tmp_K4603 char(48);
	declare tmp_K4604 char(48);
	declare tmp_K4605 char(48);
	declare tmp_K4606 char(48);
	declare tmp_K4607 char(48);
	declare tmp_K4608 char(48);
	declare tmp_K4609 char(48);
	declare tmp_K4610 char(48);
	declare tmp_K4611 char(48);
	declare tmp_K4612 char(48);
	declare tmp_K4613 char(48);
	declare tmp_K4614 char(48);
	declare tmp_K4615 char(48);
	declare tmp_K4616 char(48);
	declare tmp_K4617 char(48);
	declare tmp_K4618 char(48);
	declare tmp_K4619 char(48);
	declare tmp_K4620 char(48);
	declare tmp_K4621 date;
	declare tmp_K4622 date;
	declare tmp_K4623 date;
	declare tmp_K4624 date;
	declare tmp_K4625 decimal(12,2);
	declare tmp_K4626 decimal(12,2);
	declare tmp_K4627 decimal(12,2);
	declare tmp_K4628 decimal(12,2);
	declare tmp_K4640 char(8);
	declare tmp_K4629 timestamp;
	declare tmp_K4630 char(16);
	declare tmp_K4631 timestamp;
	declare tmp_K4632 char(16);
	declare tmp_K4633 char(40);
	declare tmp_K4634 char(30);
	declare tmp_K4635 char(20);
	declare tmp_K4636 char(20);
	declare tmp_K4637 char(60);
	declare tmp_KPUBLISH char(32);
	declare tmp_KDSRC char(3);
	declare tmp_L2801 char(20);
	declare tmp_L2802 char(20);
	declare tmp_L2803 char(20);
	declare tmp_L2804 char(10);
	declare tmp_L2805 char(8);
	declare tmp_L2806 date;
	declare tmp_L2807 date;
	declare tmp_L2808 integer;
	declare tmp_L2809 date;
	declare tmp_L2810 char(8);
	declare tmp_L2811 timestamp;
	declare tmp_L2812 char(16);
	declare tmp_L2813 timestamp;
	declare tmp_L2814 char(16);
	declare tmp_L2815 integer;
	declare tmp_L2816 char(15);
	declare tmp_L2817 decimal(12,2);
	declare tmp_L2818 decimal(12,2);
	declare tmp_L2819 decimal(12,2);
	declare tmp_L2820 decimal(12,2);
	declare tmp_L2821 decimal(12,2);
	declare tmp_L2822 date;
	declare tmp_L2823 date;
	declare tmp_L2824 date;
	declare tmp_L2825 date;
	declare tmp_L2826 char(48);
	declare tmp_L2827 char(48);
	declare tmp_L2828 char(48);
	declare tmp_L2829 char(48);
	declare tmp_L2830 char(48);
	declare tmp_L2831 char(48);
	declare tmp_L2832 char(48);
	declare tmp_L2833 char(48);
	declare tmp_L2834 char(48);
	declare tmp_L2835 char(48);
	declare tmp_L2836 long varchar;
	declare tmp_L2837 char(128);
	declare tmp_LPUBLISH char(32);
	declare tmp_ltag char(80);
	declare tmp_ldsrc char(3);
	declare tmp_operator char(60);
	declare tmp_oper_level integer;
	declare tmp_oper_seg char(8);
	declare tmp_C2301 date;
	declare tmp_C2302 integer;
	declare tmp_C2303 date;
	declare tmp_C2304 integer;
	declare tmp_C2306 date;
	declare tmp_C2307 char(20);
	declare tmp_C2308 char(10);
	declare tmp_C2309 decimal(12,2);
	declare tmp_C2310 decimal(5,1);
	declare tmp_C2311 decimal(5,1);
	declare tmp_C2312 integer;
	declare tmp_C2313 char(15);
	declare tmp_C2314 char(16);
	declare tmp_C2315 decimal(5,1);
	declare tmp_C2316 date;
	declare tmp_C2317 decimal(5,1);
	declare tmp_C2318 char(13);
	declare tmp_C2319 char(1);
	declare tmp_C2320 char(128);
	declare tmp_C2321 char(55);
	declare tmp_C2322 char(1);
	declare tmp_C2323 char(1);
	declare tmp_C2324 decimal(5,1);
	declare tmp_C2325 char(1);
	declare tmp_C2326 char(44);
	declare tmp_C2327 char(20);
	declare tmp_C2328 decimal(5,1);
	declare tmp_C2329 char(44);
	declare tmp_C2330 char(10);
	declare tmp_C2331 char(1);
	declare tmp_C2332 integer;
	declare tmp_C2333 char(8);
	declare tmp_C2334 char(8);
	declare tmp_C2335 timestamp;
	declare tmp_C2336 char(16);
	declare tmp_C2337 timestamp;
	declare tmp_C2338 char(16);
	declare tmp_C2339 integer;
	declare tmp_C2341 char(254);
	declare tmp_C2342 date;
	declare tmp_C2343 char(8);
	declare tmp_C2350 integer;
	declare tmp_C2351 integer;
	declare tmp_C2352 integer;
	declare tmp_C2353 integer;
	declare tmp_C2354 char(64);
	declare tmp_C2355 char(64);
	declare tmp_C2356 char(64);
	declare tmp_C2357 char(64);
	declare tmp_C2358 char(64);
	declare tmp_C2359 char(64);
	declare tmp_C2360 char(64);
	declare tmp_C2361 char(64);
	declare tmp_C2362 integer;
	declare tmp_C2363 char(48);
	declare tmp_C2364 char(48);
	declare tmp_C2365 char(48);
	declare tmp_C2366 char(48);
	declare tmp_C2367 char(48);
	declare tmp_C2368 char(48);
	declare tmp_C2369 char(48);
	declare tmp_C2370 char(48);
	declare tmp_C2371 date;
	declare tmp_C2372 date;
	declare tmp_C2373 date;
	declare tmp_C2374 date;
	declare tmp_C2375 decimal(12,2);
	declare tmp_C2376 decimal(12,2);
	declare tmp_C2377 decimal(12,2);
	declare tmp_C2378 decimal(12,2);
	declare tmp_C2379 decimal(12,2);
	declare tmp_C2380 date;
	declare tmp_C2381 char(8);
	declare tmp_C2382 char(1);
	declare tmp_C2383 integer;
	declare tmp_C2384 long varchar;
	declare tmp_C2385 char(128);
	declare tmp_C2386 numeric(5,1);
	declare tmp_C2387 numeric(5,1);
	declare tmp_C2388 numeric(9,2);
	declare tmp_C2389 numeric(7,2);
	declare tmp_C2390 numeric(9,2);
	declare tmp_C2391 numeric(7,2);
	declare tmp_C2392 numeric(2,0);
	declare tmp_C2393 char(1);
	declare tmp_C2394 char(1);
	declare tmp_C2395 char(10);
	declare tmp_C2396 char(16);
	declare tmp_CPUBLISH char(32);
	declare tmp_cdsrc char(3);
	declare tmp_I4201 char(60);
	declare tmp_I4202 char(30);
	declare tmp_I4203 char(30);
	declare tmp_I4204 char(60);
	declare tmp_I4205 char(1);
	declare tmp_I4206 char(30);
	declare tmp_I4207 char(24);
	declare tmp_I4208 char(29);
	declare tmp_I4209 char(1);
	declare tmp_I4210 char(12);
	declare tmp_I4211 char(15);
	declare tmp_I4212 date;
	declare tmp_I4213 char(10);
	declare tmp_I4214 char(8);
	declare tmp_I4215 char(5);
	declare tmp_I4216 char(5);
	declare tmp_I4217 char(60);
	declare tmp_I4218 char(4);
	declare tmp_I4219 decimal(12,2);
	declare tmp_I4220 integer;
	declare tmp_I4221 date;
	declare tmp_I4222 char(12);
	declare tmp_I4223 char(16);
	declare tmp_I4224 date;
	declare tmp_I4225 char(8);
	declare tmp_I4226 char(1);
	declare tmp_I4228 char(1);
	declare tmp_I4229 integer;
	declare tmp_I4230 integer;
	declare tmp_I4231 char(32);
	declare tmp_I4232 char(32);
	declare tmp_I4233 char(32);
	declare tmp_I4234 char(32);
	declare tmp_I4235 char(32);
	declare tmp_I4236 timestamp;
	declare tmp_I4237 char(16);
	declare tmp_I4238 timestamp;
	declare tmp_I4239 char(16);
	declare tmp_I4240 char(8);
	declare tmp_I4299 char(1);
	declare tmp_I4241 char(80);
	declare tmp_I4242 char(80);
	declare tmp_I4243 char(80);
	declare tmp_I4244 char(48);
	declare tmp_I4245 char(48);
	declare tmp_I4246 char(48);
	declare tmp_I4247 char(48);
	declare tmp_I4248 char(48);
	declare tmp_I4249 char(48);
	declare tmp_I4250 date;
	declare tmp_I4251 date;
	declare tmp_I4252 date;
	declare tmp_I4253 date;
	declare tmp_I4254 decimal(12,2);
	declare tmp_I4255 decimal(12,2);
	declare tmp_I4256 decimal(12,2);
	declare tmp_I4257 decimal(12,2);
	declare tmp_I4258 char(1);
	declare tmp_I4259 integer;
	declare tmp_I4260 long varchar;
	declare tmp_I4261 char(128);
	declare tmp_I4262 char(128);
	declare tmp_idsrc char(3);
	declare tmp_IPUBLISH char(32);
	declare tmp_replic char(1);
	declare err_notfound exception for sqlstate value '02000';
	declare curloc dynamic scroll cursor for select mtag from tblcalresloc;
	declare curstd dynamic scroll cursor for select C2430 from standards where ctag = asset_ctag;
	declare cur_user dynamic scroll cursor for select name,mtlevel,userlist.I4240 from
		mt.userlist,tblcalresloc where
		mtuser = tblcalresloc.C2336;
	delete from tblcalresloc;
	select C2301,C2302,C2303,C2304,C2306,C2307,C2308,C2309,C2310,C2311,C2312,C2313,
		C2314,C2315,C2316,C2317,C2318,C2319,C2320,C2321,C2322,C2323,C2324,C2325,C2326,
		C2327,C2328,C2329,C2330,C2331,C2332,C2333,C2334,C2335,C2336,C2337,C2338,C2339,
		C2341,C2342,C2343,C2350,C2351,C2352,C2353,C2354,C2355,C2356,C2357,C2358,C2359,
		C2360,C2361,C2362,C2363,C2364,C2365,C2366,C2367,C2368,C2369,C2370,C2371,C2372,C2373,
		C2374,C2375,C2376,C2377,C2378,C2379,C2380,C2381,C2382,C2383,C2384,C2385,C2386,C2387,
		C2388,C2389,C2390,C2391,C2392,C2393,C2394,C2395,C2396,CPUBLISH,
		cdsrc,mtag,ctag into tmp_C2301,tmp_C2302,tmp_C2303,tmp_C2304,tmp_C2306,tmp_C2307,
		tmp_C2308,tmp_C2309,tmp_C2310,tmp_C2311,tmp_C2312,tmp_C2313,tmp_C2314,tmp_C2315,
		tmp_C2316,tmp_C2317,tmp_C2318,tmp_C2319,tmp_C2320,tmp_C2321,tmp_C2322,tmp_C2323,
		tmp_C2324,tmp_C2325,tmp_C2326,tmp_C2327,tmp_C2328,tmp_C2329,tmp_C2330,tmp_C2331,
		tmp_C2332,tmp_C2333,tmp_C2334,tmp_C2335,tmp_C2336,tmp_C2337,tmp_C2338,tmp_C2339,
		tmp_C2341,tmp_C2342,tmp_C2343,tmp_C2350,tmp_C2351,tmp_C2352,tmp_C2353,tmp_C2354,
		tmp_C2355,tmp_C2356,tmp_C2357,tmp_C2358,tmp_C2359,tmp_C2360,tmp_C2361,tmp_C2362,tmp_C2363,
		tmp_C2364,tmp_C2365,tmp_C2366,tmp_C2367,tmp_C2368,tmp_C2369,tmp_C2370,tmp_C2371,
		tmp_C2372,tmp_C2373,tmp_C2374,tmp_C2375,tmp_C2376,tmp_C2377,tmp_C2378,tmp_C2379,
		tmp_C2380,tmp_C2381,tmp_C2382,tmp_C2383,tmp_C2384,tmp_C2385,tmp_C2386,tmp_C2387,
		tmp_C2388,tmp_C2389,tmp_C2390,tmp_C2391,tmp_C2392,tmp_C2393,tmp_C2394,tmp_C2395,
		tmp_C2396,tmp_CPUBLISH,tmp_cdsrc,my_mtag,my_ctag from mt.calibration where ctag = asset_ctag;
	select I4201,I4202,I4203,I4204,I4205,I4206,I4207,I4208,I4209,I4210,I4211,I4212,
		I4213,I4214,I4215,I4216,I4217,I4218,I4219,I4220,I4221,I4222,I4223,I4224,I4225,
		I4226,I4228,I4229,I4230,I4231,I4232,I4233,I4234,I4235,I4236,I4237,I4238,I4239,
		I4240,I4299,I4241,I4242,I4243,I4244,I4245,I4246,I4247,I4248,I4249,I4250,I4251,
		I4252,I4253,I4254,I4255,I4256,I4257,I4258,I4259,I4260,I4261,I4262,idsrc,IPUBLISH,
		replic,ktag into tmp_I4201,tmp_I4202,tmp_I4203,tmp_I4204,tmp_I4205,tmp_I4206,
		tmp_I4207,tmp_I4208,tmp_I4209,tmp_I4210,tmp_I4211,tmp_I4212,tmp_I4213,tmp_I4214,
		tmp_I4215,tmp_I4216,tmp_I4217,tmp_I4218,tmp_I4219,tmp_I4220,tmp_I4221,tmp_I4222,
		tmp_I4223,tmp_I4224,tmp_I4225,tmp_I4226,tmp_I4228,tmp_I4229,tmp_I4230,tmp_I4231,
		tmp_I4232,tmp_I4233,tmp_I4234,tmp_I4235,tmp_I4236,tmp_I4237,tmp_I4238,tmp_I4239,
		tmp_I4240,tmp_I4299,tmp_I4241,tmp_I4242,tmp_I4243,tmp_I4244,tmp_I4245,tmp_I4246,
		tmp_I4247,tmp_I4248,tmp_I4249,tmp_I4250,tmp_I4251,tmp_I4252,tmp_I4253,tmp_I4254,
		tmp_I4255,tmp_I4256,tmp_I4257,tmp_I4258,tmp_I4259,tmp_I4260,tmp_I4261,tmp_I4262,
		tmp_idsrc,tmp_IPUBLISH,tmp_replic,tmp_ktag from mt.inventory where mtag = my_mtag;
	if(tmp_ktag is not null) then
		select K4601,K4602,K4603,K4604,K4605,K4606,K4607,K4608,K4609,K4610,K4611,K4612,
			K4613,K4614,K4615,K4616,K4617,K4618,K4619,K4620,K4621,K4622,K4623,K4624,K4625,
			K4626,K4627,K4628,K4640,K4629,K4630,K4631,K4632,K4633,K4634,K4635,K4636,K4637,
			KPUBLISH,KDSRC into tmp_K4601,
			tmp_K4602,tmp_K4603,tmp_K4604,tmp_K4605,tmp_K4606,tmp_K4607,tmp_K4608,tmp_K4609,
			tmp_K4610,tmp_K4611,tmp_K4612,tmp_K4613,tmp_K4614,tmp_K4615,tmp_K4616,tmp_K4617,
			tmp_K4618,tmp_K4619,tmp_K4620,tmp_K4621,tmp_K4622,tmp_K4623,tmp_K4624,tmp_K4625,
			tmp_K4626,tmp_K4627,tmp_K4628,tmp_K4640,tmp_K4629,tmp_K4630,tmp_K4631,tmp_K4632,
			tmp_K4633,tmp_K4634,tmp_K4635,tmp_K4636,tmp_K4637,
			tmp_KPUBLISH,tmp_KDSRC from mt.customers where ktag = tmp_ktag
	end if;
	if(my_mtag is not null) then
		select L2801,L2802,L2803,L2804,L2805,L2806,L2807,L2808,L2809,L2810,L2811,L2812,
			L2813,L2814,L2815,L2816,L2817,L2818,L2819,L2820,L2821,L2822,L2823,L2824,L2825,L2826,
			L2827,L2828,L2829,L2830,L2831,L2832,L2833,L2834,L2835,L2836,L2837,LPUBLISH,ltag,ldsrc
			into tmp_L2801,
			tmp_L2802,tmp_L2803,tmp_L2804,tmp_L2805,tmp_L2806,tmp_L2807,tmp_L2808,tmp_L2809,tmp_L2810,
			tmp_L2811,tmp_L2812,tmp_L2813,tmp_L2814,tmp_L2815,tmp_L2816,tmp_L2817,tmp_L2818,tmp_L2819,
			tmp_L2820,tmp_L2821,tmp_L2822,tmp_L2823,tmp_L2824,tmp_L2825,tmp_L2826,tmp_L2827,tmp_L2828,
			tmp_L2829,tmp_L2830,tmp_L2831,tmp_L2832,tmp_L2833,tmp_L2834,tmp_L2835,tmp_L2836, tmp_L2837,
			tmp_LPUBLISH,tmp_ltag,
			tmp_ldsrc from mt.location where mtag = my_mtag and L2815 = 1
	end if;
	insert into mt.tblcalresloc(SOURCE,C2430,std_4201,std_4202,std_4203,std_4204,
		std_4205,std_4206,std_4207,std_4208,std_4241,std_4242,std_4243,std_4244,
		std_4245) select 'STD' as SOURCE,C2430,I4201,I4202,I4203,I4204,I4205,I4206,
		I4207,I4208,I4241,I4242,I4243,I4244,I4245 from mt.calibration,mt.inventory,
		mt.standards where
		standards.ctag = asset_ctag and
		inventory.mtag = standards.C2430 and
		calibration.ctag = asset_ctag;
	insert into mt.tblcalresloc(SOURCE,C2501,C2502) select 'RES' as SOURCE,C2501,
		C2502 from mt.calibration,mt.calresults where
		calibration.ctag = calresults.ctag and
		calibration.ctag = asset_ctag order by
		C2502 asc;
	open curstd;
	Zerostdloop: loop
		fetch next curstd into tmp_c2430;
		if sqlstate = err_notfound then
			leave Zerostdloop
		end if;
		set tmp_stdctag=null;
		call std_ctag_from_event(tmp_c2430,asset_ctag,tmp_stdctag);
		if(tmp_stdctag is not null) then
			select C2301,C2303,C2333,C2334,C2323,C2354,C2355,C2356,ctag,C2308 into tmp_std_2301,
				tmp_std_2303,tmp_std_2333,tmp_std_2334,tmp_std_2323,tmp_std_2354,tmp_std_2355,
				tmp_std_2356,tmp_std_ctag,tmp_std_2308 from
				mt.calibration where
				ctag = tmp_stdctag;
			update mt.tblcalresloc set std_ctag = tmp_stdctag,std_2301 = tmp_std_2301,
				std_2303 = tmp_std_2303,std_2333 = tmp_std_2333,std_2334 = tmp_std_2334,
				std_2323 = tmp_std_2323,std_2354 = tmp_std_2354,std_2355 = tmp_std_2355,
				std_2356 = tmp_std_2356 where
				C2430 = tmp_c2430
		end if
	end loop Zerostdloop;
	close curstd;
	if(tmp_ktag is not null) then
		update mt.tblcalresloc set K4601 = tmp_K4601,K4602 = tmp_K4602,K4603 = tmp_K4603,
			K4604 = tmp_K4604,K4605 = tmp_K4605,K4606 = tmp_K4606,K4607 = tmp_K4607,
			K4608 = tmp_K4608,K4609 = tmp_K4609,K4610 = tmp_K4610,K4611 = tmp_K4611,
			K4612 = tmp_K4612,K4613 = tmp_K4613,K4614 = tmp_K4614,K4615 = tmp_K4615,
			K4616 = tmp_K4616,K4617 = tmp_K4617,K4618 = tmp_K4618,K4619 = tmp_K4619,
			K4620 = tmp_K4620,K4621 = tmp_K4621,K4622 = tmp_K4622,K4623 = tmp_K4623,
			K4624 = tmp_K4624,K4625 = tmp_K4625,K4626 = tmp_K4626,K4627 = tmp_K4627,
			K4628 = tmp_K4628,K4629 = tmp_K4629,K4630 = tmp_K4630,K4631 = tmp_K4631,
			K4632 = tmp_K4632,K4640 = tmp_K4640,KDSRC = tmp_KDSRC,KPUBLISH = tmp_KPUBLISH
	end if;
	if(tmp_ltag is not null) then
		update mt.tblcalresloc set L2801 = tmp_L2801,L2802 = tmp_L2802,L2803 = tmp_L2803,
			L2804 = tmp_L2804,L2805 = tmp_L2805,L2806 = tmp_L2806,L2807 = tmp_L2807,
			L2808 = tmp_L2808,L2809 = tmp_L2809,L2810 = tmp_L2810,L2811 = tmp_L2811,
			L2812 = tmp_L2812,L2813 = tmp_L2813,L2814 = tmp_L2814,L2815 = tmp_L2815,
			L2816 = tmp_L2816,L2817 = tmp_L2817,L2818 = tmp_L2818,L2819 = tmp_L2819,
			L2820 = tmp_L2820,L2821 = tmp_L2821,L2822 = tmp_L2822,L2823 = tmp_L2823,
			L2824 = tmp_L2824,L2825 = tmp_L2825,L2826 = tmp_L2826,L2827 = tmp_L2827,
			L2828 = tmp_L2828,L2829 = tmp_L2829,L2830 = tmp_L2830,L2831 = tmp_L2831,
			L2832 = tmp_L2832,L2833 = tmp_L2833,L2834 = tmp_L2834,L2835 = tmp_L2835,
			L2836 = tmp_L2836,L2837 = tmp_L2837,LDSRC = tmp_LDSRC,LTAG = tmp_LTAG,
            MTAG = my_mtag,LPUBLISH = tmp_LPUBLISH
	end if;
	update mt.tblcalresloc set C2301 = tmp_C2301,C2302 = tmp_C2302,C2303 = tmp_C2303,
		C2304 = tmp_C2304,C2306 = tmp_C2306,C2307 = tmp_C2307,C2308 = tmp_C2308,
		C2309 = tmp_C2309,C2310 = tmp_C2310,C2311 = tmp_C2311,C2312 = tmp_C2312,
		C2313 = tmp_C2313,C2314 = tmp_C2314,C2315 = tmp_C2315,C2316 = tmp_C2316,
		C2317 = tmp_C2317,C2318 = tmp_C2318,C2319 = tmp_C2319,C2320 = tmp_C2320,
		C2321 = tmp_C2321,C2322 = tmp_C2322,C2323 = tmp_C2323,C2324 = tmp_C2324,
		C2325 = tmp_C2325,C2326 = tmp_C2326,C2327 = tmp_C2327,C2328 = tmp_C2328,
		C2329 = tmp_C2329,C2330 = tmp_C2330,C2331 = tmp_C2331,C2332 = tmp_C2332,
		C2333 = tmp_C2333,C2334 = tmp_C2334,C2335 = tmp_C2335,C2336 = tmp_C2336,
		C2337 = tmp_C2337,C2338 = tmp_C2338,C2339 = tmp_C2339,C2341 = tmp_C2341,
		C2342 = tmp_C2342,C2343 = tmp_C2343,C2350 = tmp_C2350,C2351 = tmp_C2351,
		C2352 = tmp_C2352,C2353 = tmp_C2353,C2354 = tmp_C2354,C2355 = tmp_C2355,
		C2356 = tmp_C2356,C2357 = tmp_C2357,C2358 = tmp_C2358,C2359 = tmp_C2359,
		C2360 = tmp_C2360,C2361 = tmp_C2361,C2363 = tmp_C2363,C2364 = tmp_C2364,
		C2365 = tmp_C2365,C2366 = tmp_C2366,C2367 = tmp_C2367,C2368 = tmp_C2368,
		C2369 = tmp_C2369,C2370 = tmp_C2370,C2371 = tmp_C2371,C2372 = tmp_C2372,
		C2373 = tmp_C2373,C2374 = tmp_C2374,C2375 = tmp_C2375,C2376 = tmp_C2376,
		C2377 = tmp_C2377,C2378 = tmp_C2378,C2379 = tmp_C2379,C2380 = tmp_C2380,
		C2381 = tmp_C2381,C2382 = tmp_C2382,C2383 = tmp_C2383,C2384 = tmp_C2384,
		C2385 = tmp_C2385,C2386 = tmp_C2386,C2387 = tmp_C2387,C2388 = tmp_C2388,
		C2389 = tmp_C2389,C2390 = tmp_C2390,C2391 = tmp_C2391,C2392 = tmp_C2392,
		C2393 = tmp_C2393,C2394 = tmp_C2394,C2395 = tmp_C2395,
		CPUBLISH = tmp_CPUBLISH,cdsrc = tmp_cdsrc,mtag = my_mtag,ctag = my_ctag;
	update mt.tblcalresloc set I4201 = tmp_I4201,I4202 = tmp_I4202,I4203 = tmp_I4203,
		I4204 = tmp_I4204,I4205 = tmp_I4205,I4206 = tmp_I4206,I4207 = tmp_I4207,
		I4208 = tmp_I4208,I4209 = tmp_I4209,I4210 = tmp_I4210,I4211 = tmp_I4211,
		I4212 = tmp_I4212,I4213 = tmp_I4213,I4214 = tmp_I4214,I4215 = tmp_I4215,
		I4216 = tmp_I4216,I4217 = tmp_I4217,I4218 = tmp_I4218,I4219 = tmp_I4219,
		I4220 = tmp_I4220,I4221 = tmp_I4221,I4222 = tmp_I4222,I4223 = tmp_I4223,
		I4224 = tmp_I4224,I4225 = tmp_I4225,I4226 = tmp_I4226,I4228 = tmp_I4228,
		I4229 = tmp_I4229,I4230 = tmp_I4230,I4231 = tmp_I4231,I4232 = tmp_I4232,
		I4233 = tmp_I4233,I4234 = tmp_I4234,I4235 = tmp_I4235,I4236 = tmp_I4236,
		I4237 = tmp_I4237,I4238 = tmp_I4238,I4239 = tmp_I4239,I4240 = tmp_I4240,
		I4241 = tmp_I4241,I4242 = tmp_I4242,I4243 = tmp_I4243,I4244 = tmp_I4244,
		I4245 = tmp_I4245,I4246 = tmp_I4246,I4247 = tmp_I4247,I4248 = tmp_I4248,
		I4249 = tmp_I4249,I4250 = tmp_I4250,I4251 = tmp_I4251,I4252 = tmp_I4252,
		I4253 = tmp_I4253,I4254 = tmp_I4254,I4255 = tmp_I4255,I4256 = tmp_I4256,
		I4257 = tmp_I4257,I4258 = tmp_I4258,I4259 = tmp_I4259,I4299 = tmp_I4299,
		idsrc = tmp_idsrc,IPUBLISH = tmp_IPUBLISH,replic = tmp_replic;
	open cur_user;
	fetch next cur_user into tmp_operator,tmp_oper_level,tmp_oper_seg;
	update mt.tblcalresloc set
		operator = tmp_operator,oper_level = tmp_oper_level,oper_seg = tmp_oper_seg;
	close cur_user;
	select* from tblcalresloc order by source desc,C2502 asc;
end;;
grant execute on mt.mccalresloc to mtreports;;
comment on procedure mt.mccalresloc is 'April 2002: Fluke : Fluke calibration report.  
Uses ctag to identify a particular cal event and returns cal summary, test results, 
uut info, standards used and current location data. Source = "std" for standards data 
and "res" for cal data.';;
/*
//
// =================================================================
//
// mccalresult
//
*/
call mtxdropprocedure('mccalresult');;
CREATE procedure mt.mccalresult(in asset_ctag char(80))
result(SOURCE char(3),C2301 date,C2302 integer,C2303 date,C2304 integer,C2306 date,
C2307 char(20),C2308 char(10),C2309 numeric(12,2),C2310 numeric(5,1),C2311 numeric(6,2),C2312 numeric(6,2),
C2313 char(15),C2314 char(16),C2315 numeric(5,1),C2316 date,C2317 numeric(5,1),
C2318 char(13),C2319 char(1),C2320 char(128),C2321 char(55),C2322 char(1),
C2323 char(1),C2324 numeric(5,1),C2325 char(1),C2326 char(44),C2327 char(20),C2328 numeric(5,1),
C2329 char(44),C2330 char(10),C2331 char(1),C2332 integer,C2333 char(8),C2334 char(8),
C2335 timestamp,C2336 char(16),C2337 timestamp,C2338 char(16),C2339 integer,
C2341 char(254),C2342 date,C2343 char(8),C2344 integer,C2345 integer,C2346 integer,
C2347 integer,C2350 integer,C2351 integer,C2352 integer,C2353 integer,C2354 char(64),
C2355 char(64),C2356 char(64),C2357 char(64),C2358 char(64),C2359 char(64),C2360 char(64),
C2361 char(64),C2362 integer,C2363 char(1),C2364 char(48),C2365 char(48),C2366 char(48),
C2367 char(48),C2368 char(48),C2369 char(48),C2370 char(48),C2371 date,C2372 date,
C2373 date,C2374 date,C2375 numeric(12,2),C2376 numeric(12,2),C2377 numeric(12,2),
C2378 numeric(12,2),C2379 numeric(12,2),
C2380 date,C2381 char(8),C2382 char(1),C2383 integer,C2384 long varchar,C2385 char(128),
C2386 numeric(5,1),C2387 numeric(5,1),C2388 numeric(9,2),C2389 numeric(7,2),C2390 numeric(9,2),
C2391 numeric(7,2),C2392 numeric(2,0),C2393 char(1),C2394 char(1),C2395 char(10),C2396 char(16),
CPUBLISH char(32),CTAG  char(80),cdsrc char(3),I4201 char(60),I4202 char(30),I4203 char(30),
I4204 char(60),I4205 char(1),I4206 char(30),I4207 char(24),I4208 char(29),I4209 char(1) ,
I4210 char(12),I4211 char(15),I4212 date,I4213 char(10),I4214 char(8),I4215 char(5),
I4216 char(5),I4217 char(60),I4218 char(4),I4219 numeric(12,2),I4220 integer,I4221 date,
I4222 char(12),I4223 char(16),I4224 date,I4225 char(8),I4226 char(1),I4228 char(1),
I4229 integer,I4230 integer,I4231 char(32),I4232 char(32),I4233 char(32),I4234 char(32),
I4235 char(32),I4236 timestamp,I4237 char(16),I4238 timestamp,I4239 char(16),I4240 char(8),
I4241 char(80),I4242 char(80),I4243 char(80),I4244 char(48),I4245 char(48),I4246 char(48),
I4247 char(48),I4248 char(48),I4249 char(48),I4250 date,I4251 date,I4252 date,I4253 date,
I4254 numeric(12,2),I4255 numeric(12,2),I4256 numeric(12,2),I4257 numeric(12,2),I4258 char(1),
I4259 integer,I4260 long varchar,I4261 char(128),I4262 char(128),I4299 char(1),MTAG  char(80),
ktag  char(80),idsrc char(3),IPUBLISH  char(32),replic char(1),L2801 char(20),L2802 char(20),
L2803 char(20),L2804 char(10),L2805 char(8),L2806 date,L2807 date,L2808 integer,L2809 date,
L2810 char(8),L2811 timestamp,L2812 char(16),L2813 timestamp,L2814 char(16),L2815 integer,
L2816 char(15),L2817 numeric(12,2),L2818 numeric(12,2),L2819 numeric(12,2),L2820 numeric(12,2),
L2821 numeric(12,2),L2822 date,L2823 date,L2824 date,L2825 date,L2826 char(48),L2827 char(48),
L2828 char(48),L2829 char(48),L2830 char(48),L2831 char(48),L2832 char(48),L2833 char(48),
L2834 char(48),L2835 char(48),L2836 long varchar,L2837 char(128),LPUBLISH char(32),ltag  char(80),
ldsrc char(3),C2430 char(80),C2501 char(254),C2502 integer,std_4201 char(60),std_4202 char(30),
std_4203 char(30),std_4204 char(60),std_4205 char(1),std_4206 char(30),std_4207 char(24),
std_4208 char(29),std_4241 char(80),std_4242 char(80),std_4243 char(80),std_4244 char(48),
std_4245 char(48),std_2301 date,std_2333 char(8),std_2303 date,std_2334 char(8),std_2323 char(1),
std_ctag char(80),std_2308 char(10),std_2354 char(64),std_2355 char(64),std_2356 char(64),
K4601 char(48),K4602 char(48),K4603 char(48),K4604 char(48),K4605 char(48),K4606 char(48),
K4607 char(48),K4608 char(48),K4609 char(48),K4610 char(48),K4611 char(48),K4612 char(48),
K4613 char(48),K4614 char(48),K4615 char(48),K4616 char(48),K4617 char(48),K4618 char(48),
K4619 char(48),K4620 char(48),K4621 date,K4622 date,K4623 date,K4624 date,K4625 numeric(12,2),
K4626 numeric(12,2),K4627 numeric(12,2),K4628 numeric(12,2),K4629 timestamp,K4630 char(16),
K4631 timestamp,K4632 char(16),K4633 char(40),K4634 char(30),K4635 char(20),K4636 char(20),
K4637 char(60),K4640 char(8),KPUBLISH char(32),KDSRC char(3),operator char(60),oper_level integer,
oper_seg char(8))
begin
	declare tmp_int char(80);
	declare tmp_ktag char(80);
	declare tmp_ctag char(80);
	declare tmp_c2430 char(80);
	declare tmp_mtag char(80);
	declare my_2301 date;
	declare my_2333 char(8);
	declare my_4201 char(60);
	declare my_4202 char(30);
	declare my_4203 char(30);
	declare my_4204 char(60);
	declare my_4206 char(30);
	declare my_mtag char(80);
	declare my_ctag char(80);
	declare tmp_std_2301 date;
	declare tmp_std_2333 char(8);
	declare tmp_std_2303 date;
	declare tmp_std_2334 char(8);
	declare tmp_std_2323 char(1);
	declare tmp_std_ctag char(80);
	declare tmp_std_2308 char(10);
	declare tmp_std_2354 char(64);
	declare tmp_std_2355 char(64);
	declare tmp_std_2356 char(64);
	declare tmp_K4601 char(48);
	declare tmp_K4602 char(48);
	declare tmp_K4603 char(48);
	declare tmp_K4604 char(48);
	declare tmp_K4605 char(48);
	declare tmp_K4606 char(48);
	declare tmp_K4607 char(48);
	declare tmp_K4608 char(48);
	declare tmp_K4609 char(48);
	declare tmp_K4610 char(48);
	declare tmp_K4611 char(48);
	declare tmp_K4612 char(48);
	declare tmp_K4613 char(48);
	declare tmp_K4614 char(48);
	declare tmp_K4615 char(48);
	declare tmp_K4616 char(48);
	declare tmp_K4617 char(48);
	declare tmp_K4618 char(48);
	declare tmp_K4619 char(48);
	declare tmp_K4620 char(48);
	declare tmp_K4621 date;
	declare tmp_K4622 date;
	declare tmp_K4623 date;
	declare tmp_K4624 date;
	declare tmp_K4625 decimal(12,2);
	declare tmp_K4626 decimal(12,2);
	declare tmp_K4627 decimal(12,2);
	declare tmp_K4628 decimal(12,2);
	declare tmp_K4640 char(8);
	declare tmp_K4629 timestamp;
	declare tmp_K4630 char(16);
	declare tmp_K4631 timestamp;
	declare tmp_K4632 char(16);
	declare tmp_K4633 char(40);
	declare tmp_K4634 char(30);
	declare tmp_K4635 char(20);
	declare tmp_K4636 char(20);
	declare tmp_K4637 char(60);
	declare tmp_KPUBLISH char(32);
	declare tmp_KDSRC char(3);
	declare tmp_operator char(60);
	declare tmp_oper_level integer;
	declare tmp_oper_seg char(8);
	declare nint integer;
	declare err_notfound exception for sqlstate value '02000';
	declare curstd dynamic scroll cursor for select C2430,mtag,ctag from tblcalresloc;
	declare cur_user dynamic scroll cursor for select name,mtlevel,userlist.I4240 from
	mt.userlist,tblcalresloc where
	mtuser = tblcalresloc.C2336;
	delete from tblcalresloc;
	insert into mt.tblcalresloc(SOURCE,C2502,C2301,C2302,C2303,C2304,C2306,C2307,C2309,C2310,
		C2311,C2312,C2313,C2314,C2316,C2320,C2321,C2322,C2323,C2324,C2326,C2327,C2328,C2329,
		C2330,C2331,C2332,C2333,C2334,C2335,C2336,C2337,C2338,C2339,C2341,C2362,C2308,C2315,
		C2342,C2343,C2317,C2318,C2319,C2325,C2350,C2351,C2352,C2353,C2354,C2355,C2356,C2357,
		C2358,C2359,C2360,C2361,C2363,C2364,C2365,C2366,C2367,C2368,C2369,C2370,C2371,C2372,
		C2373,C2374,C2375,C2376,C2377,C2378,C2379,C2380,C2381,C2382,C2383,C2384,C2385,C2386,
		C2387,C2388,C2389,C2390,C2391,C2392,C2393,C2394,C2395,CPUBLISH,CTAG,
		cdsrc,I4201,I4202,I4203,I4204,I4205,I4206,I4207,I4208,I4209,I4210,I4211,I4212,I4213,
		I4214,I4215,I4216,I4217,I4218,I4219,I4220,I4221,I4222,I4223,I4224,I4225,I4226,I4228,
		I4229,I4230,I4231,I4232,I4233,I4234,I4235,I4236,I4237,I4238,I4239,I4240,I4299,I4241,
		I4242,I4243,I4244,I4245,I4246,I4247,I4248,I4249,I4250,I4251,I4252,I4253,I4254,I4255,
		I4256,I4257,I4258,I4259,I4260,I4261,I4262,mtag,idsrc,IPUBLISH,ktag,replic)
		select 'STD' as SOURCE,'0' as C2502,X.C2301,X.C2302,X.C2303,X.C2304,X.C2306,X.C2307,X.C2309,
		X.C2310,X.C2311,X.C2312,X.C2313,X.C2314,X.C2316,X.C2320,X.C2321,X.C2322,X.C2323,
		X.C2324,X.C2326,X.C2327,X.C2328,X.C2329,X.C2330,X.C2331,X.C2332,X.C2333,X.C2334,
		X.C2335,X.C2336,X.C2337,X.C2338,X.C2339,X.C2341,X.C2362,X.C2308,X.C2315,X.C2342,
		X.C2343,X.C2317,X.C2318,X.C2319,X.C2325,X.C2350,X.C2351,X.C2352,X.C2353,X.C2354,
		X.C2355,X.C2356,X.C2357,X.C2358,X.C2359,X.C2360,X.C2361,X.C2363,X.C2364,X.C2365,
		X.C2366,X.C2367,X.C2368,X.C2369,X.C2370,X.C2371,X.C2372,X.C2373,X.C2374,X.C2375,
		X.C2376,X.C2377,X.C2378,X.C2379,X.C2380,X.C2381,X.C2382,X.C2383,X.C2384,X.C2385,
		X.C2386,X.C2387,X.C2388,X.C2389,X.C2390,X.C2391,X.C2392,X.C2393,X.C2394,X.C2395,
		X.CPUBLISH,X.CTAG,
		X.cdsrc,Z.I4201,Z.I4202,Z.I4203,Z.I4204,Z.I4205,Z.I4206,Z.I4207,Z.I4208,Z.I4209,
		Z.I4210,Z.I4211,Z.I4212,Z.I4213,Z.I4214,Z.I4215,Z.I4216,Z.I4217,Z.I4218,Z.I4219,
		Z.I4220,Z.I4221,Z.I4222,Z.I4223,Z.I4224,Z.I4225,Z.I4226,Z.I4228,Z.I4229,Z.I4230,
		Z.I4231,Z.I4232,Z.I4233,Z.I4234,Z.I4235,Z.I4236,Z.I4237,Z.I4238,Z.I4239,Z.I4240,
		Z.I4299,Z.I4241,Z.I4242,Z.I4243,Z.I4244,Z.I4245,Z.I4246,Z.I4247,Z.I4248,Z.I4249,
		Z.I4250,Z.I4251,Z.I4252,Z.I4253,Z.I4254,Z.I4255,Z.I4256,Z.I4257,Z.I4258,Z.I4259,
		Z.I4260,Z.I4261,Z.I4262,Z.mtag,Z.idsrc,Z.IPUBLISH,Z.ktag,Z.replic from
		mt.calibration as X,mt.inventory as Z where
		Z.mtag = X.mtag and X.ctag = asset_ctag;
	set my_ctag=(select ctag from tblcalresloc);
	set my_mtag=(select mtag from tblcalresloc);
	set my_2301=(select C2301 from tblcalresloc);
	set my_2333=(select C2333 from tblcalresloc);
	set my_4201=(select I4201 from tblcalresloc);
	set my_4202=(select I4202 from tblcalresloc);
	set my_4203=(select I4203 from tblcalresloc);
	set my_4204=(select I4204 from tblcalresloc);
	set my_4206=(select I4206 from tblcalresloc);
	set tmp_ktag=(select ktag from tblcalresloc);
	if (tmp_ktag is not null) then
		select K4601,K4602,K4603,K4604,K4605,K4606,K4607,K4608,K4609,K4610,K4611,K4612,
				K4613,K4614,K4615,K4616,K4617,K4618,K4619,K4620,K4621,K4622,K4623,K4624,K4625,
				K4626,K4627,K4628,K4640,K4629,K4630,K4631,K4632,K4633,K4634,K4635,K4636,K4637,
				KPUBLISH,KDSRC into tmp_K4601,
				tmp_K4602,tmp_K4603,tmp_K4604,tmp_K4605,tmp_K4606,tmp_K4607,tmp_K4608,tmp_K4609,
				tmp_K4610,tmp_K4611,tmp_K4612,tmp_K4613,tmp_K4614,tmp_K4615,tmp_K4616,tmp_K4617,
				tmp_K4618,tmp_K4619,tmp_K4620,tmp_K4621,tmp_K4622,tmp_K4623,tmp_K4624,tmp_K4625,
				tmp_K4626,tmp_K4627,tmp_K4628,tmp_K4640,tmp_K4629,tmp_K4630,tmp_K4631,tmp_K4632,
				tmp_K4633,tmp_K4634,tmp_K4635,tmp_K4636,tmp_K4637,tmp_KPUBLISH,tmp_KDSRC from
				mt.customers where ktag = tmp_ktag;
			update mt.tblcalresloc set K4601 = tmp_K4601,K4602 = tmp_K4602,K4603 = tmp_K4603,
				K4604 = tmp_K4604,K4605 = tmp_K4605,K4606 = tmp_K4606,K4607 = tmp_K4607,
				K4608 = tmp_K4608,K4609 = tmp_K4609,K4610 = tmp_K4610,K4611 = tmp_K4611,
				K4612 = tmp_K4612,K4613 = tmp_K4613,K4614 = tmp_K4614,K4615 = tmp_K4615,
				K4616 = tmp_K4616,K4617 = tmp_K4617,K4618 = tmp_K4618,K4619 = tmp_K4619,
				K4620 = tmp_K4620,K4621 = tmp_K4621,K4622 = tmp_K4622,K4623 = tmp_K4623,
				K4624 = tmp_K4624,K4625 = tmp_K4625,K4626 = tmp_K4626,K4627 = tmp_K4627,
				K4628 = tmp_K4628,K4629 = tmp_K4629,K4630 = tmp_K4630,K4631 = tmp_K4631,
				K4632 = tmp_K4632,K4633 = tmp_K4633,K4634 = tmp_K4634,K4635 = tmp_K4635,
				K4636 = tmp_K4636,K4637 = tmp_K4637,K4640 = tmp_K4640,KDSRC = tmp_KDSRC,
				KPUBLISH = tmp_KPUBLISH
	end if;
	insert into mt.tblcalresloc(SOURCE,C2430,std_4201,std_4202,std_4203,std_4204,std_4205,
		std_4206,std_4207,std_4208,std_4241,std_4242,std_4243,std_4244,std_4245)
		select 'STD' as SOURCE,C2430,I4201,I4202,I4203,I4204,I4205,I4206,I4207,I4208,I4241,
		I4242,I4243,I4244,I4245 from mt.calibration,mt.inventory,mt.standards where
		calibration.ctag = standards.ctag and
		standards.C2430 = inventory.mtag and
		calibration.ctag = asset_ctag;
	insert into mt.tblcalresloc(SOURCE,C2501,C2502) select 'RES' as SOURCE,C2501,
		C2502 from mt.calibration,mt.calresults where
		calibration.ctag = calresults.ctag and
		calibration.ctag = asset_ctag order by
		C2502 asc;
	open cur_user;
	fetch next cur_user into tmp_operator,tmp_oper_level,tmp_oper_seg;
	update mt.tblcalresloc set operator = tmp_operator,oper_level = tmp_oper_level,
		oper_seg = tmp_oper_seg,ctag = my_ctag,mtag = my_mtag,C2301 = my_2301,C2333 = my_2333,
		I4201 = my_4201,I4202 = my_4202,I4203 = my_4203,I4204 = my_4204,I4206 = my_4206;
	close cur_user;
	set tmp_int=null;
	open curstd;
	set nint =1;
	Zerostdloop: loop
		fetch next curstd into tmp_c2430,tmp_mtag,tmp_ctag;
		if sqlstate = err_notfound then
			leave Zerostdloop
		end if;
		call std_ctag_from_event(tmp_c2430,tmp_ctag,tmp_int);
		if(tmp_int is not null) then
			select C2301,C2303,C2333,C2334,C2323,C2354,C2355,C2356,ctag,C2308 into tmp_std_2301,
				tmp_std_2303,tmp_std_2333,tmp_std_2334,tmp_std_2323,tmp_std_2354,tmp_std_2355,
				tmp_std_2356,tmp_std_ctag,tmp_std_2308 from mt.calibration where ctag = tmp_int;
			update mt.tblcalresloc set std_ctag = tmp_int,std_2301 = tmp_std_2301,
				std_2303 = tmp_std_2303,std_2333 = tmp_std_2333,std_2334 = tmp_std_2334,
				std_2323 = tmp_std_2323,std_2354 = tmp_std_2354,std_2355 = tmp_std_2355,
				std_2356 = tmp_std_2356,C2502=nint where
				C2430 = tmp_C2430 and
				mtag = tmp_mtag and
				ctag = tmp_ctag;
			set nint=nint+1;
		end if;
	end loop Zerostdloop;
	close curstd;
	select* from mt.tblcalresloc order by source desc,C2502 asc 
end;;
grant execute on mt.mccalresult to mtreports;;
comment on procedure mt.mccalresult is 'April 2002: Fluke : A Calibration report.  
Uses ctag to identify a particular cal event and returns cal summary, test results, 
uut info and standards used.  Source = "std" for standards data and "res" for 
cal data.';;
/*
//
// =================================================================
//
// mcktag
//
*/
call mtxdropprocedure('mcktag');;
CREATE procedure mt.mcktag(in asset_ktag char(80))
result(KTAG char(80),KPUBLISH char(32),K4601 char(48),K4602 char(48),K4603 char(48),
K4604 char(48),K4605 char(48),K4606 char(48),K4607 char(48),K4608 char(48),K4609 char(48),
K4610 char(48),K4611 char(48),K4612 char(48),K4613 char(48),K4614 char(48),K4615 char(48),
K4616 char(48),K4617 char(48),K4618 char(48),K4619 char(48),K4620 char(48),K4621 date,
K4622 date,K4623 date,K4624 date,K4625 decimal(12,2),K4626 decimal(12,2),K4627 decimal(12,2),
K4628 decimal(12,2),K4640 char(8),K4629 timestamp,K4630 char(16),K4631 timestamp,K4632 char(16),
KDSRC char(3),kreplic char(1))
begin
  select customers.KTAG,
    customers.KPUBLISH,customers.K4601,customers.K4602,
    customers.K4603,customers.K4604,customers.K4605,
    customers.K4606,
    customers.K4607,
    customers.K4608,
    customers.K4609,
    customers.K4610,
    customers.K4611,
    customers.K4612,
    customers.K4613,
    customers.K4614,
    customers.K4615,
    customers.K4616,customers.K4617,
    customers.K4618,
    customers.K4619,
    customers.K4620,
    customers.K4621,
    customers.K4622,
    customers.K4623,
    customers.K4624,
    customers.K4625,
    customers.K4626,
    customers.K4627,
    customers.K4628,
    customers.K4640,
    customers.K4629,
    customers.K4630,
    customers.K4631,
    customers.K4632,
    customers.KDSRC,
    customers.kreplic from
    mt.customers where
    ktag = asset_ktag
end;;
grant execute on mt.mcktag to mtreports;;
comment on procedure mt.mcktag is 'April 2002: Fluke :  returns information about a 
specific customer record. Input parameters is KTAG';;
/*
//
// =================================================================
//
// mcktaginventory
//
*/
call mtxdropprocedure('mcktaginventory');;
CREATE procedure mt.mcktaginventory(in asset_ktag char(80))
result(KTAG char(80),KPUBLISH char(32),K4601 char(48),K4602 char(48),K4603 char(48),
K4604 char(48),K4605 char(48),K4606 char(48),K4607 char(48),K4608 char(48),K4609 char(48),
K4610 char(48),K4611 char(48),K4612 char(48),K4613 char(48),K4614 char(48),K4615 char(48),
K4616 char(48),K4617 char(48),K4618 char(48),K4619 char(48),K4620 char(48),K4621 date,
K4622 date,K4623 date,K4624 date,K4625 decimal(12,2),K4626 decimal(12,2),K4627 decimal(12,2),
K4628 decimal(12,2),K4640 char(8),K4629 timestamp,K4630 char(16),K4631 timestamp,
K4632 char(16),KDSRC char(3),kreplic char(1),I4201 char(60),I4202 char(30),I4203 char(30),
I4204 char(60),I4205 char(1),I4206 char(30),I4207 char(24),I4208 char(29),I4209 char(1),
I4210 char(12),I4211 char(15),I4212 date,I4213 char(10),I4214 char(8),I4215 char(5),
I4216 char(5),I4217 char(60),I4218 char(4),I4219 decimal(12,2),I4220 integer,I4221 date,
I4222 char(12),I4223 char(16),I4224 date,I4225 char(8),I4226 char(1),I4228 char(1),
I4229 integer,I4230 integer,I4231 char(32),I4232 char(32),I4233 char(32),I4234 char(32),
I4235 char(32),I4236 timestamp,I4237 char(16),I4238 timestamp,I4239 char(16),I4240 char(8),
I4299 char(1),MTAG char(80),I4241 char(80),I4242 char(80),I4243 char(80),idsrc char(3),
IPUBLISH char(32),IKTAG char(80),replic char(1),I4258 char(1),I4244 char(48),I4245 char(48),
I4246 char(48),I4247 char(48),I4248 char(48),I4249 char(48),I4250 date,I4251 date,
I4252 date,I4253 date,I4254 decimal(12,2),I4255 decimal(12,2),I4256 decimal(12,2),
I4257 decimal(12,2),I4259 integer,I4260 long varchar,I4261 char(128))
begin
  select customers.KTAG,customers.KPUBLISH,
    customers.K4601,customers.K4602,customers.K4603,customers.K4604,
    customers.K4605,customers.K4606,customers.K4607,customers.K4608,
    customers.K4609,customers.K4610,customers.K4611,customers.K4612,
    customers.K4613,customers.K4614,customers.K4615,customers.K4616,
    customers.K4617,customers.K4618,customers.K4619,customers.K4620,
    customers.K4621,customers.K4622,customers.K4623,customers.K4624,
    customers.K4625,customers.K4626,customers.K4627,customers.K4628,
    customers.K4640,customers.K4629,customers.K4630,customers.K4631,
    customers.K4632,customers.KDSRC,customers.kreplic,
    Inventory.I4201,
    Inventory.I4202,Inventory.I4203,Inventory.I4204,Inventory.I4205,
    Inventory.I4206,Inventory.I4207,Inventory.I4208,Inventory.I4209,
    Inventory.I4210,Inventory.I4211,Inventory.I4212,Inventory.I4213,
    Inventory.I4214,Inventory.I4215,Inventory.I4216,Inventory.I4217,
    Inventory.I4218,Inventory.I4219,Inventory.I4220,Inventory.I4221,
    Inventory.I4222,Inventory.I4223,Inventory.I4224,Inventory.I4225,
    Inventory.I4226,Inventory.I4228,Inventory.I4229,Inventory.I4230,
    Inventory.I4231,Inventory.I4232,Inventory.I4233,Inventory.I4234,
    Inventory.I4235,Inventory.I4236,Inventory.I4237,Inventory.I4238,
    Inventory.I4239,Inventory.I4240,Inventory.I4299,Inventory.MTAG,
    Inventory.I4241,Inventory.I4242,Inventory.I4243,Inventory.idsrc,
    Inventory.IPUBLISH,Inventory.ktag,Inventory.replic,Inventory.I4258,
    Inventory.I4244,Inventory.I4245,Inventory.I4246,Inventory.I4247,
    Inventory.I4248,Inventory.I4249,Inventory.I4250,Inventory.I4251,
    Inventory.I4252,Inventory.I4253,Inventory.I4254,Inventory.I4255,
    Inventory.I4256,Inventory.I4257,Inventory.I4259,Inventory.I4260,
    Inventory.I4261 from
    mt.customers,mt.inventory where
    customers.ktag = inventory.ktag and
    customers.ktag = asset_ktag
end;;
grant execute on mt.mcktaginventory to mtreports;;
comment on procedure mt.mcktaginventory is 'April 2002: Fluke :  returns information 
about a specific customer record with its assets. Input parameters is MTAG';;
/*
//
// =================================================================
//
// mcltag
//
*/
call mtxdropprocedure('mcltag');;
CREATE procedure mt.mcltag(in asset_ltag char(80))
result(L2801 char(20),L2802 char(20),L2803 char(20),L2804 char(10),L2805 char(8),
L2806 date,L2807 date,L2808 integer,L2809 date,L2810 char(8),L2811 timestamp,
L2812 char(16),L2813 timestamp,L2814 char(16),L2815 integer,MTAG char(80),ltag char(80),
ldsrc char(3),L2816 char(15),L2817 decimal(12,2),LPUBLISH char(32),L2818 decimal(12,2),
L2819 decimal(12,2),L2820 decimal(12,2),L2821 decimal(12,2),L2822 date,L2823 date,
L2824 date,L2825 date,L2826 char(48),L2827 char(48),L2828 char(48),L2829 char(48),
L2830 char(48),L2831 char(48),L2832 char(48),L2833 char(48),L2834 char(48),
L2835 char(48),L2836 long varchar,L2837 char(128))
begin
  select Location.L2801,Location.L2802,Location.L2803,Location.L2804,
    Location.L2805,Location.L2806,Location.L2807,Location.L2808,
    Location.L2809,Location.L2810,Location.L2811,Location.L2812,
    Location.L2813,Location.L2814,Location.L2815,Location.MTAG,
    Location.ltag,Location.ldsrc,Location.L2816,Location.L2817,
    Location.LPUBLISH,Location.L2818,Location.L2819,Location.L2820,
    Location.L2821,Location.L2822,Location.L2823,Location.L2824,
    Location.L2825,Location.L2826,Location.L2827,Location.L2828,
    Location.L2829,Location.L2830,Location.L2831,Location.L2832,
    Location.L2833,Location.L2834,Location.L2835,Location.L2836,
    Location.L2837 from
    mt.location where
    ltag = asset_ltag
end;;
grant execute on mt.mcltag to mtreports;;
comment on procedure mt.mcltag is 'April 2002: Fluke :  returns information about a 
specific location record. Input parameters is LTAG';;
/*
//
// =================================================================
//
// mcltaginventory
//
*/
call mtxdropprocedure('mcltaginventory');;
CREATE procedure mt.mcltaginventory(in asset_ltag char(80))
result(I4201 char(60),I4202 char(30),I4203 char(30),I4204 char(60),I4205 char(1),
I4206 char(30),I4207 char(24),I4208 char(29),I4209 char(1),I4210 char(12),I4211 char(15),
I4212 date,I4213 char(10),I4214 char(8),I4215 char(5),I4216 char(5),I4217 char(60),
I4218 char(4),I4219 decimal(12,2),I4220 integer,I4221 date,I4222 char(12),I4223 char(16),
I4224 date,I4225 char(8),I4226 char(1),I4228 char(1),I4229 integer,I4230 integer,
I4231 char(32),I4232 char(32),I4233 char(32),I4234 char(32),I4235 char(32),
I4236 timestamp,I4237 char(16),I4238 timestamp,I4239 char(16),I4240 char(8),
I4299 char(1),MTAG char(80),I4241 char(80),I4242 char(80),I4243 char(80),idsrc char(3),
IPUBLISH char(32),ktag char(80),replic char(1),I4258 char(1),I4244 char(48),
I4245 char(48),I4246 char(48),I4247 char(48),I4248 char(48),I4249 char(48),I4250 date,
I4251 date,I4252 date,I4253 date,I4254 decimal(12,2),I4255 decimal(12,2),
I4256 decimal(12,2),I4257 decimal(12,2),I4259 integer,I4260 long varchar,I4261 char(128),
L2801 char(20),L2802 char(20),L2803 char(20),L2804 char(10),L2805 char(8),L2806 date,
L2807 date,L2808 integer,L2809 date,L2810 char(8),L2811 timestamp,L2812 char(16),
L2813 timestamp,L2814 char(16),L2815 integer,LMTAG char(80),ltag char(80),ldsrc char(3),
L2816 char(15),L2817 decimal(12,2),LPUBLISH char(32),L2818 decimal(12,2),
L2819 decimal(12,2),L2820 decimal(12,2),L2821 decimal(12,2),L2822 date,L2823 date,
L2824 date,L2825 date,L2826 char(48),L2827 char(48),L2828 char(48),L2829 char(48),
L2830 char(48),L2831 char(48),L2832 char(48),L2833 char(48),L2834 char(48),
L2835 char(48),L2836 long varchar,L2837 char(128))
begin
  select Inventory.I4201,Inventory.I4202,Inventory.I4203,Inventory.I4204,
    Inventory.I4205,Inventory.I4206,Inventory.I4207,Inventory.I4208,
    Inventory.I4209,Inventory.I4210,Inventory.I4211,Inventory.I4212,
    Inventory.I4213,Inventory.I4214,Inventory.I4215,Inventory.I4216,
    Inventory.I4217,Inventory.I4218,Inventory.I4219,Inventory.I4220,
    Inventory.I4221,Inventory.I4222,Inventory.I4223,Inventory.I4224,
    Inventory.I4225,Inventory.I4226,Inventory.I4228,Inventory.I4229,
    Inventory.I4230,Inventory.I4231,Inventory.I4232,Inventory.I4233,
    Inventory.I4234,Inventory.I4235,Inventory.I4236,Inventory.I4237,
    Inventory.I4238,Inventory.I4239,Inventory.I4240,Inventory.I4299,
    Inventory.MTAG,Inventory.I4241,Inventory.I4242,Inventory.I4243,
    Inventory.idsrc,Inventory.IPUBLISH,Inventory.ktag,Inventory.replic,
    Inventory.I4258,Inventory.I4244,Inventory.I4245,Inventory.I4246,
    Inventory.I4247,Inventory.I4248,Inventory.I4249,Inventory.I4250,
    Inventory.I4251,Inventory.I4252,Inventory.I4253,Inventory.I4254,
    Inventory.I4255,Inventory.I4256,Inventory.I4257,Inventory.I4259,
    Inventory.I4260,Inventory.I4261,
    Location.L2801,Location.L2802,Location.L2803,Location.L2804,
    Location.L2805,Location.L2806,Location.L2807,Location.L2808,
    Location.L2809,Location.L2810,Location.L2811,Location.L2812,
    Location.L2813,Location.L2814,Location.L2815,Location.MTAG,
    Location.ltag,Location.ldsrc,Location.L2816,Location.L2817,
    Location.LPUBLISH,Location.L2818,Location.L2819,Location.L2820,
    Location.L2821,Location.L2822,Location.L2823,Location.L2824,
    Location.L2825,Location.L2826,Location.L2827,Location.L2828,
    Location.L2829,Location.L2830,Location.L2831,Location.L2832,
    Location.L2833,Location.L2834,Location.L2835,Location.L2836,
    Location.L2837 from
    mt.inventory key join mt.location where
    ltag = asset_ltag
end;;
grant execute on mt.mcltaginventory to mtreports;;
comment on procedure mt.mcltaginventory is 'April 2002: Fluke :  returns information about a 
specific location record with its inventory. Input parameters is LTAG';;
/*
//
// =================================================================
//
// mcmtag
//
*/
call mtxdropprocedure('mcmtag');;
CREATE procedure mt.mcmtag(in asset_mtag char(80))
result(I4201 char(60),I4202 char(30),I4203 char(30),I4204 char(60),I4205 char(1),
I4206 char(30),I4207 char(24),I4208 char(29),I4209 char(1),I4210 char(12),
I4211 char(15),I4212 date,I4213 char(10),I4214 char(8),I4215 char(5),I4216 char(5),
I4217 char(60),I4218 char(4),I4219 decimal(12,2),I4220 integer,I4221 date,
I4222 char(12),I4223 char(16),I4224 date,I4225 char(8),I4226 char(1),I4228 char(1),
I4229 integer,I4230 integer,I4231 char(32),I4232 char(32),I4233 char(32),
I4234 char(32),I4235 char(32),I4236 timestamp,I4237 char(16),I4238 timestamp,
I4239 char(16),I4240 char(8),I4299 char(1),MTAG char(80),I4241 char(80),
I4242 char(80),I4243 char(80),idsrc char(3),IPUBLISH char(32),ktag char(80),
replic char(1),I4258 char(1),I4244 char(48),I4245 char(48),I4246 char(48),
I4247 char(48),I4248 char(48),I4249 char(48),I4250 date,I4251 date,I4252 date,
I4253 date,I4254 decimal(12,2),I4255 decimal(12,2),I4256 decimal(12,2),
I4257 decimal(12,2),I4259 integer,I4260 long varchar,I4261 char(128)) 
begin 
  select Inventory.I4201,
    Inventory.I4202,Inventory.I4203,Inventory.I4204,Inventory.I4205,
    Inventory.I4206,Inventory.I4207,Inventory.I4208,Inventory.I4209,
    Inventory.I4210,Inventory.I4211,Inventory.I4212,Inventory.I4213,
    Inventory.I4214,Inventory.I4215,Inventory.I4216,Inventory.I4217,
    Inventory.I4218,Inventory.I4219,Inventory.I4220,Inventory.I4221,
    Inventory.I4222,Inventory.I4223,Inventory.I4224,Inventory.I4225,
    Inventory.I4226,Inventory.I4228,Inventory.I4229,Inventory.I4230,
    Inventory.I4231,Inventory.I4232,Inventory.I4233,Inventory.I4234,
    Inventory.I4235,Inventory.I4236,Inventory.I4237,Inventory.I4238,
    Inventory.I4239,Inventory.I4240,Inventory.I4299,Inventory.MTAG,
    Inventory.I4241,Inventory.I4242,Inventory.I4243,Inventory.idsrc,
    Inventory.IPUBLISH,Inventory.ktag,Inventory.replic,Inventory.I4258,
    Inventory.I4244,Inventory.I4245,Inventory.I4246,Inventory.I4247,
    Inventory.I4248,Inventory.I4249,Inventory.I4250,Inventory.I4251,
    Inventory.I4252,Inventory.I4253,Inventory.I4254,Inventory.I4255,
    Inventory.I4256,Inventory.I4257,Inventory.I4259,Inventory.I4260,
    Inventory.I4261 from
    mt.inventory where
    mtag = asset_mtag
end;;
grant execute on mt.mcmtag to mtreports;;
comment on procedure mt.mcmtag is 'April 2002: Fluke :  returns information about a 
specific inventory record. Input parameters is MTAG';;
/*
//
// =================================================================
//
// mcmtagcustomer
//
*/
call mtxdropprocedure('mcmtagcustomer');;
CREATE procedure mt.mcmtagcustomer(in asset_mtag char(80))
result(expression smallint)
begin
  select* from
    mt.inventory key left outer join mt.customers where
    mtag = asset_mtag
end;;
grant execute on mt.mcmtagcustomer to mtreports;;
comment on procedure mt.mcmtagcustomer is 'April 2002: Fluke :  returns information about a 
specific inventory record with its customer. Input parameters is MTAG';;
/*
//
// =================================================================
//
// mcrtag
//
*/
call mtxdropprocedure('mcrtag');;
CREATE procedure mt.mcrtag(in asset_rtag char(80))
result(R3201 char(102),R3204 char(102),R3207 char(15),R3208 char(14),R3209 decimal(12,2),
R3210 char(15),R3211 char(14),R3212 decimal(12,2),R3213 char(15),R3214 char(14),
R3215 decimal(12,2),R3216 char(15),R3217 char(14),R3218 decimal(12,2),R3219 char(15),
R3220 char(14),R3221 decimal(12,2),R3222 char(15),R3223 char(14),R3224 decimal(12,2),
R3225 char(15),R3226 char(14),R3227 decimal(12,2),R3229 decimal(5,1),R3230 date,
R3231 decimal(12,2),R3232 decimal(12,2),R3233 char(15),R3235 decimal(12,2),R3236 char(15),
R3237 char(15),R3238 decimal(5,1),R3239 decimal(5,1),R3240 char(12),R3241 char(8),
R3242 timestamp,R3243 char(16),R3244 timestamp,R3245 char(16),R3246 integer,R3247 date,
R3248 char(8),R3249 integer,R3250 char(1),MTAG char(80),R3251 char(1),rtag char(80),
rdsrc char(3),RPUBLISH char(32),R3252 decimal(12,2),R3253 long varchar,R3254 char(48),
R3255 char(48),R3256 char(48),R3257 char(48),R3258 char(48),R3259 char(48),R3260 char(48),
R3261 date,R3262 date,R3263 date,R3264 date,R3265 decimal(12,2),R3266 decimal(12,2),
R3267 decimal(12,2),R3268 decimal(12,2),R3269 decimal(12,2),R3270 char(128))
begin
  select Repair.R3201,Repair.R3204,Repair.R3207,Repair.R3208,
    Repair.R3209,Repair.R3210,Repair.R3211,Repair.R3212,
    Repair.R3213,Repair.R3214,Repair.R3215,Repair.R3216,
    Repair.R3217,Repair.R3218,Repair.R3219,Repair.R3220,
    Repair.R3221,Repair.R3222,Repair.R3223,Repair.R3224,
    Repair.R3225,Repair.R3226,Repair.R3227,Repair.R3229,
    Repair.R3230,Repair.R3231,Repair.R3232,Repair.R3233,
    Repair.R3235,Repair.R3236,Repair.R3237,Repair.R3238,
    Repair.R3239,Repair.R3240,Repair.R3241,Repair.R3242,
    Repair.R3243,Repair.R3244,Repair.R3245,Repair.R3246,
    Repair.R3247,Repair.R3248,Repair.R3249,Repair.R3250,
    Repair.MTAG,Repair.R3251,Repair.rtag,Repair.rdsrc,
    Repair.RPUBLISH,Repair.R3252,Repair.R3253,Repair.R3254,
    Repair.R3255,Repair.R3256,Repair.R3257,Repair.R3258,
    Repair.R3259,Repair.R3260,Repair.R3261,Repair.R3262,
    Repair.R3263,Repair.R3264,Repair.R3265,Repair.R3266,
    Repair.R3267,Repair.R3268,Repair.R3269,
    Repair.R3270 from
    mt.repair where
    rtag = asset_rtag
end;;
grant execute on mt.mcrtag to mtreports;;
comment on procedure mt.mcrtag is 'April 2002: Fluke :  returns information about a specific repair record. Input parameters is RTAG';;
/*
//
// =================================================================
//
// mcrtaginventory
//
*/
call mtxdropprocedure('mcrtaginventory');;
CREATE procedure mt.mcrtaginventory(in asset_rtag char(80))
result(I4201 char(60),I4202 char(30),I4203 char(30),I4204 char(60),
I4205 char(1),I4206 char(30),I4207 char(24),I4208 char(29),I4209 char(1),
I4210 char(12),I4211 char(15),I4212 date,I4213 char(10),I4214 char(8),
I4215 char(5),I4216 char(5),I4217 char(60),I4218 char(4),I4219 decimal(12,2),
I4220 integer,I4221 date,I4222 char(12),I4223 char(16),I4224 date,I4225 char(8),
I4226 char(1),I4228 char(1),I4229 integer,I4230 integer,I4231 char(32),
I4232 char(32),I4233 char(32),I4234 char(32),I4235 char(32),I4236 timestamp,
I4237 char(16),I4238 timestamp,I4239 char(16),I4240 char(8),I4299 char(1),
MTAG char(80),I4241 char(80),I4242 char(80),I4243 char(80),idsrc char(3),
IPUBLISH char(32),ktag char(80),replic char(1),I4258 char(1),I4244 char(48),
I4245 char(48),I4246 char(48),I4247 char(48),I4248 char(48),I4249 char(48),
I4250 date,I4251 date,I4252 date,I4253 date,I4254 decimal(12,2),
I4255 decimal(12,2),I4256 decimal(12,2),I4257 decimal(12,2),I4259 integer,
I4260 long varchar,I4261 char(128),R3201 char(102),R3204 char(102),
R3207 char(15),R3208 char(14),R3209 decimal(12,2),R3210 char(15),R3211 char(14),
R3212 decimal(12,2),R3213 char(15),R3214 char(14),R3215 decimal(12,2),
R3216 char(15),R3217 char(14),R3218 decimal(12,2),R3219 char(15),R3220 char(14),
R3221 decimal(12,2),R3222 char(15),R3223 char(14),R3224 decimal(12,2),
R3225 char(15),R3226 char(14),R3227 decimal(12,2),R3229 decimal(5,1),R3230 date,
R3231 decimal(12,2),R3232 decimal(12,2),R3233 char(15),R3235 decimal(12,2),
R3236 char(15),R3237 char(15),R3238 decimal(5,1),R3239 decimal(5,1),
R3240 char(12),R3241 char(8),R3242 timestamp,R3243 char(16),R3244 timestamp,
R3245 char(16),R3246 integer,R3247 date,R3248 char(8),R3249 integer,
R3250 char(1),RMTAG char(80),R3251 char(1),rtag char(80),rdsrc char(3),
RPUBLISH char(32),R3252 decimal(12,2),R3253 long varchar,R3254 char(48),
R3255 char(48),R3256 char(48),R3257 char(48),R3258 char(48),R3259 char(48),
R3260 char(48),R3261 date,R3262 date,R3263 date,R3264 date,R3265 decimal(12,2),
R3266 decimal(12,2),R3267 decimal(12,2),R3268 decimal(12,2),R3269 decimal(12,2),
R3270 char(128))
begin
  select Inventory.I4201,Inventory.I4202,Inventory.I4203,Inventory.I4204,
    Inventory.I4205,Inventory.I4206,Inventory.I4207,Inventory.I4208,
    Inventory.I4209,Inventory.I4210,Inventory.I4211,Inventory.I4212,
    Inventory.I4213,Inventory.I4214,Inventory.I4215,Inventory.I4216,
    Inventory.I4217,Inventory.I4218,Inventory.I4219,Inventory.I4220,
    Inventory.I4221,Inventory.I4222,Inventory.I4223,Inventory.I4224,
    Inventory.I4225,Inventory.I4226,Inventory.I4228,Inventory.I4229,
    Inventory.I4230,Inventory.I4231,Inventory.I4232,Inventory.I4233,
    Inventory.I4234,Inventory.I4235,Inventory.I4236,Inventory.I4237,
    Inventory.I4238,Inventory.I4239,Inventory.I4240,Inventory.I4299,
    Inventory.MTAG,Inventory.I4241,Inventory.I4242,Inventory.I4243,
    Inventory.idsrc,Inventory.IPUBLISH,Inventory.ktag,Inventory.replic,
    Inventory.I4258,Inventory.I4244,Inventory.I4245,Inventory.I4246,
    Inventory.I4247,Inventory.I4248,Inventory.I4249,Inventory.I4250,
    Inventory.I4251,Inventory.I4252,Inventory.I4253,Inventory.I4254,
    Inventory.I4255,Inventory.I4256,Inventory.I4257,Inventory.I4259,
    Inventory.I4260,Inventory.I4261,
    Repair.R3201,Repair.R3204,Repair.R3207,Repair.R3208,Repair.R3209,
    Repair.R3210,Repair.R3211,Repair.R3212,Repair.R3213,Repair.R3214,
    Repair.R3215,Repair.R3216,Repair.R3217,Repair.R3218,Repair.R3219,
    Repair.R3220,Repair.R3221,Repair.R3222,Repair.R3223,Repair.R3224,
    Repair.R3225,Repair.R3226,Repair.R3227,Repair.R3229,Repair.R3230,
    Repair.R3231,Repair.R3232,Repair.R3233,Repair.R3235,Repair.R3236,
    Repair.R3237,Repair.R3238,Repair.R3239,Repair.R3240,Repair.R3241,
    Repair.R3242,Repair.R3243,Repair.R3244,Repair.R3245,Repair.R3246,
    Repair.R3247,Repair.R3248,Repair.R3249,Repair.R3250,Repair.MTAG,
    Repair.R3251,Repair.rtag,Repair.rdsrc,Repair.RPUBLISH,Repair.R3252,
    Repair.R3253,Repair.R3254,Repair.R3255,Repair.R3256,Repair.R3257,
    Repair.R3258,Repair.R3259,Repair.R3260,Repair.R3261,Repair.R3262,
    Repair.R3263,Repair.R3264,Repair.R3265,Repair.R3266,Repair.R3267,
    Repair.R3268,Repair.R3269,
    Repair.R3270 from
    mt.inventory key join mt.repair where repair.rtag = asset_rtag
end;;
grant execute on mt.mcrtaginventory to mtreports;;
comment on procedure mt.mcrtaginventory is 'April 2002: Fluke : returns information about a 
specific maintenance record with its inventory. Input parameters is RTAG';;
/*
//
// =================================================================
//
// mt_add_segregate
//
*/
call mtxdropprocedure('mt_add_segregate');;
CREATE procedure mt.mt_add_segregate(in in_seg char(8),inout rtn integer)
begin
    /*
    MT_ADD_SEGREGATE
    can only be executed by the MT user.
    Return values:
    1 = success.
    0 = general failure.
    -1 = seg is empty.
    -2 = seg has a single quote.
    -3 = seg has embedded space.
    -4 = seg starts with a number.
    -5 = seg found. (already exists)
    -6 = segregate specified is "MT"
    -7 = segregate specified is "STD"
    paramters:
    in_seg - the users segregate value (mt.userlist)
    */
  declare seg char(8);
  declare sout char(256);
  declare sout2 char(256);
  declare itmp integer;
  if(in_seg is null) then
    set seg=''
  else
    set seg=trim(in_seg)
  end if;
  set itmp=byte_length(seg);
  if(itmp = 0) then
    set rtn=-1;
    return
  end if;
  if(locate(seg,'''') > 0) then
    set rtn=-2;
    return
  end if;
  if(locate(seg,' ') > 0) then
    set rtn=-3;
    return
  end if;
  set sout=substr(seg,1,1);
  if((sout <= '9') and(sout >= '0')) then
    set rtn=-4;
    return
  end if;
  if(seg = 'mt') then
    set rtn=-6;
    return
  end if;
  if(seg = 'std') then
    set rtn=-7;
    return
  end if;
  if(exists(select I4240 from mt.segregate where I4240 = seg)) then
    set rtn=-5;
    return
  end if;
  set sout='grant connect to '+seg;
  execute immediate(sout);
  set sout='insert into mt.segregate (I4240) values ('''+seg+''')';
  execute immediate(sout);
  set sout='insert into mt.valfield values (''4240'', '''+seg+''')';
  execute immediate(sout);
  set sout='create view '+seg+'.inventory as select * from mt.inventory where inventory.I4240 =''STD'' ';
  set sout2='or inventory.I4240 = '''+seg+'''';
  execute immediate(sout || sout2);
  set sout='create view '+seg+'.customers as select * from mt.customers where customers.K4640 =''STD'' ';
  set sout2='or customers.K4640 = '''+seg+'''';
  execute immediate(sout || sout2);
  set sout='create view '+seg+'.calibration as select * from mt.calibration where calibration.mtag in ';
  set sout2='(select mtag from mt.inventory where inventory.I4240 =''STD'' or inventory.I4240 = '''+seg+''')';
  execute immediate(sout || sout2);
  set sout='create view '+seg+'.location as select * from mt.location where location.mtag in ';
  execute immediate(sout || sout2);
  set sout='create view '+seg+'.repair as select * from mt.repair where repair.mtag in ';
  execute immediate(sout || sout2);
  set sout='create view '+seg+'.calresults as select * from mt.calresults where calresults.mtag in ';
  execute immediate(sout || sout2);
  set sout='create view '+seg+'.standards as select * from mt.standards where standards.mtag in ';
  execute immediate(sout || sout2);
  set sout='create view '+seg+'.results as select * from mt.results where results.mtag in ';
  execute immediate(sout || sout2);
  set sout='create view '+seg+'.results_raw as select * from mt.results_raw where results_raw.mtag in ';
  execute immediate(sout || sout2);
  set rtn=1
end;;
grant execute on mt.mt_add_segregate to mtreports;;
comment on procedure mt.mt_add_segregate is 'April 2002: Fluke : ';;
/*
//
//
// =============================================================================
//
// MT_CAL_DELETE
//
//check for and drop procedure
*/
call mtxdropprocedure('mt_cal_delete');;
/* Delete an calibration event from the database. */
CREATE procedure mt.mt_cal_delete(in ctag char(80),in seg char(8))
begin
  declare sout char(128);
  set sout='delete from '+seg+'.calresults where ctag = '''+ctag+'''';
  execute immediate sout;
  set sout='delete from '+seg+'.results_raw where ctag = '''+ctag+'''';
  execute immediate sout;
  set sout='delete from '+seg+'.results where ctag = '''+ctag+'''';
  execute immediate sout;
  set sout='delete from '+seg+'.standards where ctag = '''+ctag+'''';
  execute immediate sout;
  set sout='delete from '+seg+'.calibration where ctag = '''+ctag+'''';
  execute immediate(sout);
end;;
grant execute on mt.mt_cal_delete to mtreports;;
//
comment on procedure mt.mt_cal_delete is 'April 2002: Fluke procedure to Delete a Calibration Event from the database';;
/*
//
// =================================================================
//
// mt_calc_due_date
//
*/
call mtxdropprocedure('mt_calc_due_date');;
CREATE procedure mt.mt_calc_due_date(in caldate char(10),in caltime char(8),in passfail char(1),in inttype char(1),in interval integer,inout duedate char(10) default '',inout duetime char(8) default '',inout rtn integer default 1)
begin
  declare itmp integer;
  declare Cdate date;
  declare Ddate date;
  declare nameday char(10);
  declare namechk integer;
  declare finalchk integer;
  declare madechange integer;
  set rtn=-7;
  set itmp=byte_length(caldate);
  if(itmp = 0) then
    set rtn=-1;
    message 'caldate is blank';
    return
  end if;
  set itmp=byte_length(passfail);
  if(itmp = 0) then
    set rtn=-2;
    message 'passfail is blank';
    return
  end if;
  set itmp=byte_length(inttype);
  if(itmp = 0) then
    set rtn=-3;
    message 'inttype is blank';
    return
  end if;
  set itmp=byte_length(caltime);
  if(itmp = 0) then
    set rtn=-5;
    message 'caltime is blank';
    return
  end if;
  if((interval =0) and (inttype <> 'N')) then
	set duedate = caldate;
	set duetime = caltime;
	set rtn = 1;
	return;
  end if;
  if((interval > 0) and(inttype = 'n')) then
    set rtn=-4;
    message 'interval greater than zero and type is N';
    return
  end if;
  if(passfail <> 'y') then
    set duedate=caldate;
    set duetime=caltime;
    set rtn=1;
    message 'due date is ',duedate;
    return
  end if;
  if(inttype = 'u') then
    set rtn=1;
    return
  end if;
  if(interval = 0) then
    set rtn=1;
    return
  end if;
  set Cdate="DATE"(caldate);
  case inttype when 'u' then
    set rtn=1;
    return when 'd' then
    set Ddate=DAYS(Cdate,interval) when 'w' then
    set Ddate=WEEKS(Cdate,interval) when 'm' then
    set Ddate=MONTHS(Cdate,interval)
  else
    set rtn=-6;
    return
  end case
  ;
  set finalchk=0;
  while(finalchk = 0) loop
    set madechange=0;
    set nameday=dayname(Ddate);
    set namechk=0;
    while(namechk = 0) loop
      if(exists(select dayofweek from nonworkdays where dayofweek = nameday)) then
        set Ddate=DAYS(Ddate,-1);
        set nameday=dayname(Ddate);
        set madechange=1
      else set namechk=1
      end if
    end loop;
    set namechk=0;
    while(namechk = 0) loop
      if(exists(select holiday from holidays where holiday = Ddate)) then
        set Ddate=DAYS(Ddate,-1);
        set madechange=1
      else set namechk=1
      end if
    end loop;
    if(madechange = 0) then
      set finalchk=1
    end if
  end loop;
  if(Ddate < Cdate) then
    set Ddate=Cdate
  end if;
  set rtn=1;
  set duedate=Ddate;
  set duetime=caltime;
end;;
grant execute on mt_calc_due_date to mtreports;;
comment on procedure mt.mt_calc_due_date is 'April 2002: Fluke : ';;
/*
//
// =================================================================
//
// mt_del_segregate
//
*/
call mtxdropprocedure('mt_del_segregate');;
CREATE procedure mt.mt_del_segregate(in in_seg char(8),inout rtn integer)
begin
    /*
    can only be executed by the MT user.
    Return values:
    1 = success.
    0 = general failure.
    -1 = seg is empty.
    -2 = seg has a single quote.
    -3 = seg has embedded space.
    -4 = seg starts with a number.
    -5 = seg not found. (cant be deleted)
    -6 = segregate specified is "MT"
    -7 = segregate specified is "STD"
    -8 = users are assigned to this segregate.
    -9 = assets are assigned to this segregate.
    paramters:
    in_seg - the users segregate value (mt.userlist)
    */
  declare seg char(8);
  declare sout char(256);
  declare itmp integer;
  if(in_seg is null) then
    set seg=''
  else
    set seg=trim(in_seg)
  end if;
  set itmp=byte_length(seg);
  if(itmp = 0) then set rtn=-1;
    return
  end if;
  if(locate(seg,'''') > 0) then
    set rtn=-2;
    return
  end if;
  if(locate(seg,' ') > 0) then
    set rtn=-3;
    return
  end if;
  set sout=substr(seg,1,1);
  if((sout <= '9') and(sout >= '0')) then
    set rtn=-4;
    return
  end if;
  if(seg = 'mt') then
    set rtn=-6;
    return
  end if;
  if(seg = 'std') then set
      rtn=-7;
    return
  end if;
  if(not exists(select I4240 from mt.segregate where I4240 = seg)) then
    set rtn=-5;
    return
  end if;
  if(exists(select I4240 from mt.userlist where I4240 = seg)) then
    set rtn=-8;
    return
  end if;
  if(exists(select I4240 from mt.inventory where I4240 = seg)) then
    set rtn=-9;
    return
  end if;
  set sout='revoke connect from '+seg;
  execute immediate(sout);
  set sout='delete from mt.segregate where I4240='''+seg+'''';
  execute immediate(sout);
  set sout='delete from mt.valfield where fldnum=''4240'' and val='''+seg+'''';
  execute immediate(sout);
  set rtn=1
end;;
comment on procedure mt.mt_del_segregate is 'April 2002: Fluke : ';;
/*
//
// =============================================================================================
//
//
// MT_INV_DELETE
// Delete an asset from the database.
//
*/
call mtxdropprocedure('mt_inv_delete');;
CREATE procedure mt.mt_inv_delete(in mtag char(80),in seg char(8))
begin
  declare sout char(128);
  set sout='delete from '+seg+'.calresults where mtag ='''+mtag+'''';
  execute immediate(sout);
  set sout='delete from '+seg+'.results_raw where mtag ='''+mtag+'''';
  execute immediate(sout);
  set sout='delete from '+seg+'.results where mtag ='''+mtag+'''';
  execute immediate(sout);
  set sout='delete from '+seg+'.standards where mtag ='''+mtag+'''';
  execute immediate(sout);
  set sout='delete from '+seg+'.standards where C2430 ='''+mtag+'''';
  execute immediate(sout);
  set sout='delete from '+seg+'.calibration where mtag ='''+mtag+'''';
  execute immediate(sout);
  set sout='delete from '+seg+'.location where mtag ='''+mtag+'''';
  execute immediate(sout);
  set sout='delete from '+seg+'.repair where mtag ='''+mtag+'''';
  execute immediate(sout);
  set sout='delete from mt.assethistory where mtag ='''+mtag+'''';
  execute immediate(sout);
  set sout='delete from '+seg+'.inventory where mtag ='''+mtag+'''';
  execute immediate(sout);
end;;
grant execute on mt_inv_delete to mtreports;;
comment on procedure mt.mt_inv_delete is 'April 2002: Fluke procedure to Delete an asset from the database';
/*
//
//
//
// ================================================================
//
// MT_NUKE_USER
// A utility procedure that DELETES all traces ofa specified user
//
//
*/
call mtxdropprocedure('mt_nuke_user');;
CREATE procedure mt.mt_nuke_user(in tmp_user char(60))
begin
  declare cmd char(256);
  message 'nuking user ',tmp_user;
  delete from mt.userlist where mtuser = tmp_user;
  set cmd='drop table '+tmp_user+'.trace';
  execute immediate cmd;
  set cmd='drop table '+tmp_user+'.reports';
  execute immediate cmd;
  set cmd='revoke connect from '+tmp_user;
  execute immediate cmd
end;;
//
comment on procedure mt.mt_nuke_user is 'April 2002: Fluke: Delete a user';;
/*
//
// ====================================================================================
//
// MT_NUM_STD
// Count up how many times a given asset is used in the standards table.
//
*/
call mtxdropprocedure('mt_num_std');;
CREATE procedure mt.mt_num_std(in mtag_std char(80),inout num_used integer)
begin
  declare this_cursor dynamic scroll cursor for select count(ctag) from
    mt.standards where c2430 = mtag_std;open this_cursor;
  fetch next this_cursor into num_used;
  close this_cursor
end;;
grant execute on mt_num_std to mtreports;;
comment on procedure mt.mt_num_std is 'April 2002: Fluke procedure to 
Count up how many times a given asset is used in the standards table';
/*
//
// =================================================================
//
// mt_std_in_cal
//
*/
call mtxdropprocedure('mt_std_in_cal');;
CREATE procedure mt.mt_std_in_cal(in stdtag char(80),in caldate char(10),in caltime char(8),inout rtn integer default 0)
begin
  declare err_notfound exception for sqlstate value '02000';
  declare itmp integer;
  declare std_caldate char(10);
  declare std_caltime char(10);
  declare std_duedate char(10);
  declare std_duetime char(10);
  declare std_pf char(1);
  declare std_calstamp integer;
  declare int_type char(1);
  declare this_cursor dynamic scroll cursor for select C2301,C2333,C2303,C2334,
      C2323,(seconds('1970-01-01',C2301)+seconds(current date,C2333)) as foo from
      mt.calibration where
      mtag = stdtag and
      (foo < (seconds('1970-01-01',caldate)+seconds(current date,caltime))) order by
      foo desc;set rtn=-7;
  set itmp=byte_length(caldate);
  if(itmp = 0) then
    set rtn=-1;
    message 'caldate is blank';
    return
  end if;
  set itmp=byte_length(stdtag);
  if(itmp = 0) then
    set rtn=-2;
    message 'stdtag is blank';
    return
  end if;
  set itmp=byte_length(caltime);
  if(itmp = 0) then
    set rtn=-3;
    message 'caltime is blank';
    return
  end if;
  set int_type=(select I4228 from mt.inventory where mtag = stdtag);
  if('N' = int_type) then
    set rtn=1;
    return
  end if;
  open this_cursor;
  fetch next this_cursor into std_caldate,std_caltime,std_duedate,std_duetime,std_pf,std_calstamp;
  if sqlstate = err_notfound then
    set rtn=-4;
    return
  end if;
  if('N' = std_pf) then
    set rtn=-5;
    return
  end if;
  set itmp=ifnull(std_duedate,0,1);
  if(0 = itmp) then
    set rtn=1;
    return
  end if;
  if((seconds('1970-01-01',caldate)+seconds(current date,caltime)) > (seconds('1970-01-01',std_duedate)+seconds(current date,std_duetime))) then
    set rtn=-6;
    return
  end if;
  close this_cursor;
  set rtn=1
end;;
grant execute on mt.mt_std_in_cal to mtreports;;
comment on procedure mt.mt_std_in_cal is 'April 2002: Fluke : ';;
/*
//
// =================================================================
//
// mt_user
//
*/
call mtxdropprocedure('mt_user');;
CREATE procedure mt.mt_user(in in_codename char(15),in in_fullname char(60),in in_passwd char(16),in in_seg char(8),
    in in_level integer,in in_rate char(12) default '0',in in_flag integer,inout rtn integer default 1)
begin
    declare codename char(15);
    declare fullname char(60);
    declare passwd char(16);
    declare seg char(8);
    declare nlevel char(1);
    declare itmp integer;
    declare T_fullname char(60);
    declare T_seg char(8);
    declare T_level integer;
    declare tracetable1 char(128);
    declare tracetable2 char(128);
    declare rep1 char(128);
    declare rep2 char(128);
    declare rep3 char(128);
    declare rep4 char(128);
    declare rep5 char(128);
    declare rep6 char(128);
    declare user1 char(128);
    declare permis1 char(64);
    declare permis2 char(64);
    declare permis3 char(64);
    declare sout char(10480);
    declare err_notfound exception for sqlstate value '02000';
    declare cur_user dynamic scroll cursor for select name,mtlevel,I4240 from mt.userlist where mtuser = codename;
    set rtn=0;
    set tracetable1='(T4201 char(60),T2301 date,T2333 char(8), Tident integer, Tflag char(8), mtag char(80),';
    set tracetable2='T2303 date,T2334 char(8),branch integer NOT NULL,rowid integer NOT NULL,PRIMARY KEY (rowid))';
    set rep1='(rgroup char(32) default ''DefaultGroup'',rgrptype char(1) default ''N'',';
    set rep2='rtype char(3) default ''GEN'',filename char(128) NOT NULL,response1 char(32),';
    set rep3='resctrl1 char(1),response2 char(32),resctrl2 char(1),response3 char(32),resctrl3 char(1),';
    set rep4='response4 char(32),resctrl4 char(1),response5 char(32),resctrl5 char(1),';
    set rep5='rperiod char(1) default ''O'',nexttime timestamp,lasttime timestamp,';
    set rep6='goutput char(1) default ''S'',gremove char(1) default ''1'')';
    set user1='insert into mt.userlist (mtuser, mtlevel, name, I4240, rate) values (';
    if(in_codename is null) then
        set codename=''
    else
        set codename=trim(in_codename)
    end if;
    if(in_passwd is null) then
        set passwd=''
    else
        set passwd=trim(in_passwd)
    end if;
    if(in_fullname is null) then
        set fullname=''
    else
        set fullname=trim(in_fullname)
    end if;
    if(in_seg is null) then
        set seg=''
    else
        set seg=trim(in_seg)
    end if;
    if((in_level < 0) or(in_level > 5)) then
        set nlevel=0
    else
        set nlevel=in_level
    end if;
    set itmp=byte_length(codename);
    if(itmp = 0) then
        set rtn=-13;
        return
    end if;
    if(locate(codename,'''') > 0) then
        set rtn=-5;
        return
    end if;
    if(locate(codename,' ') > 0) then
        set rtn=-11;
        return
    end if;
    set sout=substr(codename,1,1);
        if((sout <= '9') and(sout >= '0')) then
        set rtn=-9;
        return
    end if;
    set itmp=byte_length(passwd);
    if(itmp = 0) then
        set rtn=-14;
        return
    end if;
    if(locate(passwd,'''') > 0) then
        set rtn=-6;
        return
    end if;
    if(locate(passwd,' ') > 0) then
        set rtn=-12;
        return
    end if;
    set sout=substr(passwd,1,1);
        if((sout <= '9') and(sout >= '0')) then
        set rtn=-10;
        return
    end if;
    if(exists(select I4240 from mt.segregate where I4240 = codename)) then
        set rtn=-2;
        return
    end if;
    if(in_flag = 1) then
        if(exists(select name from mt.userlist where mtuser = codename)) then
            set rtn=-1;
            return
        else
            set itmp=byte_length(fullname);
            if(itmp = 0) then
                set rtn=-15;
                return
            end if;
            set itmp=byte_length(seg);
            if(itmp = 0) then
                set rtn=-16;
                return
            end if
        end if
    end if;
    if(locate(seg,'''') > 0) then
        set rtn=-7;
        return
    end if;
    if(locate(fullname,'''') > 0) then
        set rtn=-8;
        return
    end if;
    if(in_flag = 0) then
        if(exists(select name from mt.userlist where mtuser = codename)) then
            open cur_user;
            fetch next cur_user into T_fullname,T_level,T_seg;
            close cur_user;
            set itmp=byte_length(fullname);
            if(itmp = 0) then
                set fullname=T_fullname
            end if;
            set itmp=byte_length(seg);
            if(itmp = 0) then
                set seg=T_seg
            end if;
            set sout='revoke connect from '+codename;
            execute immediate(sout);
            set sout='delete from mt.userlist where mtuser ='''+codename+'''';
            execute immediate(sout)
        else set rtn=-3;
            return
        end if
    end if;
    set sout='grant connect to '+codename+' identified by '+passwd;
    execute immediate(sout);
    if (not exists (select table_id from 
	    sys.systable where table_name = 'trace' and 
	    creator = (select user_id from sys.sysuserperm where user_name=codename))) 
	    then
	    set sout='create table '+codename+'.trace'+tracetable1 + tracetable2;
	    execute immediate(sout);
    end if;
    if (not exists (select table_id from 
	    sys.systable where table_name = 'reports' and 
	    creator = (select user_id from sys.sysuserperm where user_name=codename))) 
    then
	    set sout='CREATE table '+codename+'.reports '+rep1+rep2+rep3+rep4+rep5+rep6;
	    execute immediate(sout);
    end if;
    delete from mt.userlist where mtuser=codename;
    set sout=user1+' '''+codename+''','''+nlevel+''','''+fullname+''','''+seg+''','''+in_rate+''')';
    execute immediate(sout);
    set sout='grant membership in group mtreports to '+codename;
    execute immediate(sout);
    set sout='grant select on mt.userlist to '+codename;
    execute immediate(sout);
    set sout='grant select on mt.customiz to '+codename;
    execute immediate(sout);
    set sout='grant select on mt.segregate to '+codename;
    execute immediate(sout);
    set sout='grant select on mt.assetlist to '+codename;
    execute immediate(sout);
    set sout='grant select on mt.customerlist to '+codename;
    execute immediate(sout);
    set sout='grant select on mt.reports to '+codename;
    execute immediate(sout);
    set sout='grant select on mt.assethistory to '+codename;
    execute immediate(sout);
    set sout='grant select on '+seg+'.inventory to '+codename;
    execute immediate(sout);
    set sout='grant select on '+seg+'.calibration to '+codename;
    execute immediate(sout);
    set sout='grant select on '+seg+'.location to '+codename;
    execute immediate(sout);
    set sout='grant select on '+seg+'.repair to '+codename;
    execute immediate(sout);
    set sout='grant select on '+seg+'.standards to '+codename;
    execute immediate(sout);
    set sout='grant select on '+seg+'.calresults to '+codename;
    execute immediate(sout);
    set sout='grant select on '+seg+'.results to '+codename;
    execute immediate(sout);
    set sout='grant select on '+seg+'.results_raw to '+codename;
    execute immediate(sout);
    set sout='grant select on '+seg+'.customers to '+codename;
    execute immediate(sout);
    if(nlevel < 1) then
        set rtn=1;
        return
    end if;
    if(nlevel < 4) then
        set permis1='grant insert, update on ';
        set permis2='grant insert on ';
        set permis3='grant insert, update, delete on '
        else
        set permis1='grant insert, update, delete on ';
        set permis2=permis1;
        set permis3=permis1
    end if;
    if(seg <> 'mt') then
        set sout=permis1+seg+'.inventory to '+codename;
        execute immediate(sout);
        set sout=permis2+seg+'.calibration to '+codename;
        execute immediate(sout);
        set sout=permis2+seg+'.location to '+codename;
        execute immediate(sout);
        set sout=permis2+seg+'.repair to '+codename;
        execute immediate(sout);
        set sout=permis3+seg+'.standards to '+codename;
        execute immediate(sout);
        set sout=permis3+seg+'.calresults to '+codename;
        execute immediate(sout);
        set sout=permis3+seg+'.results to '+codename;
        execute immediate(sout);
        set sout=permis3+seg+'.results_raw to '+codename;
        execute immediate(sout);
        set sout=permis1+seg+'.customers to '+codename;
        execute immediate(sout)
    end if;
    set sout=permis1+'mt.inventory to '+codename;
    execute immediate(sout);
    set sout=permis2+'mt.calibration to '+codename;
    execute immediate(sout);
    set sout=permis2+'mt.location to '+codename;
    execute immediate(sout);
    set sout=permis2+'mt.repair to '+codename;
    execute immediate(sout);
    set sout=permis2+'mt.reports to '+codename;
    execute immediate(sout);
    set sout=permis2+'mt.assethistory to '+codename;
    execute immediate(sout);
    set sout=permis3+'mt.standards to '+codename;
    execute immediate(sout);
    set sout=permis3+'mt.calresults to '+codename;
    execute immediate(sout);
    set sout=permis3+'mt.results to '+codename;
    execute immediate(sout);
    set sout=permis3+'mt.results_raw to '+codename;
    execute immediate(sout);
    set sout=permis1+'mt.customers to '+codename;
    execute immediate(sout);
    set sout='grant select on std.inventory to '+codename;
    execute immediate(sout);
    set rtn=1;
end;;
comment on procedure mt.mt_user is 'January 2003: Fluke : Fluke procedure to Add and Modify Users';;
/*
//
// =================================================================
//
// rep_archive
//
*/
call mtxdropprocedure('rep_archive');;
CREATE procedure mt.rep_archive(in inv_mtag char(80))
begin
  declare err_notfound exception for sqlstate value '02000';
  declare currep dynamic scroll cursor for select rtag from
      mt.repair where repair.mtag = inv_mtag order by R3230 desc,R3241 desc;
  declare cur_rtag char(80);
  declare cur_flag integer;
  set cur_flag=1;
  open currep;
  Zeroloop: loop
    fetch next currep into cur_rtag;
    if sqlstate = err_notfound then
      leave Zeroloop
    end if;
    if sqlstate = err_notfound then
      leave Zeroloop
    end if;
    update repair set R3246 = cur_flag where rtag = cur_rtag;
    if(cur_flag > 0) then
      set cur_flag=0
    end if
  end loop Zeroloop;
  close currep
end;;
comment on procedure mt.rep_archive is 'April 2002: Fluke : Archive bit logic';;
/*
//
//
// ================================================================
//
// REP_ASSET
//
*/
call mtxdropprocedure('rep_asset');;
//
//
call mtxmsg('','create procedure rep_asset');;
//
//
CREATE procedure mt.rep_asset(in uut char(30),in lolimit char(10),in uplimit char(10))
result(R3201 char(102),R3204 char(102),R3207 char(15),R3208 char(14),R3209 double,R3210 char(15),
R3211 char(14),R3212 double,R3213 char(15),R3214 char(14),R3215 double,R3216 char(15),
R3217 char(14),R3218 double,R3219 char(15),R3220 char(14),R3221 double,R3222 char(15),
R3223 char(14),R3224 double,R3225 char(15),R3226 char(14),R3227 double,R3229 double,R3230 date,
R3231 double,R3232 double,R3233 char(15),R3235 double,R3236 char(15),R3237 char(15),R3238 double,
R3239 double,R3240 char(12),R3241 char(8),R3242 timestamp,R3243 char(16),R3244 timestamp,
R3245 char(16),R3246 integer,R3247 date,R3248 char(8),R3249 integer,R3250 char(1),R3251 char(1),
rtag char(80),I4201 char(60),I4202 char(30),I4203 char(30),I4204 char(60),I4205 char(1),
I4206 char(30),I4207 char(24),I4208 char(29),I4209 char(1),I4210 char(12),I4211 char(15),
I4212 date,I4213 char(10),I4214 char(8),I4215 char(5),I4216 char(5),I4217 char(30),I4218 char(4),
I4219 double,I4220 integer,I4221 date,I4222 char(12),I4223 char(16),I4224 date,I4225 char(8),
I4226 char(1),I4228 char(1),I4229 integer,I4230 integer,I4231 char(32),I4232 char(32),
I4233 char(32),I4234 char(32),I4235 char(32),I4236 timestamp,I4237 char(16),I4238 timestamp,
I4239 char(16),I4240 char(8),I4241 char(80),I4242 char(80),I4243 char(80),I4299 char(1),
MTAG char(80),uut char(30),lolimit char(10),uplimit char(10))
begin
  declare err_notfound exception for sqlstate value '02000';
  select rp.R3201,rp.R3204,rp.R3207,rp.R3208,rp.R3209,rp.R3210,rp.R3211,rp.R3212,rp.R3213,
    rp.R3214,rp.R3215,rp.R3216,rp.R3217,rp.R3218,rp.R3219,rp.R3220,rp.R3221,rp.R3222,
    rp.R3223,rp.R3224,rp.R3225,rp.R3226,rp.R3227,rp.R3229,rp.R3230,rp.R3231,rp.R3232,
    rp.R3233,rp.R3235,rp.R3236,rp.R3237,rp.R3238,rp.R3239,rp.R3240,rp.R3241,rp.R3242,
    rp.R3243,rp.R3244,rp.R3245,rp.R3246,rp.R3247,rp.R3248,rp.R3249,rp.R3250,rp.R3251,
    rp.rtag,INV.I4201,INV.I4202,INV.I4203,INV.I4204,INV.I4205,INV.I4206,INV.I4207,
    INV.I4208,INV.I4209,INV.I4210,INV.I4211,INV.I4212,INV.I4213,INV.I4214,INV.I4215,
    INV.I4216,INV.I4217,INV.I4218,INV.I4219,INV.I4220,INV.I4221,INV.I4222,INV.I4223,
    INV.I4224,INV.I4225,INV.I4226,INV.I4228,INV.I4229,INV.I4230,INV.I4231,INV.I4232,
    INV.I4233,INV.I4234,INV.I4235,INV.I4236,INV.I4237,INV.I4238,INV.I4239,INV.I4240,
    INV.I4241,INV.I4242,INV.I4243,INV.I4299,INV.MTAG,uut as uut,lolimit as lolimit,
    uplimit as uplimit from
    mt.repair as rp,mt.inventory as Inv where
    Inv.mtag = rp.mtag and Inv.I4201 like uut and rp.R3230 <= uplimit and rp.R3230 >= lolimit order by
    Inv.mtag asc,R3230 asc
end;;
//
//
GRANT EXECUTE ON Rep_asset TO mtreports;;
//
comment on procedure mt.rep_asset is 
'April 2002: Returns information about repair events based on asset number.  Input 
parameters: uut = asset # or %, lolimit = starting date, uplimit = ending 
date.';;
/*
//
// ================================================================
//
// REP_TECH
//
*/
call mtxdropprocedure('rep_tech');;
CREATE procedure mt.rep_tech(in reptech char(15),in lolimit char(10),in uplimit char(10))
result(R3201 char(102),R3204 char(102),R3207 char(15),R3208 char(14),R3209 double,R3210 char(15),
R3211 char(14),R3212 double,R3213 char(15),R3214 char(14),R3215 double,R3216 char(15),R3217 char(14),
R3218 double,R3219 char(15),R3220 char(14),R3221 double,R3222 char(15),R3223 char(14),R3224 double,
R3225 char(15),R3226 char(14),R3227 double,R3229 double,R3230 date,R3231 double,R3232 double,
R3233 char(15),R3235 double,R3236 char(15),R3237 char(15),R3238 double,R3239 double,R3240 char(12),
R3241 char(8),R3242 timestamp,R3243 char(16),R3244 timestamp,R3245 char(16),R3246 integer,R3247 date,
R3248 char(8),R3249 integer,R3250 char(1),R3251 char(1),rtag char(80),I4201 char(60),I4202 char(30),
I4203 char(30),I4204 char(60),I4205 char(1),I4206 char(30),I4207 char(24),I4208 char(29),
I4209 char(1),I4210 char(12),I4211 char(15),I4212 date,I4213 char(10),I4214 char(8),I4215 char(5),
I4216 char(5),I4217 char(30),I4218 char(4),I4219 double,I4220 integer,I4221 date,I4222 char(12),
I4223 char(16),I4224 date,I4225 char(8),I4226 char(1),I4228 char(1),I4229 integer,I4230 integer,
I4231 char(32),I4232 char(32),I4233 char(32),I4234 char(32),I4235 char(32),I4236 timestamp,
I4237 char(16),I4238 timestamp,I4239 char(16),I4240 char(8),I4241 char(80),I4242 char(80),
I4243 char(80),I4299 char(1),MTAG char(80),reptech char(30),lolimit char(10),uplimit char(10))
begin
  declare err_notfound exception for sqlstate value '02000';
  select rp.R3201,rp.R3204,rp.R3207,rp.R3208,rp.R3209,rp.R3210,rp.R3211,rp.R3212,
    rp.R3213,rp.R3214,rp.R3215,rp.R3216,rp.R3217,rp.R3218,rp.R3219,rp.R3220,rp.R3221,
    rp.R3222,rp.R3223,rp.R3224,rp.R3225,rp.R3226,rp.R3227,rp.R3229,rp.R3230,rp.R3231,
    rp.R3232,rp.R3233,rp.R3235,rp.R3236,rp.R3237,rp.R3238,rp.R3239,rp.R3240,rp.R3241,
    rp.R3242,rp.R3243,rp.R3244,rp.R3245,rp.R3246,rp.R3247,rp.R3248,rp.R3249,rp.R3250,
    rp.R3251,rp.rtag,
    INV.I4201,INV.I4202,INV.I4203,INV.I4204,INV.I4205,INV.I4206,INV.I4207,INV.I4208,
    INV.I4209,INV.I4210,INV.I4211,INV.I4212,INV.I4213,INV.I4214,INV.I4215,INV.I4216,
    INV.I4217,INV.I4218,INV.I4219,INV.I4220,INV.I4221,INV.I4222,INV.I4223,INV.I4224,
    INV.I4225,INV.I4226,INV.I4228,INV.I4229,INV.I4230,INV.I4231,INV.I4232,INV.I4233,
    INV.I4234,INV.I4235,INV.I4236,INV.I4237,INV.I4238,INV.I4239,INV.I4240,INV.I4241,
    INV.I4242,INV.I4243,INV.I4299,INV.MTAG,
    reptech as reptech,lolimit as lolimit,
    uplimit as uplimit from
    mt.repair as rp,mt.inventory as Inv where
    Inv.mtag = rp.mtag and
    rp.R3233 like reptech and
    rp.R3230 <= uplimit and
    rp.R3230 >= lolimit order by
    Inv.mtag asc,R3230 asc
end;;
GRANT EXECUTE ON Rep_tech TO mtreports;;
comment on procedure mt.rep_tech is
'April 2002: Returns information about repair events based on repair tech.  Input 
parameters: reptech = technician or %, lolimit = starting date, uplimit = ending 
date.';;
/*
//
// =================================================================
//
// reset_archive
//
*/
call mtxdropprocedure('reset_archive');;
CREATE procedure mt.reset_archive()
begin
  declare tmp_mtag char(80);
  declare err_notfound exception for sqlstate value '02000';
  declare cur_mtag dynamic scroll cursor for select mtag from mt.inventory;
  open cur_mtag;
  Zeroloop: loop
    fetch next cur_mtag into tmp_mtag;
    if sqlstate = err_notfound then
      leave Zeroloop
    end if;
    call cal_archive(tmp_mtag);
    call loc_archive(tmp_mtag);
    call rep_archive(tmp_mtag)
  end loop Zeroloop;
  close cur_mtag
end;;
comment on procedure mt.reset_archive is 'April 2002: Fluke : Resets all archive bits
by sequentially calling the stored procedure for the individual archive bit logic.';;
/*
// =============================================================================
//
//        STD_CTAG_FROM_EVENT
//
//
//
//check for and drop procedure
*/
call mtxdropprocedure('std_ctag_from_event');;
//
create procedure mt.std_ctag_from_event(in mtag_std char(80),in ctag_asset char(80),out std_ctag char(80))
begin
  declare err_notfound exception for sqlstate value '02000';
  declare cur_ctag char(80);
  declare passfail char(1);
  declare intervaltype char(1);
  declare due_datetime integer;
  declare this_cursor dynamic scroll cursor for select ctag,C2323,I4228,(Seconds('1970-01-01',C2303)+seconds(current date,c2334)) from
      mt.calibration,mt.inventory where
      calibration.mtag = mtag_std and
      calibration.mtag = inventory.mtag and(
      Seconds('1970-01-01',C2301)+seconds(current date,c2333)) < (select Seconds('1970-01-01',C2301)+seconds(current date,c2333) from
        mt.calibration where ctag = ctag_asset) order by
      C2301 desc,C2333 desc;
  open this_cursor;
  set std_ctag=null;
  ctag_loop: loop
    fetch next this_cursor into cur_ctag,passfail,intervaltype,due_datetime;
    if sqlstate = err_notfound then
      leave ctag_loop
    end if;
    set std_ctag=cur_ctag;
    if intervaltype = 'N' then
      set std_ctag=0
    end if;
    if passfail = 'N' then
      set std_ctag=0
    end if;
    if(due_datetime < Seconds('1970-01-03')) then
      leave ctag_loop
    end if;
    if(due_datetime < (select Seconds('1970-01-01',C2301)+seconds(current date,c2333) from mt.calibration where ctag = ctag_asset)) then
      set std_ctag=0
    end if;
    leave ctag_loop
  end loop ctag_loop;
  close this_cursor
end;;
//
// grant permission on the procedure.
GRANT EXECUTE ON "mt"."std_ctag_from_event" TO "mtreports";;
//
comment on procedure mt.std_ctag_from_event is
'April 2002: This is a sub-procedure which is called from other stored procedures.  Returns 
the valid calibration ctag for a particular standard used in a cal event.  Input 
parameters mtag_std and ctag_asset identify a unique UUT cal event and 
standard.';;
/*
// =============================================================================
//
//        Stds_Used
//
//
//
//check for and drop procedure
*/
call mtxdropprocedure('Stds_Used');;
//
CREATE PROCEDURE mt."Stds_Used" (in asset_ctag char(80))

Result (

Stds_Used_C2430 char (80) ,Stds_Used_Standards_CTAG char (80) ,

Stds_Used_I4201 char (60) ,Stds_Used_I4202 char (30) ,Stds_Used_I4203 char (30) ,Stds_Used_I4204 char (60) ,
Stds_Used_I4205 char (1) ,Stds_Used_I4206 char (30) ,Stds_Used_I4207 char (24) ,Stds_Used_I4208 char (29) ,
Stds_Used_I4209 char (1) ,Stds_Used_I4210 char (12) ,Stds_Used_I4211 char (15) ,Stds_Used_I4212 date ,
Stds_Used_I4213 char (10) ,Stds_Used_I4214 char (8) ,Stds_Used_I4215 char (5) ,Stds_Used_I4216 char (5) ,
Stds_Used_I4217 char (60) ,Stds_Used_I4218 char (4) ,Stds_Used_I4219 numeric (12) ,Stds_Used_I4220 integer ,
Stds_Used_I4221 date ,Stds_Used_I4222 char (12) ,Stds_Used_I4223 char (16) ,Stds_Used_I4224 date ,
Stds_Used_I4225 char (8) ,Stds_Used_I4226 char (1) ,Stds_Used_I4228 char (1) ,Stds_Used_I4229 integer ,
Stds_Used_I4230 integer ,Stds_Used_I4231 char (32) ,Stds_Used_I4232 char (32) ,Stds_Used_I4233 char (32) ,
Stds_Used_I4234 char (32) ,Stds_Used_I4235 char (32) ,Stds_Used_I4236 timestamp ,Stds_Used_I4237 char (16) ,
Stds_Used_I4238 timestamp ,Stds_Used_I4239 char (16) ,Stds_Used_I4240 char (8) ,Stds_Used_I4299 char (1) ,
Stds_Used_Inventory_MTAG char (80) ,Stds_Used_I4241 char (80) ,Stds_Used_I4242 char (80) ,Stds_Used_I4243 char (80) ,
Stds_Used_ktag char (80) ,Stds_Used_I4258 char (1) ,Stds_Used_I4244 char (48) ,Stds_Used_I4245 char (48) ,
Stds_Used_I4246 char (48) ,Stds_Used_I4247 char (48) ,Stds_Used_I4248 char (48) ,Stds_Used_I4249 char (48) ,
Stds_Used_I4250 date ,Stds_Used_I4251 date ,Stds_Used_I4252 date ,Stds_Used_I4253 date ,
Stds_Used_I4254 numeric (12) ,Stds_Used_I4255 numeric (12) ,Stds_Used_I4256 numeric (12) ,Stds_Used_I4257 numeric (12) ,
Stds_Used_I4259 integer ,Stds_Used_I4260 long varchar  ,Stds_Used_I4261 char (128) ,Stds_Used_I4262 char (128) ,

Stds_Used_C2301 date ,Stds_Used_C2302 integer ,Stds_Used_C2303 date ,Stds_Used_C2304 integer ,
Stds_Used_C2306 date ,Stds_Used_C2307 char (20) ,Stds_Used_C2309 numeric (12) ,Stds_Used_C2310 numeric (5) ,
Stds_Used_C2311 decimal (6) ,Stds_Used_C2312 decimal (6) ,Stds_Used_C2313 char (15) ,Stds_Used_C2314 char (16) ,
Stds_Used_C2316 date ,Stds_Used_C2320 char (128) ,Stds_Used_C2321 char (55) ,Stds_Used_C2322 char (1) ,
Stds_Used_C2323 char (1) ,Stds_Used_C2324 numeric (5) ,Stds_Used_C2326 char (44) ,Stds_Used_C2327 char (20) ,
Stds_Used_C2328 numeric (5) ,Stds_Used_C2329 char (44) ,Stds_Used_C2330 char (10) ,Stds_Used_C2331 char (1) ,
Stds_Used_C2332 integer ,Stds_Used_C2333 char (8) ,Stds_Used_C2334 char (8) ,Stds_Used_C2335 timestamp ,
Stds_Used_C2336 char (16) ,Stds_Used_C2337 timestamp ,Stds_Used_C2338 char (16) ,Stds_Used_C2339 integer ,
Stds_Used_C2341 char (254) ,Stds_Used_Calibration_MTAG char (80) ,Stds_Used_Calibration_CTAG char (80) ,
Stds_Used_C2362 integer ,Stds_Used_C2308 char (10) ,Stds_Used_C2315 numeric (5) ,Stds_Used_C2342 date ,
Stds_Used_C2343 char (8) ,Stds_Used_C2317 numeric (5) ,Stds_Used_C2318 char (13) ,Stds_Used_C2319 char (1) ,
Stds_Used_C2325 char (1) ,Stds_Used_C2350 integer ,Stds_Used_C2351 integer ,Stds_Used_C2352 integer ,
Stds_Used_C2353 integer ,Stds_Used_C2354 char (64) ,Stds_Used_C2355 char (64) ,Stds_Used_C2356 char (64) ,
Stds_Used_C2357 char (64) ,Stds_Used_C2358 char (64) ,Stds_Used_C2359 char (64) ,Stds_Used_C2360 char (64) ,
Stds_Used_C2361 char (64) ,Stds_Used_C2363 char (1) ,Stds_Used_cdsrc char (3) ,Stds_Used_C2382 char (1) ,
Stds_Used_C2364 char (48) ,Stds_Used_C2365 char (48) ,Stds_Used_C2366 char (48) ,Stds_Used_C2367 char (48) ,
Stds_Used_C2368 char (48) ,Stds_Used_C2369 char (48) ,Stds_Used_C2370 char (48) ,Stds_Used_C2371 date ,
Stds_Used_C2372 date ,Stds_Used_C2373 date ,Stds_Used_C2374 date ,Stds_Used_C2375 numeric (12) ,
Stds_Used_C2376 numeric (12) ,Stds_Used_C2377 numeric (12) ,Stds_Used_C2378 numeric (12) ,Stds_Used_C2379 numeric (12) ,
Stds_Used_C2380 date ,Stds_Used_C2383 integer ,Stds_Used_C2384 long varchar  ,Stds_Used_C2385 char (128) ,
Stds_Used_C2344 integer ,Stds_Used_C2345 integer ,Stds_Used_C2346 integer ,Stds_Used_C2347 integer ,
Stds_Used_C2386 numeric (5) ,Stds_Used_C2387 numeric (5) ,Stds_Used_C2388 numeric (9) ,Stds_Used_C2389 numeric (7) ,
Stds_Used_C2390 numeric (9) ,Stds_Used_C2391 numeric (7) ,Stds_Used_C2392 numeric (2) ,Stds_Used_C2393 char (1) ,
Stds_Used_C2394 char (1) ,Stds_Used_C2395 char (10) ,Stds_Used_C2396 char (16) ,Stds_Used_combine char (3), 

Stds_Used_L2801 char (20) ,Stds_Used_L2802 char (20) ,Stds_Used_L2803 char (20) ,Stds_Used_L2804 char (10) ,
Stds_Used_L2805 char (8) ,Stds_Used_L2806 Date ,Stds_Used_L2807 Date ,Stds_Used_L2808 Integer ,Stds_Used_L2809 Date ,
Stds_Used_L2810 char (8) ,Stds_Used_L2811 timestamp ,Stds_Used_L2812 char (16) ,Stds_Used_L2813 timestamp ,
Stds_Used_L2814 char (16) ,Stds_Used_L2815 Integer ,Stds_Used_Location_MTAG char (80) ,Stds_Used_ltag char (80) ,
Stds_Used_ldsrc char (3) ,Stds_Used_L2816 char (15) ,Stds_Used_L2817 decimal (12) ,Stds_Used_L2818 numeric (12) ,
Stds_Used_L2819 numeric (12) ,Stds_Used_L2820 numeric (12) ,Stds_Used_L2821 numeric (12) ,Stds_Used_L2822 Date ,
Stds_Used_L2823 Date ,Stds_Used_L2824 Date ,Stds_Used_L2825 Date ,Stds_Used_L2826 char (48) ,Stds_Used_L2827 char (48) ,
Stds_Used_L2828 char (48) ,Stds_Used_L2829 char (48) ,Stds_Used_L2830 char (48) ,Stds_Used_L2831 char (48) ,
Stds_Used_L2832 char (48) ,Stds_Used_L2833 char (48) ,Stds_Used_L2834 char (48) ,Stds_Used_L2835 char (48) ,
Stds_Used_L2836 long varchar ,Stds_Used_L2837 char (128) 
)
BEGIN
    SELECT 
        Stds_Used_C2430 ,Stds_Used_Standards_CTAG ,

        Stds_Used_I4201 ,Stds_Used_I4202 ,Stds_Used_I4203 ,Stds_Used_I4204 ,Stds_Used_I4205 ,Stds_Used_I4206 ,Stds_Used_I4207 ,
        Stds_Used_I4208 ,Stds_Used_I4209 ,Stds_Used_I4210 ,Stds_Used_I4211 ,Stds_Used_I4212 ,Stds_Used_I4213 ,Stds_Used_I4214 ,
        Stds_Used_I4215 ,Stds_Used_I4216 ,Stds_Used_I4217 ,Stds_Used_I4218 ,Stds_Used_I4219 ,Stds_Used_I4220 ,Stds_Used_I4221 ,
        Stds_Used_I4222 ,Stds_Used_I4223 ,Stds_Used_I4224 ,Stds_Used_I4225 ,Stds_Used_I4226 ,Stds_Used_I4228 ,Stds_Used_I4229 ,
        Stds_Used_I4230 ,Stds_Used_I4231 ,Stds_Used_I4232 ,Stds_Used_I4233 ,Stds_Used_I4234 ,Stds_Used_I4235 ,Stds_Used_I4236 ,
        Stds_Used_I4237 ,Stds_Used_I4238 ,Stds_Used_I4239 ,Stds_Used_I4240 ,Stds_Used_I4299 ,Stds_Used_Inventory_MTAG ,
        Stds_Used_I4241 ,Stds_Used_I4242 ,Stds_Used_I4243 ,Stds_Used_ktag ,Stds_Used_I4258 ,Stds_Used_I4244 ,Stds_Used_I4245 ,
        Stds_Used_I4246 ,Stds_Used_I4247 ,Stds_Used_I4248 ,Stds_Used_I4249 ,Stds_Used_I4250 ,Stds_Used_I4251 ,Stds_Used_I4252 ,
        Stds_Used_I4253 ,Stds_Used_I4254 ,Stds_Used_I4255 ,Stds_Used_I4256 ,Stds_Used_I4257 ,Stds_Used_I4259 ,Stds_Used_I4260 ,
        Stds_Used_I4261 ,Stds_Used_I4262 ,

        Stds_Used_C2301 ,Stds_Used_C2302 ,Stds_Used_C2303 ,Stds_Used_C2304 ,Stds_Used_C2306 ,Stds_Used_C2307 ,Stds_Used_C2309 ,
        Stds_Used_C2310 ,Stds_Used_C2311 ,Stds_Used_C2312 ,Stds_Used_C2313 ,Stds_Used_C2314 ,Stds_Used_C2316 ,Stds_Used_C2320 ,
        Stds_Used_C2321 ,Stds_Used_C2322 ,Stds_Used_C2323 ,Stds_Used_C2324 ,Stds_Used_C2326 ,Stds_Used_C2327 ,Stds_Used_C2328 ,
        Stds_Used_C2329 ,Stds_Used_C2330 ,Stds_Used_C2331 ,Stds_Used_C2332 ,Stds_Used_C2333 ,Stds_Used_C2334 ,Stds_Used_C2335 ,
        Stds_Used_C2336 ,Stds_Used_C2337 ,Stds_Used_C2338 ,Stds_Used_C2339 ,Stds_Used_C2341 ,Stds_Used_Calibration_MTAG ,
        Stds_Used_Calibration_CTAG ,Stds_Used_C2362 ,Stds_Used_C2308 ,Stds_Used_C2315 ,Stds_Used_C2342 ,Stds_Used_C2343 ,
        Stds_Used_C2317 ,Stds_Used_C2318 ,Stds_Used_C2319 ,Stds_Used_C2325 ,Stds_Used_C2350 ,Stds_Used_C2351 ,Stds_Used_C2352 ,
        Stds_Used_C2353 ,Stds_Used_C2354 ,Stds_Used_C2355 ,Stds_Used_C2356 ,Stds_Used_C2357 ,Stds_Used_C2358 ,Stds_Used_C2359 ,
        Stds_Used_C2360 ,Stds_Used_C2361 ,Stds_Used_C2363 ,Stds_Used_cdsrc ,Stds_Used_C2382 ,Stds_Used_C2364 ,Stds_Used_C2365 ,
        Stds_Used_C2366 ,Stds_Used_C2367 ,Stds_Used_C2368 ,Stds_Used_C2369 ,Stds_Used_C2370 ,Stds_Used_C2371 ,Stds_Used_C2372 ,
        Stds_Used_C2373 ,Stds_Used_C2374 ,Stds_Used_C2375 ,Stds_Used_C2376 ,Stds_Used_C2377 ,Stds_Used_C2378 ,Stds_Used_C2379 ,
        Stds_Used_C2380 ,Stds_Used_C2383 ,Stds_Used_C2384 ,Stds_Used_C2385 ,Stds_Used_C2344 ,Stds_Used_C2345 ,Stds_Used_C2346 ,
        Stds_Used_C2347 ,Stds_Used_C2386 ,Stds_Used_C2387 ,Stds_Used_C2388 ,Stds_Used_C2389 ,Stds_Used_C2390 ,Stds_Used_C2391 ,
        Stds_Used_C2392 ,Stds_Used_C2393 ,Stds_Used_C2394 ,Stds_Used_C2395 ,Stds_Used_C2396 ,Stds_Used_combine,

        Stds_Used_L2801 ,Stds_Used_L2802 ,Stds_Used_L2803 ,Stds_Used_L2804 ,Stds_Used_L2805 ,Stds_Used_L2806 ,
        Stds_Used_L2807 ,Stds_Used_L2808 ,Stds_Used_L2809 ,Stds_Used_L2810 ,Stds_Used_L2811 ,Stds_Used_L2812 ,Stds_Used_L2813 ,
        Stds_Used_L2814 ,Stds_Used_L2815 ,Stds_Used_Location_MTAG ,Stds_Used_ltag ,Stds_Used_ldsrc ,Stds_Used_L2816 ,
        Stds_Used_L2817 ,Stds_Used_L2818 ,Stds_Used_L2819 ,Stds_Used_L2820 ,Stds_Used_L2821 ,Stds_Used_L2822 ,Stds_Used_L2823 ,
        Stds_Used_L2824 ,Stds_Used_L2825 ,Stds_Used_L2826 ,Stds_Used_L2827 ,Stds_Used_L2828 ,Stds_Used_L2829 ,Stds_Used_L2830 ,
        Stds_Used_L2831 ,Stds_Used_L2832 ,Stds_Used_L2833 ,Stds_Used_L2834 ,Stds_Used_L2835 ,Stds_Used_L2836 ,Stds_Used_L2837 

        FROM mt.Stds_Used
        WHERE Stds_Used_Standards_CTAG like asset_ctag;

END;;
GRANT EXECUTE ON "mt"."Stds_Used" TO "mtreports";;
/*
// =============================================================================
//
//        total_L2808_to_I4230
//
//
//
//check for and drop procedure
*/
call mtxdropprocedure('total_L2808_to_I4230');;
CREATE PROCEDURE mt."total_L2808_to_I4230" (MTAGin char(80))
BEGIN
    declare inttype char(1);
    declare caldate date;
    declare caltime char(8);
    declare thislocdate date;
    declare thisloctime char(8);
    declare usescurrent integer;
    declare usesthis integer;
    declare err_notfound exception for sqlstate value '02000';
    declare cur_locs dynamic scroll cursor for select L2808, L2809, L2810 from
    location where L2809 >= caldate and mtag=MTAGin;
    set usescurrent = 0;
    set inttype = (select I4228 from inventory where mtag = MTAGin);
    if (inttype = 'U') then
        set caldate = (select C2301 from calibration where mtag = MTAGin and C2339 = 1);
        set caltime = (select C2333 from calibration where mtag = MTAGin and C2339 = 1);
        open cur_locs;
        usesloop: loop
            fetch next cur_locs into usesthis, thislocdate, thisloctime;
            if sqlstate = err_notfound then
                leave usesloop
            end if;
            if (thislocdate = caldate) then
	            if (thisloctime >= caltime) then
		            if (usesthis is null) then
		                set usesthis = 0;
		            end if;
		            if (usesthis < 0) then
		                set usesthis = 0;
		            end if;
		            set usescurrent = usescurrent + usesthis;
	            end if;
            else
	            if (usesthis is null) then
	                set usesthis = 0;
	            end if;
	            if (usesthis < 0) then
	                set usesthis = 0;
	            end if;
	            set usescurrent = usescurrent + usesthis;
            end if;
        end loop usesloop;
        update inventory set I4230=usescurrent where mtag=MTAGin;
    end if; 
END;;
GRANT EXECUTE ON "mt"."total_L2808_to_I4230" TO "mtreports";;
comment on procedure mt.std_ctag_from_event is
'September 2002: when called by location insert or update triggers, this sums the values 
in multiple location.L2808 uses since the current calibration was performed and saves the 
result into I4230.';;
/*
// =============================================================================
//
//        Ver_7_Certificates
//
//
//
//check for and drop procedure
*/
call mtxdropprocedure('Ver_7_Certificates');;
//
CREATE procedure mt.Ver_7_Certificates(in asset_ctag char(80))
result(
Calibration_CTAG char(80),Results_ctag char(80),row_num integer,C2301 date,
C2302 integer,C2303 date,C2304 integer,C2306 date,C2307 char(20),
C2309 numeric(12),C2310 numeric(5),C2311 decimal(6),C2312 decimal(6),
C2313 char(15),C2314 char(16),C2316 date,C2320 char(128),C2321 char(55),
C2322 char(1),C2323 char(1),C2324 numeric(5),C2326 char(44),C2327 char(20),
C2328 numeric(5),C2329 char(44),C2330 char(10),C2331 char(1),C2332 integer,
C2333 char(8),C2334 char(8),C2335 timestamp,C2336 char(16),C2337 timestamp,
C2338 char(16),C2339 integer,C2341 char(254),Calibration_MTAG char(80),
C2362 integer,C2308 char(10),C2315 numeric(5),C2342 date,C2343 char(8),
C2317 numeric(5),C2318 char(13),C2319 char(1),C2325 char(1),C2350 integer,
C2351 integer,C2352 integer,C2353 integer,C2354 char(64),C2355 char(64),
C2356 char(64),C2357 char(64),C2358 char(64),C2359 char(64),C2360 char(64),
C2361 char(64),C2363 char(1),cdsrc char(3),C2381 char(8),C2382 char(1),
C2364 char(48),C2365 char(48),C2366 char(48),C2367 char(48),C2368 char(48),
C2369 char(48),C2370 char(48),C2371 date,C2372 date,C2373 date,C2374 date,
C2375 numeric(12),C2376 numeric(12),C2377 numeric(12),C2378 numeric(12),
C2379 numeric(12),C2380 date,C2383 integer,C2384 long varchar,
C2385 char(128),C2344 integer,C2345 integer,C2346 integer,C2347 integer,
C2386 numeric(5),C2387 numeric(5),C2388 numeric(9),C2389 numeric(7),
C2390 numeric(9),C2391 numeric(7),C2392 numeric(2),C2393 char(1),
C2394 char(1),C2395 char(10),C2396 char(16),

Customers_KTAG char(80),K4601 char(48),K4602 char(48),K4603 char(48),
K4604 char(48),K4605 char(48),K4606 char(48),K4607 char(48),K4608 char(48),
K4609 char(48),K4610 char(48),K4611 char(48),K4612 char(48),K4613 char(48),
K4614 char(48),K4615 char(48),K4616 char(48),K4617 char(48),K4618 char(48),
K4619 char(48),K4620 char(48),K4621 date,K4622 date,K4623 date,K4624 date,
K4625 numeric(12),K4626 numeric(12),K4627 numeric(12),K4628 numeric(12),
K4640 char(8),K4629 timestamp,K4630 char(16),K4631 timestamp,K4632 char(16),
KDSRC char(3),kreplic char(1),K4633 char(40),K4634 char(30),K4635 char(20),
K4636 char(20),K4637 char(60),

I4201 char(60),I4202 char(30),I4203 char(30),
I4204 char(60),I4205 char(1),I4206 char(30),I4207 char(24),I4208 char(29),
I4209 char(1),I4210 char(12),I4211 char(15),I4212 date,I4213 char(10),
I4214 char(8),I4215 char(5),I4216 char(5),I4217 char(60),I4218 char(4),
I4219 numeric(12),I4220 integer,I4221 date,I4222 char(12),I4223 char(16),
I4224 date,I4225 char(8),I4226 char(1),I4228 char(1),I4229 integer,
I4230 integer,I4231 char(32),I4232 char(32),I4233 char(32),I4234 char(32),
I4235 char(32),I4236 timestamp,I4237 char(16),I4238 timestamp,
I4239 char(16),I4240 char(8),I4299 char(1),Inventory_MTAG char(80),
I4241 char(80),I4242 char(80),I4243 char(80),idsrc char(3),
Inventory_ktag char(80),replic char(1),I4258 char(1),I4244 char(48),
I4245 char(48),I4246 char(48),I4247 char(48),I4248 char(48),I4249 char(48),
I4250 date,I4251 date,I4252 date,I4253 date,I4254 numeric(12),
I4255 numeric(12),I4256 numeric(12),I4257 numeric(12),I4259 integer,
I4260 long varchar,I4261 char(128),I4262 char(128),

L2801 char(20),L2802 char(20),L2803 char(20),L2804 char(10),L2805 char(8),
L2806 date,L2807 date,L2808 integer,L2809 date,L2810 char(8),L2811 timestamp,
L2812 char(16),L2813 timestamp,L2814 char(16),L2815 integer,
Location_MTAG char(80),ltag char(80),ldsrc char(3),L2816 char(15),
L2817 decimal(12),L2818 numeric(12),L2819 numeric(12),L2820 numeric(12),
L2821 numeric(12),L2822 date,L2823 date,L2824 date,L2825 date,L2826 char(48),
L2827 char(48),L2828 char(48),L2829 char(48),L2830 char(48),L2831 char(48),
L2832 char(48),L2833 char(48),L2834 char(48),L2835 char(48),
L2836 long varchar,L2837 char(128),

test_desc char(254),fixq char(32),
fixq_p char(1),fixq_u char(16),varq char(32),varq_p char(1),varq_u char(16),
lower_limit char(32),lower_limit_p char(1),lower_limit_u char(16),
upper_limit char(32),upper_limit_p char(1),upper_limit_u char(16),
test_status char(32),exp_uncert char(32),exp_uncert_p char(1),
exp_uncert_u char(16),std_uncert char(32),std_uncert_p char(1),
std_uncert_u char(16),cov_fac char(32),condition char(32),remark char(254),
cpt char(32),cpt_p char(1),cpt_u char(16),fix_flag integer,nominal char(32),
nominal_p char(1),nominal_u char(16),mod1 char(32),mod1_p char(1),
mod1_u char(16),sys_actual char(32),sys_actual_p char(1),
sys_actual_u char(16),corr_flag integer,uut_ind char(32),uut_ind_p char(1),
uut_ind_u char(16),expv char(32),expv_p char(1),expv_u char(16),
measurement char(32),measurement_p char(1),measurement_u char(16),
meas_flag integer,dev char(32),dev_p char(1),dev_u char(16),error char(32),
error_p char(1),error_u char(16),rel_err char(32),rel_err_p char(1),
rel_err_u char(16),corr char(32),corr_p char(1),corr_u char(16),
corr_unc char(32),corr_unc_p char(1),corr_unc_u char(16),tol_ref char(32),
tol_neg char(32),tol_neg_p char(1),tol_neg_u char(16),tol_pos char(32),
tol_pos_p char(1),tol_pos_u char(16),tol char(32),tol_p char(1),
tol_u char(16),tur char(32),tol_err char(32),tol_err_p char(1),
tol_err_u char(16),uncert_method char(32),nthrow integer,num_meas integer,
sdev char(32),sdev_p char(1),sdev_u char(16),noisy_flag integer,
reliable_flag integer,st_t char(32),st_t_flag integer,ws_flag integer,
dominant integer,df1 char(16),df2 char(16),df3 char(16),df4 char(16),
df5 char(16),df6 char(16),df7 char(16),df8 char(16),df9 char(16),
df10 char(16),deg_free char(16),u1 char(32),u1_p char(1),u1_u char(16),
u2 char(32),u2_p char(1),u2_u char(16),u3 char(32),u3_p char(1),
u3_u char(16),u4 char(32),u4_p char(1),u4_u char(16),u5 char(32),
u5_p char(1),u5_u char(16),u6 char(32),u6_p char(1),u6_u char(16),
u7 char(32),u7_p char(1),u7_u char(16),u8 char(32),u8_p char(1),
u8_u char(16),u9 char(32),u9_p char(1),u9_u char(16),u10 char(32),
u10_p char(1),u10_u char(16),c1 char(32),c2 char(32),c3 char(32),
c4 char(32),c5 char(32),c6 char(32),c7 char(32),c8 char(32),c9 char(32),
c10 char(32),s1 char(32),s1_p char(1),s1_u char(16),s2 char(32),
s2_p char(1),s2_u char(16),dom_uncert char(32),dom_uncert_p char(1),
dom_uncert_u char(16),test_step char(64),fsc char(16),result_type char(32),
accred integer,guardband_meth char(32),guardband_ll char(32),
guardband_ll_p char(1),guardband_ll_u char(16),guardband_ul char(32),
guardband_ul_p char(1),guardband_ul_u char(16),sys_acc char(32),
sys_acc_p char(1),sys_acc_u char(16),sys_cov_fac char(32),uut_range char(32),
uut_range_p char(1),uut_range_u char(16),uut_res char(32),uut_res_p char(1),
uut_res_u char(16),sense char(32),i_imped char(32),i_imped_p char(1),
i_imped_u char(16),o_imped1 char(32),o_imped1_p char(1),o_imped1_u char(16),
o_imped2 char(32),o_imped2_p char(1),o_imped2_u char(16),wave1 char(32),
ampl1 char(32),ampl1_p char(1),ampl1_u char(16),freq1 char(32),
freq1_p char(1),freq1_u char(16),per1 char(32),per1_p char(1),
per1_u char(16),pulse_width char(32),pulse_width_p char(1),
pulse_width_u char(16),dc_offset char(32),dc_offset_p char(1),
dc_offset_u char(16),duty_cycle char(32),duty_cycle_p char(1),
duty_cycle_u char(16),rise char(32),rise_p char(1),rise_u char(16),
fall char(32),fall_p char(1),fall_u char(16),trigger_skew char(32),
trigger_skew_p char(1),trigger_skew_u char(16),video char(32),
polarity char(16),rtd_type char(16),rtd_nom_res char(32),
rtd_nom_res_p char(1),rtd_nom_res_u char(16),tc_type char(32),
mod_source char(16),am_depth char(32),am_depth_p char(1),am_depth_u char(16),
fm_dev char(32),fm_dev_p char(1),fm_dev_u char(16),phase_dev char(32),
phase_dev_p char(1),phase_dev_u char(16),wave2 char(32),ampl2 char(32),
ampl2_p char(1),ampl2_u char(16),freq2 char(32),freq2_p char(1),
freq2_u char(16),per2 char(32),per2_p char(1),per2_u char(16),power char(32),
power_p char(1),power_u char(16),phase char(32),phase_p char(1),
phase_u char(16),dpf char(16),dpf_polarity char(16),Results_mtag char(80),
created timestamp,createdby char(16),editlogtime timestamp,
modifiedby char(16),test_step2 char(16),Logon_User char(16),
User_level integer,User_Full_Name char(60),User_Segregate char(8),
User_Rate numeric(12),dbconfig_company char(80),dbconfig_version char(16),
dbconfig_user1 char(64),dbconfig_user2 char(64),dbconfig_user3 char(64),
dbconfig_user4 char(64),dbconfig_user5 char(64))

/* Calibration_CTAG, Results_ctag, Row_num fields from the Results Table */
/* These are here for speed of access,  rest of Results Table Fields are */
/* on further down in this View. */
/* Fields from the Calibration Table */
/* Fields from the Customer Table */
/* Fields from the Inventory Table */
/* Fields from the Location Table */
/* Fields from the Results Table */
/* Fields from the DBconfig Table */
/* Fields from the Userlist Table */
/* Must Pass into this Stored Procedure the Asset_CTAG value that you are hunting for. */
begin
  select mt.Ver_7_Certificates.*,mt.dbconfig.company,mt.dbconfig.version,mt.dbconfig.user1,
    mt.dbconfig.user2,mt.dbconfig.user3,mt.dbconfig.user4,mt.dbconfig.user5 from
    mt.Ver_7_Certificates,mt.dbconfig where
    mt.Ver_7_Certificates.Calibration_Ctag like asset_ctag order by row_num asc
end;;
GRANT EXECUTE ON "mt"."Ver_7_Certificates" TO "mtreports";;
/*
//
// ================================================================
*/
message 'patch2 : Finshed';;
call mtxmsg('patch2','patch2 : Finished');;


















